"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var commands_exports = {};
__export(commands_exports, {
  SandstoneCommands: () => SandstoneCommands
});
module.exports = __toCommonJS(commands_exports);
var import_place = require("./implementations/block/place.js");
var import_damage = require("./implementations/entity/damage.js");
var import_implementations = require("./implementations/index.js");
function bind(pack, _class, method) {
  const cmd = new _class(pack);
  if (typeof cmd[method].bind === "function") {
    return cmd[method].bind(cmd);
  }
  throw Error("Commands binder screwed up");
}
class SandstoneCommands {
  constructor(sandstonePack) {
    this.sandstonePack = sandstonePack;
  }
  get advancement() {
    return new import_implementations.AdvancementCommand(this.sandstonePack);
  }
  get attribute() {
    return bind(this.sandstonePack, import_implementations.AttributeCommand, "attribute");
  }
  get bossbar() {
    return new import_implementations.BossBarCommand(this.sandstonePack);
  }
  get clear() {
    return bind(this.sandstonePack, import_implementations.ClearCommand, "clear");
  }
  get clone() {
    return bind(this.sandstonePack, import_implementations.CloneCommand, "clone");
  }
  get comment() {
    return bind(this.sandstonePack, import_implementations.CommentCommand, "comment");
  }
  get damage() {
    return bind(this.sandstonePack, import_damage.DamageCommand, "damage");
  }
  get data() {
    return new import_implementations.DataCommand(this.sandstonePack);
  }
  get datapack() {
    return new import_implementations.DataPackCommand(this.sandstonePack);
  }
  get debug() {
    return new import_implementations.DebugCommand(this.sandstonePack);
  }
  get defaultgamemode() {
    return bind(this.sandstonePack, import_implementations.DefaultGameModeCommand, "defaultgamemode");
  }
  get difficulty() {
    return bind(this.sandstonePack, import_implementations.DifficultyCommand, "difficulty");
  }
  get effect() {
    return new import_implementations.EffectCommand(this.sandstonePack);
  }
  get enchant() {
    return bind(this.sandstonePack, import_implementations.EnchantCommand, "enchant");
  }
  get execute() {
    return new import_implementations.ExecuteCommand(this.sandstonePack);
  }
  get experience() {
    return new import_implementations.ExperienceCommand(this.sandstonePack);
  }
  get fill() {
    return bind(this.sandstonePack, import_implementations.FillCommand, "fill");
  }
  get functionCmd() {
    return bind(this.sandstonePack, import_implementations.FunctionCommand, "function");
  }
  get forceload() {
    return new import_implementations.ForceLoadCommand(this.sandstonePack);
  }
  get gamemode() {
    return bind(this.sandstonePack, import_implementations.GameModeCommand, "gamemode");
  }
  get gamerule() {
    return bind(this.sandstonePack, import_implementations.GameRuleCommand, "gamerule");
  }
  get give() {
    return bind(this.sandstonePack, import_implementations.GiveCommand, "give");
  }
  get help() {
    return bind(this.sandstonePack, import_implementations.HelpCommand, "help");
  }
  get item() {
    return new import_implementations.ItemCommand(this.sandstonePack);
  }
  get kill() {
    return bind(this.sandstonePack, import_implementations.KillCommand, "kill");
  }
  get list() {
    return bind(this.sandstonePack, import_implementations.ListCommand, "list");
  }
  get locate() {
    return new import_implementations.LocateCommand(this.sandstonePack);
  }
  get loot() {
    return new import_implementations.LootCommand(this.sandstonePack);
  }
  get me() {
    return bind(this.sandstonePack, import_implementations.MeCommand, "me");
  }
  get particle() {
    return bind(this.sandstonePack, import_implementations.ParticleCommand, "particle");
  }
  get place() {
    return new import_place.PlaceCommand(this.sandstonePack);
  }
  get playsound() {
    return bind(this.sandstonePack, import_implementations.PlaySoundCommand, "playsound");
  }
  get raw() {
    return bind(this.sandstonePack, import_implementations.RawCommand, "raw");
  }
  get recipe() {
    return new import_implementations.RecipeCommand(this.sandstonePack);
  }
  get reload() {
    return bind(this.sandstonePack, import_implementations.ReloadCommand, "reload");
  }
  get returnCmd() {
    return new import_implementations.ReturnCommand(this.sandstonePack).return;
  }
  get ride() {
    return bind(this.sandstonePack, import_implementations.RideCommand, "ride");
  }
  get say() {
    return bind(this.sandstonePack, import_implementations.SayCommand, "say");
  }
  get schedule() {
    return new import_implementations.ScheduleCommand(this.sandstonePack);
  }
  get scoreboard() {
    return new import_implementations.ScoreboardCommand(this.sandstonePack);
  }
  get seed() {
    return bind(this.sandstonePack, import_implementations.SeedCommand, "seed");
  }
  get setblock() {
    return bind(this.sandstonePack, import_implementations.SetBlockCommand, "setblock");
  }
  get setidletimeout() {
    return bind(this.sandstonePack, import_implementations.SetIdleTimeoutCommand, "setidletimeout");
  }
  get setworldspawn() {
    return bind(this.sandstonePack, import_implementations.SetWorldSpawnCommand, "setworldspawn");
  }
  get spawnpoint() {
    return bind(this.sandstonePack, import_implementations.SpawnPointCommand, "spawnpoint");
  }
  get spectate() {
    return bind(this.sandstonePack, import_implementations.SpectateCommand, "spectate");
  }
  get stopsound() {
    return bind(this.sandstonePack, import_implementations.StopSoundCommand, "stopsound");
  }
  get spreadplayers() {
    return bind(this.sandstonePack, import_implementations.SpreadPlayersCommand, "spreadplayers");
  }
  get summon() {
    return bind(this.sandstonePack, import_implementations.SummonCommand, "summon");
  }
  get tag() {
    return bind(this.sandstonePack, import_implementations.TagCommand, "tag");
  }
  get team() {
    return new import_implementations.TeamCommand(this.sandstonePack);
  }
  get teammsg() {
    return bind(this.sandstonePack, import_implementations.TeamMessageCommand, "teammessage");
  }
  get teleport() {
    return bind(this.sandstonePack, import_implementations.TeleportCommand, "tp");
  }
  get tell() {
    return bind(this.sandstonePack, import_implementations.TellCommand, "tell");
  }
  get tellraw() {
    return bind(this.sandstonePack, import_implementations.TellRawCommand, "tellraw");
  }
  get time() {
    return new import_implementations.TimeCommand(this.sandstonePack);
  }
  get title() {
    return bind(this.sandstonePack, import_implementations.TitleCommand, "title");
  }
  get trigger() {
    return bind(this.sandstonePack, import_implementations.TriggerCommand, "trigger");
  }
  get weather() {
    return new import_implementations.WeatherCommand(this.sandstonePack);
  }
  get worldborder() {
    return new import_implementations.WorldBorderCommand(this.sandstonePack);
  }
  // Aliases
  get msg() {
    return this.tell;
  }
  get w() {
    return this.tell;
  }
  get tm() {
    return this.teammsg;
  }
  get xp() {
    return this.experience;
  }
  get tp() {
    return this.teleport;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  SandstoneCommands
});
//# sourceMappingURL=commands.cjs.map