import { PlaceCommand } from './implementations/block/place.js';
import { AdvancementCommand, BossBarCommand, DataCommand, DataPackCommand, DebugCommand, EffectCommand, ExecuteCommand, ExperienceCommand, ForceLoadCommand, ItemCommand, LocateCommand, LootCommand, RecipeCommand, ScheduleCommand, ScoreboardCommand, TeamCommand, TimeCommand, WeatherCommand, WorldBorderCommand } from './implementations/index.js';
import type { SandstonePack } from 'sandstone/pack/index.js';
export declare class SandstoneCommands<MACRO extends boolean> {
    sandstonePack: SandstonePack;
    constructor(sandstonePack: SandstonePack);
    get advancement(): AdvancementCommand<MACRO>;
    get attribute(): (target: import("../core/Macro.js").Macroable<import("../arguments/selector.js").SingleEntityArgument<MACRO>, MACRO>, attribute: import("../core/Macro.js").Macroable<string, MACRO>) => import("./helpers.js").FinalCommandOutput;
    get bossbar(): BossBarCommand<MACRO>;
    get clear(): (targets?: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultiplePlayersArgument<MACRO>, MACRO> | undefined, item?: import("../core/Macro.js").Macroable<import("../utils.js").LiteralUnion<import("../arguments/index.js").ITEMS> | import("../core/index.js").TagClass<"items">, MACRO> | undefined, maxCount?: import("../core/Macro.js").Macroable<number, MACRO> | undefined) => import("./helpers.js").FinalCommandOutput;
    get clone(): (begin: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO>, end: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO>, destination: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO>) => import("./implementations/index.js").CloneOptionsCommand<MACRO>;
    get comment(): (...comments: unknown[]) => import("./helpers.js").FinalCommandOutput;
    get damage(): (target: import("../core/Macro.js").Macroable<import("../arguments/selector.js").SingleEntityArgument<MACRO>, MACRO>, amount: import("../core/Macro.js").Macroable<number, MACRO>, damageType?: import("../core/Macro.js").Macroable<import("../utils.js").LiteralUnion<import("../arguments/index.js").DAMAGE_TYPES> | import("../core/index.js").DamageTypeClass, MACRO> | undefined) => import("./implementations/entity/damage.js").DamageSourceCommand<boolean>;
    get data(): DataCommand<MACRO>;
    get datapack(): DataPackCommand;
    get debug(): DebugCommand;
    get defaultgamemode(): (mode: import("../arguments/basics.js").GAMEMODES) => import("./helpers.js").FinalCommandOutput;
    get difficulty(): (difficulty?: import("../arguments/basics.js").DIFFICULTIES | undefined) => import("./helpers.js").FinalCommandOutput;
    get effect(): EffectCommand<MACRO>;
    get enchant(): (targets: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultipleEntitiesArgument<MACRO>, MACRO>, enchantment: import("../core/Macro.js").Macroable<import("../utils.js").LiteralUnion<import("../arguments/index.js").ENCHANTMENTS>, MACRO>, level?: number | undefined) => import("./helpers.js").FinalCommandOutput;
    get execute(): ExecuteCommand<MACRO>;
    get experience(): ExperienceCommand<MACRO>;
    get fill(): (from: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO>, to: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO>, block: import("../core/Macro.js").Macroable<import("../utils.js").LiteralUnion<import("../arguments/index.js").BLOCKS>, MACRO>) => import("./implementations/index.js").FillArgumentsCommand<boolean>;
    get functionCmd(): {
        (mcFunction: import("../core/Macro.js").Macroable<string | import("../core/index.js").MCFunctionClass<undefined, undefined> | import("../core/index.js").TagClass<"functions">, MACRO>): import("./helpers.js").FinalCommandOutput;
        (mcFunction: import("../core/Macro.js").Macroable<string | import("../core/index.js").MCFunctionClass<undefined, undefined> | import("../core/index.js").TagClass<"functions">, MACRO>, params: import("../core/Macro.js").Macroable<import("../arguments/nbt.js").RootNBT, MACRO>): import("./helpers.js").FinalCommandOutput;
        (mcFunction: import("../core/Macro.js").Macroable<string | import("../core/index.js").MCFunctionClass<undefined, undefined> | import("../core/index.js").TagClass<"functions">, MACRO>, _: "with", type: import("../variables/Data.js").DATA_TYPES, target: string, path: string): import("./helpers.js").FinalCommandOutput;
        (mcFunction: import("../core/Macro.js").Macroable<string | import("../core/index.js").MCFunctionClass<undefined, undefined> | import("../core/index.js").TagClass<"functions">, MACRO>, _: "with", dataPoint: import("../core/Macro.js").DataPointPickClass | import("../variables/Data.js").DataPointClass<any>): import("./helpers.js").FinalCommandOutput;
    };
    get forceload(): ForceLoadCommand<MACRO>;
    get gamemode(): (gamemode: import("../core/Macro.js").Macroable<import("../arguments/basics.js").GAMEMODES, MACRO>, targets?: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultiplePlayersArgument<MACRO>, MACRO> | undefined) => import("./helpers.js").FinalCommandOutput;
    get gamerule(): (gamerule: import("../core/Macro.js").Macroable<import("../utils.js").LiteralUnion<import("../arguments/gamerules.js").GAMERULES>, MACRO>, value?: import("../core/Macro.js").Macroable<number | boolean, MACRO> | undefined) => import("./helpers.js").FinalCommandOutput;
    get give(): {
        (targets: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultiplePlayersArgument<MACRO>, MACRO>, item: import("../core/Macro.js").Macroable<import("../utils.js").LiteralUnion<import("../arguments/index.js").ITEMS>, MACRO>, count?: import("../core/Macro.js").Macroable<number, MACRO> | undefined): import("./helpers.js").FinalCommandOutput;
        (targets: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultiplePlayersArgument<MACRO>, MACRO>, item: import("../core/Macro.js").Macroable<import("../utils.js").LiteralUnion<import("../arguments/index.js").ITEMS>, MACRO>, nbt: import("../core/Macro.js").Macroable<import("../arguments/nbt.js").RootNBT, MACRO>, count?: import("../core/Macro.js").Macroable<number, MACRO> | undefined): import("./helpers.js").FinalCommandOutput;
    };
    get help(): (command?: string | undefined, ...parameters: string[]) => import("./helpers.js").FinalCommandOutput;
    get item(): ItemCommand<MACRO>;
    get kill(): (targets?: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultipleEntitiesArgument<MACRO>, MACRO> | undefined) => import("./helpers.js").FinalCommandOutput;
    get list(): (uuids?: boolean | undefined) => import("./helpers.js").FinalCommandOutput;
    get locate(): LocateCommand<MACRO>;
    get loot(): LootCommand<MACRO>;
    get me(): (...actions: import("../arguments/selector.js").MultipleEntitiesArgument<false>[]) => import("./helpers.js").FinalCommandOutput;
    get particle(): ((name: import("../core/Macro.js").Macroable<import("../arguments/index.js").PARTICLE_TYPES, MACRO>, pos?: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO> | undefined, delta?: import("../core/Macro.js").Macroable<[deltaX: import("../core/Macro.js").Macroable<number, MACRO>, deltaY: import("../core/Macro.js").Macroable<number, MACRO>, deltaZ: import("../core/Macro.js").Macroable<number, MACRO>], MACRO> | undefined, speed?: import("../core/Macro.js").Macroable<number, MACRO> | undefined, count?: import("../core/Macro.js").Macroable<number, MACRO> | undefined, mode?: import("../core/Macro.js").Macroable<"force" | "normal", MACRO> | undefined, viewers?: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultiplePlayersArgument<MACRO>, MACRO> | undefined) => void) & ((name: "minecraft:dust", colors: import("../core/Macro.js").Macroable<[red: import("../core/Macro.js").Macroable<number, MACRO>, green: import("../core/Macro.js").Macroable<number, MACRO>, blue: import("../core/Macro.js").Macroable<number, MACRO>, size: import("../core/Macro.js").Macroable<number, MACRO>], MACRO>, size: import("../core/Macro.js").Macroable<number, MACRO>, pos?: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO> | undefined, delta?: import("../core/Macro.js").Macroable<[deltaX: import("../core/Macro.js").Macroable<number, MACRO>, deltaY: import("../core/Macro.js").Macroable<number, MACRO>, deltaZ: import("../core/Macro.js").Macroable<number, MACRO>], MACRO> | undefined, speed?: import("../core/Macro.js").Macroable<number, MACRO> | undefined, count?: import("../core/Macro.js").Macroable<number, MACRO> | undefined, mode?: import("../core/Macro.js").Macroable<"force" | "normal", MACRO> | undefined, viewers?: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultiplePlayersArgument<MACRO>, MACRO> | undefined) => void) & ((name: import("../core/Macro.js").Macroable<"minecraft:block" | "minecraft:falling_dust", MACRO>, block: import("../core/Macro.js").Macroable<import("../utils.js").LiteralUnion<import("../arguments/index.js").BLOCKS>, MACRO>, pos?: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO> | undefined, delta?: import("../core/Macro.js").Macroable<[deltaX: import("../core/Macro.js").Macroable<number, MACRO>, deltaY: import("../core/Macro.js").Macroable<number, MACRO>, deltaZ: import("../core/Macro.js").Macroable<number, MACRO>], MACRO> | undefined, speed?: import("../core/Macro.js").Macroable<number, MACRO> | undefined, count?: import("../core/Macro.js").Macroable<number, MACRO> | undefined, mode?: import("../core/Macro.js").Macroable<"force" | "normal", MACRO> | undefined, viewers?: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultiplePlayersArgument<MACRO>, MACRO> | undefined) => void) & ((name: "minecraft:item", item: import("../core/Macro.js").Macroable<import("../utils.js").LiteralUnion<import("../arguments/index.js").ITEMS>, MACRO>, pos?: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO> | undefined, delta?: import("../core/Macro.js").Macroable<[deltaX: import("../core/Macro.js").Macroable<number, MACRO>, deltaY: import("../core/Macro.js").Macroable<number, MACRO>, deltaZ: import("../core/Macro.js").Macroable<number, MACRO>], MACRO> | undefined, speed?: import("../core/Macro.js").Macroable<number, MACRO> | undefined, count?: import("../core/Macro.js").Macroable<number, MACRO> | undefined, mode?: import("../core/Macro.js").Macroable<"force" | "normal", MACRO> | undefined, viewers?: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultiplePlayersArgument<MACRO>, MACRO> | undefined) => void);
    get place(): PlaceCommand<MACRO>;
    get playsound(): (sound: import("../core/Macro.js").Macroable<import("../utils.js").LiteralUnion<import("../arguments/index.js").SOUND_EVENTS>, MACRO>, source: import("../core/Macro.js").Macroable<import("../arguments/basics.js").SOUND_SOURCES, MACRO>, targets: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultiplePlayersArgument<MACRO>, MACRO>, sourcePosition?: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO> | undefined, volume?: import("../core/Macro.js").Macroable<number, MACRO> | undefined, pitch?: import("../core/Macro.js").Macroable<number, MACRO> | undefined, minVolume?: import("../core/Macro.js").Macroable<number, MACRO> | undefined) => import("./helpers.js").FinalCommandOutput;
    get raw(): (...args: unknown[]) => import("./helpers.js").FinalCommandOutput;
    get recipe(): RecipeCommand<MACRO>;
    get reload(): () => import("./helpers.js").FinalCommandOutput;
    get returnCmd(): import("./implementations/index.js").ReturnArgumentsCommand<MACRO> & ((value?: import("../core/Macro.js").Macroable<number, MACRO> | undefined) => import("./helpers.js").FinalCommandOutput);
    get ride(): (target: import("../core/Macro.js").Macroable<import("../arguments/selector.js").SingleEntityArgument<MACRO>, MACRO>) => import("./implementations/index.js").RideArgumentsCommand<boolean>;
    get say(): (message: import("../core/Macro.js").Macroable<string, MACRO>) => import("./helpers.js").FinalCommandOutput;
    get schedule(): ScheduleCommand<MACRO>;
    get scoreboard(): ScoreboardCommand<MACRO>;
    get seed(): () => import("./helpers.js").FinalCommandOutput;
    get setblock(): {
        (pos: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO>, block: import("../core/Macro.js").Macroable<import("../utils.js").LiteralUnion<import("../arguments/index.js").BLOCKS>, MACRO>, type?: import("../core/Macro.js").Macroable<"replace" | "destroy" | "keep", MACRO> | undefined): import("./helpers.js").FinalCommandOutput;
        (pos: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO>, block: import("../core/Macro.js").Macroable<import("../utils.js").LiteralUnion<import("../arguments/index.js").BLOCKS>, MACRO>, nbt?: import("../core/Macro.js").Macroable<import("../arguments/nbt.js").RootNBT, MACRO> | undefined, type?: import("../core/Macro.js").Macroable<"replace" | "destroy" | "keep", MACRO> | undefined): import("./helpers.js").FinalCommandOutput;
    };
    get setidletimeout(): (minutes: number) => import("./helpers.js").FinalCommandOutput;
    get setworldspawn(): (pos?: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO> | undefined, angle?: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Rotation<MACRO>, MACRO> | undefined) => import("./helpers.js").FinalCommandOutput;
    get spawnpoint(): (targets?: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultiplePlayersArgument<MACRO>, MACRO> | undefined, pos?: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO> | undefined, angle?: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Rotation<MACRO>, MACRO> | undefined) => import("./helpers.js").FinalCommandOutput;
    get spectate(): (target: import("../core/Macro.js").Macroable<import("../arguments/selector.js").SingleEntityArgument<MACRO>, MACRO>, player?: import("../core/Macro.js").Macroable<import("../arguments/selector.js").SinglePlayerArgument<MACRO>, MACRO> | undefined) => import("./helpers.js").FinalCommandOutput;
    get stopsound(): (targets: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultiplePlayersArgument<MACRO>, MACRO>, source?: import("../core/Macro.js").Macroable<"*" | import("../arguments/basics.js").SOUND_SOURCES, MACRO> | undefined, sound?: import("../core/Macro.js").Macroable<import("../utils.js").LiteralUnion<import("../arguments/index.js").SOUND_EVENTS>, MACRO> | undefined) => import("./helpers.js").FinalCommandOutput;
    get spreadplayers(): ((center: import("../core/Macro.js").Macroable<import("../arguments/coords.js").ColumnCoordinates<MACRO>, MACRO>, spreadDistance: import("../core/Macro.js").Macroable<number, MACRO>, maxRange: import("../core/Macro.js").Macroable<number, MACRO>, respectTeams: import("../core/Macro.js").Macroable<boolean, MACRO>, targets: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultipleEntitiesArgument<MACRO>, MACRO>) => import("./helpers.js").FinalCommandOutput) & ((center: import("../core/Macro.js").Macroable<import("../arguments/coords.js").ColumnCoordinates<MACRO>, MACRO>, spreadDistance: import("../core/Macro.js").Macroable<number, MACRO>, maxRange: import("../core/Macro.js").Macroable<number, MACRO>, under: "under", height: import("../core/Macro.js").Macroable<number, MACRO>, respectTeams: import("../core/Macro.js").Macroable<boolean, MACRO>, targets: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultipleEntitiesArgument<MACRO>, MACRO>) => import("./helpers.js").FinalCommandOutput);
    get summon(): (entity: import("../core/Macro.js").Macroable<import("../utils.js").LiteralUnion<import("../arguments/index.js").ENTITY_TYPES>, MACRO>, pos?: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO> | undefined, nbt?: import("../core/Macro.js").Macroable<import("../arguments/nbt.js").RootNBT, MACRO> | undefined) => import("./helpers.js").FinalCommandOutput;
    get tag(): (targets: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultipleEntitiesArgument<MACRO>, MACRO>) => import("./implementations/index.js").TagArgumentsCommand<MACRO>;
    get team(): TeamCommand<MACRO>;
    get teammsg(): (messages_0: import("../arguments/basics.js").MessageOrSelector, ...messages_1: import("../arguments/basics.js").MessageOrSelector[]) => void;
    get teleport(): ((destinationEntity: import("../core/Macro.js").Macroable<import("../arguments/selector.js").SingleEntityArgument<MACRO>, MACRO>) => void) & ((location: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO>) => void) & ((targets: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultipleEntitiesArgument<MACRO>, MACRO>, destinationEntity: import("../core/Macro.js").Macroable<import("../arguments/selector.js").SingleEntityArgument<MACRO>, MACRO>) => void) & ((targets: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultipleEntitiesArgument<MACRO>, MACRO>, location: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO>) => import("./implementations/index.js").TeleportFacingCommand<MACRO>) & ((targets: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultipleEntitiesArgument<MACRO>, MACRO>, location: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO>, rotation: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Rotation<MACRO>, MACRO>) => void);
    get tell(): (targets: import("../arguments/selector.js").MultiplePlayersArgument<false>, messages_0: import("../arguments/basics.js").MessageOrSelector, ...messages_1: import("../arguments/basics.js").MessageOrSelector[]) => import("./helpers.js").FinalCommandOutput;
    get tellraw(): (targets: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultiplePlayersArgument<MACRO>, MACRO>, message: import("../core/Macro.js").Macroable<import("../arguments/jsonTextComponent.js").JSONTextComponent, MACRO>) => import("./helpers.js").FinalCommandOutput;
    get time(): TimeCommand<MACRO>;
    get title(): (targets: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultiplePlayersArgument<MACRO>, MACRO>) => import("./implementations/index.js").TitleArgumentsCommand<MACRO>;
    get trigger(): (objective: import("../arguments/objective.js").ObjectiveArgument) => import("./implementations/index.js").TriggerArgumentsCommand;
    get weather(): WeatherCommand<MACRO>;
    get worldborder(): WorldBorderCommand<MACRO>;
    get msg(): (targets: import("../arguments/selector.js").MultiplePlayersArgument<false>, messages_0: import("../arguments/basics.js").MessageOrSelector, ...messages_1: import("../arguments/basics.js").MessageOrSelector[]) => import("./helpers.js").FinalCommandOutput;
    get w(): (targets: import("../arguments/selector.js").MultiplePlayersArgument<false>, messages_0: import("../arguments/basics.js").MessageOrSelector, ...messages_1: import("../arguments/basics.js").MessageOrSelector[]) => import("./helpers.js").FinalCommandOutput;
    get tm(): (messages_0: import("../arguments/basics.js").MessageOrSelector, ...messages_1: import("../arguments/basics.js").MessageOrSelector[]) => void;
    get xp(): ExperienceCommand<MACRO>;
    get tp(): ((destinationEntity: import("../core/Macro.js").Macroable<import("../arguments/selector.js").SingleEntityArgument<MACRO>, MACRO>) => void) & ((location: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO>) => void) & ((targets: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultipleEntitiesArgument<MACRO>, MACRO>, destinationEntity: import("../core/Macro.js").Macroable<import("../arguments/selector.js").SingleEntityArgument<MACRO>, MACRO>) => void) & ((targets: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultipleEntitiesArgument<MACRO>, MACRO>, location: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO>) => import("./implementations/index.js").TeleportFacingCommand<MACRO>) & ((targets: import("../core/Macro.js").Macroable<import("../arguments/selector.js").MultipleEntitiesArgument<MACRO>, MACRO>, location: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Coordinates<MACRO>, MACRO>, rotation: import("../core/Macro.js").Macroable<import("../arguments/coords.js").Rotation<MACRO>, MACRO>) => void);
}
