import { PlaceCommand } from './implementations/block/place.js';
import { DamageCommand } from './implementations/entity/damage.js';
import { AdvancementCommand, AttributeCommand, BossBarCommand, ClearCommand, CloneCommand, CommentCommand, DataCommand, DataPackCommand, DebugCommand, DefaultGameModeCommand, DifficultyCommand, EffectCommand, EnchantCommand, ExecuteCommand, ExperienceCommand, FillCommand, ForceLoadCommand, FunctionCommand, GameModeCommand, GameRuleCommand, GiveCommand, HelpCommand, ItemCommand, KillCommand, ListCommand, LocateCommand, LootCommand, MeCommand, ParticleCommand, PlaySoundCommand, RawCommand, RecipeCommand, ReloadCommand, ReturnCommand, RideCommand, SayCommand, ScheduleCommand, ScoreboardCommand, SeedCommand, SetBlockCommand, SetIdleTimeoutCommand, SetWorldSpawnCommand, SpawnPointCommand, SpectateCommand, SpreadPlayersCommand, StopSoundCommand, SummonCommand, TagCommand, TeamCommand, TeamMessageCommand, TeleportCommand, TellCommand, TellRawCommand, TimeCommand, TitleCommand, TriggerCommand, WeatherCommand, WorldBorderCommand, } from './implementations/index.js';
function bind(pack, _class, method) {
    /* @ts-ignore */
    const cmd = new _class(pack);
    if (typeof cmd[method].bind === 'function') {
        return cmd[method].bind(cmd);
    }
    throw Error('Commands binder screwed up');
}
export class SandstoneCommands {
    sandstonePack;
    constructor(sandstonePack) {
        this.sandstonePack = sandstonePack;
    }
    get advancement() { return new AdvancementCommand(this.sandstonePack); }
    get attribute() { return bind(this.sandstonePack, AttributeCommand, 'attribute'); }
    get bossbar() { return new BossBarCommand(this.sandstonePack); }
    get clear() { return bind(this.sandstonePack, ClearCommand, 'clear'); }
    get clone() { return bind(this.sandstonePack, CloneCommand, 'clone'); }
    get comment() { return bind(this.sandstonePack, CommentCommand, 'comment'); }
    get damage() { return bind(this.sandstonePack, DamageCommand, 'damage'); }
    get data() { return new DataCommand(this.sandstonePack); }
    get datapack() { return new DataPackCommand(this.sandstonePack); }
    get debug() { return new DebugCommand(this.sandstonePack); }
    get defaultgamemode() { return bind(this.sandstonePack, DefaultGameModeCommand, 'defaultgamemode'); }
    get difficulty() { return bind(this.sandstonePack, DifficultyCommand, 'difficulty'); }
    get effect() { return new EffectCommand(this.sandstonePack); }
    get enchant() { return bind(this.sandstonePack, EnchantCommand, 'enchant'); }
    get execute() { return new ExecuteCommand(this.sandstonePack); }
    get experience() { return new ExperienceCommand(this.sandstonePack); }
    get fill() { return bind(this.sandstonePack, FillCommand, 'fill'); }
    get functionCmd() { return bind(this.sandstonePack, FunctionCommand, 'function'); }
    get forceload() { return new ForceLoadCommand(this.sandstonePack); }
    get gamemode() { return bind(this.sandstonePack, GameModeCommand, 'gamemode'); }
    get gamerule() { return bind(this.sandstonePack, GameRuleCommand, 'gamerule'); }
    get give() { return bind(this.sandstonePack, GiveCommand, 'give'); }
    get help() { return bind(this.sandstonePack, HelpCommand, 'help'); }
    get item() { return new ItemCommand(this.sandstonePack); }
    get kill() { return bind(this.sandstonePack, KillCommand, 'kill'); }
    get list() { return bind(this.sandstonePack, ListCommand, 'list'); }
    get locate() { return new LocateCommand(this.sandstonePack); }
    get loot() { return new LootCommand(this.sandstonePack); }
    get me() { return bind(this.sandstonePack, MeCommand, 'me'); }
    get particle() { return bind(this.sandstonePack, ParticleCommand, 'particle'); }
    get place() { return new PlaceCommand(this.sandstonePack); }
    get playsound() { return bind(this.sandstonePack, PlaySoundCommand, 'playsound'); }
    get raw() { return bind(this.sandstonePack, RawCommand, 'raw'); }
    get recipe() { return new RecipeCommand(this.sandstonePack); }
    get reload() { return bind(this.sandstonePack, ReloadCommand, 'reload'); }
    get returnCmd() { return new ReturnCommand(this.sandstonePack).return; }
    get ride() { return bind(this.sandstonePack, RideCommand, 'ride'); }
    get say() { return bind(this.sandstonePack, SayCommand, 'say'); }
    get schedule() { return new ScheduleCommand(this.sandstonePack); }
    get scoreboard() { return new ScoreboardCommand(this.sandstonePack); }
    get seed() { return bind(this.sandstonePack, SeedCommand, 'seed'); }
    get setblock() { return bind(this.sandstonePack, SetBlockCommand, 'setblock'); }
    get setidletimeout() { return bind(this.sandstonePack, SetIdleTimeoutCommand, 'setidletimeout'); }
    get setworldspawn() { return bind(this.sandstonePack, SetWorldSpawnCommand, 'setworldspawn'); }
    get spawnpoint() { return bind(this.sandstonePack, SpawnPointCommand, 'spawnpoint'); }
    get spectate() { return bind(this.sandstonePack, SpectateCommand, 'spectate'); }
    get stopsound() { return bind(this.sandstonePack, StopSoundCommand, 'stopsound'); }
    get spreadplayers() { return bind(this.sandstonePack, SpreadPlayersCommand, 'spreadplayers'); }
    get summon() { return bind(this.sandstonePack, SummonCommand, 'summon'); }
    get tag() { return bind(this.sandstonePack, TagCommand, 'tag'); }
    get team() { return new TeamCommand(this.sandstonePack); }
    get teammsg() { return bind(this.sandstonePack, TeamMessageCommand, 'teammessage'); }
    get teleport() { return bind(this.sandstonePack, TeleportCommand, 'tp'); }
    get tell() { return bind(this.sandstonePack, TellCommand, 'tell'); }
    get tellraw() { return bind(this.sandstonePack, TellRawCommand, 'tellraw'); }
    get time() { return new TimeCommand(this.sandstonePack); }
    get title() { return bind(this.sandstonePack, TitleCommand, 'title'); }
    get trigger() { return bind(this.sandstonePack, TriggerCommand, 'trigger'); }
    get weather() { return new WeatherCommand(this.sandstonePack); }
    get worldborder() { return new WorldBorderCommand(this.sandstonePack); }
    // Aliases
    get msg() { return this.tell; }
    get w() { return this.tell; }
    get tm() { return this.teammsg; }
    get xp() { return this.experience; }
    get tp() { return this.teleport; }
}
