"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var helpers_exports = {};
__export(helpers_exports, {
  CommandArguments: () => CommandArguments,
  FinalCommandOutput: () => FinalCommandOutput
});
module.exports = __toCommonJS(helpers_exports);
class FinalCommandOutput {
  constructor(node) {
    this.node = node;
  }
}
class CommandArguments {
  constructor(sandstonePack, previousNode, autoCommit = true) {
    this.sandstonePack = sandstonePack;
    this.previousNode = previousNode;
    this.autoCommit = autoCommit;
    __publicField(this, "NodeType");
    __publicField(this, "sandstoneCore");
    __publicField(this, "sandstoneCommands");
    __publicField(this, "getNode", () => {
      if (this.previousNode) {
        return this.previousNode;
      }
      if (this.NodeType) {
        return new this.NodeType(this.sandstonePack);
      }
      throw new Error("No node type specified & no previous node for a non-root-level command");
    });
    __publicField(this, "finalCommand", (args, currentNode) => {
      const node = currentNode != null ? currentNode : this.getNode();
      if (args) {
        node.args.push(...args);
      }
      if (this.autoCommit) {
        node.commit();
      }
      return new FinalCommandOutput(node);
    });
    __publicField(this, "subCommand", (args, NextArgumentType, executable = false, additionalNextArgs = [], currentNode) => {
      const node = currentNode != null ? currentNode : this.getNode();
      if (args) {
        node.args.push(...args);
      }
      if (executable && this.autoCommit) {
        node.commit();
      }
      return new NextArgumentType(this.sandstonePack, node, this.autoCommit, ...additionalNextArgs);
    });
    this.sandstoneCore = sandstonePack.core;
    this.sandstoneCommands = sandstonePack.commands;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CommandArguments,
  FinalCommandOutput
});
//# sourceMappingURL=helpers.cjs.map