import type { SandstoneCore } from 'sandstone/core';
import type { CommandNode } from 'sandstone/core/nodes';
import type { SandstonePack } from 'sandstone/pack';
import type { SandstoneCommands } from './commands.js';
type InstanceTypeOr<NODE extends (new (...args: any) => CommandNode) | undefined, X> = (NODE extends undefined ? X : NODE extends new (...args: any) => infer R ? R : never);
/**
 * This is what final commands return.
 * It has a protected access to the node that was executed, allowing users to access the node's properties.
 *
 * This should only be used by users for advanced usage.
 */
export declare class FinalCommandOutput {
    protected node: CommandNode<unknown[]>;
    constructor(node: CommandNode<unknown[]>);
}
export type CommandNodeConstructor = (new (...args: any) => CommandNode);
export type CommandArgumentsConstructor = (new (...args: any) => any);
export declare abstract class CommandArguments<NODE extends CommandNodeConstructor | undefined = CommandNodeConstructor | undefined> {
    protected sandstonePack: SandstonePack;
    protected previousNode?: CommandNode<unknown[]> | undefined;
    protected autoCommit: boolean;
    protected NodeType?: NODE;
    protected sandstoneCore: SandstoneCore;
    protected sandstoneCommands: SandstoneCommands<false>;
    constructor(sandstonePack: SandstonePack, previousNode?: CommandNode<unknown[]> | undefined, autoCommit?: boolean);
    protected getNode: (() => InstanceTypeOr<NODE, CommandNode>);
    protected finalCommand: (args?: NODE extends CommandNodeConstructor ? InstanceType<NODE>['args'] : any[], currentNode?: InstanceTypeOr<NODE, CommandNode> | undefined) => FinalCommandOutput;
    protected subCommand: <NEXT_ARGUMENT extends CommandArgumentsConstructor>(args: NODE extends CommandNodeConstructor ? InstanceType<NODE>['args'] : any[], NextArgumentType: NEXT_ARGUMENT, executable?: boolean, additionalNextArgs?: unknown[], currentNode?: InstanceTypeOr<NODE, CommandNode> | undefined) => NEXT_ARGUMENT extends CommandArgumentsConstructor ? InstanceType<NEXT_ARGUMENT> : FinalCommandOutput;
}
export {};
