import { CommandNode } from 'sandstone/core/nodes';
import { CommandArguments } from '../../helpers.js';
export class CommentCommandNode extends CommandNode {
    command = '#';
    getValue() {
        return this.args[0].join(' ').split('\n').map((line) => `# ${line}`).join('\n');
    }
}
export class CommentCommand extends CommandArguments {
    NodeType = CommentCommandNode;
    /**
     * Adds a comment, starting with a `# `, to the function.
     */
    comment = (...comments) => this.finalCommand([comments]);
}
