"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var attribute_exports = {};
__export(attribute_exports, {
  AttributeCommand: () => AttributeCommand,
  AttributeCommandNode: () => AttributeCommandNode,
  AttributeOperationCommand: () => AttributeOperationCommand
});
module.exports = __toCommonJS(attribute_exports);
var import_nodes = require("sandstone/core/nodes");
var import_parsers = require("sandstone/variables/parsers");
var import_helpers = require("../../helpers.js");
class AttributeCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "attribute");
  }
}
class AttributeOperationCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    /**
     * Returns the total value of the specified attribute.
     * @category attribute
     */
    __publicField(this, "get", (scale) => this.finalCommand(["get", scale]));
    /**
     * Returns the base value of the specified attribute.
     * @category attribute
     */
    __publicField(this, "baseGet", (scale) => this.finalCommand(["base", "get", scale]));
    /**
     * Overwrites the base value of the specified attribute with the given value.
     * @category attribute
     */
    __publicField(this, "baseSet", (value) => this.finalCommand(["base", "set", value]));
    /**
     * Adds an attribute modifier with the specified properties if no modifier with the same UUID already existed.
     * @category attribute
     */
    __publicField(this, "add", (uuid, name, value, modifier) => this.finalCommand(["modifier", "add", uuid, name, value, modifier]));
    /** Removes the attribute modifier with the specified UUID. */
    __publicField(this, "remove", (uuid) => this.finalCommand(["modifier", "remove", uuid]));
    /** Returns the value of the modifier with the specified UUID. */
    __publicField(this, "getModifierValue", (uuid, scale) => this.finalCommand(["modifier", "value", "get", uuid, scale]));
  }
}
class AttributeCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", AttributeCommandNode);
    __publicField(this, "attribute", (target, attribute) => this.finalCommand([(0, import_parsers.targetParser)(target), attribute]));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AttributeCommand,
  AttributeCommandNode,
  AttributeOperationCommand
});
//# sourceMappingURL=attribute.cjs.map