"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var clear_exports = {};
__export(clear_exports, {
  ClearCommand: () => ClearCommand,
  ClearCommandNode: () => ClearCommandNode
});
module.exports = __toCommonJS(clear_exports);
var import_nodes = require("sandstone/core/nodes");
var import_parsers = require("sandstone/variables/parsers");
var import_helpers = require("../../helpers.js");
class ClearCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "clear");
  }
}
class ClearCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", ClearCommandNode);
    /**
     * Clears items from player inventory, including items being dragged by the player.
     *
     * @param targets Specifies the player(s) whose items are cleared.
     * If not specified, defaults to the player who executes the command.
     *
     * @param item Specifies the item to be cleared. If not specified, all items are cleared.
     *
     * @param maxCount Specifies the maximum number of items to be cleared.
     *
     * If not specified, all items that match `item` are cleared.
     *
     * If `0`, instead of clearing of items, detectes and queries the amount of specified items.
     */
    __publicField(this, "clear", (targets, item, maxCount) => this.finalCommand([(0, import_parsers.targetParser)(targets), item, maxCount]));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ClearCommand,
  ClearCommandNode
});
//# sourceMappingURL=clear.cjs.map