"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var damage_exports = {};
__export(damage_exports, {
  DamageCommand: () => DamageCommand,
  DamageCommandNode: () => DamageCommandNode,
  DamageSourceCommand: () => DamageSourceCommand
});
module.exports = __toCommonJS(damage_exports);
var import_validators = require("sandstone/commands/validators");
var import_nodes = require("sandstone/core/nodes");
var import_parsers = require("sandstone/variables/parsers");
var import_helpers = require("../../helpers.js");
class DamageCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "damage");
  }
}
class DamageCauseCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    /**
     * @param cause Cause of the damage, in the case of indirect damage.
     */
    __publicField(this, "from", (cause) => this.finalCommand(["from", (0, import_parsers.targetParser)(cause)]));
  }
}
class DamageSourceCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    /**
     * @param entity Entity inflicting the damage.
     */
    __publicField(this, "by", (entity) => this.subCommand(["by", (0, import_parsers.targetParser)(entity)], DamageCauseCommand));
    /**
     * Where the damage originated at (when no entity caused the damage).
     */
    __publicField(this, "at", (position) => this.finalCommand(["at", (0, import_parsers.coordinatesParser)(position)]));
  }
}
class DamageCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", DamageCommandNode);
    /**
     * Deals damage.
     *
     * @param target Specifies the target.
     *
     * @param amount Specifies the amount of damage to be dealt.
     *
     * @param damageType This determines how the damage affects the entity as well as which death message is displayed
     */
    __publicField(this, "damage", (target, amount, damageType) => {
      (0, import_validators.validateIntegerRange)(amount, "amount", 0, 1e6);
      return this.subCommand([(0, import_parsers.targetParser)(target), amount, damageType], DamageSourceCommand);
    });
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DamageCommand,
  DamageCommandNode,
  DamageSourceCommand
});
//# sourceMappingURL=damage.cjs.map