"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var effect_exports = {};
__export(effect_exports, {
  EffectCommand: () => EffectCommand,
  EffectCommandNode: () => EffectCommandNode
});
module.exports = __toCommonJS(effect_exports);
var import_validators = require("sandstone/commands/validators");
var import_nodes = require("sandstone/core/nodes");
var import_parsers = require("sandstone/variables/parsers");
var import_helpers = require("../../helpers.js");
class EffectCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "effect");
  }
}
class EffectCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", EffectCommandNode);
    /**
     * Gives an effect.
     *
     * @param targets Specifies the target(s).
     *
     * @param effect Specifies the effect to be added.
     *
     * @param seconds
     * Specifies the effect's duration in seconds
     * (or in gameticks for `instant_damage`, `instant_health`, and `saturation`).
     * If not specified, defaults to 30 seconds (or 1 gametick for `instant_damage`, `instant_health`, and `saturation`).
     *
     * It must be between `0` and `1_000_000` (inclusive).
     *
     * @param amplifier
     * Specifies the number of additional levels to add to the effect.
     * If not specified, defaults to `0`.
     *
     * Note that the first tier of a status effect (e.g. Regeneration I) is `0`, so the second tier,
     * for example Regeneration II, would be specified by an amplifier level of `1`.
     *
     * @param hideParticles
     * Specifies whether the particles and the HUD indicator‌ of the status effect should be hidden.
     * If not specified, defaults to `false`.
     */
    __publicField(this, "give", (targets, effect, seconds, amplifier, hideParticles) => {
      if (seconds && seconds !== "infinite")
        (0, import_validators.validateIntegerRange)(seconds, "seconds", 0, 1e6);
      return this.finalCommand(["give", (0, import_parsers.targetParser)(targets), effect, seconds, amplifier, hideParticles]);
    });
    /**
     * Removes an effect.
     *
     * @param targets Specifies the target(s). If unspecified, defaults to `@s`.
     *
     * @param effect Specifies the effect to be removed. If unspecified, clears all effects.
     */
    __publicField(this, "clear", (targets, effect) => this.finalCommand(["clear", (0, import_parsers.targetParser)(targets), effect]));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  EffectCommand,
  EffectCommandNode
});
//# sourceMappingURL=effect.cjs.map