"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var enchant_exports = {};
__export(enchant_exports, {
  EnchantCommand: () => EnchantCommand,
  EnchantCommandNode: () => EnchantCommandNode
});
module.exports = __toCommonJS(enchant_exports);
var import_validators = require("sandstone/commands/validators");
var import_nodes = require("sandstone/core/nodes");
var import_parsers = require("sandstone/variables/parsers");
var import_helpers = require("../../helpers.js");
class EnchantCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "enchant");
  }
}
class EnchantCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", EnchantCommandNode);
    /**
     * Adds an enchantment to a player's selected item, subject to the same restrictions as an anvil.
     *
     * @param targets Specifies the target(s).
     *
     * @param enchantment Specifies the enchantment to be added to the item held by the target.
     *
     * @param level Specifies the enchantment level.
     * Should be not greater than the maximum level for the specified enchantment.
     * If not specified, defaults to `1`.
     *
     * It must be between 0 and 2_147_483_647 (inclusive).
     */
    __publicField(this, "enchant", (targets, enchantment, level) => {
      if (level)
        (0, import_validators.validateIntegerRange)(level, "level", 0, 2147483647);
      return this.finalCommand([(0, import_parsers.targetParser)(targets), enchantment, level]);
    });
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  EnchantCommand,
  EnchantCommandNode
});
//# sourceMappingURL=enchant.cjs.map