import { CommandNode } from 'sandstone/core/nodes';
import { CommandArguments } from '../../helpers.js';
import type { MultipleEntitiesArgument } from 'sandstone/arguments';
import type { Macroable } from 'sandstone/core';
export declare class KillCommandNode extends CommandNode {
    command: "kill";
}
export declare class KillCommand<MACRO extends boolean> extends CommandArguments {
    protected NodeType: typeof KillCommandNode;
    /**
     * Kills entities (players, mobs, items, etc.).
     *
     * @param targets Specifies the target(s) to kill. If not specified, defaults to the executor who executed the command.
     */
    kill: (targets?: Macroable<MultipleEntitiesArgument<MACRO>, MACRO>) => import("../../helpers.js").FinalCommandOutput;
}
