import { CommandNode } from 'sandstone/core/nodes';
import { CommandArguments } from '../../helpers.js';
import type { SingleEntityArgument } from 'sandstone/arguments';
import type { Macroable } from 'sandstone/core';
export declare class RideCommandNode extends CommandNode {
    command: "ride";
}
export declare class RideArgumentsCommand<MACRO extends boolean> extends CommandArguments {
    /**
     * Adds the target as a passenger of the mount.
     *
     * @param target Specifies the mount.
     */
    mount: (target: Macroable<SingleEntityArgument<MACRO>, MACRO>) => import("../../helpers.js").FinalCommandOutput;
    /**
     * Dismounts the target if it is mounted.
     */
    dismount: () => import("../../helpers.js").FinalCommandOutput;
}
export declare class RideCommand<MACRO extends boolean> extends CommandArguments {
    protected NodeType: typeof RideCommandNode;
    /**
     * Mounts or dismounts an individual entity
     *
     * @param target Specifies the command's target.
     */
    ride: (target: Macroable<SingleEntityArgument<MACRO>, MACRO>) => RideArgumentsCommand<boolean>;
}
