import { CommandNode } from 'sandstone/core/nodes';
import { targetParser } from 'sandstone/variables/parsers';
import { CommandArguments } from '../../helpers.js';
export class RideCommandNode extends CommandNode {
    command = 'ride';
}
export class RideArgumentsCommand extends CommandArguments {
    /**
     * Adds the target as a passenger of the mount.
     *
     * @param target Specifies the mount.
     */
    mount = (target) => this.finalCommand(['mount', targetParser(target)]);
    /**
     * Dismounts the target if it is mounted.
     */
    dismount = () => this.finalCommand(['dismount']);
}
export class RideCommand extends CommandArguments {
    NodeType = RideCommandNode;
    /**
     * Mounts or dismounts an individual entity
     *
     * @param target Specifies the command's target.
     */
    ride = (target) => this.subCommand([targetParser(target)], RideArgumentsCommand, false);
}
