import { CommandNode } from 'sandstone/core/nodes';
import { CommandArguments } from '../../helpers.js';
import type { Coordinates, ENTITY_TYPES, RootNBT } from 'sandstone/arguments';
import type { Macroable } from 'sandstone/core';
import type { LiteralUnion } from 'sandstone/utils';
export declare class SummonCommandNode extends CommandNode {
    command: "summon";
}
export declare class SummonCommand<MACRO extends boolean> extends CommandArguments {
    protected NodeType: typeof SummonCommandNode;
    /**
     * Summons an entity.
     *
     * @param entity Specifies the entity to be summoned.
     *
     * @param pos Specifies the position to summon the entity. If not specified, defaults to the position of the command's execution.
     *
     * @param nbt Specifies the data tag for the entity.
     */
    summon: (entity: Macroable<LiteralUnion<ENTITY_TYPES>, MACRO>, pos?: Macroable<Coordinates<MACRO>, MACRO>, nbt?: Macroable<RootNBT, MACRO>) => import("../../helpers.js").FinalCommandOutput;
}
