import { CommandNode } from 'sandstone/core/nodes';
import { nbtStringifier } from 'sandstone/variables/nbt/NBTs';
import { coordinatesParser } from 'sandstone/variables/parsers';
import { CommandArguments } from '../../helpers.js';
export class SummonCommandNode extends CommandNode {
    command = 'summon';
}
export class SummonCommand extends CommandArguments {
    NodeType = SummonCommandNode;
    /**
     * Summons an entity.
     *
     * @param entity Specifies the entity to be summoned.
     *
     * @param pos Specifies the position to summon the entity. If not specified, defaults to the position of the command's execution.
     *
     * @param nbt Specifies the data tag for the entity.
     */
    summon = (entity, pos, nbt) => this.finalCommand([entity, coordinatesParser(pos), (!nbt || (typeof nbt === 'object' && nbt.toMacro)) ? nbt : nbtStringifier(nbt)]);
}
