"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var tag_exports = {};
__export(tag_exports, {
  TagArgumentsCommand: () => TagArgumentsCommand,
  TagCommand: () => TagCommand,
  TagCommandNode: () => TagCommandNode
});
module.exports = __toCommonJS(tag_exports);
var import_nodes = require("sandstone/core/nodes");
var import_parsers = require("sandstone/variables/parsers");
var import_helpers = require("../../helpers.js");
function checkTagName(tag) {
  if (typeof tag !== "string") {
    return tag;
  }
  if (!tag.match(/[A-Za-z0-9\-_+.]/g)) {
    throw new Error(`Invalid tag name "${tag}": Valid characters are uppercase and lowercase letters, numbers, hyphen, underscore, plus sign and period.`);
  }
  return tag;
}
class TagCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "tag");
  }
}
class TagArgumentsCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    /**
     * Adds a tag to the targets.
     *
     * @param name Specifies the name of the tag to be added into the targets.
     * Valid characters are uppercase and lowercase letters, numbers, hyphen, underscore, plus sign and period.
     */
    __publicField(this, "add", (name) => this.finalCommand(["add", checkTagName(name)]));
    /**
     * Lists all tags on the targets.
     */
    __publicField(this, "list", () => this.finalCommand(["list"]));
    /**
     * Removes a tag from the targets.
     *
     * @param name Specifies the name of the tag to be removed from the targets.
     * Valid characters are uppercase and lowercase letters, numbers, hyphen, underscore, plus sign and period.
     */
    __publicField(this, "remove", (name) => this.finalCommand(["remove", checkTagName(name)]));
  }
}
class TagCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", TagCommandNode);
    /**
     * Controls scoreboard tags on individual entities.
     *
     * In Java Edition, the number of tags owned by an entity cannot exceed 1024.
     *
     * @param targets Specifies the command's target.
     */
    __publicField(this, "tag", (targets) => this.subCommand([(0, import_parsers.targetParser)(targets)], TagArgumentsCommand, false));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TagArgumentsCommand,
  TagCommand,
  TagCommandNode
});
//# sourceMappingURL=tag.cjs.map