"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var team_exports = {};
__export(team_exports, {
  TeamCommand: () => TeamCommand,
  TeamCommandNode: () => TeamCommandNode
});
module.exports = __toCommonJS(team_exports);
var import_nodes = require("sandstone/core/nodes");
var import_JSONTextComponentClass = require("sandstone/variables/JSONTextComponentClass");
var import_parsers = require("sandstone/variables/parsers");
var import_helpers = require("../../helpers.js");
class TeamCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "team");
  }
}
class TeamCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", TeamCommandNode);
    /**
     * Creates a new team.
     *
     * @param team Specifies the name of the team.
     *
     * @param displayName Specifies the team name to be displayed.
     */
    __publicField(this, "add", (team, displayName) => this.finalCommand(["add", team, (0, import_JSONTextComponentClass.parseJSONText)(displayName)]));
    /**
     * Removes all members from a team.
     *
     * @param team Specifies the name of the team.
     */
    __publicField(this, "empty", (team) => this.finalCommand(["empty", team]));
    /**
     * Makes specified entities join a team.
     *
     * @param team Specifies the name of the team.
     *
     * @param members Specifies the entities to join the team.
     * `'*'` may be used to represent all entities tracked by the scoreboard
     * If unspecified, defaults to the executor.
     */
    __publicField(this, "join", (team, members) => this.finalCommand(["join", team, (0, import_parsers.targetParser)(members)]));
    /**
     * Makes specified entities leave a team.
     *
     * @param members Specifies the entities to leave the team.
     * `'*'` may be used to represent all entities tracked by the scoreboard
     */
    __publicField(this, "leave", (members) => this.finalCommand(["leave", (0, import_parsers.targetParser)(members)]));
    /**
     * Lists all teams, or lists all members of a team if `team` is set.
     *
     * @param team Specifies the name of the team.
     */
    __publicField(this, "list", (team) => this.finalCommand(["list", (0, import_parsers.targetParser)(team)]));
    __publicField(this, "modify", (...args) => this.finalCommand(["modify", ...args]));
    /**
     * Removes a team.
     *
     * @param team Specifies the name of the team.
     */
    __publicField(this, "remove", (team) => this.finalCommand(["remove", team]));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TeamCommand,
  TeamCommandNode
});
//# sourceMappingURL=team.cjs.map