"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var teleport_exports = {};
__export(teleport_exports, {
  TeleportCommand: () => TeleportCommand,
  TeleportCommandNode: () => TeleportCommandNode,
  TeleportFacingCommand: () => TeleportFacingCommand
});
module.exports = __toCommonJS(teleport_exports);
var import_nodes = require("sandstone/core/nodes");
var import_Coordinates = require("sandstone/variables/Coordinates");
var import_parsers = require("sandstone/variables/parsers");
var import_helpers = require("../../helpers.js");
class TeleportCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "tp");
  }
}
class TeleportFacingCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    /**
     * Specifies the coordinates to make the target(s) facing to.
     * May use tilde and caret notation to specify a position relative to the position where the command is executed.
     */
    __publicField(this, "facing", (location) => this.finalCommand(["facing", (0, import_parsers.coordinatesParser)(location)]));
    /**
     * Specifies the entity to make the target(s) facing to.
     *
     * @param entity Must be a player name, a target selector, or a UUID‌.
     *             Permits entity other than players.
     *
     * @param anchor Specifies whether the entity'eyes or feet to make the target(s) facing to.
     *             Must be one of eyes and feet. If not specified, defaults to eyes.
     */
    __publicField(this, "facingEntity", (entity, anchor) => this.finalCommand(["facing", (0, import_parsers.targetParser)(entity), anchor]));
  }
}
class TeleportCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", TeleportCommandNode);
    __publicField(this, "tp", (...args) => {
      const parsedArgs = [...args.slice(0, 3).map(import_parsers.coordinatesParser), ...args.slice(3).map(import_parsers.targetParser)];
      if (parsedArgs.length === 2 && (parsedArgs[1] instanceof import_Coordinates.VectorClass || typeof parsedArgs[1] === "string")) {
        return this.subCommand(parsedArgs, TeleportFacingCommand, true);
      }
      return this.finalCommand(parsedArgs);
    });
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TeleportCommand,
  TeleportCommandNode,
  TeleportFacingCommand
});
//# sourceMappingURL=teleport.cjs.map