"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var bossbar_exports = {};
__export(bossbar_exports, {
  BossBarCommand: () => BossBarCommand,
  BossBarCommandNode: () => BossBarCommandNode,
  BossBarSetCommand: () => BossBarSetCommand
});
module.exports = __toCommonJS(bossbar_exports);
var import_nodes = require("sandstone/core/nodes");
var import_JSONTextComponentClass = require("sandstone/variables/JSONTextComponentClass");
var import_parsers = require("sandstone/variables/parsers");
var import_helpers = require("../../helpers.js");
class BossBarCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "bossbar");
  }
}
class BossBarCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", BossBarCommandNode);
    /**
     * Create a new boss bar.
     *
     * @param id Specifies a unique boss bar. Has the form of Namespaced ID (Note: "namespace:" defaults to "minecraft:" if absent.)
     *
     * @param name The display name of the boss bar.
     */
    __publicField(this, "add", (id, name) => this.finalCommand(["add", id, (0, import_JSONTextComponentClass.parseJSONText)(name)]));
    /**
     * Return the requested setting as a result of the command.
     *
     * @param id Specifies a unique boss bar. Has the form of Namespaced ID (Note: "namespace:" defaults to "minecraft:" if absent.)
     */
    __publicField(this, "get", (id, setting) => this.finalCommand(["get", id, setting]));
    /**
     * Display a list of existing boss bars.
     */
    __publicField(this, "list", () => this.finalCommand(["list"]));
    /**
     * Remove an existing bossbar.
     *
     * @param id Specifies a unique boss bar. Has the form of Namespaced ID (Note: "namespace:" defaults to "minecraft:" if absent.)
     */
    __publicField(this, "remove", (id) => this.finalCommand(["remove", id]));
    /**
     * Set some bossbar options.
     *
     * @param id Specifies a unique boss bar. Has the form of Namespaced ID (Note: "namespace:" defaults to "minecraft:" if absent.)
     *
     * @example
     * bossbar.set('custom:mybossbar').color('red')
     */
    __publicField(this, "set", (id) => this.subCommand(["set", id], BossBarSetCommand, false));
  }
}
class BossBarSetCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    /**
     * Set the text color (if no color was specified as part of a text component) and bar color.
     * Defaults to `white` upon creation.
     *
     * @param color The new color.
     */
    __publicField(this, "color", (color) => this.finalCommand(["color", color]));
    /**
     * Set the boss bar's maximum value.
     * Defaults to `100` upon creation.
     *
     * @param max The new maximum value.
     */
    __publicField(this, "max", (max) => this.finalCommand(["max", max]));
    /**
     * Set the boss bar's name.
     *
     * @param name The new name.
     */
    __publicField(this, "name", (name) => this.finalCommand(["name", name]));
    /**
     * Change the set of players to whom the bar is visible.
     * Defaults to none upon creation.
     *
     * @param players The new players that will see the bossbar. If not specified, hide the bossbar to all players.
     */
    __publicField(this, "players", (players) => this.finalCommand(["players", (0, import_parsers.targetParser)(players)]));
    /**
     * Set the boss bar's visual amount of segments: continuous, 6 segments, 10 segments, 12 segments, or 20 segments.
     * Defaults to `progress` upon creation.
     *
     * @param style The new style.
     */
    __publicField(this, "style", (style) => this.finalCommand(["style", style]));
    /**
     * Set the boss bar's current value.
     * Defaults to `0` upon creation.
     *
     * @param value The new value.
     */
    __publicField(this, "value", (value) => this.finalCommand(["value", value]));
    /**
     * Set the boss bar's visibility.
     * Defaults to `true` upon creation.
     *
     * @param visible Whether the bossbar is visible or not.
     */
    __publicField(this, "visible", (visible) => this.finalCommand(["visible", visible]));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  BossBarCommand,
  BossBarCommandNode,
  BossBarSetCommand
});
//# sourceMappingURL=bossbar.cjs.map