"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var gamemode_exports = {};
__export(gamemode_exports, {
  GameModeCommand: () => GameModeCommand,
  GameModeCommandNode: () => GameModeCommandNode
});
module.exports = __toCommonJS(gamemode_exports);
var import_nodes = require("sandstone/core/nodes");
var import_parsers = require("sandstone/variables/parsers");
var import_helpers = require("../../helpers.js");
class GameModeCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "gamemode");
  }
}
class GameModeCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", GameModeCommandNode);
    /**
     * Sets a player's game mode.
     *
     * @param gamemode Specifies the new game mode. Must be one of the following:
     * - `survival` for survival mode
     * - `creative` for creative mode
     * - `adventure` for adventure mode
     * - `spectator` for spectator mode‌
     *
     * @param targets Specifies the target(s). If not specified, defaults to the player who executes the command.
     */
    __publicField(this, "gamemode", (gamemode, targets) => this.finalCommand([(0, import_parsers.targetParser)(gamemode), targets]));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  GameModeCommand,
  GameModeCommandNode
});
//# sourceMappingURL=gamemode.cjs.map