"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var playsound_exports = {};
__export(playsound_exports, {
  PlaySoundCommand: () => PlaySoundCommand,
  PlaySoundCommandNode: () => PlaySoundCommandNode
});
module.exports = __toCommonJS(playsound_exports);
var import_nodes = require("sandstone/core/nodes");
var import_parsers = require("sandstone/variables/parsers");
var import_helpers = require("../../helpers.js");
class PlaySoundCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "playsound");
  }
}
class PlaySoundCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", PlaySoundCommandNode);
    /**
     * Plays a specified sound at a player, in a location, and in a specific volume and pitch.
     *
     * @param sound Specifies the sound to play.
     *
     * A sound event may be affiliated with multiple sounds, and the sound that is actually produced is chosen at random from them,
     * modified by their "weight", just as the game normally would.
     * For example, the `entity.pig.ambient` sound event plays one of several pig sounds at random,
     * because the event has multiple sounds associated with it.
     *
     * Resource packs may add their own events to `sounds.json`; the command successfully plays these.
     * File names are not used by this command; it strictly uses the events defined in `sounds.json`
     * (which may not even be similar to the original file names and paths),
     * and thus a resource pack adding new sound files must define events for them
     * (this is not necessary when replacing old sounds already defined in events).
     *
     * @param source Specifies the music category and options the sound falls under.
     *
     * @param targets Specifies the sound's target.
     */
    __publicField(this, "playsound", (sound, source, targets, sourcePosition, volume, pitch, minVolume) => this.finalCommand([sound, source, (0, import_parsers.targetParser)(targets), (0, import_parsers.coordinatesParser)(sourcePosition), volume, pitch, minVolume]));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  PlaySoundCommand,
  PlaySoundCommandNode
});
//# sourceMappingURL=playsound.cjs.map