"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var recipe_exports = {};
__export(recipe_exports, {
  RecipeCommand: () => RecipeCommand,
  RecipeCommandNode: () => RecipeCommandNode
});
module.exports = __toCommonJS(recipe_exports);
var import_nodes = require("sandstone/core/nodes");
var import_parsers = require("sandstone/variables/parsers");
var import_helpers = require("../../helpers.js");
class RecipeCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "recipe");
  }
}
class RecipeCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", RecipeCommandNode);
    /**
     * Gives recipes to the player.
     *
     * @param targets Specifies the player(s) to give the recipe to.
     * @param recipe Specifies a recipe to give. If `*` is specified, then all recipes will be given.
     */
    __publicField(this, "give", (targets, recipe) => this.finalCommand(["give", (0, import_parsers.targetParser)(targets), recipe]));
    /**
     * Takes recipes to the player.
     *
     * @param targets Specifies the player(s) to take the recipe from.
     * @param recipe Specifies a recipe to take. If `*` is specified, then all recipes will be taken.
     */
    __publicField(this, "take", (targets, recipe) => this.finalCommand(["take", (0, import_parsers.targetParser)(targets), recipe]));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  RecipeCommand,
  RecipeCommandNode
});
//# sourceMappingURL=recipe.cjs.map