import { CommandNode } from 'sandstone/core/nodes';
import { targetParser } from 'sandstone/variables/parsers';
import { CommandArguments } from '../../helpers.js';
export class RecipeCommandNode extends CommandNode {
    command = 'recipe';
}
/** Gives or takes (unlocks or locks) recipes for players. */
export class RecipeCommand extends CommandArguments {
    NodeType = RecipeCommandNode;
    /**
     * Gives recipes to the player.
     *
     * @param targets Specifies the player(s) to give the recipe to.
     * @param recipe Specifies a recipe to give. If `*` is specified, then all recipes will be given.
     */
    give = (targets, recipe) => this.finalCommand(['give', targetParser(targets), recipe]);
    /**
     * Takes recipes to the player.
     *
     * @param targets Specifies the player(s) to take the recipe from.
     * @param recipe Specifies a recipe to take. If `*` is specified, then all recipes will be taken.
     */
    take = (targets, recipe) => this.finalCommand(['take', targetParser(targets), recipe]);
}
