"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var spawnpoint_exports = {};
__export(spawnpoint_exports, {
  SpawnPointCommand: () => SpawnPointCommand,
  SpawnPointCommandNode: () => SpawnPointCommandNode
});
module.exports = __toCommonJS(spawnpoint_exports);
var import_nodes = require("sandstone/core/nodes");
var import_parsers = require("sandstone/variables/parsers");
var import_helpers = require("../../helpers.js");
class SpawnPointCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "spawnpoint");
  }
}
class SpawnPointCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", SpawnPointCommandNode);
    /**
     * Sets the spawn point for a player. You can now set your spawnpoint in the Nether and End.
     *
     * @param targets Specifies the player whose spawn point should be set.
     * If not specified, defaults to the command's executor.
     *
     * @param pos Specifies the coordinates of the player's new spawn point.
     * If not specified, defaults to the position of the command's executor in Java Edition.
     *
     * @param angle Specifies the yaw angle to spawn with. Defaults to the direction the executor is facing.
     */
    __publicField(this, "spawnpoint", (targets, pos, angle) => this.finalCommand([(0, import_parsers.targetParser)(targets), (0, import_parsers.coordinatesParser)(pos), (0, import_parsers.coordinatesParser)(angle)]));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  SpawnPointCommand,
  SpawnPointCommandNode
});
//# sourceMappingURL=spawnpoint.cjs.map