import { CommandNode } from 'sandstone/core/nodes';
import { targetParser } from 'sandstone/variables/parsers';
import { CommandArguments } from '../../helpers.js';
export class SpectateCommandNode extends CommandNode {
    command = 'spectate';
}
export class SpectateCommand extends CommandArguments {
    NodeType = SpectateCommandNode;
    /**
     * Causes a player in Spectator mode to spectate another entity.
     *
     * @param targets Specifies the target to be spectated.
     *
     * @param player Specifies the spectating player. If unspecified, defaults to the executor.
     */
    spectate = (target, player) => this.finalCommand([targetParser(target), player]);
}
