import { CommandNode } from 'sandstone/core/nodes';
import { targetParser } from 'sandstone/variables/parsers';
import { CommandArguments } from '../../helpers.js';
export class StopSoundCommandNode extends CommandNode {
    command = 'stopsound';
}
export class StopSoundCommand extends CommandArguments {
    NodeType = StopSoundCommandNode;
    /**
     * Stops a given sound.
     *
     * @param targets Specifies the command's target.
     *
     * @param source Specifies which category in the Music & Sound options the sound falls under. If it is *, stop sound of all category.
     *
     * @param sound Specifies the sound to stop.
     */
    stopsound = (targets, source, sound) => this.finalCommand([targetParser(targets), source, sound]);
}
