"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var title_exports = {};
__export(title_exports, {
  TitleArgumentsCommand: () => TitleArgumentsCommand,
  TitleCommand: () => TitleCommand,
  TitleCommandNode: () => TitleCommandNode
});
module.exports = __toCommonJS(title_exports);
var import_nodes = require("sandstone/core/nodes");
var import_JSONTextComponentClass = require("sandstone/variables/JSONTextComponentClass");
var import_parsers = require("sandstone/variables/parsers");
var import_helpers = require("../../helpers.js");
class TitleCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "title");
  }
}
class TitleArgumentsCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "clear", () => this.finalCommand(["clear"]));
    __publicField(this, "reset", () => this.finalCommand(["reset"]));
    __publicField(this, "title", (title) => this.finalCommand(["title", (0, import_JSONTextComponentClass.parseJSONText)(title)]));
    __publicField(this, "subtitle", (subtitle) => this.finalCommand(["subtitle", (0, import_JSONTextComponentClass.parseJSONText)(subtitle)]));
    __publicField(this, "actionbar", (actionbarText) => this.finalCommand(["actionbar", (0, import_JSONTextComponentClass.parseJSONText)(actionbarText)]));
    __publicField(this, "times", (fadeIn, stay, fadeOut) => this.finalCommand(["times", fadeIn, stay, fadeOut]));
  }
}
class TitleCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", TitleCommandNode);
    /**
     * Controls text displayed on the screen.
     *
     * @param targets Specifies the player(s) to display a screen title to.
     *
     * @example
     * // Displays a red "Hello World" as title
     * title('@a').title([{text: 'Hello World', color: 'red'}])
     *
     * // Displays a target to kill in the actionbar
     * const target = Selector('@r')
     * title('@a').actionbar(['You target is: ', target])
     */
    __publicField(this, "title", (targets) => this.subCommand([(0, import_parsers.targetParser)(targets)], TitleArgumentsCommand, false));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TitleArgumentsCommand,
  TitleCommand,
  TitleCommandNode
});
//# sourceMappingURL=title.cjs.map