"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var datapack_exports = {};
__export(datapack_exports, {
  DataPackCommand: () => DataPackCommand,
  DataPackCommandNode: () => DataPackCommandNode,
  DataPackEnableCommand: () => DataPackEnableCommand
});
module.exports = __toCommonJS(datapack_exports);
var import_nodes = require("sandstone/core/nodes");
var import_helpers = require("../../helpers.js");
class DataPackCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "datapack");
  }
}
class DataPackEnableCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    /**
     * Load this pack before all others. It will have the lowest priority.
     */
    __publicField(this, "first", () => this.finalCommand(["first"]));
    /**
     * Load this pack after all others. It will have the highest priority.
     */
    __publicField(this, "last", () => this.finalCommand(["last"]));
    /**
     * Load this pack just before an existing pack.
     * It will have a lower priority than the existing one.
     *
     * @param name The name of the existing datapack.
     */
    __publicField(this, "before", (name) => this.finalCommand(["before", name]));
    /**
     * Load this pack just after an existing pack.
     * It will have a higher priority than the existing one.
     *
     * @param name The name of the existing datapack.
     */
    __publicField(this, "after", (name) => this.finalCommand(["after", name]));
  }
}
class DataPackCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", DataPackCommandNode);
    /**
     * Disable the specified pack.
     *
     * @param name Specifies the name of the datapack.
     */
    __publicField(this, "disable", (name) => this.finalCommand([name]));
    /**
     * Enable the specified pack.
     *
     * @param name Specifies the name of the datapack.
     *
     * @example
     *
     * // Enable `myDatapack`, and give it the highest priority
     * datapack.enable('myDatapack').last()
     *
     * // Enable `myDatapack`, just before `importantDatapack`.
     * // `mydatapack` will have a lower priority.
     * datapack.enable('myDatapack').before('importantDatapack')
     */
    __publicField(this, "enable", (name) => this.subCommand(["enable", name], DataPackEnableCommand, false));
    /**
     * List all datapacks, or list only the available/enabled ones.
     *
     * Hovering over the datapacks in the chat output shows their description defined in their pack.mcmeta.
     *
     * @param typ `"available"` to only show available datapacks, `"enabled"` to only show enabled ones.
     */
    __publicField(this, "list", (type) => this.finalCommand(["list", type]));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DataPackCommand,
  DataPackCommandNode,
  DataPackEnableCommand
});
//# sourceMappingURL=datapack.cjs.map