import { CommandNode } from 'sandstone/core/nodes';
import { CommandArguments } from '../../helpers.js';
export declare class DebugCommandNode extends CommandNode {
    command: "debug";
}
/**
 * Starts or stops a debugging session.
 * While active, includes notifications about potential performance bottlenecks in the console.
 * When stopped, creates a profiler results file in the folder `debug`.
 */
export declare class DebugCommand extends CommandArguments {
    protected NodeType: typeof DebugCommandNode;
    /** Starts a new debug profiling session. */
    start: () => import("../../helpers.js").FinalCommandOutput;
    /** Stops the active debug profiling session. */
    stop: () => import("../../helpers.js").FinalCommandOutput;
    /**
     * Used to get more detailed information while debugging performance.
     * Saves information in the `.minecraft\debug` folder in the form of a zip file.
     */
    report: () => import("../../helpers.js").FinalCommandOutput;
}
