import { CommandNode } from 'sandstone/core/nodes';
import { CommandArguments } from '../../helpers.js';
import type { DIFFICULTIES } from 'sandstone/arguments';
export declare class DifficultyCommandNode extends CommandNode {
    command: "difficulty";
}
export declare class DifficultyCommand extends CommandArguments {
    protected NodeType: typeof DifficultyCommandNode;
    /**
     * Sets the new difficulty level. Must be one of the following:
     * - `peaceful` for peaceful difficulty
     * - `easy` for easy difficulty
     * - `normal` for normal difficulty
     * - `hard` for hard difficulty
     *
     * If unspecified, querys current difficulty rather than changes it.‌
     */
    difficulty: (difficulty?: DIFFICULTIES) => import("../../helpers.js").FinalCommandOutput;
}
