import { CommandNode } from 'sandstone/core/nodes';
import { TagClass } from 'sandstone/core/resources/datapack/tag';
import { CommandArguments } from '../../helpers.js';
import type { RootNBT } from 'sandstone/arguments/nbt.js';
import type { DataPointPickClass, Macroable, MCFunctionClass } from 'sandstone/core';
import type { DATA_TYPES, DataPointClass } from 'sandstone/variables';
import type { FinalCommandOutput } from '../../helpers.js';
export declare class FunctionCommandNode extends CommandNode<[string | MCFunctionClass<any, any>]> {
    command: "function";
}
type Func = MCFunctionClass<undefined, undefined> | string | TagClass<'functions'>;
export declare class FunctionCommand<MACRO extends boolean> extends CommandArguments {
    protected NodeType: typeof FunctionCommandNode;
    function(mcFunction: Macroable<Func, MACRO>): FinalCommandOutput;
    function(mcFunction: Macroable<Func, MACRO>, params: Macroable<RootNBT, MACRO>): FinalCommandOutput;
    function(mcFunction: Macroable<Func, MACRO>, _: 'with', type: DATA_TYPES, target: string, path: string): FinalCommandOutput;
    function(mcFunction: Macroable<Func, MACRO>, _: 'with', dataPoint: DataPointClass | DataPointPickClass): FinalCommandOutput;
}
export {};
