import { CommandNode } from 'sandstone/core/nodes';
import { TagClass } from 'sandstone/core/resources/datapack/tag';
import { nbtStringifier } from 'sandstone/variables/nbt/NBTs';
import { CommandArguments } from '../../helpers.js';
// Function command
export class FunctionCommandNode extends CommandNode {
    command = 'function';
}
export class FunctionCommand extends CommandArguments {
    NodeType = FunctionCommandNode;
    function(mcFunction, params, pointOrType, target, path) {
        const args = [];
        if (params) {
            if (params === 'with' && pointOrType) {
                args.push('with');
                if (typeof pointOrType === 'string') {
                    args.push(pointOrType, target, path);
                }
                else {
                    const point = (Object.hasOwn(pointOrType, '_toDataPoint') ? pointOrType._toDataPoint : pointOrType);
                    args.push(point.type, point.currentTarget, point.path);
                }
            }
            else {
                args.push(typeof params === 'object' && params.toMacro ? params : nbtStringifier(params));
            }
        }
        return this.finalCommand([mcFunction instanceof TagClass ? `#${mcFunction}` : mcFunction, ...args]);
    }
}
