import { CommandNode } from 'sandstone/core/nodes';
import { CommandArguments } from '../../helpers.js';
export declare class HelpCommandNode extends CommandNode {
    command: "help";
}
export declare class HelpCommand extends CommandArguments {
    protected NodeType: typeof HelpCommandNode;
    /**
     * Shows usages for one command, or lists of commands.
     *
     * @param command_ Specifies the command name to provide help for.
     * Entering more specific parameters of that command is allowed.
     *
     * If unspecified, lists all commands.
     *
     * @param parameters More specific parameters of the command.
     */
    help: (command?: string, ...parameters: string[]) => import("../../helpers.js").FinalCommandOutput;
}
