import { CommandNode } from 'sandstone/core/nodes';
import { CommandArguments } from '../../helpers.js';
export class HelpCommandNode extends CommandNode {
    command = 'help';
}
export class HelpCommand extends CommandArguments {
    NodeType = HelpCommandNode;
    /**
     * Shows usages for one command, or lists of commands.
     *
     * @param command_ Specifies the command name to provide help for.
     * Entering more specific parameters of that command is allowed.
     *
     * If unspecified, lists all commands.
     *
     * @param parameters More specific parameters of the command.
     */
    help = (command, ...parameters) => this.finalCommand([command, ...parameters]);
}
