import { CommandNode } from 'sandstone/core/nodes';
import { CommandArguments } from '../../helpers.js';
import type { MultipleEntitiesArgument } from 'sandstone/arguments';
export declare class MeCommandNode extends CommandNode<[string[]]> {
    command: "me";
    getValue(): string;
}
export declare class MeCommand extends CommandArguments {
    protected NodeType: typeof MeCommandNode;
    /**
     * Displays a message about yourself.
     *
     * @param actions Specifies the messages to display. They will be joined with a whitespace.
     *
     * Each action can be a message or a selector.
     * The game replaces entity selectors in the message with the list of selected entities' names,
     * which is formatted as "name1 and name2" for two entities, or "name1, name2, ... and namen" for n entities.
     */
    me: (...actions: (string | MultipleEntitiesArgument<false>)[]) => import("../../helpers.js").FinalCommandOutput;
}
