"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var random_exports = {};
__export(random_exports, {
  RandomCommand: () => RandomCommand,
  RandomCommandNode: () => RandomCommandNode
});
module.exports = __toCommonJS(random_exports);
var import_nodes = require("sandstone/core/nodes");
var import_parsers = require("sandstone/variables/parsers");
var import_helpers = require("../../helpers.js");
class RandomCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "random");
  }
}
class RandomCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", RandomCommandNode);
    /**
     * Generate a random integer.
     *
     * @param range Integer between minimum and maximum.
     * @param sequence Namespaced ID of random sequence to use, created upon use.
     */
    __publicField(this, "value", (range, sequence) => {
      let seq = sequence;
      if (typeof sequence === "string" && !sequence.includes(":")) {
        seq = `${this.sandstonePack.defaultNamespace}:${seq}`;
      }
      return this.finalCommand(["value", (0, import_parsers.rangeParser)(this.sandstoneCore, range), seq]);
    });
    /**
     * Generate a random integer and broadcasts it to all players.
     *
     * @param range Integer between minimum and maximum.
     * @param sequence Optional. Namespaced ID of random sequence to use, created upon use.
     */
    __publicField(this, "roll", (range, sequence) => {
      let seq = sequence;
      if (sequence && typeof sequence === "string" && !sequence.includes(":")) {
        seq = `${this.sandstonePack.defaultNamespace}:${seq}`;
      }
      return this.finalCommand(["roll", (0, import_parsers.rangeParser)(this.sandstoneCore, range), seq]);
    });
    /**
     * Reset a random number sequence.
     *
     * @param sequence Namespaced ID of random sequence to reset, created if non-existent.
     * @param seed Optional. Long that seeds the new sequence.
     * @param includeWorldSeed Optional. Whether to include the world seed in the random. Defaults to false.
     * @param includeSequenceID Optional. Whether to include the sequence ID in the random. Defaults to false.
     * @returns
     */
    __publicField(this, "reset", (sequence, seed, includeWorldSeed, includeSequenceID) => {
      let seq = sequence;
      if (sequence && typeof sequence === "string" && !sequence.includes(":")) {
        seq = `${this.sandstonePack.defaultNamespace}:${seq}`;
      }
      return this.finalCommand(["reset", seq, seed, includeWorldSeed, includeSequenceID]);
    });
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  RandomCommand,
  RandomCommandNode
});
//# sourceMappingURL=random.cjs.map