"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var return_exports = {};
__export(return_exports, {
  ReturnArgumentsCommand: () => ReturnArgumentsCommand,
  ReturnCommand: () => ReturnCommand,
  ReturnCommandNode: () => ReturnCommandNode,
  ReturnRunCommandNode: () => ReturnRunCommandNode
});
module.exports = __toCommonJS(return_exports);
var import_nodes = require("sandstone/core/nodes");
var import_utils = require("sandstone/utils");
var import_helpers = require("../../helpers.js");
var import_function = require("./function.js");
class ReturnRunCommandNode extends import_nodes.ContainerCommandNode {
  constructor(sandstonePack, args = [], {
    isSingleExecute = true,
    body = []
  } = {}) {
    super(sandstonePack, ...args);
    __publicField(this, "command", "return");
    /**
     * By default, the execute is treated as single (execute.run.stuff).
     * This is set to `false` if the execute is used as a function (execute.run(() => { stuff })).
     */
    __publicField(this, "isSingleExecute");
    __publicField(this, "getValue", () => {
      if (this.body.length > 1) {
        throw new Error("Return run nodes can only have one child node when toString is called.");
      }
      let command = this.body[0].getValue();
      if (command.startsWith("$")) {
        this.isMacro = true;
        command = command.slice(1);
      }
      return `${this.isMacro ? "$" : ""}${this.command} run ${command}`;
    });
    __publicField(this, "createMCFunction", (currentMCFunction) => {
      if (this.isSingleExecute || !currentMCFunction) {
        return { node: this };
      }
      const namespace = currentMCFunction.resource.name.includes(":") ? `${currentMCFunction.resource.name.split(":")[0]}:` : "";
      const mcFunction = this.sandstonePack.MCFunction(`${namespace}${currentMCFunction.resource.path.slice(2).join("/")}/return_run`, {
        addToSandstoneCore: false,
        creator: "sandstone",
        onConflict: "rename"
      });
      const mcFunctionNode = mcFunction["node"];
      mcFunctionNode.body = this.body;
      const mcFunctionCall = new import_function.FunctionCommandNode(this.sandstonePack, mcFunction);
      this.body = [mcFunctionCall];
      return { node: this, mcFunction: mcFunctionNode };
    });
    __publicField(this, "append", (...nodes) => {
      for (const node of nodes) {
        this.body.push(node);
        if (this.isSingleExecute) {
          this.sandstoneCore.getCurrentMCFunctionOrThrow().exitContext();
        }
      }
      return nodes.length === 1 ? nodes[0] : nodes;
    });
    this.isSingleExecute = isSingleExecute;
    this.append(...body);
  }
}
class ReturnArgumentsCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", ReturnRunCommandNode);
    __publicField(this, "fail", () => this.finalCommand(["fail"]));
  }
  /*
   * Run a command and return its result.
   */
  get run() {
    const node = this.getNode();
    const commands = new Proxy(this.sandstonePack.commands, {
      get: (target, p, receiver) => {
        this.sandstoneCore.getCurrentMCFunctionOrThrow().enterContext(node);
        return this.sandstonePack.commands[p];
      }
    });
    return (0, import_utils.makeCallable)(commands, (callback) => {
      node.isSingleExecute = false;
      this.sandstoneCore.insideContext(node, callback, true);
      return new import_helpers.FinalCommandOutput(node);
    }, true);
  }
}
class ReturnCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "return");
  }
}
class ReturnCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", ReturnCommandNode);
  }
  get return() {
    const run = new ReturnArgumentsCommand(this.sandstonePack);
    return (0, import_utils.makeCallable)(run, (value) => this.finalCommand([value || 0]), true);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ReturnArgumentsCommand,
  ReturnCommand,
  ReturnCommandNode,
  ReturnRunCommandNode
});
//# sourceMappingURL=return.cjs.map