import { CommandNode, ContainerCommandNode } from 'sandstone/core/nodes';
import { CommandArguments, FinalCommandOutput } from '../../helpers.js';
import type { SandstonePack } from 'sandstone';
import type { SandstoneCommands } from 'sandstone/commands';
import type { Macroable, MCFunctionNode } from 'sandstone/core';
import type { Node } from 'sandstone/core/nodes';
export declare class ReturnRunCommandNode extends ContainerCommandNode {
    command: "return";
    /**
     * By default, the execute is treated as single (execute.run.stuff).
     * This is set to `false` if the execute is used as a function (execute.run(() => { stuff })).
     */
    isSingleExecute: boolean;
    constructor(sandstonePack: SandstonePack, args?: [...args: unknown[]], { isSingleExecute, body, }?: {
        isSingleExecute?: boolean | undefined;
        body?: Node[] | undefined;
    });
    getValue: () => string;
    createMCFunction: (currentMCFunction: MCFunctionNode | null) => {
        node: ReturnRunCommandNode;
        mcFunction?: undefined;
    } | {
        node: ReturnRunCommandNode;
        mcFunction: MCFunctionNode;
    };
    append: (...nodes: Node[]) => any;
}
export declare class ReturnArgumentsCommand<MACRO extends boolean> extends CommandArguments<typeof ReturnRunCommandNode> {
    protected NodeType: typeof ReturnRunCommandNode;
    get run(): SandstoneCommands<MACRO> & ((callback: () => any) => FinalCommandOutput);
    fail: () => FinalCommandOutput;
}
export declare class ReturnCommandNode extends CommandNode {
    command: "return";
}
export declare class ReturnCommand<MACRO extends boolean> extends CommandArguments {
    protected NodeType: typeof ReturnCommandNode;
    get return(): ReturnArgumentsCommand<MACRO> & ((value?: Macroable<number, MACRO>) => FinalCommandOutput);
}
