"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var trigger_exports = {};
__export(trigger_exports, {
  TriggerArgumentsCommand: () => TriggerArgumentsCommand,
  TriggerCommand: () => TriggerCommand,
  TriggerCommandNode: () => TriggerCommandNode
});
module.exports = __toCommonJS(trigger_exports);
var import_nodes = require("sandstone/core/nodes");
var import_helpers = require("../../helpers.js");
class TriggerCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "trigger");
  }
}
class TriggerArgumentsCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    /**
     * Adds `value` to the current value of `objective`.
     *
     * @param value the value to add.
     */
    __publicField(this, "add", (value) => this.finalCommand(["add", value]));
    /**
     * Sets the value of `objective` to `value`.
     *
     * @param value the new value.
     */
    __publicField(this, "set", (value) => this.finalCommand(["set", value]));
  }
}
class TriggerCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", TriggerCommandNode);
    /**
     * Modifies a scoreboard objective with a "trigger" criterion.
     * Allows non-operator players to modify their own scoreboard objectives under tightly controlled conditions.
     * Often used to let players activate systems made by operators or mapmakers.
     *
     * @param objective An enabled scoreboard objective with the "trigger" criterion.
     *
     * @example
     *
     * // Adds 1 to the current value of `myobjective`.
     * trigger('myobjective')
     *
     * // Adds 2 to the current value of `objective`
     * trigger('myobjective').add(2)
     *
     * // Sets the value of `objective` to 5
     * trigger('myobjective').set(5)
     *
     * // If you created an objective via createObjective, and it is enabled, you can use it:
     * trigger(myObjective).add(2)
     */
    __publicField(this, "trigger", (objective) => this.subCommand([objective], TriggerArgumentsCommand, false));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TriggerArgumentsCommand,
  TriggerCommand,
  TriggerCommandNode
});
//# sourceMappingURL=trigger.cjs.map