"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var item_exports = {};
__export(item_exports, {
  ItemCommand: () => ItemCommand,
  ItemCommandNode: () => ItemCommandNode,
  ItemSourceCommand: () => ItemSourceCommand
});
module.exports = __toCommonJS(item_exports);
var import_nodes = require("sandstone/core/nodes");
var import_parsers = require("sandstone/variables/parsers");
var import_helpers = require("../../helpers.js");
class ItemCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "item");
  }
}
class ItemSourceCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    /**
     * Replace the slot with a specific item.
     * @param item The item to replace the slot with.
     * @param count The amount of items.
     */
    __publicField(this, "with", (item, count) => this.finalCommand(["with", item, count]));
    __publicField(this, "from", {
      /**
       * @param pos The coordinates of the container to copy items from.
       * @param slot The slot to copy the items from.
       * @param [modifier] An optional modifier to apply.
       */
      block: (pos, slot, modifier) => this.finalCommand(["from", "block", pos, slot, modifier]),
      /**
       * @param targets The entity to copy items from.
       * @param slot The slot to copy the items from.
       * @param [modifier] An optional modifier to apply.
       */
      entity: (targets, slot, modifier) => this.finalCommand(["from", "entity", (0, import_parsers.targetParser)(targets), slot, modifier])
    });
  }
}
class ItemCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", ItemCommandNode);
    /** Applies a modifier to a slot in an inventory. */
    __publicField(this, "modify", {
      /**
       * @param pos The position of the container containing the slot to apply the modifier to.
       * @param slot The slot to apply the modifier to.
       * @param modifier The name of the modifier.
       */
      block: (pos, slot, modifier) => this.finalCommand(["modify", "block", (0, import_parsers.coordinatesParser)(pos), slot, modifier]),
      /**
       * @param targets The entity/entities containing the slot to apply the modifier to.
       * @param slot The slot to apply the modifier to.
       * @param modifier The name of the modifier.
       */
      entity: (targets, slot, modifier) => this.finalCommand(["modify", "entity", (0, import_parsers.targetParser)(targets), slot, modifier])
    });
    /** Replaces the content of a specific slot of an inventory with another. */
    __publicField(this, "replace", {
      /**
       * @param pos The position of the container containing the slot to be replaced.
       * @param slot The slot to be replaced.
       */
      block: (pos, slot) => this.subCommand(["block", pos, slot], ItemSourceCommand, false),
      /**
       * @param targets one or more entities to modify.
       *.
       * @param slot The slot to be replaced.
       */
      entity: (targets, slot) => this.subCommand(["entity", (0, import_parsers.targetParser)(targets), slot], ItemSourceCommand, false)
    });
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ItemCommand,
  ItemCommandNode,
  ItemSourceCommand
});
//# sourceMappingURL=item.cjs.map