import { CommandNode } from 'sandstone/core/nodes';
import { CommandArguments } from '../../helpers.js';
import type { POINT_OF_INTEREST_TYPES, WORLDGEN_BIOMES, WORLDGEN_STRUCTURES } from 'sandstone/arguments';
import type { LiteralUnion } from 'sandstone/utils';
import type { Macroable } from 'sandstone/core';
export declare class LocateCommandNode extends CommandNode {
    command: "locate";
}
export declare class LocateCommand<MACRO extends boolean> extends CommandArguments {
    protected NodeType: typeof LocateCommandNode;
    /**
     * Displays the coordinates for the closest generated structure of a given type.
     *
     * @param structure Specifies the structure to locate.
     */
    structure: (structure: Macroable<LiteralUnion<WORLDGEN_STRUCTURES>, MACRO>) => import("../../helpers.js").FinalCommandOutput;
    /**
     * Displays the coordinates for the closest generated biome of a given type.
     *
     * @param biome Specifies the biome to locate.
     */
    biome: (biome: Macroable<LiteralUnion<WORLDGEN_BIOMES>, MACRO>) => import("../../helpers.js").FinalCommandOutput;
    /**
     * Displays the coordinates for the closest generated point of interest of a given type.
     *
     * @param pointOfInterest Specifies the point of interest to locate.
     */
    poi: (pointOfInterest: Macroable<LiteralUnion<POINT_OF_INTEREST_TYPES>, MACRO>) => import("../../helpers.js").FinalCommandOutput;
}
