import { CommandNode } from 'sandstone/core/nodes';
import { CommandArguments } from '../../helpers.js';
export class LocateCommandNode extends CommandNode {
    command = 'locate';
}
export class LocateCommand extends CommandArguments {
    NodeType = LocateCommandNode;
    /**
     * Displays the coordinates for the closest generated structure of a given type.
     *
     * @param structure Specifies the structure to locate.
     */
    structure = (structure) => this.finalCommand(['structure', structure]);
    /**
     * Displays the coordinates for the closest generated biome of a given type.
     *
     * @param biome Specifies the biome to locate.
     */
    biome = (biome) => this.finalCommand(['biome', biome]);
    /**
     * Displays the coordinates for the closest generated point of interest of a given type.
     *
     * @param pointOfInterest Specifies the point of interest to locate.
     */
    poi = (pointOfInterest) => this.finalCommand(['poi', pointOfInterest]);
}
