import { CommandNode } from 'sandstone/core/nodes';
import { CommandArguments } from '../../helpers.js';
import type { Coordinates, Rotation } from 'sandstone/arguments';
import type { Macroable } from 'sandstone/core';
export declare class SetWorldSpawnCommandNode extends CommandNode {
    command: "setworldspawn";
}
export declare class SetWorldSpawnCommand<MACRO extends boolean> extends CommandArguments {
    protected NodeType: typeof SetWorldSpawnCommandNode;
    /**
     * Sets the world spawn.
     *
     * @param pos Specifies the coordinates of the world spawn. If not specified, defaults to the block position of the command's execution.
     *
     * @param angle Specified the yaw angle to spawn with. Defaults to the direction the executor is facing.
     */
    setworldspawn: (pos?: Macroable<Coordinates<MACRO>, MACRO>, angle?: Macroable<Rotation<MACRO>, MACRO>) => import("../../helpers.js").FinalCommandOutput;
}
