import { CommandNode } from 'sandstone/core/nodes';
import { coordinatesParser } from 'sandstone/variables/parsers';
import { CommandArguments } from '../../helpers.js';
export class SetWorldSpawnCommandNode extends CommandNode {
    command = 'setworldspawn';
}
export class SetWorldSpawnCommand extends CommandArguments {
    NodeType = SetWorldSpawnCommandNode;
    /**
     * Sets the world spawn.
     *
     * @param pos Specifies the coordinates of the world spawn. If not specified, defaults to the block position of the command's execution.
     *
     * @param angle Specified the yaw angle to spawn with. Defaults to the direction the executor is facing.
     */
    setworldspawn = (pos, angle) => this.finalCommand([coordinatesParser(pos), coordinatesParser(angle)]);
}
