"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var time_exports = {};
__export(time_exports, {
  TimeCommand: () => TimeCommand,
  TimeCommandNode: () => TimeCommandNode
});
module.exports = __toCommonJS(time_exports);
var import_nodes = require("sandstone/core/nodes");
var import_helpers = require("../../helpers.js");
class TimeCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "time");
  }
}
class TimeCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", TimeCommandNode);
    /**
     * Adds `time` to the in-game daytime.
     *
     * @param time the time to add. It can be suffixed with a unit. Units include:
     * - `d`: an in-game day, 24000 gameticks;
     * - `s`: a second, 20 gameticks;
     * - `t` (default and omitable): a single gametick; the default unit.
     */
    __publicField(this, "add", (time) => this.finalCommand(["add", time]));
    /**
     * Queries current time.
     *
     * @param type Specifies the time to query. Can be one of the following:
     * - `daytime`: the number of game ticks since dawn. (the in-game daytime modulo 24000)
     * - `gametime`: the age of the world in game ticks. (the game time modulo 2147483647)
     * - `day`: the number of in-game days passed. (the in-game daytime divided by 24000, then modulo 2147483647)
     */
    __publicField(this, "query", (type) => this.finalCommand(["query", type]));
    /**
     * Sets the in-game daytime.
     *
     * @param time the new daytime. It can be suffixed with a unit. Units include:
     * - `d`: an in-game day, 24000 gameticks;
     * - `s`: a second, 20 gameticks;
     * - `t` (default and omitable): a single gametick; the default unit.
     */
    __publicField(this, "set", (time) => this.finalCommand(["set", time]));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TimeCommand,
  TimeCommandNode
});
//# sourceMappingURL=time.cjs.map