"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var weather_exports = {};
__export(weather_exports, {
  WeatherCommand: () => WeatherCommand,
  WeatherCommandNode: () => WeatherCommandNode
});
module.exports = __toCommonJS(weather_exports);
var import_nodes = require("sandstone/core/nodes");
var import_helpers = require("../../helpers.js");
class WeatherCommandNode extends import_nodes.CommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "command", "weather");
  }
}
class WeatherCommand extends import_helpers.CommandArguments {
  constructor() {
    super(...arguments);
    __publicField(this, "NodeType", WeatherCommandNode);
    /**
     * Set the weather to clear.
     *
     * @param duration Specifies the time in seconds for the clear weather to last.
     * If not specified, the duration defaults to 5 minutes.
     * If 0, resets to random weather duration.
     */
    __publicField(this, "clear", (duration) => this.finalCommand(["clear", duration]));
    /**
     * Set the weather to rain (or snow in cold biomes).
     *
     * @param duration Specifies the time in seconds for the rainy weather to last.
     * If not specified, the duration defaults to 5 minutes.
     * If 0, resets to random weather duration.
     */
    __publicField(this, "rain", (duration) => this.finalCommand(["rain", duration]));
    /**
     * Set the weather to a thunderstorm (or blizzard cold biomes).
     *
     * @param duration Specifies the time in seconds for the thunderstorm to last.
     * If not specified, the duration defaults to 5 minutes.
     * If 0, resets to random weather duration.
     */
    __publicField(this, "thunder", (duration) => this.finalCommand(["thunder", duration]));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  WeatherCommand,
  WeatherCommandNode
});
//# sourceMappingURL=weather.cjs.map