"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var Macro_exports = {};
__export(Macro_exports, {
  ConditionalDataPointPickClass: () => ConditionalDataPointPickClass,
  DataPointPickClass: () => DataPointPickClass,
  MacroArgument: () => MacroArgument,
  MacroLiteral: () => MacroLiteral,
  isMacroArgument: () => isMacroArgument
});
module.exports = __toCommonJS(Macro_exports);
class MacroArgument {
  constructor(sandstoneCore) {
    this.sandstoneCore = sandstoneCore;
    __publicField(this, "local");
    __publicField(this, "toMacro");
    this.local = /* @__PURE__ */ new Map();
    this.toMacro = () => {
      let currentMCFunctionName = "";
      try {
        currentMCFunctionName = sandstoneCore.getCurrentMCFunctionOrThrow().resource.name;
      } catch (e) {
      }
      return `$(${this.local.get(this.sandstoneCore.currentNode) || this.local.get(currentMCFunctionName)})`;
    };
  }
}
function isMacroArgument(core, arg) {
  if (typeof arg === "object" && Object.hasOwn(arg, "toMacro")) {
    const local = arg["local"];
    let currentMCFunctionName = "";
    try {
      currentMCFunctionName = core.getCurrentMCFunctionOrThrow().resource.name;
    } catch (e) {
    }
    if (arg instanceof MacroLiteral || local.has(currentMCFunctionName) || local.has(core.currentNode))
      return arg;
  }
  return void 0;
}
class MacroLiteral extends MacroArgument {
  constructor(sandstoneCore, strings, macros) {
    super(sandstoneCore);
    this.sandstoneCore = sandstoneCore;
    this.strings = strings;
    this.macros = macros;
    __publicField(this, "toMacro");
    this.toMacro = () => {
      let result = "";
      for (const [i, string] of this.strings.entries()) {
        result += string;
        const macro = this.macros[i];
        if (macro !== void 0 && macro !== null) {
          if (typeof macro === "string" || typeof macro === "number") {
            result += `${macro}`;
          } else {
            result += macro.toMacro();
          }
        }
      }
      return result;
    };
  }
}
class DataPointPickClass extends MacroArgument {
  /**
   * @internal
   */
  _toDataPoint() {
    throw new Error("Not implemented");
  }
}
class ConditionalDataPointPickClass extends DataPointPickClass {
  /**
   * @internal
   */
  _toMinecraftCondition() {
    throw new Error("Not implemented");
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ConditionalDataPointPickClass,
  DataPointPickClass,
  MacroArgument,
  MacroLiteral,
  isMacroArgument
});
//# sourceMappingURL=Macro.cjs.map