import type { SandstoneCore } from 'sandstone/core';
import type { ConditionNode } from 'sandstone/flow';
import type { ConditionClass, DataPointClass } from 'sandstone/variables';
export declare class MacroArgument {
    protected sandstoneCore: SandstoneCore;
    protected local: Map<string, string>;
    toMacro: () => string;
    constructor(sandstoneCore: SandstoneCore);
}
export type Macroable<T, MACRO extends boolean> = MACRO extends true ? (T | MacroArgument) : T;
export type MacroString<T, MACRO extends boolean> = MACRO extends true ? (T | string) : T;
export declare function isMacroArgument(core: SandstoneCore, arg: any): MacroArgument | undefined;
export declare class MacroLiteral extends MacroArgument {
    sandstoneCore: SandstoneCore;
    strings: TemplateStringsArray;
    macros: (MacroArgument | string | number)[];
    toMacro: () => string;
    constructor(sandstoneCore: SandstoneCore, strings: TemplateStringsArray, macros: (MacroArgument | string | number)[]);
}
export declare class DataPointPickClass extends MacroArgument {
    /**
     * @internal
     */
    _toDataPoint(): DataPointClass<'storage'>;
}
export declare class ConditionalDataPointPickClass extends DataPointPickClass implements ConditionClass {
    /**
     * @internal
     */
    _toMinecraftCondition(): ConditionNode;
}
