export class MacroArgument {
    sandstoneCore;
    local;
    toMacro;
    constructor(sandstoneCore) {
        this.sandstoneCore = sandstoneCore;
        this.local = new Map();
        this.toMacro = () => {
            let currentMCFunctionName = '';
            try {
                currentMCFunctionName = sandstoneCore.getCurrentMCFunctionOrThrow().resource.name;
                // eslint-disable-next-line no-empty
            }
            catch (e) { }
            return `$(${this.local.get(this.sandstoneCore.currentNode) || this.local.get(currentMCFunctionName)})`;
        };
    }
}
export function isMacroArgument(core, arg) {
    if (typeof arg === 'object' && Object.hasOwn(arg, 'toMacro')) {
        // eslint-disable-next-line prefer-destructuring
        const local = arg['local'];
        let currentMCFunctionName = '';
        try {
            currentMCFunctionName = core.getCurrentMCFunctionOrThrow().resource.name;
            // eslint-disable-next-line no-empty
        }
        catch (e) { }
        if (arg instanceof MacroLiteral || local.has(currentMCFunctionName) || local.has(core.currentNode))
            return arg;
    }
    return undefined;
}
export class MacroLiteral extends MacroArgument {
    sandstoneCore;
    strings;
    macros;
    toMacro;
    constructor(sandstoneCore, strings, macros) {
        super(sandstoneCore);
        this.sandstoneCore = sandstoneCore;
        this.strings = strings;
        this.macros = macros;
        this.toMacro = () => {
            let result = '';
            for (const [i, string] of this.strings.entries()) {
                result += string;
                const macro = this.macros[i];
                if (macro !== undefined && macro !== null) {
                    if (typeof macro === 'string' || typeof macro === 'number') {
                        result += `${macro}`;
                    }
                    else {
                        result += macro.toMacro();
                    }
                }
            }
            return result;
        };
    }
}
export class DataPointPickClass extends MacroArgument {
    /**
     * @internal
     */
    _toDataPoint() {
        throw new Error('Not implemented');
    }
}
export class ConditionalDataPointPickClass extends DataPointPickClass {
    /**
     * @internal
     */
    _toMinecraftCondition() {
        throw new Error('Not implemented');
    }
}
