"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var mcmeta_exports = {};
__export(mcmeta_exports, {
  MCMetaCache: () => MCMetaCache
});
module.exports = __toCommonJS(mcmeta_exports);
var import_adm_zip = __toESM(require("adm-zip"), 1);
var import_fs_extra = __toESM(require("fs-extra"), 1);
var import_lodash = __toESM(require("lodash"), 1);
var import_path = __toESM(require("path"), 1);
var import_utils = require("sandstone/utils");
class MCMetaCache {
  constructor() {
    __publicField(this, "base", "/misode/mcmeta/");
    __publicField(this, "path", import_path.default.join(process.env.WORKING_DIR, "..", "resources", "cache", "mcmeta"));
    __publicField(this, "manifest", import_path.default.join(this.path, "..", "..", "mcmeta.json"));
    __publicField(this, "lockFile", import_path.default.join(this.path, "..", "lock-mcmeta.json"));
    __publicField(this, "version", "latest");
    __publicField(this, "versionDate");
    __publicField(this, "branches", []);
    __publicField(this, "files", /* @__PURE__ */ new Map());
    __publicField(this, "loaded", false);
  }
  async load() {
    this.loaded = true;
    if (!await import_fs_extra.default.pathExists(this.manifest)) {
      return;
    }
    const manifest = JSON.parse(await import_fs_extra.default.readFile(this.manifest, "utf-8"));
    let uncached = false;
    this.version = manifest.version;
    const getZip = async (branch) => new import_adm_zip.default(await (await (0, import_utils.fetch)(`https://github.com${this.base}archive/refs/heads/${branch}.zip`)).buffer());
    if (!await import_fs_extra.default.pathExists(this.lockFile)) {
      if (manifest.files.length > 10) {
        const archives = {};
        for await (const branch of manifest.branches) {
          archives[branch] = await getZip(branch);
        }
        for await (const [file, text] of Object.entries(manifest.files)) {
          const _path = file.split("/");
          let contents = await new Promise((res) => {
            archives[_path[0]].readFileAsync(_path.slice(1).join("/"), (data) => res(data));
          });
          if (text) {
            contents = contents.toString("utf-8");
          }
          await (0, import_utils.safeWrite)(import_path.default.join(this.path, file), contents);
          this.files.set(file, { contents, text });
        }
      } else {
        uncached = true;
        for await (const [file, text] of Object.entries(manifest.files)) {
          const _path = file.split("/");
          await this.get(_path[0], _path.slice(1).join("/"), text);
        }
      }
      await (0, import_utils.safeWrite)(this.lockFile, JSON.stringify({
        files: manifest.files,
        version: manifest.version === "latest" ? await this.getVersion(false) : manifest.version,
        versionDate: this.versionDate
      }));
    } else {
      const lockFile = JSON.parse(await import_fs_extra.default.readFile(this.lockFile, "utf-8"));
      this.versionDate = lockFile.versionDate;
      const version = manifest.version === "latest" ? await this.getVersion(lockFile) : manifest.version;
      if (lockFile.version !== version) {
        if (manifest.files.length > 10) {
          const archives = {};
          for await (const branch of manifest.branches) {
            archives[branch] = await getZip(branch);
          }
          for await (const [file, text] of Object.entries(manifest.files)) {
            const _path = file.split("/");
            let contents = await new Promise((res) => {
              archives[_path[0]].readFileAsync(_path.slice(1).join("/"), (data) => res(data));
            });
            if (text) {
              contents = contents.toString("utf-8");
            }
            await (0, import_utils.safeWrite)(import_path.default.join(this.path, file), contents);
            this.files.set(file, { contents, text });
          }
        } else {
          uncached = true;
          for await (const [file, text] of Object.entries(manifest.files)) {
            const _path = file.split("/");
            await this.get(_path[0], _path.slice(1).join("/"), text);
          }
        }
      } else {
        const diff = import_lodash.default.difference(Object.entries(manifest.files), Object.entries(lockFile.files));
        if (diff.length !== 0) {
          if (diff.length > 10) {
            const archives = {};
            for await (const [file, text] of Object.entries(manifest.files)) {
              const _path = file.split("/");
              const branch = _path[0];
              if (!archives[branch]) {
                archives[branch] = await getZip(branch);
              }
              let contents = await new Promise((res) => {
                archives[branch].readFileAsync(_path.slice(1).join("/"), (data) => res(data));
              });
              if (text) {
                contents = contents.toString("utf-8");
              }
              await (0, import_utils.safeWrite)(import_path.default.join(this.path, file), contents);
              this.files.set(file, { contents, text });
            }
          } else {
            uncached = true;
            for await (const [file, text] of diff) {
              const _path = file.split("/");
              await this.get(_path[0], _path.slice(1).join("/"), text);
            }
          }
        }
      }
      await (0, import_utils.safeWrite)(this.lockFile, JSON.stringify({
        files: manifest.files,
        version: manifest.version === "latest" ? await this.getVersion(false) : manifest.version,
        versionDate: this.versionDate
      }));
    }
    this.branches = manifest.branches;
    if (!uncached) {
      for (const [file, text] of Object.entries(manifest.files)) {
        this.files.set(file, { contents: false, text });
      }
    }
  }
  async save() {
    if (this.files.size !== 0) {
      const files = {};
      for (const [_path, { text }] of this.files.entries()) {
        files[_path] = text;
      }
      await (0, import_utils.safeWrite)(this.manifest, JSON.stringify({
        files,
        branches: this.branches,
        version: this.version
      }));
      await (0, import_utils.safeWrite)(this.lockFile, JSON.stringify({
        files,
        version: this.version,
        versionDate: this.versionDate || Date.now()
      }));
    }
  }
  async get(branch, relativePath, text = true) {
    console.log(branch, relativePath);
    if (!this.loaded) {
      await this.load();
    }
    if (!this.branches.includes(branch)) {
      this.branches.push(branch);
    }
    const fullPath = import_path.default.join(branch, relativePath);
    const existing = this.files.get(fullPath);
    if (existing) {
      return existing.contents;
    }
    const req = await (0, import_utils.fetch)(`https://raw.githubusercontent.com${this.base}${branch}/${relativePath}`);
    const file = await (text ? req.text() : req.buffer());
    const finalPath = import_path.default.join(this.path, fullPath);
    await (0, import_utils.safeWrite)(finalPath, file);
    return this.files.set(fullPath, { text, contents: file }).get(fullPath).contents;
  }
  async getVersion(lockFile) {
    const fetchVersion = async () => (await (await (0, import_utils.fetch)(`https://api.github.com/repos${this.base}commits?sha=summary`)).json()).sha;
    const currentDate = Date.now();
    if (lockFile) {
      if ((lockFile.versionDate - currentDate) / 36e5 > 6) {
        this.versionDate = currentDate;
        return fetchVersion();
      }
      this.versionDate = lockFile.versionDate;
      return lockFile.version;
    }
    this.versionDate = currentDate;
    return fetchVersion();
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  MCMetaCache
});
//# sourceMappingURL=mcmeta.cjs.map