/// <reference types="node" resolution-mode="require"/>
export type MCMetaBranches = 'assets' | 'atlas' | 'data' | 'registries' | 'summary';
export declare class MCMetaCache {
    readonly base = "/misode/mcmeta/";
    readonly path: string;
    readonly manifest: string;
    readonly lockFile: string;
    version: string;
    versionDate?: number;
    branches: MCMetaBranches[];
    files: Map<string, {
        text: boolean;
        contents: Buffer | string | false;
    }>;
    loaded: boolean;
    load(): Promise<void>;
    save(): Promise<void>;
    get(branch: MCMetaBranches, relativePath: string): Promise<string>;
    get(branch: MCMetaBranches, relativePath: string, text: true): Promise<string>;
    get(branch: MCMetaBranches, relativePath: string, text: false): Promise<Buffer>;
    getVersion(lockFile?: any): Promise<string>;
}
