"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var nodes_exports = {};
__export(nodes_exports, {
  AwaitNode: () => AwaitNode,
  CommandNode: () => CommandNode,
  ContainerCommandNode: () => ContainerCommandNode,
  ContainerNode: () => ContainerNode,
  Node: () => Node
});
module.exports = __toCommonJS(nodes_exports);
var import_Macro = require("./Macro.js");
class Node {
  constructor(sandstoneCore) {
    this.sandstoneCore = sandstoneCore;
  }
}
class ContainerNode extends Node {
  constructor(sandstoneCore) {
    super(sandstoneCore);
    __publicField(this, "body");
    this.body = [];
  }
  append(...nodes) {
    this.body.push(...nodes);
    return nodes.length === 1 ? nodes[0] : nodes;
  }
  prepend(...nodes) {
    this.body.unshift(...nodes);
    return nodes.length === 1 ? nodes[0] : nodes;
  }
}
class CommandNode extends Node {
  constructor(sandstonePack, ...args) {
    super(sandstonePack.core);
    this.sandstonePack = sandstonePack;
    __publicField(this, "args");
    __publicField(this, "commited", false);
    __publicField(this, "isMacro", false);
    this.args = args;
  }
  getValue() {
    const filteredArgs = [];
    for (const arg of this.args) {
      if (arg !== void 0 && arg !== null) {
        if (typeof arg === "object") {
          if ((0, import_Macro.isMacroArgument)(this.sandstoneCore, arg)) {
            this.isMacro = true;
            filteredArgs.push(arg.toMacro());
          } else if (Object.hasOwn(arg, "toLoop")) {
            filteredArgs.push(arg.toLoop());
          } else {
            filteredArgs.push(arg);
          }
        } else {
          filteredArgs.push(arg);
        }
      }
    }
    return `${this.isMacro ? "$" : ""}${this.command} ${filteredArgs.join(" ")}`;
  }
  /**
   * Commits the command to the current MCFunction context.
   */
  commit() {
    if (this.commited) {
      return this;
    }
    this.commited = true;
    return this.sandstonePack.appendNode(this);
  }
}
class ContainerCommandNode extends CommandNode {
  constructor(sandstonePack, ...args) {
    super(sandstonePack, ...args);
    __publicField(this, "body");
    /**
     * Create a MCFunction from this node.
     * It shouldn't be added to Sandstone's core.
     *
     * The returned node will replace
     */
    __publicField(this, "createMCFunction", (currentMCFunction) => ({ node: this }));
    this.body = [];
  }
  /**
   * Appends a node at the end of this node's body.
   */
  append(node) {
    this.body.push(node);
    return node;
  }
  /**
   * Appends a node at the end of this node's body.
   */
  prepend(node) {
    this.body.unshift(node);
    return node;
  }
}
class AwaitNode extends ContainerCommandNode {
  constructor() {
    super(...arguments);
    __publicField(this, "mcfunction");
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AwaitNode,
  CommandNode,
  ContainerCommandNode,
  ContainerNode,
  Node
});
//# sourceMappingURL=nodes.cjs.map