"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var custom_exports = {};
__export(custom_exports, {
  CustomResourceClass: () => CustomResourceClass,
  CustomResourceNode: () => CustomResourceNode
});
module.exports = __toCommonJS(custom_exports);
var import_utils = require("sandstone/utils");
var import_nodes = require("../nodes.js");
var import_resource = require("./resource.js");
class CustomResourceNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "getValue", () => this.resource.getValue());
  }
}
class CustomResourceClass extends import_resource.ResourceClass {
  constructor(sandstoneCore, name, args) {
    sandstoneCore.pack.registerCustomResource(args.type);
    super(
      sandstoneCore,
      { packType: args.packType || sandstoneCore.pack.dataPack(), extension: args.extension || "json", encoding: args.encoding },
      CustomResourceNode,
      // eslint-disable-next-line no-nested-ternary
      args.folder ? name.includes("/") ? name.split("/") : [name] : sandstoneCore.pack.resourceToPath(name, args.folder),
      args
    );
    __publicField(this, "type");
    __publicField(this, "folder");
    __publicField(this, "toString", () => this.folder ? (0, import_utils.toMinecraftResourceName)(this.path, this.folder.length) : this.name);
    this.type = args.type;
    this.folder = args.folder;
    this.handleConflicts();
  }
  getValue() {
    throw new Error(`Custom Resource '${this.type}' getValue function is not defined!`);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CustomResourceClass,
  CustomResourceNode
});
//# sourceMappingURL=custom.cjs.map