"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var damageType_exports = {};
__export(damageType_exports, {
  DamageTypeClass: () => DamageTypeClass,
  DamageTypeNode: () => DamageTypeNode
});
module.exports = __toCommonJS(damageType_exports);
var import_utils = require("sandstone/utils");
var import_nodes = require("../../nodes.js");
var import_resource = require("../resource.js");
const damageTypes = /* @__PURE__ */ new Map();
class DamageTypeNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "getValue", () => JSON.stringify(this.resource.damageTypeJSON));
  }
}
class DamageTypeClass extends import_resource.ResourceClass {
  constructor(sandstoneCore, name, args) {
    super(sandstoneCore, { packType: sandstoneCore.pack.dataPack(), extension: "json" }, DamageTypeNode, sandstoneCore.pack.resourceToPath(name, ["trim_materials"]), args);
    __publicField(this, "damageTypeJSON");
    /** @internal */
    __publicField(this, "_toChatComponent", () => ({ translate: this.translationKey }));
    __publicField(this, "toString", () => (0, import_utils.toMinecraftResourceName)(this.path));
    this.damageTypeJSON = args.damageType;
    if (args.flags) {
      for (const flag of args.flags) {
        let tag = damageTypes.get(flag);
        if (!tag) {
          damageTypes.set(flag, sandstoneCore.pack.Tag("damage_type", `minecraft:${flag}`, []));
          tag = damageTypes.get(flag);
        }
        tag == null ? void 0 : tag.push(this.name);
      }
    }
    this.handleConflicts();
  }
  get translationKey() {
    return `death.attack.${this.damageTypeJSON.message_id}${this.damageTypeJSON.death_message_type === "intentional_game_design" ? ".link" : ""}`;
  }
  damage(...args) {
    const command = this.core.pack.commands.damage;
    if (typeof args[0] === "number") {
      if (args[1] === "entity") {
        if (args[3]) {
          return command("@s", args[0], this).by(args[2]).from(args[3]);
        }
        return command("@s", args[0], this).by(args[2]);
      }
      if (args[1] === "at") {
        return command("@s", args[0], this).at(args[1]);
      }
      return command("@s", args[0], this);
    }
    if (args[2] === "entity") {
      if (args[4]) {
        return command(args[0], args[1], this).by(args[2]).from(args[4]);
      }
      return command(args[0], args[1], this).by(args[2]);
    }
    return command(args[0], args[1], this);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DamageTypeClass,
  DamageTypeNode
});
//# sourceMappingURL=damageType.cjs.map