"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var itemModifier_exports = {};
__export(itemModifier_exports, {
  ItemModifierClass: () => ItemModifierClass,
  ItemModifierNode: () => ItemModifierNode
});
module.exports = __toCommonJS(itemModifier_exports);
var import_parsers = require("sandstone/variables/parsers");
var import_nodes = require("../../nodes.js");
var import_resource = require("../resource.js");
class ItemModifierNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "getValue", () => JSON.stringify(this.resource.itemModifierJSON));
  }
}
class ItemModifierClass extends import_resource.ResourceClass {
  constructor(sandstoneCore, name, args) {
    super(sandstoneCore, { packType: sandstoneCore.pack.dataPack(), extension: "json" }, ItemModifierNode, sandstoneCore.pack.resourceToPath(name, ["item_modifiers"]), args);
    __publicField(this, "itemModifierJSON");
    this.itemModifierJSON = args.itemModifier;
    this.handleConflicts();
  }
  push(...modifiers) {
    if (!Array.isArray(this.itemModifierJSON)) {
      this.itemModifierJSON = [this.itemModifierJSON];
    }
    for (const modifier of modifiers) {
      let modifierJSON;
      if (modifier instanceof ItemModifierClass) {
        modifierJSON = modifier.itemModifierJSON;
      } else {
        modifierJSON = modifier;
      }
      if (Array.isArray(modifierJSON)) {
        this.itemModifierJSON.push(...modifierJSON);
      } else {
        this.itemModifierJSON.push(modifierJSON);
      }
    }
  }
  unshift(...modifiers) {
    if (!Array.isArray(this.itemModifierJSON)) {
      this.itemModifierJSON = [this.itemModifierJSON];
    }
    for (const modifier of modifiers) {
      let modifierJSON;
      if (modifier instanceof ItemModifierClass) {
        modifierJSON = modifier.itemModifierJSON;
      } else {
        modifierJSON = modifier;
      }
      if (Array.isArray(modifierJSON)) {
        this.itemModifierJSON.unshift(...modifierJSON);
      } else {
        this.itemModifierJSON.unshift(modifierJSON);
      }
    }
  }
  get modify() {
    return {
      /**
       * @param pos The position of the container containing the slot to apply the modifier to.
       * @param slot The slot to apply the modifier to.
       */
      block: (pos, slot) => {
        this.pack.commands.item.modify.block(pos, slot, this);
      },
      /**
       * @param targets The entity/entities containing the slot to apply the modifier to.
       * @param slot The slot to apply the modifier to.
       * @param modifier The name of the modifier.
       */
      entity: (targets, slot) => {
        this.pack.commands.item.modify.entity((0, import_parsers.targetParser)(targets), slot, this);
      }
    };
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ItemModifierClass,
  ItemModifierNode
});
//# sourceMappingURL=itemModifier.cjs.map