"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var lootTable_exports = {};
__export(lootTable_exports, {
  LootTableClass: () => LootTableClass,
  LootTableNode: () => LootTableNode
});
module.exports = __toCommonJS(lootTable_exports);
var import_nodes = require("../../nodes.js");
var import_resource = require("../resource.js");
class LootTableNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "getValue", () => JSON.stringify(this.resource.lootTableJSON));
  }
}
class LootTableClass extends import_resource.ResourceClass {
  constructor(sandstoneCore, name, args) {
    super(sandstoneCore, { packType: sandstoneCore.pack.dataPack(), extension: "json" }, LootTableNode, sandstoneCore.pack.resourceToPath(name, ["loot_tables"]), args);
    __publicField(this, "lootTableJSON");
    /**
     * Gives items, ignoring empty item stacks.
     * @param players Optional. Specifies the player(s). Defaults to `@s`.
     */
    __publicField(this, "give", (players = "@s") => this.pack.commands.loot.give(players).loot(this.name));
    /**
     * Distributes items to container.
     * @param targetPos Optional. Specifies the position of the block. Defaults to `~ ~ ~`.
     */
    __publicField(this, "insert", (targetPos = "~ ~ ~") => this.pack.commands.loot.insert(targetPos).loot(this.name));
    /**
     * Replace a container block slot with the items.
     * @param targetPos Specifies the position of a block.
     *
     * @param slot Specifies the inventory slot to be modified.
     * Must be must be `container.<slot_number>` where `<slot_number>` is replaced with a number specifying the slot.
     *
     * - Chests, dispensers, droppers, hoppers, and trapped chests are numbered 0 for the top-left slot and then increase
     *   first horizontally, then vertically (so, for example, a chest's top row slots are numbered 0 to 8 from left to right).
     *   Double chests and double trapped chests are treated as two single container blocks.
     * - A brewing stand's bottom slots are numbered 0 to 2 from left to right, its top slot is 3 and the fuel slot is 4.
     * - A furnace's slots are numbered 0 for the input slot, 1 for the fuel slot, and 2 for the output slot.
     *
     * @param count Specifies the number of consecutive slots to be filled. Must be between 0 and 2147483647 (inclusive).
     */
    __publicField(this, "replaceBlock", (targetPos, slot, count) => this.pack.commands.loot.replace.block(targetPos, slot, count).loot(this.name));
    /**
     * Replace an entity slot with the items.
     *
     * @param targetPos Specifies the position of a block.
     *
     * @param slot Specifies the inventory slot to be modified.
     * Must be must be `container.<slot_number>` where `<slot_number>` is replaced with a number specifying the slot.
     *
     * - Chests, dispensers, droppers, hoppers, and trapped chests are numbered 0 for the top-left slot and then increase
     *   first horizontally, then vertically (so, for example, a chest's top row slots are numbered 0 to 8 from left to right).
     *   Double chests and double trapped chests are treated as two single container blocks.
     * - A brewing stand's bottom slots are numbered 0 to 2 from left to right, its top slot is 3 and the fuel slot is 4.
     * - A furnace's slots are numbered 0 for the input slot, 1 for the fuel slot, and 2 for the output slot.
     *
     * @param count Specifies the number of consecutive slots to be filled. Must be between 0 and 2147483647 (inclusive).
     */
    __publicField(this, "replaceEntity", (entities, slot, count) => this.pack.commands.loot.replace.entity(entities, slot, count).loot(this.name));
    __publicField(this, "toString", () => this.name);
    __publicField(this, "toJSON", this.toString);
    this.lootTableJSON = args.lootTable;
    this.handleConflicts();
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  LootTableClass,
  LootTableNode
});
//# sourceMappingURL=lootTable.cjs.map