"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var mcfunction_exports = {};
__export(mcfunction_exports, {
  MCFunctionClass: () => MCFunctionClass,
  MCFunctionNode: () => MCFunctionNode,
  _RawMCFunctionClass: () => _RawMCFunctionClass
});
module.exports = __toCommonJS(mcfunction_exports);
var import_utils = require("sandstone/utils");
var import_ResolveNBT = require("../../../variables/ResolveNBT.js");
var import_nodes = require("../../nodes.js");
var import_resource = require("../resource.js");
var import_tag = require("./tag.js");
const tags = {};
class MCFunctionNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "contextStack");
    /**
     * Sequentially add node(s) to the end of the body of the function.
     *
     * @param node The node(s) to add.
     */
    __publicField(this, "appendNode", (node) => {
      if (Array.isArray(node)) {
        for (const _node of node) {
          this.currentContext.append(_node);
        }
      } else {
        this.currentContext.append(node);
      }
    });
    /**
     * Sequentially add node(s) to the beginning of the body of the function.
     *
     * @param node The node(s) to add.
     */
    __publicField(this, "prependNode", (node) => {
      if (Array.isArray(node)) {
        for (const _node of node) {
          this.currentContext.prepend(_node);
        }
      } else {
        this.currentContext.prepend(node);
      }
    });
    /**
     * Switch the current context to the given node.
     * Also adds the node to the body of the current context, except if addNode is False.
     *
     * @param node The node to switch to.
     * @param addNode Whether to add the node to the body of the current context.
     */
    __publicField(this, "enterContext", (node, addNode = true) => {
      if (addNode) {
        this.currentContext.append(node);
      }
      this.contextStack.push(node);
    });
    /**
     * Switch the current context to the given node, run the given function, and switch back to the original context.
     * Also adds the node to the body of the current context, except if addNode is False.
     *
     * @param node The node to switch to.
     * @param callback The function to run.
     * @param addNode Whether to add the node to the body of the current context.
     *
     * @return The previously active context.
     * @throws Error if there is no previous context.
     */
    __publicField(this, "insideContext", (node, callback, addNode = true) => {
      this.enterContext(node, addNode);
      callback();
      return this.exitContext();
    });
    /**
     * Leave the current context, and return to the previous one.
     *
     * @return The previously active context.
     * @throws Error if there is no previous context.
     */
    __publicField(this, "exitContext", () => {
      if (this.contextStack.length === 0) {
        throw new Error("No previous context to return to.");
      }
      if (this.contextStack.length === 1) {
        throw new Error("It is forbidden for a MCFunction to exit its latest context, since the MCFunction itself must be in the context stack.");
      }
      return this.contextStack.pop();
    });
    __publicField(this, "getValue", () => {
      this.sandstoneCore.currentNode = this.resource.name;
      return this.body.filter((node) => node.getValue() !== null).map((node) => node.getValue()).join("\n");
    });
    this.contextStack = [this];
  }
  /**
   * The currently active context.
   *
   * For example, the current context is the function body if the function is not in a loop.
   * If the function is in a loop, the current context is the loop body.
   */
  get currentContext() {
    return this.contextStack[this.contextStack.length - 1];
  }
}
class _RawMCFunctionClass extends import_resource.CallableResourceClass {
  constructor(core, name, args, env) {
    var _a;
    super(core, { packType: core.pack.dataPack(), extension: "mcfunction" }, MCFunctionNode, core.pack.resourceToPath(name, ["functions"]), {
      ...args,
      addToSandstoneCore: args.lazy ? false : args.addToSandstoneCore
    });
    __publicField(this, "callback");
    __publicField(this, "nested", 0);
    __publicField(this, "asyncContext");
    __publicField(this, "tags");
    __publicField(this, "lazy");
    __publicField(this, "env");
    __publicField(this, "generate", () => {
      if (this.node.body.length > 0) {
      }
      this.push(this.callback.bind(void 0, (0, import_utils.makeCallable)(this, this.__call__)));
    });
    __publicField(this, "addToTag", (tag) => {
      if (tags[tag]) {
        tags[tag].push(this.name);
      } else {
        tags[tag] = new import_tag.TagClass(this.core, "functions", tag, {
          values: [this.name],
          addToSandstoneCore: true,
          creator: "sandstone",
          onConflict: "append"
        });
      }
    });
    __publicField(this, "__call__", (..._params) => {
      if (this.env || _params.length !== 0) {
        const args = {};
        if (_params.length !== 0) {
          for (const [i, param] of _params.entries()) {
            args[`param_${i}`] = (0, import_ResolveNBT.ResolveNBTPart)(param);
            param["local"].set(this.name, `param_${i}`);
          }
          this.node.body = [];
          this.core.insideContext(this.node, () => this.callback((0, import_utils.makeCallable)(this, this.__call__.bind(void 0, ..._params)), ..._params), false);
        }
        if (this.env) {
          for (const [i, env] of this.env.entries()) {
            args[`env_${i}`] = (0, import_ResolveNBT.ResolveNBTPart)(env);
            env["local"].set(this.name, `env_${i}`);
          }
        }
        return this.commands.functionCmd(this.name, "with", this.pack.ResolveNBT(args).dataPoint);
      }
      return this.commands.functionCmd(this.name);
    });
    __publicField(this, "schedule", {
      clear: () => this.commands.schedule.clear(this.name),
      function: (delay, type) => this.commands.schedule.function(this.name, delay, type)
    });
    this.callback = (_a = args.callback) != null ? _a : () => {
    };
    if (this.nested !== 0) {
      for (let i = 0; i < this.nested; i++) {
        this.node.exitContext();
      }
    }
    this.asyncContext = args.asyncContext === void 0 ? false : args.asyncContext;
    this.lazy = !!args.lazy;
    this.addToSandstoneCore = !!args.addToSandstoneCore;
    this.tags = args.tags;
    if (env) {
      this.env = env;
    }
    if (args.runOnLoad) {
      if (env) {
        core.pack.loadTags.load.push(core.pack.MCFunction(`load_${this.name.split(":")[1]}`, () => {
          this.__call__();
        }));
      } else {
        core.pack.loadTags.load.push(this.name);
      }
    } else if (args.runEveryTick) {
      core.pack.registerTickedCommands("1t", () => this.__call__());
    }
    if (args.tags) {
      for (const tag of args.tags) {
        this.addToTag(`${tag}`);
      }
    }
    if (!args.runEveryTick && args.runEvery) {
      core.pack.registerTickedCommands(args.runEvery, () => this.__call__());
    }
    this.handleConflicts();
  }
  push(...contents) {
    if (contents[0] instanceof _RawMCFunctionClass) {
      for (const mcfunction of contents) {
        this.node.body.push(...mcfunction.node.body);
      }
    } else {
      this.core.enterMCFunction(this);
      this.core.insideContext(this.node, contents[0], false);
      this.core.exitMCFunction();
    }
  }
  unshift(...contents) {
    const fake = new MCFunctionClass(this.core, "fake", {
      addToSandstoneCore: false,
      creator: "sandstone",
      onConflict: "ignore"
    });
    if (contents[0] instanceof _RawMCFunctionClass) {
      for (const mcfunction of contents) {
        this.node.body.unshift(...mcfunction.node.body);
      }
    } else {
      this.core.enterMCFunction(fake);
      this.core.insideContext(fake.node, contents[0], false);
      this.core.exitMCFunction();
      this.node.body.unshift(...fake.node.body);
    }
  }
  splice(start, removeItems, ...contents) {
    const fake = new MCFunctionClass(this.core, "fake", {
      addToSandstoneCore: false,
      creator: "sandstone",
      onConflict: "ignore"
    });
    const fullBody = [];
    if (contents[0] instanceof _RawMCFunctionClass) {
      for (const mcfunction of contents) {
        fullBody.push(...mcfunction.node.body);
      }
    } else {
      this.core.enterMCFunction(fake);
      this.core.insideContext(fake.node, contents[0], false);
      this.core.exitMCFunction();
      fullBody.push(...fake.node.body);
    }
    this.node.body.splice(start, removeItems === "auto" ? fullBody.length : removeItems, ...fullBody);
  }
}
const MCFunctionClass = (0, import_utils.makeClassCallable)(_RawMCFunctionClass);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  MCFunctionClass,
  MCFunctionNode,
  _RawMCFunctionClass
});
//# sourceMappingURL=mcfunction.cjs.map