"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var predicate_exports = {};
__export(predicate_exports, {
  PredicateClass: () => PredicateClass,
  PredicateNode: () => PredicateNode
});
module.exports = __toCommonJS(predicate_exports);
var import_nodes = require("../../nodes.js");
var import_resource = require("../resource.js");
class PredicateNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "getValue", () => JSON.stringify(this.resource.predicateJSON));
  }
}
class PredicateClass extends import_resource.ResourceClass {
  constructor(sandstoneCore, name, args) {
    super(sandstoneCore, { packType: sandstoneCore.pack.dataPack(), extension: "json" }, PredicateNode, sandstoneCore.pack.resourceToPath(name, ["predicates"]), args);
    __publicField(this, "predicateJSON");
    /** @internal */
    __publicField(this, "_toMinecraftCondition", () => new this.pack.conditions.Predicate(this.core, this.name));
    this.predicateJSON = args.predicate;
    this.handleConflicts();
  }
  push(...predicates) {
    if (!Array.isArray(this.predicateJSON)) {
      this.predicateJSON = [this.predicateJSON];
    }
    for (const predicate of predicates) {
      let predicateJSON;
      if (predicate instanceof PredicateClass) {
        predicateJSON = predicate.predicateJSON;
      } else {
        predicateJSON = predicate;
      }
      if (Array.isArray(predicateJSON)) {
        this.predicateJSON.push(...predicateJSON);
      } else {
        this.predicateJSON.push(predicateJSON);
      }
    }
  }
  unshift(...predicates) {
    if (!Array.isArray(this.predicateJSON)) {
      this.predicateJSON = [this.predicateJSON];
    }
    for (const predicate of predicates) {
      let predicateJSON;
      if (predicate instanceof PredicateClass) {
        predicateJSON = predicate.predicateJSON;
      } else {
        predicateJSON = predicate;
      }
      if (Array.isArray(predicateJSON)) {
        this.predicateJSON.unshift(...predicateJSON);
      } else {
        this.predicateJSON.unshift(predicateJSON);
      }
    }
  }
  /** @internal */
  toJSON() {
    return this.predicateJSON;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  PredicateClass,
  PredicateNode
});
//# sourceMappingURL=predicate.cjs.map