"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var recipe_exports = {};
__export(recipe_exports, {
  RecipeClass: () => RecipeClass,
  RecipeNode: () => RecipeNode
});
module.exports = __toCommonJS(recipe_exports);
var import_nodes = require("../../nodes.js");
var import_resource = require("../resource.js");
class RecipeNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "getValue", () => JSON.stringify(this.resource.recipeJSON));
  }
}
class RecipeClass extends import_resource.ResourceClass {
  constructor(sandstoneCore, name, args) {
    super(sandstoneCore, { packType: sandstoneCore.pack.dataPack(), extension: "json" }, RecipeNode, sandstoneCore.pack.resourceToPath(name, ["recipes"]), args);
    __publicField(this, "recipeJSON");
    /**
     * Give this recipe.
     * @param players Optional. Specifies the player(s). Defaults to `@s`.
     */
    __publicField(this, "give", (players = "@s") => {
      this.pack.commands.recipe.give(players, this.name);
    });
    /**
     * Take this recipe.
     * @param players Optional. Specifies the player(s). Defaults to `@s`.
     */
    __publicField(this, "take", (players = "@s") => {
      this.pack.commands.recipe.take(players, this.name);
    });
    this.recipeJSON = args.recipe;
    this.handleConflicts();
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  RecipeClass,
  RecipeNode
});
//# sourceMappingURL=recipe.cjs.map