import { ContainerNode } from '../../nodes.js';
import { ResourceClass } from '../resource.js';
/**
 * A node representing a Minecraft recipe.
 */
export class RecipeNode extends ContainerNode {
    resource;
    constructor(sandstoneCore, resource) {
        super(sandstoneCore);
        this.resource = resource;
    }
    getValue = () => JSON.stringify(this.resource.recipeJSON);
}
export class RecipeClass extends ResourceClass {
    recipeJSON;
    constructor(sandstoneCore, name, args) {
        super(sandstoneCore, { packType: sandstoneCore.pack.dataPack(), extension: 'json' }, RecipeNode, sandstoneCore.pack.resourceToPath(name, ['recipes']), args);
        this.recipeJSON = args.recipe;
        this.handleConflicts();
    }
    /**
     * Give this recipe.
     * @param players Optional. Specifies the player(s). Defaults to `@s`.
     */
    give = (players = '@s') => {
        this.pack.commands.recipe.give(players, this.name);
    };
    /**
     * Take this recipe.
     * @param players Optional. Specifies the player(s). Defaults to `@s`.
     */
    take = (players = '@s') => {
        this.pack.commands.recipe.take(players, this.name);
    };
}
