"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var tag_exports = {};
__export(tag_exports, {
  TagClass: () => TagClass,
  TagNode: () => TagNode
});
module.exports = __toCommonJS(tag_exports);
var import_utils = require("sandstone/utils");
var import_nodes = require("../../nodes.js");
var import_resource = require("../resource.js");
function isMCFunctionClass(v) {
  return typeof v === "function";
}
function isTagClass(v) {
  return v instanceof TagClass;
}
function isTagObject(v) {
  return typeof v === "object";
}
function objectToString(value) {
  if (isMCFunctionClass(value)) {
    if (value["node"].resource["env"]) {
      return value["node"].sandstoneCore.pack.MCFunction(`${value.name}/_env`, () => value(), { creator: "sandstone", onConflict: "rename" }).name;
    }
    return value.name;
  }
  if (isTagClass(value)) {
    return value.name;
  }
  if (isTagObject(value)) {
    if (isMCFunctionClass(value.id)) {
      if (value.id["node"].resource["env"]) {
        return {
          id: value.id["node"].sandstoneCore.pack.MCFunction(`${value.id.name}/_env`, () => value.id(), { creator: "sandstone", onConflict: "rename" }).name,
          required: value.required
        };
      }
      return {
        id: value.id.name,
        required: value.required
      };
    }
    if (isTagClass(value.id)) {
      return {
        id: value.id.name,
        required: value.required
      };
    }
  }
  return value;
}
class TagNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "getValue", () => JSON.stringify(this.resource.tagJSON));
  }
}
class TagClass extends import_resource.ResourceClass {
  constructor(sandstoneCore, type, name, args) {
    super(sandstoneCore, { packType: sandstoneCore.pack.dataPack(), extension: "json" }, TagNode, sandstoneCore.pack.resourceToPath(name, ["tags", type]), args);
    __publicField(this, "type");
    __publicField(this, "tagJSON");
    /**
     * @internal
     */
    __publicField(this, "_toMinecraftCondition", () => {
      if (this.type === "blocks" || this.type === "entity_types") {
        return new this.pack.conditions.Tag(this.core, this.type, this.name);
      }
      throw new Error(`Cannot use a ${this.type} group tag as a condition. Only supports 'blocks' or 'entity_types'.`);
    });
    this.type = type;
    this.tagJSON = {
      replace: args.replace || false,
      values: []
    };
    this.tagJSON.values = Array.from(args.values, objectToString);
    this.handleConflicts();
  }
  get name() {
    return `#${(0, import_utils.toMinecraftResourceName)(this.path, 2)}`;
  }
  push(...resources) {
    for (const resource of resources) {
      this.tagJSON.values.push(objectToString(resource));
    }
  }
  unshift(..._resources) {
    const resources = [];
    for (const resource of _resources) {
      resources.push(objectToString(resource));
    }
    this.tagJSON.values.push(...resources);
  }
  /** Checks whether a given resource is in this tag. */
  has(resource) {
    this.tagJSON.values.some((tagValue) => (typeof tagValue !== "string" ? tagValue.id : tagValue) === objectToString(resource));
  }
  toString() {
    return this.name;
  }
  toJSON() {
    return (0, import_utils.toMinecraftResourceName)(this.path);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TagClass,
  TagNode
});
//# sourceMappingURL=tag.cjs.map