"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var trimMaterial_exports = {};
__export(trimMaterial_exports, {
  TrimMaterialClass: () => TrimMaterialClass,
  TrimMaterialNode: () => TrimMaterialNode
});
module.exports = __toCommonJS(trimMaterial_exports);
var import_nodes = require("../../nodes.js");
var import_resource = require("../resource.js");
let trimMaterials;
class TrimMaterialNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "getValue", () => JSON.stringify(this.resource.trimMaterialJSON));
  }
}
class TrimMaterialClass extends import_resource.ResourceClass {
  constructor(sandstoneCore, name, args) {
    super(sandstoneCore, { packType: sandstoneCore.pack.dataPack(), extension: "json" }, TrimMaterialNode, sandstoneCore.pack.resourceToPath(name, ["trim_materials"]), args);
    __publicField(this, "trimMaterialJSON");
    __publicField(this, "equipmentCheck");
    /**
     * @internal
     */
    __publicField(this, "_toMinecraftCondition", () => new this.pack.conditions.TrimMaterial(this.core, this));
    this.trimMaterialJSON = args.trimMaterial;
    this.equipmentCheck = args.equipmentCheck;
    if (args.registerMaterial !== false) {
      if (!trimMaterials)
        trimMaterials = sandstoneCore.pack.Tag("items", "minecraft:trim_materials", [this.material]);
      else
        trimMaterials.push(this.material);
    }
    this.handleConflicts();
  }
  /** String which will be used in the resource pack. */
  get assetName() {
    return this.trimMaterialJSON.asset_name;
  }
  /** Model override predicate float between 1 & 0. */
  get overrideIndex() {
    return this.trimMaterialJSON.item_model_index;
  }
  /** The item used in the smithing table for this material. */
  get material() {
    return this.trimMaterialJSON.ingredient;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TrimMaterialClass,
  TrimMaterialNode
});
//# sourceMappingURL=trimMaterial.cjs.map