"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var trimPattern_exports = {};
__export(trimPattern_exports, {
  TrimPatternClass: () => TrimPatternClass,
  TrimPatternNode: () => TrimPatternNode
});
module.exports = __toCommonJS(trimPattern_exports);
var import_nodes = require("../../nodes.js");
var import_resource = require("../resource.js");
class TrimPatternNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "getValue", () => JSON.stringify(this.resource.trimPatternJSON));
  }
}
class TrimPatternClass extends import_resource.ResourceClass {
  constructor(sandstoneCore, name, args) {
    super(sandstoneCore, { packType: sandstoneCore.pack.dataPack(), extension: "json" }, TrimPatternNode, sandstoneCore.pack.resourceToPath(name, ["trim_patterns"]), args);
    __publicField(this, "trimPatternJSON");
    __publicField(this, "equipmentCheck");
    /**
     * @internal
     */
    __publicField(this, "_toMinecraftCondition", () => new this.pack.conditions.TrimPattern(this.core, this));
    this.trimPatternJSON = args.trimPattern;
    this.equipmentCheck = args.equipmentCheck;
    if (args.registerPatternTag !== false) {
      sandstoneCore.pack.Tag("items", "minecraft:trim_templates", [this.template], { onConflict: "append" });
    }
    if (args.registerPatternRecipe !== false) {
      let assetID = this.trimPatternJSON.asset_id;
      if (assetID.includes(":")) {
        assetID = assetID.split(":")[1];
      }
      sandstoneCore.pack.Recipe(assetID, {
        type: "smithing_trim",
        base: { tag: "minecraft:trimmable_armor" },
        addition: { tag: "minecraft:trim_materials" },
        template: { item: this.trimPatternJSON.template_item }
      });
    }
    this.handleConflicts();
  }
  /** The item used in the smithing table for this pattern. */
  get template() {
    return this.trimPatternJSON.template_item;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TrimPatternClass,
  TrimPatternNode
});
//# sourceMappingURL=trimPattern.cjs.map