/// <reference types="node" resolution-mode="require"/>
import { ContainerNode } from '../nodes.js';
import { ResourceClass } from './resource.js';
import type { SandstoneCore } from '../sandstoneCore.js';
import type { Dependency } from '../smithed.js';
import type { ResourceNode } from './resource.js';
/**
 * A node representing a custom resource.
 */
export declare class DependencyNode extends ContainerNode implements ResourceNode<SmithedDependencyClass> {
    resource: SmithedDependencyClass;
    constructor(sandstoneCore: SandstoneCore, resource: SmithedDependencyClass);
    getValue: () => Buffer;
}
export declare class SmithedDependencyClass extends ResourceClass<DependencyNode> {
    dependency: Dependency;
    side: 'client' | 'server';
    constructor(sandstoneCore: SandstoneCore, name: string, dependency: Dependency, side: 'client' | 'server');
    getValue(): Buffer;
}
