import { ContainerNode } from '../nodes.js';
import { ResourceClass } from './resource.js';
/**
 * A node representing a custom resource.
 */
export class DependencyNode extends ContainerNode {
    resource;
    constructor(sandstoneCore, resource) {
        super(sandstoneCore);
        this.resource = resource;
    }
    getValue = () => this.resource.getValue();
}
export class SmithedDependencyClass extends ResourceClass {
    dependency;
    side;
    constructor(sandstoneCore, name, dependency, side) {
        super(sandstoneCore, {
            packType: (side === 'client' ? sandstoneCore.pack.packTypes.get('resourcepack-dependencies') : sandstoneCore.pack.packTypes.get('datapack-dependencies')),
            extension: 'zip',
            encoding: false,
        }, DependencyNode, [name], {
            addToSandstoneCore: true,
            creator: 'sandstone',
        });
        this.dependency = dependency;
        this.side = side;
        this.handleConflicts();
    }
    getValue() {
        if (this.side === 'client') {
            return this.dependency.resourcepack;
        }
        return this.dependency.datapack;
    }
}
