import { ContainerNode } from '../../nodes.js';
import { ResourceClass } from '../resource.js';
import type { AtlasDefinition, AtlasSpriteSource } from 'sandstone/arguments';
import type { SandstoneCore } from '../../sandstoneCore.js';
import type { ListResource, ResourceClassArguments, ResourceNode } from '../resource.js';
/**
 * A node representing a Minecraft block state.
 */
export declare class AtlasNode extends ContainerNode implements ResourceNode<AtlasClass> {
    resource: AtlasClass;
    constructor(sandstoneCore: SandstoneCore, resource: AtlasClass);
    getValue: () => string;
}
export type AtlasClassArguments = {
    /**
     * The block state's JSON.
     */
    atlas?: AtlasDefinition;
} & ResourceClassArguments<'list'>;
export declare class AtlasClass extends ResourceClass<AtlasNode> implements ListResource {
    atlasJSON: NonNullable<AtlasClassArguments['atlas']>;
    constructor(core: SandstoneCore, name: string, args: AtlasClassArguments);
    push(...sources: AtlasSpriteSource[] | AtlasClass[]): void;
    unshift(...sources: AtlasSpriteSource[] | AtlasClass[]): void;
}
