import { ContainerNode } from '../../nodes.js';
import { ResourceClass } from '../resource.js';
/**
 * A node representing a Minecraft block state.
 */
export class AtlasNode extends ContainerNode {
    resource;
    constructor(sandstoneCore, resource) {
        super(sandstoneCore);
        this.resource = resource;
    }
    getValue = () => JSON.stringify(this.resource.atlasJSON);
}
export class AtlasClass extends ResourceClass {
    atlasJSON;
    constructor(core, name, args) {
        super(core, { packType: core.pack.resourcePack() }, AtlasNode, core.pack.resourceToPath(name, ['atlases']), args);
        this.atlasJSON = args.atlas || { sources: [] };
        this.handleConflicts();
    }
    push(...sources) {
        if (sources[0] instanceof AtlasClass) {
            for (const provider of sources) {
                /** @ts-ignore */
                this.atlasJSON.sources.push(...provider.atlasJSON.sources);
            }
        }
        else {
            /** @ts-ignore */
            this.atlasJSON.sources.push(...sources);
        }
    }
    unshift(...sources) {
        if (sources[0] instanceof AtlasClass) {
            for (const provider of sources) {
                /** @ts-ignore */
                this.atlasJSON.sources.unshift(...provider.atlasJSON.sources);
            }
        }
        else {
            /** @ts-ignore */
            this.atlasJSON.sources.unshift(...sources);
        }
    }
}
