"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var blockstate_exports = {};
__export(blockstate_exports, {
  BlockStateClass: () => BlockStateClass,
  BlockStateNode: () => BlockStateNode
});
module.exports = __toCommonJS(blockstate_exports);
var import_nodes = require("../../nodes.js");
var import_resource = require("../resource.js");
class BlockStateNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "getValue", () => JSON.stringify(this.resource.blockStateJSON));
  }
}
class BlockStateClass extends import_resource.ResourceClass {
  constructor(core, name, type, args) {
    super(core, { packType: core.pack.resourcePack() }, BlockStateNode, core.pack.resourceToPath(name, ["blockstates"]), args);
    this.type = type;
    __publicField(this, "blockStateJSON");
    this.blockStateJSON = args.blockState || (type === "variant" ? { variants: {} } : { multipart: [] });
    this.handleConflicts();
  }
  push(...states) {
    if (this.type === "variant") {
      if (states[0] instanceof BlockStateClass) {
        for (const state of states) {
          this.blockStateJSON.variants = { ...this.blockStateJSON.variants, ...state.blockStateJSON.variants };
        }
      } else {
        for (const state of states) {
          this.blockStateJSON.variants = { ...this.blockStateJSON.variants, ...state.variants };
        }
      }
    }
    if (this.type === "multipart") {
      if (states[0] instanceof BlockStateClass) {
        for (const state of states) {
          this.blockStateJSON.multipart.push(...state.blockStateJSON.multipart);
        }
      } else {
        for (const state of states) {
          this.blockStateJSON.multipart.push(...state.multipart);
        }
      }
    }
  }
  unshift(...states) {
    if (this.type === "variant") {
      if (states[0] instanceof BlockStateClass) {
        for (const state of states) {
          this.blockStateJSON.variants = { ...state.blockStateJSON.variants, ...this.blockStateJSON.variants };
        }
      } else {
        for (const state of states) {
          this.blockStateJSON.variants = { ...state.variants, ...this.blockStateJSON.variants };
        }
      }
    }
    if (this.type === "multipart") {
      if (states[0] instanceof BlockStateClass) {
        for (const state of states) {
          this.blockStateJSON.multipart.unshift(...state.blockStateJSON.multipart);
        }
      } else {
        for (const state of states) {
          this.blockStateJSON.multipart.unshift(...state.multipart);
        }
      }
    }
  }
  /*
   * blockWithState<B extends keyof Blockstates>(
   * block: LiteralUnion<B>,
   * state?: (B extends keyof Blockstates ? Blockstates[B] : Blockstates[keyof Blockstates]) | { [name: string]: string},
   * ): string {
   * let id: string = block
   * if (state) {
   *  id += `[${Object.entries(state).map(([name, val]) => `${name}=${val}`).join(',')}]`
   * }
   * return id
   * }
   */
  async load() {
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  BlockStateClass,
  BlockStateNode
});
//# sourceMappingURL=blockstate.cjs.map