"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var font_exports = {};
__export(font_exports, {
  FontClass: () => FontClass,
  FontNode: () => FontNode
});
module.exports = __toCommonJS(font_exports);
var import_nodes = require("../../nodes.js");
var import_resource = require("../resource.js");
class FontNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "getValue", () => JSON.stringify(this.resource.fontJSON));
  }
}
class FontClass extends import_resource.ResourceClass {
  constructor(core, name, args) {
    super(core, { packType: core.pack.resourcePack() }, FontNode, core.pack.resourceToPath(name, ["font"]), args);
    __publicField(this, "fontJSON");
    this.fontJSON = { providers: args.providers };
    this.handleConflicts();
  }
  push(...providers) {
    if (providers[0] instanceof FontClass) {
      for (const provider of providers) {
        this.fontJSON.providers.push(...provider.fontJSON.providers);
      }
    } else {
      this.fontJSON.providers.push(...providers);
    }
  }
  unshift(...providers) {
    if (providers[0] instanceof FontClass) {
      for (const provider of providers) {
        this.fontJSON.providers.unshift(...provider.fontJSON.providers);
      }
    } else {
      this.fontJSON.providers.unshift(...providers);
    }
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  FontClass,
  FontNode
});
//# sourceMappingURL=font.cjs.map