import { ContainerNode } from '../../nodes.js';
import { ResourceClass } from '../resource.js';
import type { FontProvider } from 'sandstone/arguments';
import type { SandstoneCore } from '../../sandstoneCore.js';
import type { ListResource, ResourceClassArguments, ResourceNode } from '../resource.js';
/**
 * A node representing a Minecraft font definition.
 */
export declare class FontNode extends ContainerNode implements ResourceNode<FontClass> {
    resource: FontClass;
    constructor(sandstoneCore: SandstoneCore, resource: FontClass);
    getValue: () => string;
}
export type FontArguments = {
    /**
     * The font's JSON.
     */
    providers: FontProvider[] | [];
} & ResourceClassArguments<'list'>;
export declare class FontClass extends ResourceClass<FontNode> implements ListResource {
    fontJSON: {
        providers: FontArguments['providers'];
    };
    constructor(core: SandstoneCore, name: string, args: FontArguments);
    push(...providers: FontProvider[] | FontClass[]): void;
    unshift(...providers: FontProvider[] | FontClass[]): void;
}
