import { ContainerNode } from '../../nodes.js';
import { ResourceClass } from '../resource.js';
/**
 * A node representing a Minecraft font definition.
 */
export class FontNode extends ContainerNode {
    resource;
    constructor(sandstoneCore, resource) {
        super(sandstoneCore);
        this.resource = resource;
    }
    getValue = () => JSON.stringify(this.resource.fontJSON);
}
export class FontClass extends ResourceClass {
    fontJSON;
    constructor(core, name, args) {
        super(core, { packType: core.pack.resourcePack() }, FontNode, core.pack.resourceToPath(name, ['font']), args);
        this.fontJSON = { providers: args.providers };
        this.handleConflicts();
    }
    push(...providers) {
        if (providers[0] instanceof FontClass) {
            for (const provider of providers) {
                /** @ts-ignore */
                this.fontJSON.providers.push(...provider.fontJSON.providers);
            }
        }
        else {
            /** @ts-ignore */
            this.fontJSON.providers.push(...providers);
        }
    }
    unshift(...providers) {
        if (providers[0] instanceof FontClass) {
            for (const provider of providers) {
                /** @ts-ignore */
                this.fontJSON.providers.unshift(...provider.fontJSON.providers);
            }
        }
        else {
            /** @ts-ignore */
            this.fontJSON.providers.unshift(...providers);
        }
    }
}
