"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var language_exports = {};
__export(language_exports, {
  LanguageClass: () => LanguageClass,
  LanguageNode: () => LanguageNode
});
module.exports = __toCommonJS(language_exports);
var import_nodes = require("../../nodes.js");
var import_resource = require("../resource.js");
class LanguageNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "getValue", () => JSON.stringify(this.resource.languageJSON));
  }
}
class LanguageClass extends import_resource.ResourceClass {
  constructor(core, name, args) {
    super(core, { packType: core.pack.resourcePack() }, LanguageNode, core.pack.resourceToPath(name, ["lang"]), args);
    __publicField(this, "languageJSON");
    this.languageJSON = args.language || {};
    this.handleConflicts();
  }
  push(...translations) {
    if (translations[0] instanceof LanguageClass) {
      for (const translation of translations) {
        this.languageJSON = { ...this.languageJSON, ...translation.languageJSON };
      }
    } else {
      for (const translation of translations) {
        this.languageJSON = { ...this.languageJSON, ...translation };
      }
    }
  }
  unshift(...translations) {
    if (translations[0] instanceof LanguageClass) {
      for (const translation of translations) {
        this.languageJSON = { ...translation.languageJSON, ...this.languageJSON };
      }
    } else {
      for (const translation of translations) {
        this.languageJSON = { ...translation, ...this.languageJSON };
      }
    }
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  LanguageClass,
  LanguageNode
});
//# sourceMappingURL=language.cjs.map