import { ContainerNode } from '../../nodes.js';
import { ResourceClass } from '../resource.js';
import type { SandstoneCore } from '../../sandstoneCore.js';
import type { ListResource, ResourceClassArguments, ResourceNode } from '../resource.js';
import type { TRANSLATION_KEYS } from 'sandstone/arguments';
/**
 * A node representing a Minecraft language file.
 */
export declare class LanguageNode extends ContainerNode implements ResourceNode<LanguageClass> {
    resource: LanguageClass;
    constructor(sandstoneCore: SandstoneCore, resource: LanguageClass);
    getValue: () => string;
}
export type LanguageArguments = {
    /**
     * The language's JSON.
     */
    language?: Partial<Record<TRANSLATION_KEYS, string>> | {
        [key: string]: string;
    };
} & ResourceClassArguments<'list'>;
export declare class LanguageClass extends ResourceClass<LanguageNode> implements ListResource {
    languageJSON: NonNullable<LanguageArguments['language']>;
    constructor(core: SandstoneCore, name: string, args: LanguageArguments);
    push(...translations: NonNullable<LanguageArguments['language']>[] | LanguageClass[]): void;
    unshift(...translations: NonNullable<LanguageArguments['language']>[] | LanguageClass[]): void;
}
