import { ContainerNode } from '../../nodes.js';
import { ResourceClass } from '../resource.js';
/**
 * A node representing a Minecraft language file.
 */
export class LanguageNode extends ContainerNode {
    resource;
    constructor(sandstoneCore, resource) {
        super(sandstoneCore);
        this.resource = resource;
    }
    getValue = () => JSON.stringify(this.resource.languageJSON);
}
export class LanguageClass extends ResourceClass {
    languageJSON;
    constructor(core, name, args) {
        super(core, { packType: core.pack.resourcePack() }, LanguageNode, core.pack.resourceToPath(name, ['lang']), args);
        this.languageJSON = args.language || {};
        this.handleConflicts();
    }
    push(...translations) {
        if (translations[0] instanceof LanguageClass) {
            for (const translation of translations) {
                /** @ts-ignore */
                this.languageJSON = { ...this.languageJSON, ...translation.languageJSON };
            }
        }
        else {
            for (const translation of translations) {
                /** @ts-ignore */
                this.languageJSON = { ...this.languageJSON, ...translation };
            }
        }
    }
    unshift(...translations) {
        if (translations[0] instanceof LanguageClass) {
            for (const translation of translations) {
                /** @ts-ignore */
                this.languageJSON = { ...translation.languageJSON, ...this.languageJSON };
            }
        }
        else {
            for (const translation of translations) {
                /** @ts-ignore */
                this.languageJSON = { ...translation, ...this.languageJSON };
            }
        }
    }
}
