"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var sound_exports = {};
__export(sound_exports, {
  SoundEventClass: () => SoundEventClass,
  SoundEventNode: () => SoundEventNode,
  SoundsClass: () => SoundsClass,
  SoundsNode: () => SoundsNode
});
module.exports = __toCommonJS(sound_exports);
var import_path = __toESM(require("path"), 1);
var import_nodes = require("../../nodes.js");
var import_resource = require("../resource.js");
const sounds = /* @__PURE__ */ new Map();
class SoundEventNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "getValue", () => this.resource.buffer);
  }
}
class SoundEventClass extends import_resource.ResourceClass {
  constructor(core, type, name, args) {
    super(core, { packType: core.pack.resourcePack(), extension: "ogg", encoding: false }, SoundEventNode, core.pack.resourceToPath(name, ["sounds", type]), args);
    this.type = type;
    __publicField(this, "buffer");
    if (args.addToSandstoneCore && args.sound !== void 0) {
      if (typeof args.sound === "string") {
        this.buffer = core.getExistingResource(import_path.default.join("resourcepack", "assets", ...this.path), false);
      } else {
        this.buffer = args.sound;
      }
      if (args.addToSounds) {
        let def = sounds.get(this.path[0]);
        if (!def) {
          def = sounds.set(this.path[0], new SoundsClass(this.core, this.path[0], {
            addToSandstoneCore: true,
            creator: "sandstone"
          })).get(this.path[0]);
        }
        def.push(this);
      }
    }
    this.handleConflicts();
  }
  // TODO: Add sound event methods; play, stop, etc.
  // silent() {}
}
class SoundsNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "getValue", () => JSON.stringify(this.resource.soundsJSON));
  }
}
class SoundsClass extends import_resource.ResourceClass {
  constructor(core, namespace, args) {
    super(core, { packType: core.pack.resourcePack() }, SoundsNode, core.pack.resourceToPath(`${namespace}:sounds`, []), args);
    __publicField(this, "soundsJSON");
    if (args.definitions) {
      this.soundsJSON = args.definitions;
    } else {
      this.soundsJSON = (async () => JSON.parse(await core.getExistingResource(this)))();
    }
  }
  async push(...soundEvents) {
    if (soundEvents[0] instanceof SoundsClass) {
      for await (const _sounds of soundEvents) {
        const def = _sounds;
        const s = await this.soundsJSON;
        this.soundsJSON = { ...s, ...def };
      }
    } else {
      for await (const _sound of soundEvents) {
        const sound = _sound;
        const s = await this.soundsJSON;
        s[`${sound.type}.${sound.name}`] = {
          sounds: [`${sound.type}.${sound.name}`]
        };
      }
    }
  }
  async unshift(...soundEvents) {
    if (soundEvents[0] instanceof SoundsClass) {
      for await (const _sounds of soundEvents) {
        const def = _sounds;
        const s = await this.soundsJSON;
        this.soundsJSON = { ...def, ...s };
      }
    } else {
      for await (const _sound of soundEvents) {
        const sound = _sound;
        const s = await this.soundsJSON;
        s[`${sound.type}.${sound.name}`] = {
          sounds: [`${sound.type}.${sound.name}`]
        };
      }
    }
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  SoundEventClass,
  SoundEventNode,
  SoundsClass,
  SoundsNode
});
//# sourceMappingURL=sound.cjs.map