"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var text_exports = {};
__export(text_exports, {
  PlainTextClass: () => PlainTextClass,
  PlainTextNode: () => PlainTextNode
});
module.exports = __toCommonJS(text_exports);
var import_variables = require("sandstone/variables");
var import_nodes = require("../../nodes.js");
var import_resource = require("../resource.js");
class PlainTextNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "getValue", () => this.resource.texts);
  }
}
class PlainTextClass extends import_resource.ResourceClass {
  constructor(core, name, args) {
    super(core, { packType: core.pack.resourcePack(), extension: "txt" }, PlainTextNode, core.pack.resourceToPath(name, ["texts"]), args);
    __publicField(this, "texts", "");
    this.texts = "";
    if (args.text) {
      if (Array.isArray(args.text)) {
        this.push(...args.text);
      } else {
        this.push(args.text);
      }
    }
    this.handleConflicts();
  }
  componentToPlainText(__text) {
    const text = new import_variables.JSONTextComponentClass(__text).toJSON();
    let converted = "";
    const type = typeof text;
    if (type === "string") {
      converted += text;
    } else if (type === "boolean" || type === "number") {
      converted += `${text}`;
    } else if (Array.isArray(text)) {
      for (const _text of text) {
        converted += this.componentToPlainText(_text);
      }
    } else {
      const currentText = text;
      if (!currentText.text) {
        throw new Error("Dynamic JSON content is not supported in plaintext");
      }
      if (currentText.color) {
        const { color } = currentText;
        if (color.startsWith("#")) {
          throw new Error("Hex codes are not supported in plaintext");
        }
        const colors = ["black", "dark_blue", "dark_green", "dark_aqua", "dark_red", "dark_purple", "gold", "gray", "dark_gray", "blue", "green", "aqua", "red", "light_purple", "yellow", "white"];
        converted = `\xA7${colors.indexOf(color).toString(16)}`;
      }
      if (currentText.obfuscated) {
        converted += "\xA7k";
      }
      if (currentText.bold) {
        converted += "\xA7l";
      }
      if (currentText.strikethrough) {
        converted += "\xA7m";
      }
      if (currentText.underlined) {
        converted += "\xA7n";
      }
      if (currentText.italic) {
        converted += "\xA7o";
      }
      converted += `${currentText.text}`;
      if (currentText.extra) {
        converted += this.componentToPlainText(currentText.extra);
      }
    }
    return converted;
  }
  push(...texts) {
    if (typeof texts[0] === "string") {
      for (const text of texts) {
        this.texts += `${text}
`;
      }
    } else {
      for (const text of texts) {
        this.texts += `${this.componentToPlainText(text)}
`;
      }
    }
  }
  unshift(...texts) {
    if (typeof texts[0] === "string") {
      for (const text of texts) {
        this.texts = `${text}
${this.texts}`;
      }
    } else {
      for (const text of texts) {
        this.texts = `${this.componentToPlainText(text)}
${this.texts}`;
      }
    }
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  PlainTextClass,
  PlainTextNode
});
//# sourceMappingURL=text.cjs.map