import { ContainerNode } from '../../nodes.js';
import { ResourceClass } from '../resource.js';
import type { JSONTextComponent } from 'sandstone/arguments';
import type { SandstoneCore } from '../../sandstoneCore.js';
import type { ListResource, ResourceClassArguments, ResourceNode } from '../resource.js';
/**
 * A node representing a Minecraft text.
 */
export declare class PlainTextNode extends ContainerNode implements ResourceNode<PlainTextClass> {
    resource: PlainTextClass;
    constructor(sandstoneCore: SandstoneCore, resource: PlainTextClass);
    getValue: () => NonNullable<string[] | JSONTextComponent | JSONTextComponent[] | undefined>;
}
export type PlainTextArguments = {
    /**
     * The text.
     */
    text?: string | JSONTextComponent | string[] | JSONTextComponent[];
} & ResourceClassArguments<'list'>;
export declare class PlainTextClass extends ResourceClass<PlainTextNode> implements ListResource {
    texts: NonNullable<PlainTextArguments['text']>;
    constructor(core: SandstoneCore, name: string, args: PlainTextArguments);
    componentToPlainText(__text: JSONTextComponent): string;
    push(...texts: string[] | JSONTextComponent[]): void;
    unshift(...texts: string[] | JSONTextComponent[]): void;
}
