"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var texture_exports = {};
__export(texture_exports, {
  TextureClass: () => TextureClass,
  TextureNode: () => TextureNode
});
module.exports = __toCommonJS(texture_exports);
var import_nodes = require("../../nodes.js");
var import_resource = require("../resource.js");
class TextureNode extends import_nodes.ContainerNode {
  constructor(sandstoneCore, resource) {
    super(sandstoneCore);
    this.resource = resource;
    __publicField(this, "getValue", () => this.resource.buffer);
  }
}
class TextureClass extends import_resource.ResourceClass {
  constructor(core, type, name, args) {
    super(core, { packType: core.pack.resourcePack(), extension: "png", encoding: false }, TextureNode, core.pack.resourceToPath(name, ["textures", type]), args);
    __publicField(this, "type");
    __publicField(this, "isSprite");
    __publicField(this, "spriteTarget");
    __publicField(this, "meta");
    __publicField(this, "buffer");
    this.type = type;
    this.buffer = args.texture;
    this.isSprite = args.sprite === void 0 ? false : args.sprite !== false;
    this.meta = args.meta;
    if (typeof args.sprite === "string") {
      this.spriteTarget = args.sprite;
    }
    this.handleConflicts();
  }
  toString() {
    return `${this.path[0]}:${this.path.slice(2)}`;
  }
  videoToAnimation(path) {
    console.log("Unimplemented");
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TextureClass,
  TextureNode
});
//# sourceMappingURL=texture.cjs.map