import { ContainerNode } from '../../nodes.js';
import { ResourceClass } from '../resource.js';
/**
 * A node representing a Minecraft sound.
 */
export class TextureNode extends ContainerNode {
    resource;
    constructor(sandstoneCore, resource) {
        super(sandstoneCore);
        this.resource = resource;
    }
    getValue = () => this.resource.buffer;
}
export class TextureClass extends ResourceClass {
    type;
    isSprite;
    spriteTarget;
    meta;
    buffer;
    constructor(core, type, name, args) {
        super(core, { packType: core.pack.resourcePack(), extension: 'png', encoding: false }, TextureNode, core.pack.resourceToPath(name, ['textures', type]), args);
        this.type = type;
        this.buffer = args.texture;
        this.isSprite = args.sprite === undefined ? false : args.sprite !== false;
        this.meta = args.meta;
        if (typeof args.sprite === 'string') {
            this.spriteTarget = args.sprite;
        }
        this.handleConflicts();
    }
    toString() {
        return `${this.path[0]}:${this.path.slice(2)}`;
    }
    videoToAnimation(path) {
        console.log('Unimplemented');
    }
}
