/// <reference types="node" resolution-mode="require"/>
import type { SandstoneCore } from './sandstoneCore.js';
export type Dependency = {
    version: string;
    date: number;
    added: boolean;
    datapack: Buffer;
    resourcepack?: Buffer | false;
};
export declare class SmithedDependencyCache {
    readonly core: SandstoneCore;
    constructor(core: SandstoneCore);
    readonly baseURL = "https://api.smithed.dev/v2/";
    readonly path: string;
    readonly manifest: string;
    readonly lockFile: string;
    dependencies: Map<string, Dependency>;
    loaded: boolean;
    load(): Promise<void>;
    save(): Promise<void>;
    get(dependency: string, version: string): Promise<Dependency>;
    has(dependency: string): boolean | undefined;
}
