"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var visitors_exports = {};
__export(visitors_exports, {
  GenericCoreVisitor: () => GenericCoreVisitor,
  ancestors: () => ancestors
});
module.exports = __toCommonJS(visitors_exports);
var import_core = require("sandstone/core");
function ancestors(prototype) {
  if (!prototype.name) {
    return [];
  }
  return [prototype.name, ...ancestors(Object.getPrototypeOf(prototype))];
}
class GenericCoreVisitor {
  constructor(core) {
    this.core = core;
    __publicField(this, "methodCache");
    __publicField(this, "getSingleNodeMethod", (nodeName) => {
      const methodName = `visit${nodeName}`;
      const that = this;
      const method = that[methodName];
      return method;
    });
    // eslint-disable-next-line @typescript-eslint/ban-types
    __publicField(this, "getNodeMethods", (prototype) => {
      const key = prototype.name;
      const cachedResult = this.methodCache.get(key);
      if (cachedResult) {
        return cachedResult;
      }
      const names = ancestors(prototype);
      for (const name of names) {
        const method = this.getSingleNodeMethod(name);
        if (method) {
          this.methodCache.set(key, method);
          return method;
        }
      }
      const result = (node_) => node_;
      this.methodCache.set(key, result);
      return result;
    });
    __publicField(this, "visit", (node) => this.getNodeMethods(node.constructor)(node));
    __publicField(this, "genericVisit", (node) => {
      if (node instanceof import_core.ContainerNode || node instanceof import_core.ContainerCommandNode) {
        node.body = node.body.flatMap((n) => this.visit(n));
      }
      return node;
    });
    __publicField(this, "onStart", () => {
    });
    __publicField(this, "onEnd", () => {
    });
    __publicField(this, "genericNodeVisitor", () => (node) => this.genericVisit(node));
    // Container nodes
    __publicField(this, "visitCommandNode", this.genericNodeVisitor());
    __publicField(this, "visitContainerCommandNode", this.genericNodeVisitor());
    __publicField(this, "visitContainerNode", this.genericNodeVisitor());
    // //// Those aren't necessary, but are here for better auto-completion & type-checking. //// //
    // Resources
    __publicField(this, "visitNode");
    __publicField(this, "visitMCFunctionNode");
    __publicField(this, "visitAdvancementNode");
    __publicField(this, "visitItemModifierNode");
    __publicField(this, "visitLootTableNode");
    __publicField(this, "visitPredicateNode");
    __publicField(this, "visitRecipeNode");
    __publicField(this, "visitTagNode");
    __publicField(this, "visitTrimMaterialNode");
    __publicField(this, "visitTrimPatternNode");
    this.methodCache = /* @__PURE__ */ new Map();
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  GenericCoreVisitor,
  ancestors
});
//# sourceMappingURL=visitors.cjs.map