import { ContainerCommandNode, ContainerNode } from 'sandstone/core';
import type { AdvancementNode, CommandNode, ItemModifierNode, LootTableNode, MCFunctionNode, Node, PredicateNode, RecipeNode, SandstoneCore, TagNode, TrimMaterialNode, TrimPatternNode } from 'sandstone/core';
export declare function ancestors(prototype: Function): string[];
export type NodeVisitorMethod = ((node_: Node) => Node | Node[]);
export type GenericNodeVisitor<N extends Node> = (node: N) => Node | Node[];
export type GenericResourceNodeVisitor<N extends Node> = (node: N) => N;
export declare class GenericCoreVisitor {
    core: SandstoneCore;
    private methodCache;
    constructor(core: SandstoneCore);
    private getSingleNodeMethod;
    private getNodeMethods;
    visit: (node: Node) => Node | Node[];
    genericVisit: <N extends Node>(node: N) => N;
    onStart: () => void;
    onEnd: () => void;
    protected genericNodeVisitor: <N extends Node>() => GenericNodeVisitor<N>;
    visitCommandNode: GenericNodeVisitor<CommandNode<unknown[]>>;
    visitContainerCommandNode: GenericNodeVisitor<ContainerCommandNode<unknown[]>>;
    visitContainerNode: GenericNodeVisitor<ContainerNode>;
    visitNode?: GenericNodeVisitor<Node>;
    visitMCFunctionNode?: GenericResourceNodeVisitor<MCFunctionNode>;
    visitAdvancementNode?: GenericResourceNodeVisitor<AdvancementNode>;
    visitItemModifierNode?: GenericResourceNodeVisitor<ItemModifierNode>;
    visitLootTableNode?: GenericResourceNodeVisitor<LootTableNode>;
    visitPredicateNode?: GenericResourceNodeVisitor<PredicateNode>;
    visitRecipeNode?: GenericResourceNodeVisitor<RecipeNode>;
    visitTagNode?: GenericResourceNodeVisitor<TagNode>;
    visitTrimMaterialNode?: GenericResourceNodeVisitor<TrimMaterialNode>;
    visitTrimPatternNode?: GenericResourceNodeVisitor<TrimPatternNode>;
}
