"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var Flow_exports = {};
__export(Flow_exports, {
  Flow: () => Flow
});
module.exports = __toCommonJS(Flow_exports);
var import_variables = require("sandstone/variables");
var import_conditions = require("./conditions/index.js");
var import_if_else = require("./if_else.js");
var import_loops = require("./loops/index.js");
var import_switch_case = require("./switch_case.js");
let switches = 0;
class Flow {
  constructor(sandstoneCore) {
    this.sandstoneCore = sandstoneCore;
    __publicField(this, "if", (condition, callback) => new import_if_else.IfStatement(this.sandstoneCore, this.conditionToNode(condition), callback));
    __publicField(this, "and", (...conditions) => new import_conditions.AndNode(this.sandstoneCore, conditions.map((condition) => this.conditionToNode(condition))));
    __publicField(this, "or", (...conditions) => new import_conditions.OrNode(this.sandstoneCore, conditions.map((condition) => this.conditionToNode(condition))));
    __publicField(this, "not", (condition) => new import_conditions.NotNode(this.sandstoneCore, this.conditionToNode(condition)));
  }
  conditionToNode(condition) {
    if (!(condition instanceof import_conditions.ConditionNode)) {
      return condition._toMinecraftCondition();
    }
    return condition;
  }
  get return() {
    return this.sandstoneCore.pack.commands.returnCmd;
  }
  throw(error, broadcast, dataPoint) {
    const { pack, getCurrentMCFunctionOrThrow } = this.sandstoneCore;
    const { DataVariable, commands } = pack;
    const { tellraw, returnCmd } = commands;
    const node = getCurrentMCFunctionOrThrow();
    const fullError = [
      { text: "\nSandstone Pack Error:\n", color: "yellow" },
      error || "[Function Threw]",
      "\n\n",
      `@ Function ${node.resource.name}. Node ${node.body.length - 1}.
`
    ];
    if (broadcast !== false) {
      tellraw(broadcast || "@a", fullError);
    }
    const errorString = (0, import_variables.parseJSONText)(fullError);
    if (dataPoint !== false) {
      let point;
      if (dataPoint === void 0) {
        point = DataVariable((0, import_variables.parseJSONText)(fullError));
      } else {
        point = dataPoint.set(errorString);
      }
      returnCmd.fail();
      return point;
    }
    returnCmd.fail();
    return errorString;
  }
  while(condition, callback) {
    return new import_loops.WhileStatement(this.sandstoneCore, this.conditionToNode(condition), callback);
  }
  doWhile(condition, callback) {
    callback();
    return new import_loops.WhileStatement(this.sandstoneCore, this.conditionToNode(condition), callback);
  }
  for(arg1, arg2, arg3, arg4) {
    if (typeof arg1 === "number" || arg1 instanceof import_variables.Score) {
      return new import_loops.ForIStatement(this.sandstoneCore, arg1, arg2, arg3, arg4);
    }
    if (arg1 === "entry") {
      return new import_loops.ForOfStatement(this.sandstoneCore, arg1, arg3, arg4);
    }
    if (arg1[0] === "key") {
      return new import_loops.ForOfStatement(this.sandstoneCore, arg1, arg3, arg4);
    }
    if (typeof arg1[0] === "number" || arg1[0] instanceof import_variables.Score) {
      if (arg2 === "iterate") {
        return new import_loops.ForIStatement(this.sandstoneCore, arg1[0], (i) => i["<="](arg1[1]), (i) => i["++"], arg3);
      }
      return (0, import_loops.binaryFor)(this, arg1[0], arg1[1], arg3, arg1[2]);
    }
    return new import_loops.ForOfStatement(this.sandstoneCore, arg1, arg3, arg4);
  }
  switch(value, _cases, _default) {
    let cases;
    if (_cases instanceof import_switch_case.CaseStatement) {
      cases = _cases["getCases"]().map((c) => c["getValue"]());
    } else if (Array.isArray(_cases)) {
      cases = _cases;
    } else {
      cases = _cases.cases.map((c) => c["getValue"]());
      _default = ["default", _cases.default];
    }
    const {
      Data,
      initMCFunction,
      MCFunction,
      Macro
    } = this.sandstoneCore.pack;
    const id = switches++;
    const values = Data("storage", `__sandstone:switch_${id}`, "Values");
    initMCFunction.push(() => values.set(cases.map(([_, v, callback], i) => {
      MCFunction(`__sandstone:switch_${id}_case_${i}`, [], () => callback());
      return { Value: v, Index: i };
    })));
    const flow = this;
    MCFunction(`__sandstone:switch_${id}`, [value], () => {
      const index = Data("storage", `__sandstone:switch_${id}`, "Index");
      Macro.data.modify.storage(index.currentTarget, "Index").set.from.storage(values.currentTarget, Macro`Values[{Value:${value}}}].Index`);
      const _if = flow.if(index, () => {
        MCFunction(`__sandstone:switch_${id}_inner`, [index], () => {
          Macro.functionCmd(Macro`__sandstone:switch_${id}_case_${index}`);
        })();
      });
      if (_default)
        _if.else(() => _default == null ? void 0 : _default[1]());
    })();
  }
  case(value, callback) {
    return new import_switch_case.CaseStatement(value, callback);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Flow
});
//# sourceMappingURL=Flow.cjs.map