import { rangeParser } from 'sandstone/variables/parsers';
import { SingleConditionNode } from './condition.js';
export class CommandConditionNode extends SingleConditionNode {
    type;
    result;
    variable;
    // eslint-disable-next-line max-len
    constructor(sandstoneCore, type, command, result = '1..') {
        super(sandstoneCore);
        this.type = type;
        this.result = result;
        const store = sandstoneCore.pack.commands.execute.store[type];
        this.variable = sandstoneCore.pack.Variable(undefined, 'condition');
        command(store.score(this.variable));
    }
    getCondition() {
        if (this.type === 'success') {
            return ['score', this.variable, 'matches', '1'];
        }
        if (typeof this.result === 'function') {
            /** @ts-ignore */
            return this.result(this.variable)._toMinecraftCondition().getCondition();
        }
        return ['score', this.variable, 'matches', rangeParser(this.sandstoneCore, this.result)];
    }
}
