import { AdvancementConditionNode } from './resources/advancement.js';
import { PredicateConditionNode } from './resources/predicate.js';
import { TagConditionNode } from './resources/tag.js';
import { TrimMaterialConditionNode } from './resources/trimMaterial.js';
import { TrimPatternConditionNode } from './resources/trimPattern.js';
import { DataPointEqualsConditionNode, DataPointExistsConditionNode } from './variables/dataPoint.js';
import { LabelConditionNode } from './variables/label.js';
import { ScoreConditionNode } from './variables/score.js';
import { SelectorConditionNode } from './variables/selector.js';
import { UUIDConditionNode } from './variables/uuid.js';
export * from './and.js';
export * from './condition.js';
export * from './not.js';
export * from './or.js';
export * from './variables/score.js';
export declare const SandstoneConditions: {
    Advancement: typeof AdvancementConditionNode;
    Predicate: typeof PredicateConditionNode;
    Tag: typeof TagConditionNode;
    TrimMaterial: typeof TrimMaterialConditionNode;
    TrimPattern: typeof TrimPatternConditionNode;
    DataPoint: typeof DataPointExistsConditionNode;
    DataPointEquals: typeof DataPointEqualsConditionNode;
    Label: typeof LabelConditionNode;
    Score: typeof ScoreConditionNode;
    Selector: typeof SelectorConditionNode;
    UUID: typeof UUIDConditionNode;
};
