import { IfNode } from '../if_else.js';
import { ConditionNode } from './condition.js';
export class OrNode extends ConditionNode {
    conditions;
    variable;
    constructor(sandstoneCore, conditions) {
        super(sandstoneCore);
        this.conditions = conditions;
        const { Variable, _ } = sandstoneCore.pack;
        this.variable = Variable(undefined, 'condition');
        const currentNode = this.sandstoneCore.getCurrentMCFunctionOrThrow();
        currentNode.resource.push(() => {
            this.variable.reset();
            for (const condition of conditions) {
                // eslint-disable-next-line no-new
                new IfNode(sandstoneCore, condition, () => this.variable.add(1), false);
            }
        });
    }
    getValue = (negated) => this.variable.matches('1..')._toMinecraftCondition().getValue(negated);
}
