"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var trimMaterial_exports = {};
__export(trimMaterial_exports, {
  TrimMaterialConditionNode: () => TrimMaterialConditionNode
});
module.exports = __toCommonJS(trimMaterial_exports);
var import_condition = require("../condition.js");
class TrimMaterialConditionNode extends import_condition.SingleConditionNode {
  constructor(sandstoneCore, trimMaterial) {
    super(sandstoneCore);
    this.trimMaterial = trimMaterial;
  }
  getCondition() {
    const { trimMaterial } = this;
    if (trimMaterial.equipmentCheck === "whole_inventory") {
      return ["data", "entity", "@s", `Inventory[{tag:{Trim:{material:"${trimMaterial.name}"}}}]`];
    }
    const slotCheck = {
      condition: "entity_properties",
      entity: "this",
      predicate: {
        equipment: {}
      }
    };
    for (const slot of trimMaterial.equipmentCheck ? [...trimMaterial.equipmentCheck] : ["mainhand", "offhand", "head", "chest", "legs", "feet"]) {
      slotCheck[slot] = {
        nbt: `{Trim:{material:"${trimMaterial.name}"}}`
      };
    }
    const predicate = this.sandstoneCore.pack.Predicate(`trim_material/${trimMaterial.path.slice(1).join("/")}`, slotCheck);
    return ["predicate", predicate.name];
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TrimMaterialConditionNode
});
//# sourceMappingURL=trimMaterial.cjs.map