import { SingleConditionNode } from '../condition.js';
export class DataPointExistsConditionNode extends SingleConditionNode {
    dataPoint;
    constructor(sandstoneCore, dataPoint) {
        super(sandstoneCore);
        this.dataPoint = dataPoint;
    }
    getCondition() {
        return ['data', this.dataPoint.type, this.dataPoint.currentTarget, this.dataPoint.path];
    }
}
export class DataPointEqualsConditionNode extends SingleConditionNode {
    dataPoint;
    value;
    conditional;
    constructor(sandstoneCore, dataPoint, value) {
        super(sandstoneCore);
        this.dataPoint = dataPoint;
        this.value = value;
        const { DataVariable, Variable, commands } = sandstoneCore.pack;
        const { execute } = commands;
        const anon = DataVariable(this.dataPoint);
        this.conditional = Variable();
        execute.store.result.score(this.conditional).run(() => anon.set(this.value));
    }
    getValue = (negated) => (negated ? ['if', ...this.getCondition()] : ['unless', ...this.getCondition()]).join(' ');
    getCondition() {
        return ['score', 'matches', '0..'];
    }
}
