import { CommandConditionNode } from '../command.js';
import { SingleConditionNode } from '../condition.js';
export class UUIDConditionNode extends SingleConditionNode {
    UUID;
    constructor(sandstoneCore, UUID) {
        super(sandstoneCore);
        this.UUID = UUID;
    }
    getCondition() {
        if (this.UUID.primarySource === 'known') {
            return new CommandConditionNode(this.sandstoneCore, 'result', (execute) => execute.as(this.UUID).if.entity('@s')).getCondition();
        }
        // TODO: Implement stack indexing when we get there
        return ['entity', `${this.UUID._toSelector()}`];
    }
}
