"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var if_else_exports = {};
__export(if_else_exports, {
  ElseNode: () => ElseNode,
  ElseStatement: () => ElseStatement,
  IfNode: () => IfNode,
  IfStatement: () => IfStatement
});
module.exports = __toCommonJS(if_else_exports);
var import_core = require("../core/index.js");
class IfNode extends import_core.ContainerNode {
  constructor(sandstoneCore, condition, callback, reset = false) {
    super(sandstoneCore);
    this.condition = condition;
    this.callback = callback;
    __publicField(this, "nextFlowNode");
    __publicField(this, "_isElseIf", false);
    __publicField(this, "getValue", () => {
      throw new Error("Minecraft does not support if statements. This must be postprocessed.");
    });
    const currentNode = this.sandstoneCore.getCurrentMCFunctionOrThrow();
    if (reset) {
      currentNode.resource.push(() => sandstoneCore.pack.flowVariable.reset());
    }
    if (callback.toString() !== "() => {}") {
      currentNode.enterContext(this);
      this.callback();
      currentNode.exitContext();
    }
  }
}
class IfStatement {
  constructor(sandstoneCore, condition, callback) {
    this.sandstoneCore = sandstoneCore;
    this.condition = condition;
    this.callback = callback;
    __publicField(this, "node");
    __publicField(this, "elseIf", (condition, callback) => {
      const statement = new IfStatement(this.sandstoneCore, this.sandstoneCore.pack.flow.conditionToNode(condition), callback);
      this.node.nextFlowNode = statement["getNode"]();
      statement.node["_isElseIf"] = true;
      return statement;
    });
    __publicField(this, "else", (callback) => {
      const statement = new ElseStatement(this.sandstoneCore, callback);
      this.node.nextFlowNode = statement["getNode"]();
      return statement;
    });
    __publicField(this, "getNode", () => this.node);
    this.node = new IfNode(sandstoneCore, condition, callback);
  }
}
class ElseNode extends import_core.ContainerNode {
  constructor(sandstoneCore, callback) {
    var _a;
    super(sandstoneCore);
    this.callback = callback;
    __publicField(this, "getValue", () => null);
    this.sandstoneCore.getCurrentMCFunctionOrThrow().enterContext(this);
    this.callback();
    (_a = this.sandstoneCore.currentMCFunction) == null ? void 0 : _a.exitContext();
  }
}
class ElseStatement {
  constructor(sandstoneCore, callback) {
    this.sandstoneCore = sandstoneCore;
    this.callback = callback;
    __publicField(this, "node");
    __publicField(this, "getNode", () => this.node);
    this.node = new ElseNode(sandstoneCore, callback);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ElseNode,
  ElseStatement,
  IfNode,
  IfStatement
});
//# sourceMappingURL=if_else.cjs.map