import { ContainerNode } from '../core/index.js';
import type { SandstoneCore } from '../core/index.js';
import type { ConditionNode } from './conditions/index.js';
import type { Condition } from './Flow.js';
export declare class IfNode extends ContainerNode {
    condition: ConditionNode;
    callback: () => void;
    nextFlowNode?: IfNode | ElseNode;
    protected _isElseIf: boolean;
    constructor(sandstoneCore: SandstoneCore, condition: ConditionNode, callback: () => void, reset?: boolean);
    getValue: () => never;
}
export declare class IfStatement {
    protected sandstoneCore: SandstoneCore;
    protected condition: ConditionNode;
    protected callback: () => void;
    protected node: IfNode;
    constructor(sandstoneCore: SandstoneCore, condition: ConditionNode, callback: () => void);
    elseIf: (condition: Condition, callback: () => void) => IfStatement;
    else: (callback: () => void) => ElseStatement;
    protected getNode: () => IfNode;
}
export declare class ElseNode extends ContainerNode {
    callback: () => void;
    constructor(sandstoneCore: SandstoneCore, callback: () => void);
    getValue: () => null;
}
export declare class ElseStatement {
    protected sandstoneCore: SandstoneCore;
    protected callback: () => void;
    protected node: ElseNode;
    constructor(sandstoneCore: SandstoneCore, callback: () => void);
    protected getNode: () => ElseNode;
}
