import { ContainerNode } from '../core/index.js';
export class LoopNode extends ContainerNode {
    executeArgs;
    callback;
    loopback;
    constructor(sandstoneCore, executeArgs, callback, loopback) {
        super(sandstoneCore);
        this.executeArgs = executeArgs;
        this.callback = callback;
        this.loopback = loopback;
        if (callback.toString() !== '() => {}') {
            const currentNode = this.sandstoneCore.getCurrentMCFunctionOrThrow();
            // Generate the body of the If node.
            currentNode.enterContext(this);
            this.callback();
            this.loopback();
            currentNode.exitContext();
        }
    }
    getValue = () => {
        throw new Error('Minecraft does not support loop statements. This must be postprocessed.');
    };
}
