import { LoopArgument } from 'sandstone/variables';
import { IfStatement } from '../if_else.js';
import { LoopNode } from '../loop.js';
export class ForINode extends LoopNode {
    // eslint-disable-next-line max-len
    constructor(sandstoneCore, initialValue, endCondition, iterate, callback) {
        callback(initialValue);
        // Since we're calling the callback once regardless, we need to increase the initial value by 1
        let initial = initialValue;
        if (typeof initial === 'number') {
            initial += 1;
        }
        const iterator = sandstoneCore.pack.Variable(initialValue, 'loop_iterator');
        if (typeof initial !== 'number') {
            iterator.increase();
        }
        const condition = sandstoneCore.pack._.conditionToNode(endCondition(iterator));
        const value = condition.getValue().split(' ');
        const conditionValue = [value[0], value.join(' ')];
        super(sandstoneCore, [conditionValue], () => callback(iterator), () => {
            iterate(iterator);
            return new IfStatement(sandstoneCore, condition, () => new LoopArgument(sandstoneCore.pack));
        });
    }
}
export class ForIStatement {
    sandstoneCore;
    initialValue;
    endCondition;
    iterate;
    callback;
    node;
    constructor(sandstoneCore, initialValue, endCondition, iterate, callback) {
        this.sandstoneCore = sandstoneCore;
        this.initialValue = initialValue;
        this.endCondition = endCondition;
        this.iterate = iterate;
        this.callback = callback;
        this.node = new ForINode(sandstoneCore, initialValue, endCondition, iterate, callback);
    }
    getNode = () => this.node;
}
