"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var for_of_exports = {};
__export(for_of_exports, {
  ForOfNode: () => ForOfNode,
  ForOfStatement: () => ForOfStatement
});
module.exports = __toCommonJS(for_of_exports);
var import_variables = require("sandstone/variables");
var import_if_else = require("../if_else.js");
var import_loop = require("../loop.js");
class ForOfNode extends import_loop.LoopNode {
  constructor(sandstoneCore, iteratorType, iterable, callback) {
    const _iterable = iterable._toDataPoint();
    let startCondition;
    let iterate;
    let continueCondition;
    if (Array.isArray(iteratorType)) {
      if (iteratorType[0] === "key") {
        startCondition = ["if", "data", _iterable.type, `${_iterable.path}{}`];
        iterate = iterable.iterator((dataPoints) => {
          if (dataPoints.length === 1) {
            throw new Error('Error: Attempt to use "for key value" loop with an Array dataset; this is not supported. (Hint: use "for entry" or "for i entry" instead)');
          }
          callback(...[dataPoints[0], dataPoints[1]]);
        });
      } else {
        startCondition = ["if", "data", _iterable.type, `${_iterable.path}{}`];
        const _iterator = sandstoneCore.pack.Variable();
        _iterator.set(iterable.size());
        continueCondition = _iterator["!="](-1);
        iterate = iterable.iterator((dataPoints) => {
          _iterator.decrease();
          if (dataPoints.length === 1) {
            return callback(...[_iterator, dataPoints[0]]);
          }
          return callback(...[_iterator, dataPoints[1]]);
        });
      }
    } else {
      startCondition = ["if", "data", _iterable.type, `${_iterable.path}{}`];
      iterate = iterable.iterator((dataPoints) => {
        if (dataPoints.length === 1) {
          return callback(...[dataPoints[0]]);
        }
        return callback(...[dataPoints[1]]);
      });
    }
    iterate();
    super(sandstoneCore, [startCondition], () => iterate, () => new import_if_else.IfStatement(sandstoneCore, continueCondition || iterable.continue, () => new import_variables.LoopArgument(sandstoneCore.pack)));
  }
}
class ForOfStatement {
  constructor(sandstoneCore, iteratorType, iterable, callback) {
    this.sandstoneCore = sandstoneCore;
    this.iteratorType = iteratorType;
    this.iterable = iterable;
    this.callback = callback;
    __publicField(this, "node");
    __publicField(this, "getNode", () => this.node);
    this.node = new ForOfNode(sandstoneCore, iteratorType, iterable, callback);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ForOfNode,
  ForOfStatement
});
//# sourceMappingURL=for_of.cjs.map