import { LoopNode } from '../loop.js';
import type { SandstoneCore } from 'sandstone/core/sandstoneCore.js';
import type { DataPointClass, IterableDataClass, Score, StringDataPointClass } from 'sandstone/variables';
export type ForOfIterator = 'entry' | ['i', 'entry'] | ['key', 'value'];
export type ForOfIterate<ITERATOR extends ForOfIterator> = ITERATOR extends 'entry' ? [entry: DataPointClass] : ITERATOR extends string[] ? ITERATOR[0] extends 'i' ? [index: Score, entry: DataPointClass] : [key: StringDataPointClass, value: DataPointClass] : [never];
export declare class ForOfNode<ITERATOR extends ForOfIterator, ITERATE extends ForOfIterate<ForOfIterator>> extends LoopNode {
    constructor(sandstoneCore: SandstoneCore, iteratorType: ITERATOR, iterable: IterableDataClass, callback: (...args: ITERATE) => any);
}
export declare class ForOfStatement<ITERATOR extends ForOfIterator, ITERATE extends ForOfIterate<ForOfIterator>> {
    protected sandstoneCore: SandstoneCore;
    protected iteratorType: ITERATOR;
    protected iterable: IterableDataClass;
    protected callback: (...args: ITERATE) => any;
    protected node: ForOfNode<ITERATOR, ITERATE>;
    constructor(sandstoneCore: SandstoneCore, iteratorType: ITERATOR, iterable: IterableDataClass, callback: (...args: ITERATE) => any);
    protected getNode: () => ForOfNode<ITERATOR, ITERATE>;
}
