import { LoopArgument } from 'sandstone/variables';
import { IfStatement } from '../if_else.js';
import { LoopNode } from '../loop.js';
export class WhileNode extends LoopNode {
    constructor(sandstoneCore, condition, callback) {
        const _condition = sandstoneCore.pack._.conditionToNode(condition);
        super(sandstoneCore, [_condition.getValue().split(' ')], callback, () => new IfStatement(sandstoneCore, _condition, () => new LoopArgument(sandstoneCore.pack)));
    }
}
export class WhileStatement {
    sandstoneCore;
    condition;
    callback;
    node;
    constructor(sandstoneCore, condition, callback) {
        this.sandstoneCore = sandstoneCore;
        this.condition = condition;
        this.callback = callback;
        this.node = new WhileNode(sandstoneCore, condition, callback);
    }
}
