import type { NBTObject } from 'sandstone/arguments';
export type DefaultType<ValueType extends number | NBTObject> = {
    cases: CaseStatement<ValueType>[];
    default: () => any;
};
export declare class CaseStatement<ValueType extends number | NBTObject> {
    readonly value: ValueType;
    readonly callback: () => any;
    readonly previous?: CaseStatement<ValueType>[] | undefined;
    constructor(value: ValueType, callback: () => any, previous?: CaseStatement<ValueType>[] | undefined);
    protected getCases: () => CaseStatement<ValueType>[];
    protected getValue(): readonly ['case', ValueType, () => any];
    case(value: ValueType, callback: () => any): CaseStatement<ValueType>;
    default(callback: () => any): {
        cases: CaseStatement<ValueType>[];
        default: () => any;
    };
}
