"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var src_exports = {};
__export(src_exports, {
  Advancement: () => Advancement,
  Atlas: () => Atlas,
  BlockState: () => BlockState,
  DamageType: () => DamageType,
  Data: () => Data,
  DataArray: () => DataArray,
  DataIndexMap: () => DataIndexMap,
  DataVariable: () => DataVariable,
  Font: () => Font,
  ItemModifier: () => ItemModifier,
  Label: () => Label,
  Language: () => Language,
  LootTable: () => LootTable,
  MCFunction: () => MCFunction,
  Macro: () => Macro,
  Model: () => Model,
  Objective: () => Objective,
  PlainText: () => PlainText,
  Predicate: () => Predicate,
  RawResource: () => RawResource,
  Recipe: () => Recipe,
  ResolveNBT: () => ResolveNBT,
  ResolveNBTPart: () => import_ResolveNBT.ResolveNBTPart,
  SandstonePack: () => import_pack.SandstonePack,
  Selector: () => Selector,
  SoundEvent: () => SoundEvent,
  Tag: () => Tag,
  Texture: () => Texture,
  TrimMaterial: () => TrimMaterial,
  TrimPattern: () => TrimPattern,
  UUID: () => UUID,
  Variable: () => Variable,
  _: () => _,
  advancement: () => advancement,
  attribute: () => attribute,
  bossbar: () => bossbar,
  clear: () => clear,
  clone: () => clone,
  comment: () => comment,
  damage: () => damage,
  data: () => data,
  datapack: () => datapack,
  debug: () => debug,
  defaultgamemode: () => defaultgamemode,
  depend: () => depend,
  difficulty: () => difficulty,
  effect: () => effect,
  enchant: () => enchant,
  execute: () => execute,
  experience: () => experience,
  fill: () => fill,
  flowVariable: () => flowVariable,
  forceload: () => forceload,
  functionCmd: () => functionCmd,
  gamemode: () => gamemode,
  gamerule: () => gamerule,
  getExistingResource: () => getExistingResource,
  getTempStorage: () => getTempStorage,
  getVanillaResource: () => getVanillaResource,
  give: () => give,
  help: () => help,
  item: () => item,
  kill: () => kill,
  list: () => list,
  locate: () => locate,
  loot: () => loot,
  makeCustomResource: () => makeCustomResource,
  mcmetaCache: () => mcmetaCache,
  me: () => me,
  msg: () => msg,
  packTypes: () => packTypes,
  particle: () => particle,
  playsound: () => playsound,
  raw: () => raw,
  recipe: () => recipe,
  reload: () => reload,
  returnCmd: () => returnCmd,
  sandstonePack: () => sandstonePack,
  say: () => say,
  schedule: () => schedule,
  scoreboard: () => scoreboard,
  seed: () => seed,
  setblock: () => setblock,
  setidletimeout: () => setidletimeout,
  setworldspawn: () => setworldspawn,
  sleep: () => sleep,
  spawnpoint: () => spawnpoint,
  spectate: () => spectate,
  spreadplayers: () => spreadplayers,
  stopsound: () => stopsound,
  summon: () => summon,
  tag: () => tag,
  team: () => team,
  teammsg: () => teammsg,
  teleport: () => teleport,
  tell: () => tell,
  tellraw: () => tellraw,
  time: () => time,
  title: () => title,
  tm: () => tm,
  tp: () => tp,
  trigger: () => trigger,
  w: () => w,
  weather: () => weather,
  worldborder: () => worldborder,
  xp: () => xp
});
module.exports = __toCommonJS(src_exports);
var import_pack = require("./pack/index.js");
var import_ResolveNBT = require("./variables/ResolveNBT.js");
const sandstonePack = new import_pack.SandstonePack("default", "0");
const {
  advancement,
  attribute,
  bossbar,
  clear,
  clone,
  comment,
  damage,
  data,
  datapack,
  debug,
  defaultgamemode,
  difficulty,
  effect,
  enchant,
  execute,
  experience,
  fill,
  functionCmd,
  forceload,
  gamemode,
  gamerule,
  give,
  help,
  kill,
  list,
  locate,
  loot,
  me,
  msg,
  particle,
  playsound,
  raw,
  recipe,
  reload,
  returnCmd,
  item,
  say,
  schedule,
  scoreboard,
  seed,
  setblock,
  setidletimeout,
  setworldspawn,
  spawnpoint,
  spectate,
  spreadplayers,
  stopsound,
  summon,
  tag,
  team,
  teammsg,
  teleport,
  tellraw,
  time,
  title,
  trigger,
  w,
  weather,
  worldborder,
  tm,
  tp,
  xp,
  tell
} = sandstonePack.commands;
const {
  // Resources
  RawResource,
  MCFunction,
  Advancement,
  DamageType,
  ItemModifier,
  LootTable,
  Predicate,
  Recipe,
  Tag,
  TrimMaterial,
  TrimPattern,
  Atlas,
  BlockState,
  Font,
  Language,
  Model,
  SoundEvent,
  PlainText,
  // TODO: text type is any when in a workspace, w h y
  Texture,
  // Variables
  packTypes,
  Objective,
  Macro,
  _,
  Variable,
  flowVariable,
  Label,
  Data,
  DataVariable,
  getTempStorage,
  ResolveNBT,
  DataIndexMap,
  DataArray,
  Selector,
  UUID,
  makeCustomResource,
  sleep
} = sandstonePack;
const {
  getVanillaResource,
  getExistingResource,
  mcmetaCache,
  depend
} = sandstonePack.core;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Advancement,
  Atlas,
  BlockState,
  DamageType,
  Data,
  DataArray,
  DataIndexMap,
  DataVariable,
  Font,
  ItemModifier,
  Label,
  Language,
  LootTable,
  MCFunction,
  Macro,
  Model,
  Objective,
  PlainText,
  Predicate,
  RawResource,
  Recipe,
  ResolveNBT,
  ResolveNBTPart,
  SandstonePack,
  Selector,
  SoundEvent,
  Tag,
  Texture,
  TrimMaterial,
  TrimPattern,
  UUID,
  Variable,
  _,
  advancement,
  attribute,
  bossbar,
  clear,
  clone,
  comment,
  damage,
  data,
  datapack,
  debug,
  defaultgamemode,
  depend,
  difficulty,
  effect,
  enchant,
  execute,
  experience,
  fill,
  flowVariable,
  forceload,
  functionCmd,
  gamemode,
  gamerule,
  getExistingResource,
  getTempStorage,
  getVanillaResource,
  give,
  help,
  item,
  kill,
  list,
  locate,
  loot,
  makeCustomResource,
  mcmetaCache,
  me,
  msg,
  packTypes,
  particle,
  playsound,
  raw,
  recipe,
  reload,
  returnCmd,
  sandstonePack,
  say,
  schedule,
  scoreboard,
  seed,
  setblock,
  setidletimeout,
  setworldspawn,
  sleep,
  spawnpoint,
  spectate,
  spreadplayers,
  stopsound,
  summon,
  tag,
  team,
  teammsg,
  teleport,
  tell,
  tellraw,
  time,
  title,
  tm,
  tp,
  trigger,
  w,
  weather,
  worldborder,
  xp
});
//# sourceMappingURL=index.cjs.map