/// <reference types="node" resolution-mode="require"/>
/// <reference types="node" resolution-mode="require"/>
import { SandstonePack } from './pack/index.js';
import { ResolveNBTPart } from './variables/ResolveNBT.js';
import type { JSONTextComponent } from './arguments/jsonTextComponent.js';
import type { AdvancementClassArguments, AtlasClassArguments, BlockStateArguments, DamageTypeClassArguments, FontArguments, ItemModifierClassArguments, LanguageArguments, LootTableClassArguments, MCFunctionClassArguments, ModelClassArguments, PlainTextArguments, PredicateClassArguments, RecipeClassArguments, SoundEventArguments, TagClassArguments, TextureArguments, TrimMaterialClassArguments, TrimPatternClassArguments } from './core/index.js';
import type { BASIC_CONFLICT_STRATEGIES, LiteralUnion } from './utils.js';
export declare const sandstonePack: SandstonePack;
export { SandstonePack };
export { ResolveNBTPart };
export declare const advancement: import("./commands/index.js").AdvancementCommand<false>, attribute: (target: import("./arguments/selector.js").SingleEntityArgument<false>, attribute: string) => import("./commands/helpers.js").FinalCommandOutput, bossbar: import("./commands/index.js").BossBarCommand<false>, clear: (targets?: import("./arguments/selector.js").MultiplePlayersArgument<false> | undefined, item?: LiteralUnion<import("./arguments/index.js").ITEMS> | import("./core/index.js").TagClass<"items"> | undefined, maxCount?: number | undefined) => import("./commands/helpers.js").FinalCommandOutput, clone: (begin: import("./arguments/coords.js").Coordinates<false>, end: import("./arguments/coords.js").Coordinates<false>, destination: import("./arguments/coords.js").Coordinates<false>) => import("./commands/index.js").CloneOptionsCommand<false>, comment: (...comments: unknown[]) => import("./commands/helpers.js").FinalCommandOutput, damage: (target: import("./arguments/selector.js").SingleEntityArgument<false>, amount: number, damageType?: LiteralUnion<import("./arguments/index.js").DAMAGE_TYPES> | import("./core/index.js").DamageTypeClass | undefined) => import("./commands/implementations/entity/damage.js").DamageSourceCommand<boolean>, data: import("./commands/index.js").DataCommand<false>, datapack: import("./commands/index.js").DataPackCommand, debug: import("./commands/index.js").DebugCommand, defaultgamemode: (mode: import("./arguments/basics.js").GAMEMODES) => import("./commands/helpers.js").FinalCommandOutput, difficulty: (difficulty?: import("./arguments/basics.js").DIFFICULTIES | undefined) => import("./commands/helpers.js").FinalCommandOutput, effect: import("./commands/index.js").EffectCommand<false>, enchant: (targets: import("./arguments/selector.js").MultipleEntitiesArgument<false>, enchantment: LiteralUnion<import("./arguments/index.js").ENCHANTMENTS>, level?: number | undefined) => import("./commands/helpers.js").FinalCommandOutput, execute: import("./commands/index.js").ExecuteCommand<false>, experience: import("./commands/index.js").ExperienceCommand<false>, fill: (from: import("./arguments/coords.js").Coordinates<false>, to: import("./arguments/coords.js").Coordinates<false>, block: LiteralUnion<import("./arguments/index.js").BLOCKS>) => import("./commands/index.js").FillArgumentsCommand<boolean>, functionCmd: {
    (mcFunction: string | import("./core/index.js").MCFunctionClass<undefined, undefined> | import("./core/index.js").TagClass<"functions">): import("./commands/helpers.js").FinalCommandOutput;
    (mcFunction: string | import("./core/index.js").MCFunctionClass<undefined, undefined> | import("./core/index.js").TagClass<"functions">, params: import("./arguments/nbt.js").RootNBT): import("./commands/helpers.js").FinalCommandOutput;
    (mcFunction: string | import("./core/index.js").MCFunctionClass<undefined, undefined> | import("./core/index.js").TagClass<"functions">, _: "with", type: import("./variables/Data.js").DATA_TYPES, target: string, path: string): import("./commands/helpers.js").FinalCommandOutput;
    (mcFunction: string | import("./core/index.js").MCFunctionClass<undefined, undefined> | import("./core/index.js").TagClass<"functions">, _: "with", dataPoint: import("./core/Macro.js").DataPointPickClass | import("./variables/Data.js").DataPointClass<any>): import("./commands/helpers.js").FinalCommandOutput;
}, forceload: import("./commands/index.js").ForceLoadCommand<false>, gamemode: (gamemode: import("./arguments/basics.js").GAMEMODES, targets?: import("./arguments/selector.js").MultiplePlayersArgument<false> | undefined) => import("./commands/helpers.js").FinalCommandOutput, gamerule: (gamerule: LiteralUnion<import("./arguments/gamerules.js").GAMERULES>, value?: number | boolean | undefined) => import("./commands/helpers.js").FinalCommandOutput, give: {
    (targets: import("./arguments/selector.js").MultiplePlayersArgument<false>, item: LiteralUnion<import("./arguments/index.js").ITEMS>, count?: number | undefined): import("./commands/helpers.js").FinalCommandOutput;
    (targets: import("./arguments/selector.js").MultiplePlayersArgument<false>, item: LiteralUnion<import("./arguments/index.js").ITEMS>, nbt: import("./arguments/nbt.js").RootNBT, count?: number | undefined): import("./commands/helpers.js").FinalCommandOutput;
}, help: (command?: string | undefined, ...parameters: string[]) => import("./commands/helpers.js").FinalCommandOutput, kill: (targets?: import("./arguments/selector.js").MultipleEntitiesArgument<false> | undefined) => import("./commands/helpers.js").FinalCommandOutput, list: (uuids?: boolean | undefined) => import("./commands/helpers.js").FinalCommandOutput, locate: import("./commands/index.js").LocateCommand<false>, loot: import("./commands/index.js").LootCommand<false>, me: (...actions: import("./arguments/selector.js").MultipleEntitiesArgument<false>[]) => import("./commands/helpers.js").FinalCommandOutput, msg: (targets: import("./arguments/selector.js").MultiplePlayersArgument<false>, messages_0: import("./arguments/basics.js").MessageOrSelector, ...messages_1: import("./arguments/basics.js").MessageOrSelector[]) => import("./commands/helpers.js").FinalCommandOutput, particle: ((name: import("./arguments/index.js").PARTICLE_TYPES, pos?: import("./arguments/coords.js").Coordinates<false> | undefined, delta?: [deltaX: number, deltaY: number, deltaZ: number] | undefined, speed?: number | undefined, count?: number | undefined, mode?: "force" | "normal" | undefined, viewers?: import("./arguments/selector.js").MultiplePlayersArgument<false> | undefined) => void) & ((name: "minecraft:dust", colors: [red: number, green: number, blue: number, size: number], size: number, pos?: import("./arguments/coords.js").Coordinates<false> | undefined, delta?: [deltaX: number, deltaY: number, deltaZ: number] | undefined, speed?: number | undefined, count?: number | undefined, mode?: "force" | "normal" | undefined, viewers?: import("./arguments/selector.js").MultiplePlayersArgument<false> | undefined) => void) & ((name: "minecraft:block" | "minecraft:falling_dust", block: LiteralUnion<import("./arguments/index.js").BLOCKS>, pos?: import("./arguments/coords.js").Coordinates<false> | undefined, delta?: [deltaX: number, deltaY: number, deltaZ: number] | undefined, speed?: number | undefined, count?: number | undefined, mode?: "force" | "normal" | undefined, viewers?: import("./arguments/selector.js").MultiplePlayersArgument<false> | undefined) => void) & ((name: "minecraft:item", item: LiteralUnion<import("./arguments/index.js").ITEMS>, pos?: import("./arguments/coords.js").Coordinates<false> | undefined, delta?: [deltaX: number, deltaY: number, deltaZ: number] | undefined, speed?: number | undefined, count?: number | undefined, mode?: "force" | "normal" | undefined, viewers?: import("./arguments/selector.js").MultiplePlayersArgument<false> | undefined) => void), playsound: (sound: LiteralUnion<import("./arguments/index.js").SOUND_EVENTS>, source: import("./arguments/basics.js").SOUND_SOURCES, targets: import("./arguments/selector.js").MultiplePlayersArgument<false>, sourcePosition?: import("./arguments/coords.js").Coordinates<false> | undefined, volume?: number | undefined, pitch?: number | undefined, minVolume?: number | undefined) => import("./commands/helpers.js").FinalCommandOutput, raw: (...args: unknown[]) => import("./commands/helpers.js").FinalCommandOutput, recipe: import("./commands/index.js").RecipeCommand<false>, reload: () => import("./commands/helpers.js").FinalCommandOutput, returnCmd: import("./commands/index.js").ReturnArgumentsCommand<false> & ((value?: number | undefined) => import("./commands/helpers.js").FinalCommandOutput), item: import("./commands/index.js").ItemCommand<false>, say: (message: string) => import("./commands/helpers.js").FinalCommandOutput, schedule: import("./commands/index.js").ScheduleCommand<false>, scoreboard: import("./commands/index.js").ScoreboardCommand<false>, seed: () => import("./commands/helpers.js").FinalCommandOutput, setblock: {
    (pos: import("./arguments/coords.js").Coordinates<false>, block: LiteralUnion<import("./arguments/index.js").BLOCKS>, type?: "replace" | "destroy" | "keep" | undefined): import("./commands/helpers.js").FinalCommandOutput;
    (pos: import("./arguments/coords.js").Coordinates<false>, block: LiteralUnion<import("./arguments/index.js").BLOCKS>, nbt?: import("./arguments/nbt.js").RootNBT | undefined, type?: "replace" | "destroy" | "keep" | undefined): import("./commands/helpers.js").FinalCommandOutput;
}, setidletimeout: (minutes: number) => import("./commands/helpers.js").FinalCommandOutput, setworldspawn: (pos?: import("./arguments/coords.js").Coordinates<false> | undefined, angle?: import("./arguments/coords.js").Rotation<false> | undefined) => import("./commands/helpers.js").FinalCommandOutput, spawnpoint: (targets?: import("./arguments/selector.js").MultiplePlayersArgument<false> | undefined, pos?: import("./arguments/coords.js").Coordinates<false> | undefined, angle?: import("./arguments/coords.js").Rotation<false> | undefined) => import("./commands/helpers.js").FinalCommandOutput, spectate: (target: import("./arguments/selector.js").SingleEntityArgument<false>, player?: import("./arguments/selector.js").SinglePlayerArgument<false> | undefined) => import("./commands/helpers.js").FinalCommandOutput, spreadplayers: ((center: import("./arguments/coords.js").ColumnCoordinates<false>, spreadDistance: number, maxRange: number, respectTeams: boolean, targets: import("./arguments/selector.js").MultipleEntitiesArgument<false>) => import("./commands/helpers.js").FinalCommandOutput) & ((center: import("./arguments/coords.js").ColumnCoordinates<false>, spreadDistance: number, maxRange: number, under: "under", height: number, respectTeams: boolean, targets: import("./arguments/selector.js").MultipleEntitiesArgument<false>) => import("./commands/helpers.js").FinalCommandOutput), stopsound: (targets: import("./arguments/selector.js").MultiplePlayersArgument<false>, source?: "*" | import("./arguments/basics.js").SOUND_SOURCES | undefined, sound?: LiteralUnion<import("./arguments/index.js").SOUND_EVENTS> | undefined) => import("./commands/helpers.js").FinalCommandOutput, summon: (entity: LiteralUnion<import("./arguments/index.js").ENTITY_TYPES>, pos?: import("./arguments/coords.js").Coordinates<false> | undefined, nbt?: import("./arguments/nbt.js").RootNBT | undefined) => import("./commands/helpers.js").FinalCommandOutput, tag: (targets: import("./arguments/selector.js").MultipleEntitiesArgument<false>) => import("./commands/index.js").TagArgumentsCommand<false>, team: import("./commands/index.js").TeamCommand<false>, teammsg: (messages_0: import("./arguments/basics.js").MessageOrSelector, ...messages_1: import("./arguments/basics.js").MessageOrSelector[]) => void, teleport: ((destinationEntity: import("./arguments/selector.js").SingleEntityArgument<false>) => void) & ((location: import("./arguments/coords.js").Coordinates<false>) => void) & ((targets: import("./arguments/selector.js").MultipleEntitiesArgument<false>, destinationEntity: import("./arguments/selector.js").SingleEntityArgument<false>) => void) & ((targets: import("./arguments/selector.js").MultipleEntitiesArgument<false>, location: import("./arguments/coords.js").Coordinates<false>) => import("./commands/index.js").TeleportFacingCommand<false>) & ((targets: import("./arguments/selector.js").MultipleEntitiesArgument<false>, location: import("./arguments/coords.js").Coordinates<false>, rotation: import("./arguments/coords.js").Rotation<false>) => void), tellraw: (targets: import("./arguments/selector.js").MultiplePlayersArgument<false>, message: JSONTextComponent) => import("./commands/helpers.js").FinalCommandOutput, time: import("./commands/index.js").TimeCommand<false>, title: (targets: import("./arguments/selector.js").MultiplePlayersArgument<false>) => import("./commands/index.js").TitleArgumentsCommand<false>, trigger: (objective: import("./arguments/objective.js").ObjectiveArgument) => import("./commands/index.js").TriggerArgumentsCommand, w: (targets: import("./arguments/selector.js").MultiplePlayersArgument<false>, messages_0: import("./arguments/basics.js").MessageOrSelector, ...messages_1: import("./arguments/basics.js").MessageOrSelector[]) => import("./commands/helpers.js").FinalCommandOutput, weather: import("./commands/index.js").WeatherCommand<false>, worldborder: import("./commands/index.js").WorldBorderCommand<false>, tm: (messages_0: import("./arguments/basics.js").MessageOrSelector, ...messages_1: import("./arguments/basics.js").MessageOrSelector[]) => void, tp: ((destinationEntity: import("./arguments/selector.js").SingleEntityArgument<false>) => void) & ((location: import("./arguments/coords.js").Coordinates<false>) => void) & ((targets: import("./arguments/selector.js").MultipleEntitiesArgument<false>, destinationEntity: import("./arguments/selector.js").SingleEntityArgument<false>) => void) & ((targets: import("./arguments/selector.js").MultipleEntitiesArgument<false>, location: import("./arguments/coords.js").Coordinates<false>) => import("./commands/index.js").TeleportFacingCommand<false>) & ((targets: import("./arguments/selector.js").MultipleEntitiesArgument<false>, location: import("./arguments/coords.js").Coordinates<false>, rotation: import("./arguments/coords.js").Rotation<false>) => void), xp: import("./commands/index.js").ExperienceCommand<false>, tell: (targets: import("./arguments/selector.js").MultiplePlayersArgument<false>, messages_0: import("./arguments/basics.js").MessageOrSelector, ...messages_1: import("./arguments/basics.js").MessageOrSelector[]) => import("./commands/helpers.js").FinalCommandOutput;
export declare const RawResource: {
    (path: string, contents: string | Buffer | Promise<Buffer>): import("./core/index.js").CustomResourceClass;
    (pack: import("./pack/packType.js").PackType, path: string, contents: string | Buffer | Promise<Buffer>): import("./core/index.js").CustomResourceClass;
}, MCFunction: {
    (name: string, options?: Partial<MCFunctionClassArguments> | undefined): import("./core/index.js").MCFunctionClass<undefined, undefined>;
    (name: string, callback: (loop: import("./core/index.js").MCFunctionClass<undefined, undefined>) => void, options?: Partial<MCFunctionClassArguments> | undefined): import("./core/index.js").MCFunctionClass<undefined, undefined>;
    <PARAMS extends readonly import("./core/Macro.js").MacroArgument[]>(name: string, callback: (loop: import("./core/index.js").MCFunctionClass<PARAMS, undefined>, ...params: PARAMS) => void, options?: Partial<MCFunctionClassArguments> | undefined): import("./core/index.js").MCFunctionClass<PARAMS, undefined>;
    <ENV extends readonly import("./core/Macro.js").MacroArgument[]>(name: string, environmentVariables: ENV, callback: (loop: import("./core/index.js").MCFunctionClass<undefined, ENV>) => void, options?: Partial<MCFunctionClassArguments> | undefined): import("./core/index.js").MCFunctionClass<undefined, ENV>;
    <PARAMS_1 extends readonly import("./core/Macro.js").MacroArgument[], ENV_1 extends readonly import("./core/Macro.js").MacroArgument[]>(name: string, environmentVariables: ENV_1, callback: (loop: import("./core/index.js").MCFunctionClass<PARAMS_1, ENV_1>, ...params: PARAMS_1) => void, options?: Partial<MCFunctionClassArguments> | undefined): import("./core/index.js").MCFunctionClass<PARAMS_1, ENV_1>;
}, Advancement: <T extends string>(name: string, advancement: import("./arguments/index.js").AdvancementJSON<T>, options?: Partial<AdvancementClassArguments> | undefined) => import("./core/index.js").AdvancementClass<string>, DamageType: (name: string, damageType: import("./arguments/index.js").DamageTypeJSON, options?: Partial<DamageTypeClassArguments> | undefined) => import("./core/index.js").DamageTypeClass, ItemModifier: (name: string, itemModifier: import("./arguments/index.js").ItemModifierJSON, options?: Partial<ItemModifierClassArguments> | undefined) => import("./core/index.js").ItemModifierClass, LootTable: (name: string, lootTable: import("./arguments/index.js").LootTableJSON, options?: Partial<LootTableClassArguments> | undefined) => import("./core/index.js").LootTableClass, Predicate: (name: string, predicate: import("./arguments/index.js").PredicateJSON, options?: Partial<PredicateClassArguments> | undefined) => import("./core/index.js").PredicateClass, Recipe: (name: string, recipe: import("./arguments/index.js").RecipeJSON, options?: Partial<RecipeClassArguments> | undefined) => import("./core/index.js").RecipeClass, Tag: <T extends LiteralUnion<import("./arguments/registry.js").REGISTRIES>>(type: T, name: string, values: import("./arguments/index.js").TagValuesJSON<T>, options?: Partial<TagClassArguments<T>> | undefined) => import("./core/index.js").TagClass<T>, TrimMaterial: (name: string, trimMaterial: import("./arguments/index.js").TrimMaterialJSON, options?: Partial<TrimMaterialClassArguments> | undefined) => import("./core/index.js").TrimMaterialClass, TrimPattern: (name: string, trimPattern: import("./arguments/index.js").TrimPatternJSON, options?: Partial<TrimPatternClassArguments> | undefined) => import("./core/index.js").TrimPatternClass, Atlas: (name: string, atlas: import("./arguments/index.js").AtlasDefinition, options?: Partial<AtlasClassArguments> | undefined) => import("./core/index.js").AtlasClass, BlockState: <Type extends import("./arguments/index.js").BlockStateType>(type: Type, name: string, blockState: import("./arguments/index.js").BlockStateDefinition<Type>, options?: Partial<BlockStateArguments<Type>> | undefined) => import("./core/index.js").BlockStateClass<Type>, Font: (name: string, providers: import("./arguments/index.js").FontProvider[], options?: Partial<FontArguments> | undefined) => import("./core/index.js").FontClass, Language: (name: string, language: Partial<Record<import("./arguments/index.js").TRANSLATION_KEYS, string>> | {
    [key: string]: string;
} | undefined, options?: Partial<LanguageArguments> | undefined) => import("./core/index.js").LanguageClass, Model: (type: "item" | "block", name: string, model: string | import("./core/index.js").ModelData | undefined, options?: Partial<ModelClassArguments> | undefined) => import("./core/index.js").ModelClass, SoundEvent: <Type extends import("./arguments/basics.js").SOUND_TYPES>(type: Type, name: string, sound: string | Buffer | Promise<Buffer> | undefined, options?: Partial<SoundEventArguments> | undefined) => import("./core/index.js").SoundEventClass<Type>, PlainText: (name: string, text: string[] | JSONTextComponent | JSONTextComponent[] | undefined, options?: Partial<PlainTextArguments> | undefined) => import("./core/index.js").PlainTextClass, Texture: <Type extends import("./arguments/index.js").TEXTURE_TYPES>(type: Type, name: string, texture: Buffer | Promise<Buffer> | undefined, options?: Partial<TextureArguments<Type>> | undefined) => import("./core/index.js").TextureClass<Type>, packTypes: Map<string, import("./pack/packType.js").PackType>, Objective: {
    create: (name: string, criteria?: LiteralUnion<import("./arguments/index.js").OBJECTIVE_CRITERION>, display?: JSONTextComponent | undefined, alreadyExists?: boolean | undefined) => import("./variables/Objective.js").ObjectiveClass;
    get: (name: string) => import("./variables/Objective.js").ObjectiveClass;
}, Macro: import("./commands/commands.js").SandstoneCommands<true> & ((strings: TemplateStringsArray, ...macros: (string | number | import("./core/Macro.js").MacroArgument)[]) => import("./core/Macro.js").MacroLiteral), _: import("./flow/Flow.js").Flow, Variable: ((initialValue?: number | import("./variables/Score.js").Score | undefined, name?: string | undefined) => import("./variables/Score.js").Score) & ((nbt: import("./variables/Data.js").DataPointClass<any>, scale?: number | undefined, name?: string | undefined) => import("./variables/Score.js").Score), flowVariable: import("./variables/Score.js").Score, Label: (label: string, description?: string | undefined) => import("./utils.js").MakeInstanceCallable<import("./variables/Label.js")._RawLabelClass>, Data: {
    <T extends import("./variables/Data.js").DATA_TYPES>(type: T): import("./variables/Data.js").TargetlessDataClass<T>;
    <T_1 extends "entity">(type: T_1, target: import("./arguments/selector.js").SingleEntityArgument<false>): import("./variables/Data.js").DataClass<T_1>;
    <T_2 extends "storage">(type: T_2, target: string): import("./variables/Data.js").DataClass<T_2>;
    <T_3 extends "block">(type: T_3, target: import("./arguments/coords.js").Coordinates<false>): import("./variables/Data.js").DataClass<T_3>;
    <T_4 extends import("./variables/Data.js").DATA_TYPES>(type: T_4, target: undefined, path: import("./variables/Data.js").DATA_PATH | import("./variables/Data.js").DATA_PATH[]): import("./variables/Data.js").TargetlessDataPointClass<T_4>;
    <T_5 extends "entity">(type: T_5, target: import("./arguments/selector.js").SingleEntityArgument<false>, path: import("./variables/Data.js").DATA_PATH | import("./variables/Data.js").DATA_PATH[]): import("./variables/Data.js").DataPointClass<T_5>;
    <T_6 extends "storage">(type: T_6, target: string, path: import("./variables/Data.js").DATA_PATH | import("./variables/Data.js").DATA_PATH[]): import("./variables/Data.js").DataPointClass<T_6>;
    <T_7 extends "block">(type: T_7, target: import("./arguments/coords.js").Coordinates<false>, path: import("./variables/Data.js").DATA_PATH | import("./variables/Data.js").DATA_PATH[]): import("./variables/Data.js").DataPointClass<T_7>;
}, DataVariable: ((initialValue?: import("./arguments/nbt.js").NBTObject | import("./core/Macro.js").DataPointPickClass | import("./variables/Data.js").DataPointClass<any> | undefined, name?: string | undefined) => import("./variables/Data.js").DataPointClass<"storage">) & ((score: import("./variables/Score.js").Score, storeType?: import("./commands/index.js").StoreType | undefined, scale?: number | undefined, name?: string | undefined) => import("./variables/Data.js").DataPointClass<"storage">), getTempStorage: (name: string) => import("./variables/Data.js").DataPointClass<"storage">, ResolveNBT: (nbt: import("./arguments/nbt.js").NBTObject, dataPoint?: import("./variables/Data.js").DataPointClass<"storage"> | undefined) => import("./variables/ResolveNBT.js").ResolveNBTClass, DataIndexMap: <INITIAL extends import("./arguments/nbt.js").RootNBT | Record<string, import("./core/Macro.js").DataPointPickClass | import("./variables/Data.js").DataPointClass<any>>>(initialize: INITIAL, dataPoint?: import("./variables/Data.js").DataPointClass<"storage"> | undefined) => import("./variables/DataSets.js").DataIndexMap<INITIAL>, DataArray: <INITIAL extends readonly [string, import("./core/Macro.js").DataPointPickClass | import("./variables/Data.js").DataPointClass<any>] | readonly import("./arguments/nbt.js").NBTObject[]>(initialize: INITIAL, dataPoint?: import("./variables/Data.js").DataPointClass<"storage"> | undefined) => import("./variables/DataSets.js").DataArray<INITIAL>, Selector: import("./variables/Selector.js").SelectorCreator<false>, UUID: {
    (source: string | import("./variables/UUID.js").UUIDinNumber, options?: import("./variables/UUID.js").UUIDOptions | undefined): import("./variables/UUID.js").UUIDClass<"known">;
    (source: import("./variables/UUID.js").UUIDinScore, options?: import("./variables/UUID.js").UUIDOptions | undefined): import("./variables/UUID.js").UUIDClass<"scores">;
    (source: import("./variables/Data.js").DataPointClass<any>, options?: import("./variables/UUID.js").UUIDOptions | undefined): import("./variables/UUID.js").UUIDClass<"data">;
    (source: import("./variables/Selector.js").SelectorClass<true, boolean, false>, options?: import("./variables/UUID.js").UUIDOptions | undefined): import("./variables/UUID.js").UUIDClass<"selector">;
}, makeCustomResource: [import("./core/sandstoneCore.js").SandstoneCore, typeof import("./core/index.js").CustomResourceClass], sleep: (delay: import("./arguments/basics.js").TimeArgument) => PromiseLike<import("./variables/Sleep.js").SleepClass>;
export declare const getVanillaResource: {
    (relativePath: string): Promise<string>;
    (relativePath: string, text: true, type: "client" | "server"): Promise<string>;
    (relativePath: string, text: false, type: "client" | "server"): Promise<Buffer>;
}, getExistingResource: {
    (relativePath: string): Promise<string>;
    (relativePath: string, encoding: false): Promise<Buffer>;
    (relativePath: string, encoding: import("fs").EncodingOption): Promise<string | Buffer>;
    (resource: import("./core/index.js").ResourceClass<import("./core/index.js").ResourceNode<any>>, encoding?: "utf-8" | undefined): Promise<string>;
    (resource: import("./core/index.js").ResourceClass<import("./core/index.js").ResourceNode<any>>, encoding: false | import("fs").EncodingOption): Promise<Buffer>;
}, mcmetaCache: import("./core/mcmeta.js").MCMetaCache, depend: (dependency: string, version?: string) => void;
export type DatapackConfig = {
    /**
     * The description of the datapack.
     * Can be a single string or a JSON Text Component
     * (like in /tellraw or /title).
     */
    description: JSONTextComponent;
    /**
     * The format version of the datapack.
     * Can change depending on the versions of Minecraft.
     *
     * @see [https://minecraft.wiki/w/Data_Pack#pack.mcmeta](https://minecraft.wiki/w/Data_Pack#pack.mcmeta)
     */
    packFormat: number;
    /** List of experimental game features to enable. */
    features?: string[];
    supported_formats: number | number[] | {
        min_inclusive: number;
        max_inclusive: number;
    };
    /**
     * Section for filtering out files from datapacks applied below this one. Any file that matches one of the patterns inside `block` will be treated as if it was not present in the pack at all.
     */
    filter?: {
        /** List of patterns */
        block: {
            /** A regular expression for the namespace of files to be filtered out. If unspecified, it applies to every namespace. */
            namespace?: string;
            /** A regular expression for the paths of files to be filtered out. If unspecified, it applies to every file. */
            path?: string;
        }[];
    };
};
export type ResourcePackConfig = {
    /**
     * The description of the resource pack.
     * Can be a single string or a JSON Text Component
     * (like in /tellraw or /title).
     */
    description: JSONTextComponent;
    /**
     * The format version of the resource pack.
     * Can change depending on the versions of Minecraft.
     *
     * @see [https://minecraft.wiki/w/Resource_pack#Contents](https://minecraft.wiki/w/Resource_pack#Contents)
     */
    packFormat: number;
    supported_formats: number | number[] | {
        min_inclusive: number;
        max_inclusive: number;
    };
    /**
     * Section for filtering out files from resource packs applied below this one. Any file that matches one of the patterns inside `block` will be treated as if it was not present in the pack at all.
     */
    filter?: {
        /** List of patterns */
        block: {
            /** A regular expression for the namespace of files to be filtered out. If unspecified, it applies to every namespace. */
            namespace?: string;
            /** A regular expression for the paths of files to be filtered out. If unspecified, it applies to every file. */
            path?: string;
        }[];
    };
};
type PackConfigs<PackType extends LiteralUnion<'datapack' | 'resourcepack'>> = Record<PackType, PackType extends 'datapack' ? DatapackConfig : PackType extends 'resourcepack' ? ResourcePackConfig : unknown>;
export interface SandstoneConfig {
    /**
     * The default namespace for the packs.
     * It can be changed for each resources, individually or using Base Paths.
     */
    namespace: string;
    /**
     * The name of the pack.
     */
    name: string;
    packs: PackConfigs<LiteralUnion<'datapack'>>;
    /**
     * The strategy to use when 2 resources of the same type (Advancement, MCFunctions...) have the same name.
     */
    onConflict?: Partial<OnConflict<ContentStrategy>>;
    /**
     * A unique identifier that is used to distinguish your variables from other Sandstone pack variables.
     *
     * It must be a string of valid scoreboard characters.
     */
    packUid: string;
    /** All the options to save the pack. */
    saveOptions: {
        /**
         * A custom handler for saving files. If specified, files won't be saved anymore, you will have to handle that yourself.
         */
        customFileHandler?: (relativePath: string, content: any, contentSummary: string) => void;
        /**
         * The indentation to use for all JSON & MCMeta files. This argument is the same than `JSON.stringify` 3d argument.
         */
        indentation?: string | number;
        /**
         * The world to save the packs in.
         *
         * Incompatible with `root`.
         */
        world?: string;
        /**
         * Whether to save the resource pack & datapack in the `.minecraft/datapacks` & `.minecraft/resource_pack` folders.
         *
         * Incompatible with `world`.
         */
        root?: true;
        /**
         * A custom path to your .minecraft folder,
         * in case you changed the default and Sandstone fails to find it.
         */
        clientPath?: string;
        /**
         * A server path to save the server-side packs at.
         */
        serverPath?: string;
    };
    /** Some scripts that can run at defined moments. */
    scripts?: {
        /** A script running before Sandstone starts importing source files. */
        beforeAll?: () => (void | Promise<void>);
        /** A script running before Sandstone starts saving the files. */
        beforeSave?: () => (void | Promise<void>);
        /** A script running after Sandstone saved all files. */
        afterAll?: () => (void | Promise<void>);
    };
    resources?: {
        /** Path regex of files to exclude from the output. */
        exclude?: {
            /** From `SandstonePack` (your code in `./src`). */
            generated?: RegExp[];
            /** From `./resources`. */
            existing?: RegExp[];
        } | RegExp[];
        /** Handle files before they are written to the output. */
        handle?: {
            path: RegExp;
            callback: (contents: string | Buffer | Promise<Buffer>) => Promise<Buffer>;
        }[];
    };
}
export type ContentStrategyKind<Resource extends string, Conflict extends string> = {
    resource: Resource;
    conflict: Conflict;
};
type ContentStrategy = (
/**
 * The default conflict strategy to use for all resources.
 *
 * @default
 * 'warn'
 */
ContentStrategyKind<'default', BASIC_CONFLICT_STRATEGIES> | 
/**
 * The conflict strategy to use for Advancements.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'advancements', NonNullable<AdvancementClassArguments['onConflict']>> | 
/**
 * The conflict strategy to use for damage types.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'damage_types', NonNullable<DamageTypeClassArguments['onConflict']>> | 
/**
 * The conflict strategy to use for Loot Tables.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'loot_tables', NonNullable<LootTableClassArguments['onConflict']>> | 
/**
 * The conflict strategy to use for MCFunctions.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'functions', NonNullable<MCFunctionClassArguments['onConflict']>> | 
/**
 * The conflict strategy to use for Predicates.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'predicates', NonNullable<PredicateClassArguments['onConflict']>> | 
/**
 * The conflict strategy to use for RecipeOptions.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'recipes', NonNullable<RecipeClassArguments['onConflict']>> | 
/**
 * The conflict strategy to use for Tags.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'tags', NonNullable<TagClassArguments<any>['onConflict']>> | 
/**
 * The conflict strategy to use for Item modifiers.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'item_modifiers', NonNullable<ItemModifierClassArguments['onConflict']>> | 
/**
 * The conflict strategy to use for Trim materials.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'trim_materials', NonNullable<TrimMaterialClassArguments['onConflict']>> | 
/**
 * The conflict strategy to use for Trim patterns.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'trim_patterns', NonNullable<TrimPatternClassArguments['onConflict']>> | 
/**
 * The conflict strategy to use for Atlases.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'atlass', NonNullable<AtlasClassArguments['onConflict']>> | // atlass is not a typo. feel free to PR :trolley:
/**
 * The conflict strategy to use for Block states.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'block_states', NonNullable<BlockStateArguments<any>['onConflict']>> | 
/**
 * The conflict strategy to use for Fonts.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'fonts', NonNullable<FontArguments['onConflict']>> | 
/**
 * The conflict strategy to use for Languages.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'languages', NonNullable<LanguageArguments['onConflict']>> | 
/**
 * The conflict strategy to use for Models.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'models', NonNullable<ModelClassArguments['onConflict']>> | 
/**
 * The conflict strategy to use for Sound Events.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'sound_events', NonNullable<SoundEventArguments['onConflict']>> | 
/**
 * The conflict strategy to use for Plain Text files.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'texts', NonNullable<PlainTextArguments['onConflict']>> | 
/**
 * The conflict strategy to use for Textures.
 * Will override the defined `default` strategy.
 */
ContentStrategyKind<'texture', NonNullable<TextureArguments<any>['onConflict']>>);
type OnConflict<Strategy extends ContentStrategy> = Record<Strategy['resource'], Strategy['conflict']>;
