"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var packType_exports = {};
__export(packType_exports, {
  PackType: () => PackType
});
module.exports = __toCommonJS(packType_exports);
class PackType {
  /**
   * @param type eg. datapack or resource_pack
   * @param clientPath from active client directory (eg. .minecraft), can use variables $worldName$ & $packName$; eg. 'saves/$worldName$/datapacks/$packName$' or 'saves/$worldName$/resources'
   * @param serverPath from active server directory, can use variable $packName$; eg. 'world/datapacks/$packName$'
   * @param rootPath from active client directory (eg. .minecraft), can use variable $packName$; eg. 'datapacks/$packName$' or 'resource_packs/$packName$'
   * @param networkSides which sides of the network the pack needs to be exported to; if both the client & server are defined which side this pack needs to be exported to
   * @param archiveOutput whether to archive the directory on output
   * @param resourceSubFolder Optional. Defines sub folder for resources to go; eg. data or assets (use handleOutput if you want to bypass this)
   */
  // eslint-disable-next-line max-len
  constructor(type, clientPath, serverPath, rootPath, networkSides, archiveOutput = false, resourceSubFolder, namespaced = false) {
    __publicField(this, "type");
    __publicField(this, "clientPath");
    __publicField(this, "serverPath");
    __publicField(this, "rootPath");
    __publicField(this, "networkSides");
    __publicField(this, "resourceSubFolder");
    __publicField(this, "namespaced");
    __publicField(this, "archiveOutput");
    /** `output` executes from `<workspace>/.sandstone/output/$packName$_<type>`*/
    __publicField(this, "handleOutput");
    this.type = type;
    this.clientPath = clientPath;
    this.serverPath = serverPath;
    this.rootPath = rootPath;
    this.networkSides = networkSides;
    this.archiveOutput = archiveOutput;
    this.resourceSubFolder = resourceSubFolder;
    this.namespaced = namespaced;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  PackType
});
//# sourceMappingURL=packType.cjs.map