"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var containerCommandsToMCFunction_exports = {};
__export(containerCommandsToMCFunction_exports, {
  ContainerCommandsToMCFunctionVisitor: () => ContainerCommandsToMCFunctionVisitor
});
module.exports = __toCommonJS(containerCommandsToMCFunction_exports);
var import_core = require("sandstone/core");
var import_visitor = require("./visitor.js");
class ContainerCommandsToMCFunctionVisitor extends import_visitor.GenericSandstoneVisitor {
  constructor() {
    super(...arguments);
    __publicField(this, "currentMCFunction", null);
    __publicField(this, "visitContainerCommandNode", (node_) => {
      const { node, mcFunction } = node_.createMCFunction(this.currentMCFunction);
      if (mcFunction) {
        const visitedMCFunction = this.visitMCFunctionNode(mcFunction);
        this.core.resourceNodes.add(visitedMCFunction);
      } else if (node instanceof import_core.ContainerCommandNode && node.body) {
        for (const [i, child] of node.body.entries()) {
          const visit = this.visit(child);
          node.body.splice(i, 1, ...Array.isArray(visit) ? visit : [visit]);
        }
      }
      return Array.isArray(node) ? node.flatMap((n) => this.visit(n)) : node;
    });
    __publicField(this, "visitMCFunctionNode", (node) => {
      const prev = this.currentMCFunction;
      this.currentMCFunction = node;
      const result = this.genericVisit(node);
      this.currentMCFunction = prev;
      return result;
    });
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ContainerCommandsToMCFunctionVisitor
});
//# sourceMappingURL=containerCommandsToMCFunction.cjs.map