/* eslint-disable dot-notation */
import { MCFunctionClass } from 'sandstone/core';
import { GenericSandstoneVisitor } from './visitor.js';
// TODO: Add support for macros
/**
 * Transforms an execute with several nodes into an execute calling a new function.
 */
export class GenerateLazyMCFunction extends GenericSandstoneVisitor {
    generateLazyFunction(mcFunction) {
        // If it's not a MCFunction / it's not lazy, there's nothing to do
        if (!(mcFunction instanceof MCFunctionClass) || !mcFunction['lazy']) {
            return;
        }
        const mcFunctionNode = mcFunction['node'];
        // We can generate the function.
        mcFunction['generate']();
        this.visit(mcFunctionNode);
    }
    visitFunctionCommandNode = (node) => {
        this.generateLazyFunction(node.args[0]);
        return node;
    };
    visitScheduleCommandNode = (node) => {
        /* @ts-ignore */
        this.generateLazyFunction(node.args[1]);
        return this.genericVisit(node);
    };
}
