"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var ifElseTransformationVisitor_exports = {};
__export(ifElseTransformationVisitor_exports, {
  IfElseTransformationVisitor: () => IfElseTransformationVisitor
});
module.exports = __toCommonJS(ifElseTransformationVisitor_exports);
var import_commands = require("sandstone/commands");
var import_flow = require("sandstone/flow");
var import_visitor = require("./visitor.js");
function* flattenIfNode(node) {
  yield node;
  const next = node.nextFlowNode;
  if (next instanceof import_flow.IfNode) {
    yield* flattenIfNode(next);
  } else if (next) {
    yield next;
  }
}
class IfElseTransformationVisitor extends import_visitor.GenericSandstoneVisitor {
  constructor() {
    super(...arguments);
    __publicField(this, "visitIfNode", (node_) => {
      if (node_["_isElseIf"]) {
        return [];
      }
      const nodes = Array.from(flattenIfNode(node_));
      if (nodes.length === 1) {
        return new import_commands.ExecuteCommandNode(this.pack, [[node_.condition.getValue()]], {
          isSingleExecute: false,
          givenCallbackName: "if",
          body: node_.body.map((_node) => this.genericVisit(_node))
        });
      }
      const wrapper = new import_commands.ExecuteCommandNode(this.pack, [], {
        isFake: true,
        // trolley
        isSingleExecute: false,
        givenCallbackName: "if",
        body: nodes.flatMap((node, i) => {
          const { body } = node;
          if (node instanceof import_flow.IfNode) {
            const callbackName = i === 0 ? "if" : "elseif";
            if (body.length === 1) {
              return new import_commands.ExecuteCommandNode(this.pack, [[node.condition.getValue()]], {
                isSingleExecute: false,
                givenCallbackName: callbackName,
                body: [new import_commands.ReturnCommandNode(this.pack, [`run ${this.genericVisit(body[0]).getValue()}`])]
              });
            }
            return new import_commands.ExecuteCommandNode(this.pack, [[node.condition.getValue()]], {
              isSingleExecute: false,
              givenCallbackName: `${i}_${callbackName}`,
              body: [new import_commands.ReturnRunCommandNode(this.pack, ["run"], {
                isSingleExecute: false,
                body: body.map((_node) => this.genericVisit(_node))
              })]
            });
          }
          return body.map((_node) => this.genericVisit(_node));
        })
      });
      return [wrapper];
    });
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  IfElseTransformationVisitor
});
//# sourceMappingURL=ifElseTransformationVisitor.cjs.map