"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var initObjectivesVisitor_exports = {};
__export(initObjectivesVisitor_exports, {
  InitObjectivesVisitor: () => InitObjectivesVisitor
});
module.exports = __toCommonJS(initObjectivesVisitor_exports);
var import_visitor = require("./visitor.js");
class InitObjectivesVisitor extends import_visitor.GenericSandstoneVisitor {
  constructor() {
    super(...arguments);
    __publicField(this, "onStart", () => {
      const { pack } = this;
      const { commands, core } = pack;
      const sandstoneRegisteredObjectives = /* @__PURE__ */ new Set();
      const userRegisteredObjectives = /* @__PURE__ */ new Set();
      const objectives = [...pack.objectives.values()];
      if (objectives.length !== 0) {
        pack.initMCFunction.unshift(() => {
          var _a;
          for (const obj of objectives) {
            if (userRegisteredObjectives.has(obj.name)) {
              throw new Error(`An objective named "${obj.name}" has been created twice.`);
            }
            if (obj["creator"] === "user") {
              userRegisteredObjectives.add(obj.name);
            } else {
              sandstoneRegisteredObjectives.add(obj.name);
            }
            commands.scoreboard.objectives.add(obj.name, obj.criteria, (_a = obj.display) == null ? void 0 : _a.jsonTextComponent);
          }
        });
      }
    });
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  InitObjectivesVisitor
});
//# sourceMappingURL=initObjectivesVisitor.cjs.map