"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var inlineFunctionCallVisitor_exports = {};
__export(inlineFunctionCallVisitor_exports, {
  InlineFunctionCallVisitor: () => InlineFunctionCallVisitor
});
module.exports = __toCommonJS(inlineFunctionCallVisitor_exports);
var import_commands = require("sandstone/commands");
var import_core = require("sandstone/core");
var import_visitor = require("./visitor.js");
class InlineFunctionCallVisitor extends import_visitor.GenericSandstoneVisitor {
  constructor() {
    super(...arguments);
    __publicField(this, "deletedMCFunction", null);
    __publicField(this, "visitFunctionCommandNode", (node) => {
      const mcFunction = node.args[0];
      if (!this.deletedMCFunction) {
        return node;
      }
      const [deleted, newOne] = this.deletedMCFunction;
      if (node.args[0] instanceof import_core.MCFunctionClass && node.args[0] === deleted) {
        node.args[0] = newOne;
      }
      return node;
    });
    __publicField(this, "visitMCFunctionNode", (functionNode) => {
      if (functionNode.body.length > 1) {
        return functionNode;
      }
      const node = functionNode.body[0];
      if (node instanceof import_commands.FunctionCommandNode && node.args[0] instanceof import_core.MCFunctionClass && node.args[0]["creator"] === "sandstone") {
        const sandstoneCreatedFunction = node.args[0];
        this.core.resourceNodes.delete(sandstoneCreatedFunction["node"]);
        this.deletedMCFunction = [sandstoneCreatedFunction, functionNode.resource];
        functionNode.body = sandstoneCreatedFunction["node"].body;
      }
      this.genericVisit(functionNode);
      this.deletedMCFunction = null;
      return functionNode;
    });
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  InlineFunctionCallVisitor
});
//# sourceMappingURL=inlineFunctionCallVisitor.cjs.map