"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var simplifyExecuteFunction_exports = {};
__export(simplifyExecuteFunction_exports, {
  SimplifyExecuteFunctionVisitor: () => SimplifyExecuteFunctionVisitor
});
module.exports = __toCommonJS(simplifyExecuteFunction_exports);
var import_commands = require("sandstone/commands");
var import_nodes = require("sandstone/core/nodes");
var import_visitor = require("./visitor.js");
class SimplifyExecuteFunctionVisitor extends import_visitor.GenericSandstoneVisitor {
  constructor() {
    super(...arguments);
    __publicField(this, "visitExecuteCommandNode", (node) => {
      if (node.body.length === 0 || node.body.length > 1) {
        return this.genericVisit(node);
      }
      const functionNode = node.body[0];
      if (!(functionNode instanceof import_commands.FunctionCommandNode)) {
        return this.genericVisit(node);
      }
      const mcFunction = functionNode.args[0];
      if (typeof mcFunction === "string") {
        return this.genericVisit(node);
      }
      const mcFunctionNode = mcFunction["node"];
      if (mcFunctionNode.body.length > 1) {
        return this.genericVisit(node);
      }
      const command = mcFunctionNode.body[0];
      if (!(command instanceof import_nodes.CommandNode)) {
        return this.genericVisit(node);
      }
      if (command instanceof import_commands.ExecuteCommandNode) {
        return this.genericVisit(node);
      }
      node.body = [command];
      if (mcFunction["creator"] === "sandstone") {
        this.core.resourceNodes.delete(mcFunctionNode);
      }
      return this.genericVisit(node);
    });
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  SimplifyExecuteFunctionVisitor
});
//# sourceMappingURL=simplifyExecuteFunction.cjs.map