import { GenericCoreVisitor } from 'sandstone/core/visitors';
import type { AdvancementCommandNode, AttributeCommandNode, CloneCommandNode, DataCommandNode, ExecuteCommandNode, FunctionCommandNode, GameRuleCommandNode, SayCommandNode } from 'sandstone/commands';
import type { GenericNodeVisitor } from 'sandstone/core/visitors';
import type { ElseNode, IfNode, LoopNode } from 'sandstone/flow';
import type { SandstonePack } from 'sandstone/pack';
export declare class GenericSandstoneVisitor extends GenericCoreVisitor {
    readonly pack: SandstonePack;
    constructor(pack: SandstonePack);
    visitIfNode?: GenericNodeVisitor<IfNode>;
    visitElseNode?: GenericNodeVisitor<ElseNode>;
    visitLoopNode?: GenericNodeVisitor<LoopNode>;
    visitAdvancementCommandNode?: GenericNodeVisitor<AdvancementCommandNode>;
    visitAttributeCommandNode?: GenericNodeVisitor<AttributeCommandNode>;
    visitCloneCommandNode?: GenericNodeVisitor<CloneCommandNode>;
    visitDataCommandNode?: GenericNodeVisitor<DataCommandNode>;
    visitExecuteCommandNode?: GenericNodeVisitor<ExecuteCommandNode>;
    visitFunctionCommandNode?: GenericNodeVisitor<FunctionCommandNode>;
    visitGameruleCommandNode?: GenericNodeVisitor<GameRuleCommandNode>;
    visitSayCommandNode?: GenericNodeVisitor<SayCommandNode>;
}
