"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var utils_exports = {};
__export(utils_exports, {
  HTTPResponses: () => HTTPResponses,
  MetaDataSchema: () => MetaDataSchema,
  MinecraftVersionSchema: () => MinecraftVersionSchema,
  PackDataSchema: () => PackDataSchema,
  PackVersionSchema: () => PackVersionSchema,
  add: () => add,
  capitalize: () => capitalize,
  fetch: () => fetch,
  isAsyncFunction: () => isAsyncFunction,
  isPromise: () => isPromise,
  iterateEntries: () => iterateEntries,
  latestMinecraftVersion: () => latestMinecraftVersion,
  makeCallable: () => makeCallable,
  makeCallableProxy: () => makeCallableProxy,
  makeClassCallable: () => makeClassCallable,
  packCategories: () => packCategories,
  randomUUID: () => randomUUID,
  safeWrite: () => safeWrite,
  sanitizeTarget: () => sanitizeTarget,
  supportedMinecraftVersions: () => supportedMinecraftVersions,
  toMinecraftResourceName: () => toMinecraftResourceName
});
module.exports = __toCommonJS(utils_exports);
var import_fs_extra = __toESM(require("fs-extra"), 1);
var import_semver = require("semver");
var util = __toESM(require("util"), 1);
var import_typebox = require("@sinclair/typebox");
const fetch = Object.hasOwn(globalThis, "fetch") ? globalThis.fetch : async (...args) => (await import("node-fetch")).default(...args);
function isAsyncFunction(func) {
  if (util.types) {
    return util.types.isAsyncFunction(func);
  }
  if (func.constructor.name === "AsyncFunction") {
    return true;
  }
  const string = func.toString().trim();
  return !!// native
  (string.match(/^async /) || string.match(/return _ref[^.]*\.apply/));
}
function isPromise(promise) {
  return promise && typeof promise.then === "function" && promise[Symbol.toStringTag] === "Promise";
}
function makeCallableProxy(func, object) {
  return new Proxy(func, {
    get: (target, p, receiver) => object[p],
    set: (target, p, value, receiver) => {
      object[p] = value;
      return value;
    },
    getPrototypeOf: (target) => Object.getPrototypeOf(object)
  });
}
function makeClassCallable(Class_) {
  return new Proxy(Class_, {
    construct: (target, argArray, newTarget) => {
      const obj = new Class_(...argArray);
      const result = makeCallableProxy(obj.__call__, obj);
      return result;
    }
  });
}
function makeCallable(object, func, useProxy = false) {
  if (useProxy) {
    return makeCallableProxy(func, object);
  }
  const { name, ...objectExceptName } = object;
  const result = Object.assign(func, objectExceptName);
  if (name !== void 0) {
    const descriptor = Object.getOwnPropertyDescriptor(func, "name");
    descriptor.value = name;
    Object.defineProperty(func, "name", descriptor);
  }
  return result;
}
function toMinecraftResourceName(path, typeNested = 1) {
  const [namespace, ...folders] = path;
  folders.splice(0, typeNested);
  return `${namespace}:${folders.join("/")}`;
}
const uuidBytes = new Uint8Array(16);
const uuid = new DataView(uuidBytes.buffer);
function randomUUID() {
  crypto.getRandomValues(uuidBytes);
  uuidBytes[6] = uuidBytes[6] & 15 | 4 << 4;
  uuidBytes[8] = uuidBytes[8] & 63 | 128;
  const array = [];
  for (let i = 0; i < 4; i++) {
    array.push(uuid.getInt32(i * 4, false));
  }
  return array;
}
const capitalize = (s) => s.charAt(0).toUpperCase() + s.slice(1);
function add(object) {
  if (object === void 0) {
    return {};
  }
  const output = {};
  for (const [key, value] of object.entries()) {
    if (value !== void 0) {
      output[key] = value;
    }
  }
  return output;
}
function iterateEntries(node, fn) {
  const newNode = {};
  node.forEach(([key, val]) => newNode[key] = fn(val));
  return newNode;
}
import_typebox.FormatRegistry.Set("semver", (v) => (0, import_semver.coerce)(v) != null);
const supportedMinecraftVersions = [
  "1.18",
  "1.18.1",
  "1.18.2",
  "1.19"
];
const latestMinecraftVersion = "1.19";
const MinecraftVersionSchema = import_typebox.Type.Union(supportedMinecraftVersions.map((v) => import_typebox.Type.Literal(v)));
const packCategories = [
  "Extensive",
  "Lightweight",
  "QoL",
  "Vanilla+",
  "Tech",
  "Magic",
  "Library",
  "Exploration",
  "World Overhaul",
  "No Resource Pack"
];
const PackDependencySchema = import_typebox.Type.Object({
  id: import_typebox.Type.String(),
  version: import_typebox.Type.String()
});
const PackVersionSchema = import_typebox.Type.Object({
  name: import_typebox.Type.String({ minLength: 1 }),
  downloads: import_typebox.Type.Object({
    datapack: import_typebox.Type.String({ minLength: 1 }),
    resourcepack: import_typebox.Type.String()
  }),
  supports: import_typebox.Type.Array(MinecraftVersionSchema, { minItems: 1 }),
  dependencies: import_typebox.Type.Array(PackDependencySchema)
});
const PackDataSchema = import_typebox.Type.Object({
  id: import_typebox.Type.String({ minLength: 3 }),
  display: import_typebox.Type.Object({
    name: import_typebox.Type.String({ minLength: 3 }),
    description: import_typebox.Type.String({ minLength: 3 }),
    icon: import_typebox.Type.String({ default: "" }),
    hidden: import_typebox.Type.Boolean({ default: false }),
    webPage: import_typebox.Type.Optional(import_typebox.Type.String())
  }),
  versions: import_typebox.Type.Array(PackVersionSchema, { minItems: 1 }),
  categories: import_typebox.Type.Array(import_typebox.Type.Union(packCategories.map((c) => import_typebox.Type.Literal(c))))
});
const MetaDataSchema = import_typebox.Type.Object({
  docId: import_typebox.Type.String(),
  rawId: import_typebox.Type.String(),
  stats: import_typebox.Type.Object({
    updated: import_typebox.Type.Optional(import_typebox.Type.Number()),
    added: import_typebox.Type.Number(),
    downloads: import_typebox.Type.Object({
      total: import_typebox.Type.Number(),
      today: import_typebox.Type.Number()
    })
  }),
  owner: import_typebox.Type.String(),
  contributors: import_typebox.Type.Array(import_typebox.Type.String(), { default: [] })
});
var HTTPResponses = /* @__PURE__ */ ((HTTPResponses2) => {
  HTTPResponses2[HTTPResponses2["OK"] = 200] = "OK";
  HTTPResponses2[HTTPResponses2["CREATED"] = 201] = "CREATED";
  HTTPResponses2[HTTPResponses2["BAD_REQUEST"] = 400] = "BAD_REQUEST";
  HTTPResponses2[HTTPResponses2["UNAUTHORIZED"] = 401] = "UNAUTHORIZED";
  HTTPResponses2[HTTPResponses2["FORBIDDEN"] = 403] = "FORBIDDEN";
  HTTPResponses2[HTTPResponses2["NOT_FOUND"] = 404] = "NOT_FOUND";
  HTTPResponses2[HTTPResponses2["CONFLICT"] = 409] = "CONFLICT";
  HTTPResponses2[HTTPResponses2["SERVER_ERROR"] = 500] = "SERVER_ERROR";
  return HTTPResponses2;
})(HTTPResponses || {});
async function safeWrite(...args) {
  if (typeof args[0] !== "string")
    throw new Error("unimplemented");
  await import_fs_extra.default.ensureDir(args[0].replace(/(?:\/|\\)(?:.(?!(?:\/|\\)))+$/, ""));
  return import_fs_extra.default.writeFile(...args);
}
function sanitizeTarget(target) {
  return `${target}`.toLowerCase().replaceAll(/-|=|\[|\]|\{|\}|:|"|'|,|@/g, "_");
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  HTTPResponses,
  MetaDataSchema,
  MinecraftVersionSchema,
  PackDataSchema,
  PackVersionSchema,
  add,
  capitalize,
  fetch,
  isAsyncFunction,
  isPromise,
  iterateEntries,
  latestMinecraftVersion,
  makeCallable,
  makeCallableProxy,
  makeClassCallable,
  packCategories,
  randomUUID,
  safeWrite,
  sanitizeTarget,
  supportedMinecraftVersions,
  toMinecraftResourceName
});
//# sourceMappingURL=utils.cjs.map