"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var Coordinates_exports = {};
__export(Coordinates_exports, {
  VectorClass: () => VectorClass,
  absolute: () => absolute,
  local: () => local,
  relative: () => relative
});
module.exports = __toCommonJS(Coordinates_exports);
var import_util = require("util");
class VectorClass {
  constructor(values) {
    __publicField(this, "values");
    if (!Array.isArray(values) || !values.every((i) => typeof i === "string")) {
      throw new Error(`Expected array of string for Vector values, got ${(0, import_util.inspect)(values)}`);
    }
    this.values = values;
  }
  toString() {
    return this.values.join(" ");
  }
  toJSON() {
    return this.toString();
  }
  [Symbol.iterator]() {
    return this.values[Symbol.iterator]();
  }
}
function absolute(...coordinates) {
  if (coordinates.length === 1) {
    return coordinates[0].toString();
  }
  return new VectorClass(coordinates.map((coord) => coord.toString()));
}
function relative(...coordinates) {
  if (coordinates.length === 0) {
    return new VectorClass(["~", "~", "~"]);
  }
  if (coordinates.length === 1) {
    return `~${coordinates[0] || ""}`;
  }
  return new VectorClass(coordinates.map((coord) => `~${coord || ""}`));
}
function local(...coordinates) {
  if (coordinates.length === 0) {
    return new VectorClass(["^", "^", "^"]);
  }
  if (coordinates.length === 1) {
    return `^${coordinates[0] || ""}`;
  }
  return new VectorClass(coordinates.map((coord) => `^${coord || ""}`));
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  VectorClass,
  absolute,
  local,
  relative
});
//# sourceMappingURL=Coordinates.cjs.map