"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var Data_exports = {};
__export(Data_exports, {
  DataClass: () => DataClass,
  DataPointClass: () => DataPointClass,
  NBTpathToString: () => NBTpathToString,
  StringDataPointClass: () => StringDataPointClass,
  TargetlessDataClass: () => TargetlessDataClass,
  TargetlessDataPointClass: () => TargetlessDataPointClass
});
module.exports = __toCommonJS(Data_exports);
var import_Macro = require("../core/Macro.js");
var import_NBTs = require("./nbt/NBTs.js");
var import_Score = require("./Score.js");
function NBTpathToString(path) {
  let result = "";
  for (const p of path) {
    if (typeof p === "string") {
      if (result.length > 0) {
        result += ".";
      }
      result += p;
    } else {
      result += (0, import_NBTs.nbtStringifier)(p);
    }
  }
  return result;
}
class TargetlessDataClass {
  constructor(sandstonePack, type) {
    this.sandstonePack = sandstonePack;
    this.type = type;
    __publicField(this, "target", (target) => new DataClass(this.sandstonePack, this.type, target));
    __publicField(this, "select", (...path) => new TargetlessDataPointClass(this.sandstonePack, this.type, path));
  }
}
class TargetlessDataPointClass {
  constructor(sandstonePack, type, path) {
    this.sandstonePack = sandstonePack;
    this.type = type;
    __publicField(this, "path");
    __publicField(this, "target", (target) => new DataPointClass(this.sandstonePack, this.type, target, [this.path]));
    __publicField(this, "select", (...path) => new TargetlessDataPointClass(this.sandstonePack, this.type, [this.path, ...path]));
    this.path = NBTpathToString(path);
  }
}
class DataClass {
  constructor(sandstonePack, type, target) {
    this.sandstonePack = sandstonePack;
    this.type = type;
    __publicField(this, "currentTarget");
    /**
     * Merge the given NBT to the current target.
     */
    __publicField(this, "merge", (value) => {
      this.sandstonePack.commands.data.merge[this.type](this.currentTarget, value);
    });
    __publicField(this, "target", (target) => new DataClass(this.sandstonePack, this.type, target));
    __publicField(this, "select", (...path) => new DataPointClass(this.sandstonePack, this.type, this.currentTarget, path));
    __publicField(this, "toString", () => this.currentTarget);
    __publicField(this, "toJSON", this.toString);
    this.currentTarget = target;
  }
}
class DataPointClass extends import_Macro.MacroArgument {
  constructor(sandstonePack, type, target, path) {
    super(sandstonePack.core);
    this.sandstonePack = sandstonePack;
    this.type = type;
    __publicField(this, "path");
    __publicField(this, "currentTarget");
    __publicField(this, "target", (target) => new DataPointClass(this.sandstonePack, this.type, target, [this.path]));
    __publicField(this, "select", (...path) => new DataPointClass(this.sandstonePack, this.type, this.currentTarget, [this.path, ...path]));
    __publicField(this, "modify", (cb, value) => {
      const data = cb(this.sandstonePack.commands.data.modify[this.type](this.currentTarget, this.path));
      if (value instanceof DataPointClass) {
        data.from[value.type](value.currentTarget, value.path);
        return this;
      }
      if (value instanceof import_Macro.DataPointPickClass) {
        this.set(value._toDataPoint());
        return this;
      }
      data.value(value);
      return this;
    });
    __publicField(this, "string", (cb, value, start, end) => {
      const data = cb(this.sandstonePack.commands.data.modify[this.type](this.currentTarget, this.path));
      if (!end)
        data.string[value.type](value.currentTarget, value.path, start);
      else if (start === 0) {
        data.from[value.type](value.currentTarget, value.path);
      } else {
        data.string[value.type](value.currentTarget, value.path, start, end);
      }
    });
    __publicField(this, "executeStore", (storeType, scale) => this.sandstonePack.commands.execute.store.result[this.type](this.currentTarget, this.path, storeType, scale));
    __publicField(this, "set", (value, storeType, scale = 1) => {
      if (value instanceof StringDataPointClass) {
        if (value.sliceBounds[1])
          this.string((data) => data.set, value, value.sliceBounds[0], value.sliceBounds[1]);
        else
          this.string((data) => data.set, value, value.sliceBounds[0]);
        return this;
      }
      if (value instanceof import_Score.Score) {
        this.executeStore(storeType || "int", scale).run.scoreboard.players.get(value.target, value.objective);
        return this;
      }
      this.modify((data) => data.set, value);
      return this;
    });
    /**
     * Set the data point to the given NBT.
     */
    __publicField(this, "merge", (value) => this.modify((data) => data.merge, value));
    /**
     * Append the given NBT to the current data point.
     */
    __publicField(this, "append", (value) => this.modify((data) => data.append, value));
    /**
     * Prepend the given NBT to the current data point.
     */
    __publicField(this, "prepend", (value) => this.modify((data) => data.prepend, value));
    /**
     * Insert the given NBT to the given index of the current data point.
     */
    __publicField(this, "insert", (value, index) => this.modify((data) => data.insert(index), value));
    /**
     * Remove the current NBT value.
     */
    __publicField(this, "remove", () => this.sandstonePack.commands.data.remove[this.type](this.currentTarget, this.path));
    /**
     * Extracts a section of a string available for setting to another path, without modifying the original path.
     *
     * Use slice(0) to get a type-safe string data point; it compiles to a regular `from` argument.
     *
     * @param start Index of first character to include at the start of the string.
     * @param end Optional. Index of the first character to exclude at the end of the string.
     */
    __publicField(this, "slice", (start, end) => new StringDataPointClass(this.sandstonePack, this.type, this.currentTarget, this.path, start, end));
    __publicField(this, "_toMinecraftCondition", () => new this.sandstonePack.conditions.DataPoint(this.sandstonePack.core, this));
    __publicField(this, "equals", (value) => new this.sandstonePack.conditions.DataPointEquals(this.sandstonePack.core, this, value));
    /**
     * @internal
     */
    __publicField(this, "_toChatComponent", () => ({
      nbt: this.path,
      [this.type]: this.currentTarget
    }));
    this.path = NBTpathToString(path);
    this.currentTarget = target;
  }
}
class StringDataPointClass extends DataPointClass {
  constructor(sandstonePack, type, target, path, start, end) {
    super(sandstonePack, type, target, [path]);
    this.sandstonePack = sandstonePack;
    this.type = type;
    __publicField(this, "sliceBounds");
    this.sliceBounds = [start];
    if (end)
      this.sliceBounds.push(end);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DataClass,
  DataPointClass,
  NBTpathToString,
  StringDataPointClass,
  TargetlessDataClass,
  TargetlessDataPointClass
});
//# sourceMappingURL=Data.cjs.map