"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var Label_exports = {};
__export(Label_exports, {
  EntityLabel: () => EntityLabel,
  LabelClass: () => LabelClass,
  _RawLabelClass: () => _RawLabelClass
});
module.exports = __toCommonJS(Label_exports);
var import_utils = require("sandstone/utils");
var import_Selector = require("./Selector.js");
class _RawLabelClass {
  constructor(pack, name, description) {
    this.pack = pack;
    /**
     * Label name
     */
    __publicField(this, "name");
    /**
     * Label Tag name with namespace
     */
    __publicField(this, "fullName");
    /**
     * Label Description (optional)
     */
    __publicField(this, "description");
    __publicField(this, "LabelHolder", (entity) => {
      if (typeof entity === "string")
        return new EntityLabel(this.pack, new import_Selector.SelectorClass(this.pack, entity), this);
      return new EntityLabel(this.pack, entity, this);
    });
    /**
     * Contains the name and description of the Label (eg. 'wasd:is_walking; Whether the player is not mounted')
     */
    __publicField(this, "toString", () => `${this.fullName}${this.description ? `; ${this.description}` : ""}`);
    /**
     * @internal
     */
    __publicField(this, "__call__", (entity) => this.LabelHolder(entity));
    if (name.includes(".")) {
      this.name = name.split(".").slice(1).join(".");
      this.fullName = name;
    } else {
      this.name = name;
      this.fullName = `${pack.defaultNamespace}.${name}`;
    }
    if (description)
      this.description = description;
  }
}
const LabelClass = (0, import_utils.makeClassCallable)(_RawLabelClass);
class EntityLabel {
  constructor(pack, entity, label) {
    this.pack = pack;
    /** Label */
    __publicField(this, "label");
    /**
     * Selects entity with the label
     */
    __publicField(this, "selector");
    /**
     * Selects entity
     */
    __publicField(this, "originalSelector");
    /** Test for label on entity */
    __publicField(this, "test", this);
    /**
     * Add label to entity
     */
    __publicField(this, "add", () => this.pack.commands.tag(this.originalSelector).add(this.label.fullName));
    /**
     * Remove label from entity
     */
    __publicField(this, "remove", () => this.pack.commands.tag(this.originalSelector).remove(this.label.fullName));
    /**
     * Contains the selector, and the name/description of the Label (eg. 'Whether @s has the label wasd:is_walking; Whether the player is not mounted')
     */
    __publicField(this, "toString", () => `Whether ${this.originalSelector.toString()} has the label ${this.label.toString()}`);
    /**
     * @internal
     */
    __publicField(this, "_toMinecraftCondition", () => new this.pack.conditions.Label(this.pack.core, this));
    /**
     * @internal
     */
    __publicField(this, "_toSelector", () => this.selector._toSelector());
    this.originalSelector = entity._toSelector();
    this.label = label;
    const selector = typeof this.originalSelector === "string" ? new import_Selector.SelectorClass(this.pack, "@s") : new import_Selector.SelectorClass(this.pack, this.originalSelector.target, { ...this.originalSelector.arguments });
    if (selector.arguments) {
      if (selector.arguments.tag) {
        if (typeof selector.arguments.tag === "string" || !Array.isArray(selector.arguments.tag)) {
          selector.arguments.tag = [selector.arguments.tag, label.fullName];
        } else {
          selector.arguments.tag = [...selector.arguments.tag, label.fullName];
        }
      } else
        selector.arguments.tag = [label.fullName];
    } else
      selector.arguments = { tag: [label.fullName] };
    this.selector = selector;
  }
  /**
   * Set label on/off for entity
   */
  set(set) {
    if (typeof set === "boolean") {
      if (set)
        this.add();
      else
        this.remove();
    } else {
      this.pack._.if(set, () => this.add()).else(() => this.remove());
    }
  }
  /**
   * Toggle label on/off for entity
   */
  toggle() {
    this.pack._.if(this.test, () => this.remove()).else(() => this.add());
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  EntityLabel,
  LabelClass,
  _RawLabelClass
});
//# sourceMappingURL=Label.cjs.map