import { JSONTextComponentClass } from './JSONTextComponentClass.js';
import { Score } from './Score.js';
import type { JSONTextComponent, MultipleEntitiesArgument, OBJECTIVE_CRITERION } from 'sandstone/arguments';
import type { LiteralUnion, MakeInstanceCallable } from 'sandstone/utils';
import type { SandstonePack } from '../pack/index.js';
import type { ScoreDisplay } from './Score.js';
export declare class _RawObjectiveClass {
    protected sandstonePack: SandstonePack;
    name: string;
    criteria: LiteralUnion<OBJECTIVE_CRITERION>;
    display: JSONTextComponentClass | undefined;
    _displayRaw: JSONTextComponent | undefined;
    protected creator: 'user' | 'sandstone';
    constructor(sandstonePack: SandstonePack, name: string, criteria: LiteralUnion<OBJECTIVE_CRITERION>, display: JSONTextComponent | undefined, opts: {
        creator: 'user' | 'sandstone';
    });
    /** Resets all scores on the objective */
    reset: () => import("../commands/helpers.js").FinalCommandOutput;
    ScoreHolder: (scoreHolder: MultipleEntitiesArgument<false>, display?: ScoreDisplay) => Score;
    toString(): string;
    toJSON: () => string;
    __call__: (scoreHolder: MultipleEntitiesArgument<false>, display?: ScoreDisplay) => Score;
}
export declare const ObjectiveClass: import("sandstone/utils").MakeClassCallable<typeof _RawObjectiveClass>;
export type ObjectiveClass = MakeInstanceCallable<_RawObjectiveClass>;
