import { makeClassCallable } from 'sandstone/utils';
import { JSONTextComponentClass } from './JSONTextComponentClass.js';
import { targetParser } from './parsers.js';
import { Score } from './Score.js';
export class _RawObjectiveClass {
    sandstonePack;
    name;
    criteria;
    display;
    _displayRaw;
    creator;
    constructor(sandstonePack, name, criteria = 'dummy', display, opts) {
        this.sandstonePack = sandstonePack;
        this.name = name;
        this.criteria = criteria;
        this.display = display === undefined ? undefined : new JSONTextComponentClass(display);
        this._displayRaw = display;
        this.creator = opts.creator;
    }
    /** Resets all scores on the objective */
    reset = () => this.sandstonePack.commands.scoreboard.players.reset('*', this.name);
    ScoreHolder = (scoreHolder, display) => new Score(this.sandstonePack, targetParser(scoreHolder), display, this);
    toString() {
        return this.name;
    }
    toJSON = this.toString;
    __call__ = this.ScoreHolder;
}
export const ObjectiveClass = makeClassCallable(_RawObjectiveClass);
