"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var ResolveNBT_exports = {};
__export(ResolveNBT_exports, {
  ResolveNBTClass: () => ResolveNBTClass,
  ResolveNBTPart: () => ResolveNBTPart,
  ResolveNBTPartClass: () => ResolveNBTPartClass
});
module.exports = __toCommonJS(ResolveNBT_exports);
var util = __toESM(require("util"), 1);
var import_Macro = require("../core/Macro.js");
var import_utils = require("../utils.js");
var import_Data = require("./Data.js");
var import_nbt = require("./nbt/index.js");
var import_Score = require("./Score.js");
var _a;
class ResolveNBTClass extends import_Macro.DataPointPickClass {
  constructor(pack, nbt, dataPoint) {
    super(pack.core);
    this.pack = pack;
    __publicField(this, "dataPoint");
    if (dataPoint) {
      this.dataPoint = dataPoint;
    } else {
      this.dataPoint = this.pack.Data("storage", "__sandstone:temp", "Resolve");
    }
    const out = this._resolveNBT(nbt);
    if (Object.keys(out).length !== 0) {
      pack.commands.data.modify.storage(this.dataPoint.currentTarget, this.dataPoint.path).merge.value(this._resolveNBT(nbt));
    }
  }
  /**
   * @internal
   */
  _resolveNBT(nbt, path, index) {
    let resolvedNBT = {};
    if (typeof nbt !== "object") {
      throw new Error(`ResolveNBT expected an object or array, received ${typeof nbt}!`);
    }
    if (Array.isArray(nbt)) {
      resolvedNBT = [];
      this.dataPoint.set([]);
      if (resolvedNBT.length !== 0) {
        for (const [i, value] of nbt.entries()) {
          const resolved = this._resolveNBT(value, `${path === void 0 ? "" : path}`, i);
          if (resolved !== void 0) {
            resolvedNBT.push(resolved);
          }
        }
      }
      return resolvedNBT;
    }
    if (nbt instanceof ResolveNBTPartClass) {
      return this[`_resolve${(0, import_utils.capitalize)(nbt.type)}`](nbt, path, index);
    }
    if (nbt instanceof import_nbt.NBTPrimitive) {
      return resolvedNBT;
    }
    this.dataPoint.set({});
    for (const [key, value] of Object.entries(nbt)) {
      const resolved = this._resolveNBT(value, `${path === void 0 ? "" : `${path}.`}${key}`);
      if (resolved !== void 0) {
        resolvedNBT[key] = resolved;
      }
    }
    return resolvedNBT;
  }
  /**
   * @internal
   */
  _resolveData(part, path, index) {
    const { value } = part;
    const dataPoint = this.dataPoint.select(path);
    if (index) {
      let _value = value;
      if (value instanceof import_Data.StringDataPointClass) {
        _value = this.pack.DataVariable(value);
      }
      dataPoint.insert(_value, index);
      return void 0;
    }
    if (value instanceof import_Data.StringDataPointClass) {
      dataPoint.set(value);
      return void 0;
    }
    dataPoint.set(value);
    return void 0;
  }
  /**
   * @internal
   */
  _resolveScore(value, path, index) {
    const dataPoint = this.dataPoint.select(path);
    const args = [value.value, value.primitive.toString().split(" ")[1].slice(3).toLowerCase(), value.scale];
    if (index) {
      const temp = this.pack.getTempStorage("Score");
      temp.set(...args);
      dataPoint.insert(temp, index);
    }
    dataPoint.set(...args);
    return void 0;
  }
  /**
   * @internal
   */
  _resolveScores(value, path, index) {
    const temp = this.pack.getTempStorage("Score");
    const args = [value.primitive.constructor.name.slice(3).slice(0, -5).toLowerCase(), value.scale];
    const dataPoint = this.dataPoint.select(path);
    if (index) {
      dataPoint.insert(new value.primitive([]), index);
      const _dataPoint = dataPoint.select([index]);
      for (const score of value) {
        temp.set(score, ...args);
        _dataPoint.append(temp);
      }
    }
    dataPoint.set(new value.primitive([]));
    for (const score of value) {
      temp.set(score, ...args);
      dataPoint.append(temp);
    }
  }
  /**
   * @internal
   */
  _toDataPoint() {
    return this.dataPoint;
  }
}
class ResolveNBTPartClass extends import_nbt.NBTClass {
  constructor(value, type, primitive, scale) {
    super();
    __publicField(this, "value");
    __publicField(this, "type");
    __publicField(this, "primitive");
    __publicField(this, "scale");
    __publicField(this, _a, () => "Unresolved NBT! Make sure to run ResolveNBT on the nbt before use.");
    this.value = value;
    this.type = type;
    this.primitive = primitive;
    if (type.indexOf("score") !== -1) {
      this.scale = scale;
    }
  }
}
_a = util.inspect.custom;
function ResolveNBTPart(value, option1, option2) {
  if (Array.isArray(value)) {
    return new ResolveNBTPartClass(value, "scores", option2 || import_nbt.NBTIntArray, option1 || 1);
  }
  if (value instanceof import_Score.Score) {
    return new ResolveNBTPartClass(value, "score", option2 || import_nbt.NBTInt, option1 || 1);
  }
  return new ResolveNBTPartClass(value, "data", option1 || import_nbt.NBTAnyValue);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ResolveNBTClass,
  ResolveNBTPart,
  ResolveNBTPartClass
});
//# sourceMappingURL=ResolveNBT.cjs.map