"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var Score_exports = {};
__export(Score_exports, {
  Score: () => Score
});
module.exports = __toCommonJS(Score_exports);
var import_Macro = require("../core/Macro.js");
var import_abstractClasses = require("./abstractClasses.js");
var import_parsers = require("./parsers.js");
let matchers = 0;
function createVariable(pack, ...args) {
  const anonymousScore = pack.Variable();
  if (typeof args[0] === "number" || args[0] instanceof Score) {
    return anonymousScore.set(args[0]);
  }
  return anonymousScore.set(args[0], args[1]);
}
class Score extends import_Macro.MacroArgument {
  constructor(sandstonePack, target, display, objective) {
    super(sandstonePack.core);
    this.sandstonePack = sandstonePack;
    this.target = target;
    this.display = display;
    this.objective = objective;
    __publicField(this, "commands");
    /**
     * @internal
     */
    __publicField(this, "_toMinecraftCondition", () => this.sandstonePack._.not(new this.sandstonePack.conditions.Score(this.sandstonePack.core, [`${this.target}`, `${this.objective}`, "matches", "0"])));
    __publicField(this, "setDisplay", (display) => {
      if (display.name) {
        this.commands.scoreboard.players.display.name(this, display.name);
      }
      if (display.numberformat) {
        if (display.numberformat === "blank") {
          this.commands.scoreboard.players.display.numberformat(this, "blank");
        } else if (display.numberformat[0] === "styled") {
          this.commands.scoreboard.players.display.numberformat(this, "styled", display.numberformat[1]);
        } else {
          this.commands.scoreboard.players.display.numberformat(this, "fixed", display.numberformat[1]);
        }
      }
      this.display = display;
      return this;
    });
    /** INLINE OPERATORS */
    /**
     * Reset the entity's score.
     */
    __publicField(this, "reset", () => {
      this.commands.scoreboard.players.reset(this);
    });
    __publicField(this, "=", this.set);
    __publicField(this, "+=", this.add);
    __publicField(this, "-=", this.remove);
    __publicField(this, "*=", this.multiply);
    __publicField(this, "/=", this.divide);
    __publicField(this, "%=", this.modulo);
    __publicField(this, "><", this.swap);
    __publicField(this, "+", this.plus);
    __publicField(this, "-", this.minus);
    __publicField(this, "*", this.multipliedBy);
    __publicField(this, "/", this.dividedBy);
    __publicField(this, "%", this.moduloBy);
    __publicField(this, ">", this.greaterThan);
    __publicField(this, ">=", this.greaterOrEqualThan);
    __publicField(this, "<", this.lessThan);
    __publicField(this, "<=", this.lessOrEqualThan);
    __publicField(this, "==", this.equalTo);
    __publicField(this, "!=", this.notEqualTo);
    /**
     * Check if the current score matches a certain range.
     *
     * @param range The range to compare the current score against.
     */
    __publicField(this, "matches", (range) => ({
      _toMinecraftCondition: () => new this.sandstonePack.conditions.Score(this.sandstonePack.core, [`${this.target}`, `${this.objective}`, "matches", (0, import_parsers.rangeParser)(this.sandstoneCore, range)])
    }));
    __publicField(this, "match", (minimum, maximum, callback) => {
      const { MCFunction, Macro } = this.sandstonePack;
      if (maximum > 1e3) {
        console.warn(
          `
Warning: Score.match() will have to create ${maximum - minimum} mcfunction files, this *will* take a while. Consider only compiling this once and saving it to external resources.`
        );
      }
      const matcher = matchers++;
      const score = this;
      for (let i = minimum; i < maximum; i++) {
        MCFunction(`__sandstone:score_match/${matcher}/${i}`, () => callback(i));
      }
      return MCFunction(`__sandstone:score_match/${matcher}`, [score], () => Macro.returnCmd.run.functionCmd(Macro`__sandstone:score_match/${matcher}/${score}`));
    });
    this.commands = sandstonePack.commands;
    if (display !== void 0) {
      if (sandstonePack.core.currentMCFunction) {
        this.setDisplay(display);
      } else {
        sandstonePack.initMCFunction.push(() => this.setDisplay(display));
      }
    }
  }
  toString() {
    return `${this.target} ${this.objective}`;
  }
  toJSON() {
    return {
      type: "minecraft:score",
      target: {
        type: "minecraft:fixed",
        name: this.target.toString()
      },
      score: this.objective.toString(),
      scale: 1
    };
  }
  /**
   * @internal
   */
  _toChatComponent() {
    return {
      score: { name: this.target, objective: this.objective.name }
    };
  }
  unaryOperation(operation, operator, ...args) {
    var _a;
    if (typeof args[0] === "number") {
      this.commands.scoreboard.players[operation](this, args[0]);
    } else if (args[0] instanceof Score) {
      this.commands.scoreboard.players.operation(this, operator, args[0].target, args[0].objective);
    } else {
      this.commands.scoreboard.players.operation(this, operator, args[0], (_a = args[1]) != null ? _a : this.objective);
    }
    return this;
  }
  binaryOperation(operator, ...args) {
    var _a;
    if (args[0] instanceof Score) {
      this.commands.scoreboard.players.operation(this, operator, args[0].target, args[0].objective);
      return this;
    }
    let objective = (_a = args[1]) != null ? _a : this.objective;
    if (typeof args[0] === "number") {
      this.sandstonePack.registerNewConstant(args[0]);
      objective = "sandstone_const";
    }
    this.commands.scoreboard.players.operation(this, operator, args[0], objective);
    return this;
  }
  set(...args) {
    if (typeof args[0] === "object" && !(args[0] instanceof import_abstractClasses.SelectorPickClass) && !(args[0] instanceof Score)) {
      const [data, scale] = args;
      this.commands.execute.store.result.score(this).run.data.get[data.type](data.currentTarget, data.path, scale);
      return this;
    }
    return this.unaryOperation("set", "=", ...args);
  }
  add(...args) {
    return this.unaryOperation("add", "+=", ...args);
  }
  remove(...args) {
    return this.unaryOperation("remove", "-=", ...args);
  }
  /**
   * Adds one to the current entity's score.
   */
  increase() {
    return this.add(1);
  }
  get "++"() {
    return this.increase();
  }
  /**
   * Subtracts one from the current entity's score.
   */
  decrease() {
    return this.remove(1);
  }
  get "--"() {
    return this.decrease();
  }
  multiply(...args) {
    return this.binaryOperation("*=", ...args);
  }
  divide(...args) {
    return this.binaryOperation("/=", ...args);
  }
  modulo(...args) {
    return this.binaryOperation("%=", ...args);
  }
  swap(...args) {
    this.binaryOperation("><", ...args);
  }
  plus(...args) {
    return createVariable(this.sandstonePack, this).unaryOperation("add", "+=", ...args);
  }
  minus(...args) {
    return createVariable(this.sandstonePack, this).unaryOperation("remove", "-=", ...args);
  }
  multipliedBy(...args) {
    return createVariable(this.sandstonePack, this).binaryOperation("*=", ...args);
  }
  dividedBy(...args) {
    return createVariable(this.sandstonePack, this).binaryOperation("/=", ...args);
  }
  moduloBy(...args) {
    return createVariable(this.sandstonePack, this).binaryOperation("%=", ...args);
  }
  /** COMPARISONS OPERATORS */
  comparison(operator, matchesRange, args) {
    const playerScore = this;
    if (typeof args[0] === "number") {
      return {
        _toMinecraftCondition: () => new this.sandstonePack.conditions.Score(this.sandstonePack.core, [`${playerScore.target}`, `${playerScore.objective}`, "matches", matchesRange])
      };
    }
    const endArgs = args[1] ? args : [args[0]];
    return {
      // eslint-disable-next-line max-len
      _toMinecraftCondition: () => new this.sandstonePack.conditions.Score(this.sandstonePack.core, [`${playerScore.target}`, `${playerScore.objective}`, operator, ...endArgs.map((arg) => arg.toString())])
    };
  }
  greaterThan(...args) {
    return this.comparison(">", `${typeof args[0] === "number" ? args[0] + 1 : null}..`, args);
  }
  greaterOrEqualThan(...args) {
    return this.comparison(">=", `${args[0]}..`, args);
  }
  lessThan(...args) {
    return this.comparison("<", `..${typeof args[0] === "number" ? args[0] - 1 : null}`, args);
  }
  lessOrEqualThan(...args) {
    return this.comparison("<=", `..${args[0]}`, args);
  }
  equalTo(...args) {
    return this.comparison("=", args[0].toString(), args);
  }
  notEqualTo(...args) {
    return this.sandstonePack._.not(this.comparison("=", args[0].toString(), args));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Score
});
//# sourceMappingURL=Score.cjs.map