"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var Sleep_exports = {};
__export(Sleep_exports, {
  SleepClass: () => SleepClass
});
module.exports = __toCommonJS(Sleep_exports);
var import_nodes = require("sandstone/core/nodes");
var import_Objective = require("./Objective.js");
const SLEEP_CHILD_NAME = "__sleep";
class SleepClass extends import_nodes.AwaitNode {
  constructor(core, delay) {
    super(core.pack);
    this.delay = delay;
    __publicField(this, "command", "schedule");
    __publicField(this, "mcfunction");
    __publicField(this, "inSleepFunction");
    const currentFunction = core.getCurrentMCFunctionOrThrow();
    const { path } = currentFunction.resource;
    this.inSleepFunction = path[path.length - 1].startsWith(SLEEP_CHILD_NAME);
    currentFunction.resource.nested += 1;
    this.mcfunction = core.pack.MCFunction(`${currentFunction.resource.path.slice(2).join("/")}/${SLEEP_CHILD_NAME}`, () => {
    }, {
      addToSandstoneCore: true,
      lazy: false,
      creator: "sandstone",
      onConflict: "rename",
      packType: currentFunction.resource.packType
    });
    let schedule = this.mcfunction.name;
    let type = "append";
    if (currentFunction.resource.asyncContext) {
      const Duration = (() => {
        if (typeof delay === "number") {
          return delay + 1;
        }
        const unit = delay.charAt(delay.length - 1);
        let value = Number(delay.replace(unit, ""));
        if (unit === "s") {
          value *= 20;
        } else if (unit === "d") {
          value *= 24e3;
        }
        return value;
      })();
      type = "replace";
      const {
        commands,
        MCFunction,
        Label,
        Selector
      } = core.pack;
      const { execute } = commands;
      const name = `__sandstone.asyncTimer.${currentFunction.resource.name.replace(/[:/]/g, ".")}`;
      const timer = new import_Objective.ObjectiveClass(core.pack, name, "dummy", void 0, { creator: "sandstone" });
      execute.store.result.score(timer("@s")).run.time.query("gametime");
      timer("@s").add(Duration);
      const label = Label(name);
      label("@s").add();
      this.mcfunction.unshift(() => label("@s").remove());
      schedule = MCFunction(`${this.mcfunction.name}/_context`, () => {
        execute.store.result.score(timer("#current")).run.time.query("gametime");
        execute.as(Selector("@e", { tag: label.fullName })).if.score(timer("@s"), "=", timer("#current")).at("@s").run.functionCmd(this.mcfunction);
      }, {
        packType: currentFunction.resource.packType
      }).name;
    }
    this.args = ["function", schedule, this.delay, type];
    currentFunction.enterContext(this);
    core.awaitNodes.add(this);
  }
  promise() {
    return {
      then: async (onfullfilled) => {
        await (onfullfilled == null ? void 0 : onfullfilled());
        return this;
      }
    };
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  SleepClass
});
//# sourceMappingURL=Sleep.cjs.map