"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var parser_exports = {};
__export(parser_exports, {
  parseNBT: () => parseNBT
});
module.exports = __toCommonJS(parser_exports);
var import_nearley = __toESM(require("nearley"), 1);
var import_grammar = __toESM(require("./grammar.js"), 1);
function isCompoundNbt(nbt) {
  return !!nbt[import_grammar.isCompoundSymbol];
}
function parseRaw(nbt) {
  const parser = new import_nearley.default.Parser(import_nearley.default.Grammar.fromCompiled(import_grammar.default));
  parser.feed(nbt);
  parser.finish();
  return parser.results[0];
}
function parseExpression(NBT, nbt) {
  if (Array.isArray(nbt)) {
    return nbt.map((x) => parseExpression(NBT, x));
  }
  if (typeof nbt === "object") {
    if (isCompoundNbt(nbt)) {
      return Object.keys(nbt).reduce((acc, key) => {
        acc[key] = parseExpression(NBT, nbt[key]);
        return acc;
      }, {});
    }
    switch (nbt.dataType) {
      case "byte":
        return NBT.byte(nbt.value);
      case "short":
        return NBT.short(nbt.value);
      case "long":
        return NBT.long(nbt.value);
      case "float":
        return NBT.float(nbt.value);
      case "double":
        return NBT.double(nbt.value);
      case "number":
        return nbt.value;
      case "string":
        return nbt.value;
      case "byteArray":
        return NBT.byteArray(nbt.value.map((x) => x.value));
      case "intArray":
        return NBT.intArray(nbt.value.map((x) => x.value));
      case "longArray":
        return NBT.longArray(nbt.value.map((x) => x.value));
    }
  }
  throw new Error(`Unrecognized data type: ${nbt.dataType}`);
}
function parseNBT(NBT, nbt) {
  const rawResult = parseRaw(nbt);
  return parseExpression(NBT, rawResult);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  parseNBT
});
//# sourceMappingURL=parser.cjs.map