import { type MacroArgument } from '../core/Macro.js';
import { VectorClass } from './Coordinates.js';
import type { Coordinates, Range, Rotation, STRUCTURE_MIRROR, STRUCTURE_ROTATION } from 'sandstone/arguments';
import type { SandstoneCore } from 'sandstone/core/sandstoneCore.js';
export declare function arrayToArgsParser(args: unknown): (typeof args extends string[] ? VectorClass<readonly unknown[]> : typeof args);
export declare function coordinatesParser<T>(coordinates: T): (T extends Coordinates<boolean> ? VectorClass<[string, string, string]> : T);
export declare function rotationParser<T>(rotation: T): (T extends Rotation<boolean> ? VectorClass<[string, string]> : T);
export declare const sanitizeValue: (core: SandstoneCore, value: MacroArgument | number | string | null | undefined) => string;
export declare const rangeParser: (core: SandstoneCore, range: Range<boolean> | MacroArgument) => string;
export type StructureRotation = STRUCTURE_ROTATION | number | `${90 | 180 | 270}` | `-${90 | 180 | 270}`;
export declare const structureRotationParser: (rotation?: StructureRotation | MacroArgument) => MacroArgument | STRUCTURE_ROTATION;
export type StructureMirror = STRUCTURE_MIRROR | '^x' | '^z' | 'x' | 'z' | boolean;
export declare const structureMirrorParser: (mirror?: StructureMirror | MacroArgument) => STRUCTURE_MIRROR;
export declare function targetParser(target: any): string;
