export type OBJECTIVE_CRITERION = ('air' | 'armor' | 'deathCount' | 'dummy' | 'food' | 'health' | 'level' | 'killedByTeam.aqua' | 'killedByTeam.black' | 'killedByTeam.blue' | 'killedByTeam.dark_aqua' | 'killedByTeam.dark_blue' | 'killedByTeam.dark_gray' | 'killedByTeam.dark_green' | 'killedByTeam.dark_purple' | 'killedByTeam.dark_red' | 'killedByTeam.gold' | 'killedByTeam.gray' | 'killedByTeam.green' | 'killedByTeam.light_purple' | 'killedByTeam.red' | 'killedByTeam.white' | 'killedByTeam.yellow' | 'minecraft.broken:minecraft.acacia_button' | 'minecraft.mined:minecraft.acacia_button' | 'minecraft.broken:minecraft.acacia_door' | 'minecraft.mined:minecraft.acacia_door' | 'minecraft.broken:minecraft.acacia_fence' | 'minecraft.mined:minecraft.acacia_fence' | 'minecraft.broken:minecraft.acacia_fence_gate' | 'minecraft.mined:minecraft.acacia_fence_gate' | 'minecraft.broken:minecraft.acacia_hanging_sign' | 'minecraft.mined:minecraft.acacia_hanging_sign' | 'minecraft.broken:minecraft.acacia_leaves' | 'minecraft.mined:minecraft.acacia_leaves' | 'minecraft.broken:minecraft.acacia_log' | 'minecraft.mined:minecraft.acacia_log' | 'minecraft.broken:minecraft.acacia_planks' | 'minecraft.mined:minecraft.acacia_planks' | 'minecraft.broken:minecraft.acacia_pressure_plate' | 'minecraft.mined:minecraft.acacia_pressure_plate' | 'minecraft.broken:minecraft.acacia_sapling' | 'minecraft.mined:minecraft.acacia_sapling' | 'minecraft.broken:minecraft.acacia_sign' | 'minecraft.mined:minecraft.acacia_sign' | 'minecraft.broken:minecraft.acacia_slab' | 'minecraft.mined:minecraft.acacia_slab' | 'minecraft.broken:minecraft.acacia_stairs' | 'minecraft.mined:minecraft.acacia_stairs' | 'minecraft.broken:minecraft.acacia_trapdoor' | 'minecraft.mined:minecraft.acacia_trapdoor' | 'minecraft.broken:minecraft.acacia_wall_hanging_sign' | 'minecraft.mined:minecraft.acacia_wall_hanging_sign' | 'minecraft.broken:minecraft.acacia_wall_sign' | 'minecraft.mined:minecraft.acacia_wall_sign' | 'minecraft.broken:minecraft.acacia_wood' | 'minecraft.mined:minecraft.acacia_wood' | 'minecraft.broken:minecraft.activator_rail' | 'minecraft.mined:minecraft.activator_rail' | 'minecraft.broken:minecraft.air' | 'minecraft.mined:minecraft.air' | 'minecraft.broken:minecraft.allium' | 'minecraft.mined:minecraft.allium' | 'minecraft.broken:minecraft.amethyst_block' | 'minecraft.mined:minecraft.amethyst_block' | 'minecraft.broken:minecraft.amethyst_cluster' | 'minecraft.mined:minecraft.amethyst_cluster' | 'minecraft.broken:minecraft.ancient_debris' | 'minecraft.mined:minecraft.ancient_debris' | 'minecraft.broken:minecraft.andesite' | 'minecraft.mined:minecraft.andesite' | 'minecraft.broken:minecraft.andesite_slab' | 'minecraft.mined:minecraft.andesite_slab' | 'minecraft.broken:minecraft.andesite_stairs' | 'minecraft.mined:minecraft.andesite_stairs' | 'minecraft.broken:minecraft.andesite_wall' | 'minecraft.mined:minecraft.andesite_wall' | 'minecraft.broken:minecraft.anvil' | 'minecraft.mined:minecraft.anvil' | 'minecraft.broken:minecraft.attached_melon_stem' | 'minecraft.mined:minecraft.attached_melon_stem' | 'minecraft.broken:minecraft.attached_pumpkin_stem' | 'minecraft.mined:minecraft.attached_pumpkin_stem' | 'minecraft.broken:minecraft.azalea' | 'minecraft.mined:minecraft.azalea' | 'minecraft.broken:minecraft.azalea_leaves' | 'minecraft.mined:minecraft.azalea_leaves' | 'minecraft.broken:minecraft.azure_bluet' | 'minecraft.mined:minecraft.azure_bluet' | 'minecraft.broken:minecraft.bamboo' | 'minecraft.mined:minecraft.bamboo' | 'minecraft.broken:minecraft.bamboo_block' | 'minecraft.mined:minecraft.bamboo_block' | 'minecraft.broken:minecraft.bamboo_button' | 'minecraft.mined:minecraft.bamboo_button' | 'minecraft.broken:minecraft.bamboo_door' | 'minecraft.mined:minecraft.bamboo_door' | 'minecraft.broken:minecraft.bamboo_fence' | 'minecraft.mined:minecraft.bamboo_fence' | 'minecraft.broken:minecraft.bamboo_fence_gate' | 'minecraft.mined:minecraft.bamboo_fence_gate' | 'minecraft.broken:minecraft.bamboo_hanging_sign' | 'minecraft.mined:minecraft.bamboo_hanging_sign' | 'minecraft.broken:minecraft.bamboo_mosaic' | 'minecraft.mined:minecraft.bamboo_mosaic' | 'minecraft.broken:minecraft.bamboo_mosaic_slab' | 'minecraft.mined:minecraft.bamboo_mosaic_slab' | 'minecraft.broken:minecraft.bamboo_mosaic_stairs' | 'minecraft.mined:minecraft.bamboo_mosaic_stairs' | 'minecraft.broken:minecraft.bamboo_planks' | 'minecraft.mined:minecraft.bamboo_planks' | 'minecraft.broken:minecraft.bamboo_pressure_plate' | 'minecraft.mined:minecraft.bamboo_pressure_plate' | 'minecraft.broken:minecraft.bamboo_sapling' | 'minecraft.mined:minecraft.bamboo_sapling' | 'minecraft.broken:minecraft.bamboo_sign' | 'minecraft.mined:minecraft.bamboo_sign' | 'minecraft.broken:minecraft.bamboo_slab' | 'minecraft.mined:minecraft.bamboo_slab' | 'minecraft.broken:minecraft.bamboo_stairs' | 'minecraft.mined:minecraft.bamboo_stairs' | 'minecraft.broken:minecraft.bamboo_trapdoor' | 'minecraft.mined:minecraft.bamboo_trapdoor' | 'minecraft.broken:minecraft.bamboo_wall_hanging_sign' | 'minecraft.mined:minecraft.bamboo_wall_hanging_sign' | 'minecraft.broken:minecraft.bamboo_wall_sign' | 'minecraft.mined:minecraft.bamboo_wall_sign' | 'minecraft.broken:minecraft.barrel' | 'minecraft.mined:minecraft.barrel' | 'minecraft.broken:minecraft.barrier' | 'minecraft.mined:minecraft.barrier' | 'minecraft.broken:minecraft.basalt' | 'minecraft.mined:minecraft.basalt' | 'minecraft.broken:minecraft.beacon' | 'minecraft.mined:minecraft.beacon' | 'minecraft.broken:minecraft.bedrock' | 'minecraft.mined:minecraft.bedrock' | 'minecraft.broken:minecraft.bee_nest' | 'minecraft.mined:minecraft.bee_nest' | 'minecraft.broken:minecraft.beehive' | 'minecraft.mined:minecraft.beehive' | 'minecraft.broken:minecraft.beetroots' | 'minecraft.mined:minecraft.beetroots' | 'minecraft.broken:minecraft.bell' | 'minecraft.mined:minecraft.bell' | 'minecraft.broken:minecraft.big_dripleaf' | 'minecraft.mined:minecraft.big_dripleaf' | 'minecraft.broken:minecraft.big_dripleaf_stem' | 'minecraft.mined:minecraft.big_dripleaf_stem' | 'minecraft.broken:minecraft.birch_button' | 'minecraft.mined:minecraft.birch_button' | 'minecraft.broken:minecraft.birch_door' | 'minecraft.mined:minecraft.birch_door' | 'minecraft.broken:minecraft.birch_fence' | 'minecraft.mined:minecraft.birch_fence' | 'minecraft.broken:minecraft.birch_fence_gate' | 'minecraft.mined:minecraft.birch_fence_gate' | 'minecraft.broken:minecraft.birch_hanging_sign' | 'minecraft.mined:minecraft.birch_hanging_sign' | 'minecraft.broken:minecraft.birch_leaves' | 'minecraft.mined:minecraft.birch_leaves' | 'minecraft.broken:minecraft.birch_log' | 'minecraft.mined:minecraft.birch_log' | 'minecraft.broken:minecraft.birch_planks' | 'minecraft.mined:minecraft.birch_planks' | 'minecraft.broken:minecraft.birch_pressure_plate' | 'minecraft.mined:minecraft.birch_pressure_plate' | 'minecraft.broken:minecraft.birch_sapling' | 'minecraft.mined:minecraft.birch_sapling' | 'minecraft.broken:minecraft.birch_sign' | 'minecraft.mined:minecraft.birch_sign' | 'minecraft.broken:minecraft.birch_slab' | 'minecraft.mined:minecraft.birch_slab' | 'minecraft.broken:minecraft.birch_stairs' | 'minecraft.mined:minecraft.birch_stairs' | 'minecraft.broken:minecraft.birch_trapdoor' | 'minecraft.mined:minecraft.birch_trapdoor' | 'minecraft.broken:minecraft.birch_wall_hanging_sign' | 'minecraft.mined:minecraft.birch_wall_hanging_sign' | 'minecraft.broken:minecraft.birch_wall_sign' | 'minecraft.mined:minecraft.birch_wall_sign' | 'minecraft.broken:minecraft.birch_wood' | 'minecraft.mined:minecraft.birch_wood' | 'minecraft.broken:minecraft.black_banner' | 'minecraft.mined:minecraft.black_banner' | 'minecraft.broken:minecraft.black_bed' | 'minecraft.mined:minecraft.black_bed' | 'minecraft.broken:minecraft.black_candle' | 'minecraft.mined:minecraft.black_candle' | 'minecraft.broken:minecraft.black_candle_cake' | 'minecraft.mined:minecraft.black_candle_cake' | 'minecraft.broken:minecraft.black_carpet' | 'minecraft.mined:minecraft.black_carpet' | 'minecraft.broken:minecraft.black_concrete' | 'minecraft.mined:minecraft.black_concrete' | 'minecraft.broken:minecraft.black_concrete_powder' | 'minecraft.mined:minecraft.black_concrete_powder' | 'minecraft.broken:minecraft.black_glazed_terracotta' | 'minecraft.mined:minecraft.black_glazed_terracotta' | 'minecraft.broken:minecraft.black_shulker_box' | 'minecraft.mined:minecraft.black_shulker_box' | 'minecraft.broken:minecraft.black_stained_glass' | 'minecraft.mined:minecraft.black_stained_glass' | 'minecraft.broken:minecraft.black_stained_glass_pane' | 'minecraft.mined:minecraft.black_stained_glass_pane' | 'minecraft.broken:minecraft.black_terracotta' | 'minecraft.mined:minecraft.black_terracotta' | 'minecraft.broken:minecraft.black_wall_banner' | 'minecraft.mined:minecraft.black_wall_banner' | 'minecraft.broken:minecraft.black_wool' | 'minecraft.mined:minecraft.black_wool' | 'minecraft.broken:minecraft.blackstone' | 'minecraft.mined:minecraft.blackstone' | 'minecraft.broken:minecraft.blackstone_slab' | 'minecraft.mined:minecraft.blackstone_slab' | 'minecraft.broken:minecraft.blackstone_stairs' | 'minecraft.mined:minecraft.blackstone_stairs' | 'minecraft.broken:minecraft.blackstone_wall' | 'minecraft.mined:minecraft.blackstone_wall' | 'minecraft.broken:minecraft.blast_furnace' | 'minecraft.mined:minecraft.blast_furnace' | 'minecraft.broken:minecraft.blue_banner' | 'minecraft.mined:minecraft.blue_banner' | 'minecraft.broken:minecraft.blue_bed' | 'minecraft.mined:minecraft.blue_bed' | 'minecraft.broken:minecraft.blue_candle' | 'minecraft.mined:minecraft.blue_candle' | 'minecraft.broken:minecraft.blue_candle_cake' | 'minecraft.mined:minecraft.blue_candle_cake' | 'minecraft.broken:minecraft.blue_carpet' | 'minecraft.mined:minecraft.blue_carpet' | 'minecraft.broken:minecraft.blue_concrete' | 'minecraft.mined:minecraft.blue_concrete' | 'minecraft.broken:minecraft.blue_concrete_powder' | 'minecraft.mined:minecraft.blue_concrete_powder' | 'minecraft.broken:minecraft.blue_glazed_terracotta' | 'minecraft.mined:minecraft.blue_glazed_terracotta' | 'minecraft.broken:minecraft.blue_ice' | 'minecraft.mined:minecraft.blue_ice' | 'minecraft.broken:minecraft.blue_orchid' | 'minecraft.mined:minecraft.blue_orchid' | 'minecraft.broken:minecraft.blue_shulker_box' | 'minecraft.mined:minecraft.blue_shulker_box' | 'minecraft.broken:minecraft.blue_stained_glass' | 'minecraft.mined:minecraft.blue_stained_glass' | 'minecraft.broken:minecraft.blue_stained_glass_pane' | 'minecraft.mined:minecraft.blue_stained_glass_pane' | 'minecraft.broken:minecraft.blue_terracotta' | 'minecraft.mined:minecraft.blue_terracotta' | 'minecraft.broken:minecraft.blue_wall_banner' | 'minecraft.mined:minecraft.blue_wall_banner' | 'minecraft.broken:minecraft.blue_wool' | 'minecraft.mined:minecraft.blue_wool' | 'minecraft.broken:minecraft.bone_block' | 'minecraft.mined:minecraft.bone_block' | 'minecraft.broken:minecraft.bookshelf' | 'minecraft.mined:minecraft.bookshelf' | 'minecraft.broken:minecraft.brain_coral' | 'minecraft.mined:minecraft.brain_coral' | 'minecraft.broken:minecraft.brain_coral_block' | 'minecraft.mined:minecraft.brain_coral_block' | 'minecraft.broken:minecraft.brain_coral_fan' | 'minecraft.mined:minecraft.brain_coral_fan' | 'minecraft.broken:minecraft.brain_coral_wall_fan' | 'minecraft.mined:minecraft.brain_coral_wall_fan' | 'minecraft.broken:minecraft.brewing_stand' | 'minecraft.mined:minecraft.brewing_stand' | 'minecraft.broken:minecraft.brick_slab' | 'minecraft.mined:minecraft.brick_slab' | 'minecraft.broken:minecraft.brick_stairs' | 'minecraft.mined:minecraft.brick_stairs' | 'minecraft.broken:minecraft.brick_wall' | 'minecraft.mined:minecraft.brick_wall' | 'minecraft.broken:minecraft.bricks' | 'minecraft.mined:minecraft.bricks' | 'minecraft.broken:minecraft.brown_banner' | 'minecraft.mined:minecraft.brown_banner' | 'minecraft.broken:minecraft.brown_bed' | 'minecraft.mined:minecraft.brown_bed' | 'minecraft.broken:minecraft.brown_candle' | 'minecraft.mined:minecraft.brown_candle' | 'minecraft.broken:minecraft.brown_candle_cake' | 'minecraft.mined:minecraft.brown_candle_cake' | 'minecraft.broken:minecraft.brown_carpet' | 'minecraft.mined:minecraft.brown_carpet' | 'minecraft.broken:minecraft.brown_concrete' | 'minecraft.mined:minecraft.brown_concrete' | 'minecraft.broken:minecraft.brown_concrete_powder' | 'minecraft.mined:minecraft.brown_concrete_powder' | 'minecraft.broken:minecraft.brown_glazed_terracotta' | 'minecraft.mined:minecraft.brown_glazed_terracotta' | 'minecraft.broken:minecraft.brown_mushroom' | 'minecraft.mined:minecraft.brown_mushroom' | 'minecraft.broken:minecraft.brown_mushroom_block' | 'minecraft.mined:minecraft.brown_mushroom_block' | 'minecraft.broken:minecraft.brown_shulker_box' | 'minecraft.mined:minecraft.brown_shulker_box' | 'minecraft.broken:minecraft.brown_stained_glass' | 'minecraft.mined:minecraft.brown_stained_glass' | 'minecraft.broken:minecraft.brown_stained_glass_pane' | 'minecraft.mined:minecraft.brown_stained_glass_pane' | 'minecraft.broken:minecraft.brown_terracotta' | 'minecraft.mined:minecraft.brown_terracotta' | 'minecraft.broken:minecraft.brown_wall_banner' | 'minecraft.mined:minecraft.brown_wall_banner' | 'minecraft.broken:minecraft.brown_wool' | 'minecraft.mined:minecraft.brown_wool' | 'minecraft.broken:minecraft.bubble_column' | 'minecraft.mined:minecraft.bubble_column' | 'minecraft.broken:minecraft.bubble_coral' | 'minecraft.mined:minecraft.bubble_coral' | 'minecraft.broken:minecraft.bubble_coral_block' | 'minecraft.mined:minecraft.bubble_coral_block' | 'minecraft.broken:minecraft.bubble_coral_fan' | 'minecraft.mined:minecraft.bubble_coral_fan' | 'minecraft.broken:minecraft.bubble_coral_wall_fan' | 'minecraft.mined:minecraft.bubble_coral_wall_fan' | 'minecraft.broken:minecraft.budding_amethyst' | 'minecraft.mined:minecraft.budding_amethyst' | 'minecraft.broken:minecraft.cactus' | 'minecraft.mined:minecraft.cactus' | 'minecraft.broken:minecraft.cake' | 'minecraft.mined:minecraft.cake' | 'minecraft.broken:minecraft.calcite' | 'minecraft.mined:minecraft.calcite' | 'minecraft.broken:minecraft.calibrated_sculk_sensor' | 'minecraft.mined:minecraft.calibrated_sculk_sensor' | 'minecraft.broken:minecraft.campfire' | 'minecraft.mined:minecraft.campfire' | 'minecraft.broken:minecraft.candle' | 'minecraft.mined:minecraft.candle' | 'minecraft.broken:minecraft.candle_cake' | 'minecraft.mined:minecraft.candle_cake' | 'minecraft.broken:minecraft.carrots' | 'minecraft.mined:minecraft.carrots' | 'minecraft.broken:minecraft.cartography_table' | 'minecraft.mined:minecraft.cartography_table' | 'minecraft.broken:minecraft.carved_pumpkin' | 'minecraft.mined:minecraft.carved_pumpkin' | 'minecraft.broken:minecraft.cauldron' | 'minecraft.mined:minecraft.cauldron' | 'minecraft.broken:minecraft.cave_air' | 'minecraft.mined:minecraft.cave_air' | 'minecraft.broken:minecraft.cave_vines' | 'minecraft.mined:minecraft.cave_vines' | 'minecraft.broken:minecraft.cave_vines_plant' | 'minecraft.mined:minecraft.cave_vines_plant' | 'minecraft.broken:minecraft.chain' | 'minecraft.mined:minecraft.chain' | 'minecraft.broken:minecraft.chain_command_block' | 'minecraft.mined:minecraft.chain_command_block' | 'minecraft.broken:minecraft.cherry_button' | 'minecraft.mined:minecraft.cherry_button' | 'minecraft.broken:minecraft.cherry_door' | 'minecraft.mined:minecraft.cherry_door' | 'minecraft.broken:minecraft.cherry_fence' | 'minecraft.mined:minecraft.cherry_fence' | 'minecraft.broken:minecraft.cherry_fence_gate' | 'minecraft.mined:minecraft.cherry_fence_gate' | 'minecraft.broken:minecraft.cherry_hanging_sign' | 'minecraft.mined:minecraft.cherry_hanging_sign' | 'minecraft.broken:minecraft.cherry_leaves' | 'minecraft.mined:minecraft.cherry_leaves' | 'minecraft.broken:minecraft.cherry_log' | 'minecraft.mined:minecraft.cherry_log' | 'minecraft.broken:minecraft.cherry_planks' | 'minecraft.mined:minecraft.cherry_planks' | 'minecraft.broken:minecraft.cherry_pressure_plate' | 'minecraft.mined:minecraft.cherry_pressure_plate' | 'minecraft.broken:minecraft.cherry_sapling' | 'minecraft.mined:minecraft.cherry_sapling' | 'minecraft.broken:minecraft.cherry_sign' | 'minecraft.mined:minecraft.cherry_sign' | 'minecraft.broken:minecraft.cherry_slab' | 'minecraft.mined:minecraft.cherry_slab' | 'minecraft.broken:minecraft.cherry_stairs' | 'minecraft.mined:minecraft.cherry_stairs' | 'minecraft.broken:minecraft.cherry_trapdoor' | 'minecraft.mined:minecraft.cherry_trapdoor' | 'minecraft.broken:minecraft.cherry_wall_hanging_sign' | 'minecraft.mined:minecraft.cherry_wall_hanging_sign' | 'minecraft.broken:minecraft.cherry_wall_sign' | 'minecraft.mined:minecraft.cherry_wall_sign' | 'minecraft.broken:minecraft.cherry_wood' | 'minecraft.mined:minecraft.cherry_wood' | 'minecraft.broken:minecraft.chest' | 'minecraft.mined:minecraft.chest' | 'minecraft.broken:minecraft.chipped_anvil' | 'minecraft.mined:minecraft.chipped_anvil' | 'minecraft.broken:minecraft.chiseled_bookshelf' | 'minecraft.mined:minecraft.chiseled_bookshelf' | 'minecraft.broken:minecraft.chiseled_copper' | 'minecraft.mined:minecraft.chiseled_copper' | 'minecraft.broken:minecraft.chiseled_deepslate' | 'minecraft.mined:minecraft.chiseled_deepslate' | 'minecraft.broken:minecraft.chiseled_nether_bricks' | 'minecraft.mined:minecraft.chiseled_nether_bricks' | 'minecraft.broken:minecraft.chiseled_polished_blackstone' | 'minecraft.mined:minecraft.chiseled_polished_blackstone' | 'minecraft.broken:minecraft.chiseled_quartz_block' | 'minecraft.mined:minecraft.chiseled_quartz_block' | 'minecraft.broken:minecraft.chiseled_red_sandstone' | 'minecraft.mined:minecraft.chiseled_red_sandstone' | 'minecraft.broken:minecraft.chiseled_sandstone' | 'minecraft.mined:minecraft.chiseled_sandstone' | 'minecraft.broken:minecraft.chiseled_stone_bricks' | 'minecraft.mined:minecraft.chiseled_stone_bricks' | 'minecraft.broken:minecraft.chiseled_tuff' | 'minecraft.mined:minecraft.chiseled_tuff' | 'minecraft.broken:minecraft.chiseled_tuff_bricks' | 'minecraft.mined:minecraft.chiseled_tuff_bricks' | 'minecraft.broken:minecraft.chorus_flower' | 'minecraft.mined:minecraft.chorus_flower' | 'minecraft.broken:minecraft.chorus_plant' | 'minecraft.mined:minecraft.chorus_plant' | 'minecraft.broken:minecraft.clay' | 'minecraft.mined:minecraft.clay' | 'minecraft.broken:minecraft.coal_block' | 'minecraft.mined:minecraft.coal_block' | 'minecraft.broken:minecraft.coal_ore' | 'minecraft.mined:minecraft.coal_ore' | 'minecraft.broken:minecraft.coarse_dirt' | 'minecraft.mined:minecraft.coarse_dirt' | 'minecraft.broken:minecraft.cobbled_deepslate' | 'minecraft.mined:minecraft.cobbled_deepslate' | 'minecraft.broken:minecraft.cobbled_deepslate_slab' | 'minecraft.mined:minecraft.cobbled_deepslate_slab' | 'minecraft.broken:minecraft.cobbled_deepslate_stairs' | 'minecraft.mined:minecraft.cobbled_deepslate_stairs' | 'minecraft.broken:minecraft.cobbled_deepslate_wall' | 'minecraft.mined:minecraft.cobbled_deepslate_wall' | 'minecraft.broken:minecraft.cobblestone' | 'minecraft.mined:minecraft.cobblestone' | 'minecraft.broken:minecraft.cobblestone_slab' | 'minecraft.mined:minecraft.cobblestone_slab' | 'minecraft.broken:minecraft.cobblestone_stairs' | 'minecraft.mined:minecraft.cobblestone_stairs' | 'minecraft.broken:minecraft.cobblestone_wall' | 'minecraft.mined:minecraft.cobblestone_wall' | 'minecraft.broken:minecraft.cobweb' | 'minecraft.mined:minecraft.cobweb' | 'minecraft.broken:minecraft.cocoa' | 'minecraft.mined:minecraft.cocoa' | 'minecraft.broken:minecraft.command_block' | 'minecraft.mined:minecraft.command_block' | 'minecraft.broken:minecraft.comparator' | 'minecraft.mined:minecraft.comparator' | 'minecraft.broken:minecraft.composter' | 'minecraft.mined:minecraft.composter' | 'minecraft.broken:minecraft.conduit' | 'minecraft.mined:minecraft.conduit' | 'minecraft.broken:minecraft.copper_block' | 'minecraft.mined:minecraft.copper_block' | 'minecraft.broken:minecraft.copper_bulb' | 'minecraft.mined:minecraft.copper_bulb' | 'minecraft.broken:minecraft.copper_door' | 'minecraft.mined:minecraft.copper_door' | 'minecraft.broken:minecraft.copper_grate' | 'minecraft.mined:minecraft.copper_grate' | 'minecraft.broken:minecraft.copper_ore' | 'minecraft.mined:minecraft.copper_ore' | 'minecraft.broken:minecraft.copper_trapdoor' | 'minecraft.mined:minecraft.copper_trapdoor' | 'minecraft.broken:minecraft.cornflower' | 'minecraft.mined:minecraft.cornflower' | 'minecraft.broken:minecraft.cracked_deepslate_bricks' | 'minecraft.mined:minecraft.cracked_deepslate_bricks' | 'minecraft.broken:minecraft.cracked_deepslate_tiles' | 'minecraft.mined:minecraft.cracked_deepslate_tiles' | 'minecraft.broken:minecraft.cracked_nether_bricks' | 'minecraft.mined:minecraft.cracked_nether_bricks' | 'minecraft.broken:minecraft.cracked_polished_blackstone_bricks' | 'minecraft.mined:minecraft.cracked_polished_blackstone_bricks' | 'minecraft.broken:minecraft.cracked_stone_bricks' | 'minecraft.mined:minecraft.cracked_stone_bricks' | 'minecraft.broken:minecraft.crafter' | 'minecraft.mined:minecraft.crafter' | 'minecraft.broken:minecraft.crafting_table' | 'minecraft.mined:minecraft.crafting_table' | 'minecraft.broken:minecraft.creeper_head' | 'minecraft.mined:minecraft.creeper_head' | 'minecraft.broken:minecraft.creeper_wall_head' | 'minecraft.mined:minecraft.creeper_wall_head' | 'minecraft.broken:minecraft.crimson_button' | 'minecraft.mined:minecraft.crimson_button' | 'minecraft.broken:minecraft.crimson_door' | 'minecraft.mined:minecraft.crimson_door' | 'minecraft.broken:minecraft.crimson_fence' | 'minecraft.mined:minecraft.crimson_fence' | 'minecraft.broken:minecraft.crimson_fence_gate' | 'minecraft.mined:minecraft.crimson_fence_gate' | 'minecraft.broken:minecraft.crimson_fungus' | 'minecraft.mined:minecraft.crimson_fungus' | 'minecraft.broken:minecraft.crimson_hanging_sign' | 'minecraft.mined:minecraft.crimson_hanging_sign' | 'minecraft.broken:minecraft.crimson_hyphae' | 'minecraft.mined:minecraft.crimson_hyphae' | 'minecraft.broken:minecraft.crimson_nylium' | 'minecraft.mined:minecraft.crimson_nylium' | 'minecraft.broken:minecraft.crimson_planks' | 'minecraft.mined:minecraft.crimson_planks' | 'minecraft.broken:minecraft.crimson_pressure_plate' | 'minecraft.mined:minecraft.crimson_pressure_plate' | 'minecraft.broken:minecraft.crimson_roots' | 'minecraft.mined:minecraft.crimson_roots' | 'minecraft.broken:minecraft.crimson_sign' | 'minecraft.mined:minecraft.crimson_sign' | 'minecraft.broken:minecraft.crimson_slab' | 'minecraft.mined:minecraft.crimson_slab' | 'minecraft.broken:minecraft.crimson_stairs' | 'minecraft.mined:minecraft.crimson_stairs' | 'minecraft.broken:minecraft.crimson_stem' | 'minecraft.mined:minecraft.crimson_stem' | 'minecraft.broken:minecraft.crimson_trapdoor' | 'minecraft.mined:minecraft.crimson_trapdoor' | 'minecraft.broken:minecraft.crimson_wall_hanging_sign' | 'minecraft.mined:minecraft.crimson_wall_hanging_sign' | 'minecraft.broken:minecraft.crimson_wall_sign' | 'minecraft.mined:minecraft.crimson_wall_sign' | 'minecraft.broken:minecraft.crying_obsidian' | 'minecraft.mined:minecraft.crying_obsidian' | 'minecraft.broken:minecraft.cut_copper' | 'minecraft.mined:minecraft.cut_copper' | 'minecraft.broken:minecraft.cut_copper_slab' | 'minecraft.mined:minecraft.cut_copper_slab' | 'minecraft.broken:minecraft.cut_copper_stairs' | 'minecraft.mined:minecraft.cut_copper_stairs' | 'minecraft.broken:minecraft.cut_red_sandstone' | 'minecraft.mined:minecraft.cut_red_sandstone' | 'minecraft.broken:minecraft.cut_red_sandstone_slab' | 'minecraft.mined:minecraft.cut_red_sandstone_slab' | 'minecraft.broken:minecraft.cut_sandstone' | 'minecraft.mined:minecraft.cut_sandstone' | 'minecraft.broken:minecraft.cut_sandstone_slab' | 'minecraft.mined:minecraft.cut_sandstone_slab' | 'minecraft.broken:minecraft.cyan_banner' | 'minecraft.mined:minecraft.cyan_banner' | 'minecraft.broken:minecraft.cyan_bed' | 'minecraft.mined:minecraft.cyan_bed' | 'minecraft.broken:minecraft.cyan_candle' | 'minecraft.mined:minecraft.cyan_candle' | 'minecraft.broken:minecraft.cyan_candle_cake' | 'minecraft.mined:minecraft.cyan_candle_cake' | 'minecraft.broken:minecraft.cyan_carpet' | 'minecraft.mined:minecraft.cyan_carpet' | 'minecraft.broken:minecraft.cyan_concrete' | 'minecraft.mined:minecraft.cyan_concrete' | 'minecraft.broken:minecraft.cyan_concrete_powder' | 'minecraft.mined:minecraft.cyan_concrete_powder' | 'minecraft.broken:minecraft.cyan_glazed_terracotta' | 'minecraft.mined:minecraft.cyan_glazed_terracotta' | 'minecraft.broken:minecraft.cyan_shulker_box' | 'minecraft.mined:minecraft.cyan_shulker_box' | 'minecraft.broken:minecraft.cyan_stained_glass' | 'minecraft.mined:minecraft.cyan_stained_glass' | 'minecraft.broken:minecraft.cyan_stained_glass_pane' | 'minecraft.mined:minecraft.cyan_stained_glass_pane' | 'minecraft.broken:minecraft.cyan_terracotta' | 'minecraft.mined:minecraft.cyan_terracotta' | 'minecraft.broken:minecraft.cyan_wall_banner' | 'minecraft.mined:minecraft.cyan_wall_banner' | 'minecraft.broken:minecraft.cyan_wool' | 'minecraft.mined:minecraft.cyan_wool' | 'minecraft.broken:minecraft.damaged_anvil' | 'minecraft.mined:minecraft.damaged_anvil' | 'minecraft.broken:minecraft.dandelion' | 'minecraft.mined:minecraft.dandelion' | 'minecraft.broken:minecraft.dark_oak_button' | 'minecraft.mined:minecraft.dark_oak_button' | 'minecraft.broken:minecraft.dark_oak_door' | 'minecraft.mined:minecraft.dark_oak_door' | 'minecraft.broken:minecraft.dark_oak_fence' | 'minecraft.mined:minecraft.dark_oak_fence' | 'minecraft.broken:minecraft.dark_oak_fence_gate' | 'minecraft.mined:minecraft.dark_oak_fence_gate' | 'minecraft.broken:minecraft.dark_oak_hanging_sign' | 'minecraft.mined:minecraft.dark_oak_hanging_sign' | 'minecraft.broken:minecraft.dark_oak_leaves' | 'minecraft.mined:minecraft.dark_oak_leaves' | 'minecraft.broken:minecraft.dark_oak_log' | 'minecraft.mined:minecraft.dark_oak_log' | 'minecraft.broken:minecraft.dark_oak_planks' | 'minecraft.mined:minecraft.dark_oak_planks' | 'minecraft.broken:minecraft.dark_oak_pressure_plate' | 'minecraft.mined:minecraft.dark_oak_pressure_plate' | 'minecraft.broken:minecraft.dark_oak_sapling' | 'minecraft.mined:minecraft.dark_oak_sapling' | 'minecraft.broken:minecraft.dark_oak_sign' | 'minecraft.mined:minecraft.dark_oak_sign' | 'minecraft.broken:minecraft.dark_oak_slab' | 'minecraft.mined:minecraft.dark_oak_slab' | 'minecraft.broken:minecraft.dark_oak_stairs' | 'minecraft.mined:minecraft.dark_oak_stairs' | 'minecraft.broken:minecraft.dark_oak_trapdoor' | 'minecraft.mined:minecraft.dark_oak_trapdoor' | 'minecraft.broken:minecraft.dark_oak_wall_hanging_sign' | 'minecraft.mined:minecraft.dark_oak_wall_hanging_sign' | 'minecraft.broken:minecraft.dark_oak_wall_sign' | 'minecraft.mined:minecraft.dark_oak_wall_sign' | 'minecraft.broken:minecraft.dark_oak_wood' | 'minecraft.mined:minecraft.dark_oak_wood' | 'minecraft.broken:minecraft.dark_prismarine' | 'minecraft.mined:minecraft.dark_prismarine' | 'minecraft.broken:minecraft.dark_prismarine_slab' | 'minecraft.mined:minecraft.dark_prismarine_slab' | 'minecraft.broken:minecraft.dark_prismarine_stairs' | 'minecraft.mined:minecraft.dark_prismarine_stairs' | 'minecraft.broken:minecraft.daylight_detector' | 'minecraft.mined:minecraft.daylight_detector' | 'minecraft.broken:minecraft.dead_brain_coral' | 'minecraft.mined:minecraft.dead_brain_coral' | 'minecraft.broken:minecraft.dead_brain_coral_block' | 'minecraft.mined:minecraft.dead_brain_coral_block' | 'minecraft.broken:minecraft.dead_brain_coral_fan' | 'minecraft.mined:minecraft.dead_brain_coral_fan' | 'minecraft.broken:minecraft.dead_brain_coral_wall_fan' | 'minecraft.mined:minecraft.dead_brain_coral_wall_fan' | 'minecraft.broken:minecraft.dead_bubble_coral' | 'minecraft.mined:minecraft.dead_bubble_coral' | 'minecraft.broken:minecraft.dead_bubble_coral_block' | 'minecraft.mined:minecraft.dead_bubble_coral_block' | 'minecraft.broken:minecraft.dead_bubble_coral_fan' | 'minecraft.mined:minecraft.dead_bubble_coral_fan' | 'minecraft.broken:minecraft.dead_bubble_coral_wall_fan' | 'minecraft.mined:minecraft.dead_bubble_coral_wall_fan' | 'minecraft.broken:minecraft.dead_bush' | 'minecraft.mined:minecraft.dead_bush' | 'minecraft.broken:minecraft.dead_fire_coral' | 'minecraft.mined:minecraft.dead_fire_coral' | 'minecraft.broken:minecraft.dead_fire_coral_block' | 'minecraft.mined:minecraft.dead_fire_coral_block' | 'minecraft.broken:minecraft.dead_fire_coral_fan' | 'minecraft.mined:minecraft.dead_fire_coral_fan' | 'minecraft.broken:minecraft.dead_fire_coral_wall_fan' | 'minecraft.mined:minecraft.dead_fire_coral_wall_fan' | 'minecraft.broken:minecraft.dead_horn_coral' | 'minecraft.mined:minecraft.dead_horn_coral' | 'minecraft.broken:minecraft.dead_horn_coral_block' | 'minecraft.mined:minecraft.dead_horn_coral_block' | 'minecraft.broken:minecraft.dead_horn_coral_fan' | 'minecraft.mined:minecraft.dead_horn_coral_fan' | 'minecraft.broken:minecraft.dead_horn_coral_wall_fan' | 'minecraft.mined:minecraft.dead_horn_coral_wall_fan' | 'minecraft.broken:minecraft.dead_tube_coral' | 'minecraft.mined:minecraft.dead_tube_coral' | 'minecraft.broken:minecraft.dead_tube_coral_block' | 'minecraft.mined:minecraft.dead_tube_coral_block' | 'minecraft.broken:minecraft.dead_tube_coral_fan' | 'minecraft.mined:minecraft.dead_tube_coral_fan' | 'minecraft.broken:minecraft.dead_tube_coral_wall_fan' | 'minecraft.mined:minecraft.dead_tube_coral_wall_fan' | 'minecraft.broken:minecraft.decorated_pot' | 'minecraft.mined:minecraft.decorated_pot' | 'minecraft.broken:minecraft.deepslate' | 'minecraft.mined:minecraft.deepslate' | 'minecraft.broken:minecraft.deepslate_brick_slab' | 'minecraft.mined:minecraft.deepslate_brick_slab' | 'minecraft.broken:minecraft.deepslate_brick_stairs' | 'minecraft.mined:minecraft.deepslate_brick_stairs' | 'minecraft.broken:minecraft.deepslate_brick_wall' | 'minecraft.mined:minecraft.deepslate_brick_wall' | 'minecraft.broken:minecraft.deepslate_bricks' | 'minecraft.mined:minecraft.deepslate_bricks' | 'minecraft.broken:minecraft.deepslate_coal_ore' | 'minecraft.mined:minecraft.deepslate_coal_ore' | 'minecraft.broken:minecraft.deepslate_copper_ore' | 'minecraft.mined:minecraft.deepslate_copper_ore' | 'minecraft.broken:minecraft.deepslate_diamond_ore' | 'minecraft.mined:minecraft.deepslate_diamond_ore' | 'minecraft.broken:minecraft.deepslate_emerald_ore' | 'minecraft.mined:minecraft.deepslate_emerald_ore' | 'minecraft.broken:minecraft.deepslate_gold_ore' | 'minecraft.mined:minecraft.deepslate_gold_ore' | 'minecraft.broken:minecraft.deepslate_iron_ore' | 'minecraft.mined:minecraft.deepslate_iron_ore' | 'minecraft.broken:minecraft.deepslate_lapis_ore' | 'minecraft.mined:minecraft.deepslate_lapis_ore' | 'minecraft.broken:minecraft.deepslate_redstone_ore' | 'minecraft.mined:minecraft.deepslate_redstone_ore' | 'minecraft.broken:minecraft.deepslate_tile_slab' | 'minecraft.mined:minecraft.deepslate_tile_slab' | 'minecraft.broken:minecraft.deepslate_tile_stairs' | 'minecraft.mined:minecraft.deepslate_tile_stairs' | 'minecraft.broken:minecraft.deepslate_tile_wall' | 'minecraft.mined:minecraft.deepslate_tile_wall' | 'minecraft.broken:minecraft.deepslate_tiles' | 'minecraft.mined:minecraft.deepslate_tiles' | 'minecraft.broken:minecraft.detector_rail' | 'minecraft.mined:minecraft.detector_rail' | 'minecraft.broken:minecraft.diamond_block' | 'minecraft.mined:minecraft.diamond_block' | 'minecraft.broken:minecraft.diamond_ore' | 'minecraft.mined:minecraft.diamond_ore' | 'minecraft.broken:minecraft.diorite' | 'minecraft.mined:minecraft.diorite' | 'minecraft.broken:minecraft.diorite_slab' | 'minecraft.mined:minecraft.diorite_slab' | 'minecraft.broken:minecraft.diorite_stairs' | 'minecraft.mined:minecraft.diorite_stairs' | 'minecraft.broken:minecraft.diorite_wall' | 'minecraft.mined:minecraft.diorite_wall' | 'minecraft.broken:minecraft.dirt' | 'minecraft.mined:minecraft.dirt' | 'minecraft.broken:minecraft.dirt_path' | 'minecraft.mined:minecraft.dirt_path' | 'minecraft.broken:minecraft.dispenser' | 'minecraft.mined:minecraft.dispenser' | 'minecraft.broken:minecraft.dragon_egg' | 'minecraft.mined:minecraft.dragon_egg' | 'minecraft.broken:minecraft.dragon_head' | 'minecraft.mined:minecraft.dragon_head' | 'minecraft.broken:minecraft.dragon_wall_head' | 'minecraft.mined:minecraft.dragon_wall_head' | 'minecraft.broken:minecraft.dried_kelp_block' | 'minecraft.mined:minecraft.dried_kelp_block' | 'minecraft.broken:minecraft.dripstone_block' | 'minecraft.mined:minecraft.dripstone_block' | 'minecraft.broken:minecraft.dropper' | 'minecraft.mined:minecraft.dropper' | 'minecraft.broken:minecraft.emerald_block' | 'minecraft.mined:minecraft.emerald_block' | 'minecraft.broken:minecraft.emerald_ore' | 'minecraft.mined:minecraft.emerald_ore' | 'minecraft.broken:minecraft.enchanting_table' | 'minecraft.mined:minecraft.enchanting_table' | 'minecraft.broken:minecraft.end_gateway' | 'minecraft.mined:minecraft.end_gateway' | 'minecraft.broken:minecraft.end_portal' | 'minecraft.mined:minecraft.end_portal' | 'minecraft.broken:minecraft.end_portal_frame' | 'minecraft.mined:minecraft.end_portal_frame' | 'minecraft.broken:minecraft.end_rod' | 'minecraft.mined:minecraft.end_rod' | 'minecraft.broken:minecraft.end_stone' | 'minecraft.mined:minecraft.end_stone' | 'minecraft.broken:minecraft.end_stone_brick_slab' | 'minecraft.mined:minecraft.end_stone_brick_slab' | 'minecraft.broken:minecraft.end_stone_brick_stairs' | 'minecraft.mined:minecraft.end_stone_brick_stairs' | 'minecraft.broken:minecraft.end_stone_brick_wall' | 'minecraft.mined:minecraft.end_stone_brick_wall' | 'minecraft.broken:minecraft.end_stone_bricks' | 'minecraft.mined:minecraft.end_stone_bricks' | 'minecraft.broken:minecraft.ender_chest' | 'minecraft.mined:minecraft.ender_chest' | 'minecraft.broken:minecraft.exposed_chiseled_copper' | 'minecraft.mined:minecraft.exposed_chiseled_copper' | 'minecraft.broken:minecraft.exposed_copper' | 'minecraft.mined:minecraft.exposed_copper' | 'minecraft.broken:minecraft.exposed_copper_bulb' | 'minecraft.mined:minecraft.exposed_copper_bulb' | 'minecraft.broken:minecraft.exposed_copper_door' | 'minecraft.mined:minecraft.exposed_copper_door' | 'minecraft.broken:minecraft.exposed_copper_grate' | 'minecraft.mined:minecraft.exposed_copper_grate' | 'minecraft.broken:minecraft.exposed_copper_trapdoor' | 'minecraft.mined:minecraft.exposed_copper_trapdoor' | 'minecraft.broken:minecraft.exposed_cut_copper' | 'minecraft.mined:minecraft.exposed_cut_copper' | 'minecraft.broken:minecraft.exposed_cut_copper_slab' | 'minecraft.mined:minecraft.exposed_cut_copper_slab' | 'minecraft.broken:minecraft.exposed_cut_copper_stairs' | 'minecraft.mined:minecraft.exposed_cut_copper_stairs' | 'minecraft.broken:minecraft.farmland' | 'minecraft.mined:minecraft.farmland' | 'minecraft.broken:minecraft.fern' | 'minecraft.mined:minecraft.fern' | 'minecraft.broken:minecraft.fire' | 'minecraft.mined:minecraft.fire' | 'minecraft.broken:minecraft.fire_coral' | 'minecraft.mined:minecraft.fire_coral' | 'minecraft.broken:minecraft.fire_coral_block' | 'minecraft.mined:minecraft.fire_coral_block' | 'minecraft.broken:minecraft.fire_coral_fan' | 'minecraft.mined:minecraft.fire_coral_fan' | 'minecraft.broken:minecraft.fire_coral_wall_fan' | 'minecraft.mined:minecraft.fire_coral_wall_fan' | 'minecraft.broken:minecraft.fletching_table' | 'minecraft.mined:minecraft.fletching_table' | 'minecraft.broken:minecraft.flower_pot' | 'minecraft.mined:minecraft.flower_pot' | 'minecraft.broken:minecraft.flowering_azalea' | 'minecraft.mined:minecraft.flowering_azalea' | 'minecraft.broken:minecraft.flowering_azalea_leaves' | 'minecraft.mined:minecraft.flowering_azalea_leaves' | 'minecraft.broken:minecraft.frogspawn' | 'minecraft.mined:minecraft.frogspawn' | 'minecraft.broken:minecraft.frosted_ice' | 'minecraft.mined:minecraft.frosted_ice' | 'minecraft.broken:minecraft.furnace' | 'minecraft.mined:minecraft.furnace' | 'minecraft.broken:minecraft.gilded_blackstone' | 'minecraft.mined:minecraft.gilded_blackstone' | 'minecraft.broken:minecraft.glass' | 'minecraft.mined:minecraft.glass' | 'minecraft.broken:minecraft.glass_pane' | 'minecraft.mined:minecraft.glass_pane' | 'minecraft.broken:minecraft.glow_lichen' | 'minecraft.mined:minecraft.glow_lichen' | 'minecraft.broken:minecraft.glowstone' | 'minecraft.mined:minecraft.glowstone' | 'minecraft.broken:minecraft.gold_block' | 'minecraft.mined:minecraft.gold_block' | 'minecraft.broken:minecraft.gold_ore' | 'minecraft.mined:minecraft.gold_ore' | 'minecraft.broken:minecraft.granite' | 'minecraft.mined:minecraft.granite' | 'minecraft.broken:minecraft.granite_slab' | 'minecraft.mined:minecraft.granite_slab' | 'minecraft.broken:minecraft.granite_stairs' | 'minecraft.mined:minecraft.granite_stairs' | 'minecraft.broken:minecraft.granite_wall' | 'minecraft.mined:minecraft.granite_wall' | 'minecraft.broken:minecraft.grass' | 'minecraft.mined:minecraft.grass' | 'minecraft.broken:minecraft.grass_block' | 'minecraft.mined:minecraft.grass_block' | 'minecraft.broken:minecraft.gravel' | 'minecraft.mined:minecraft.gravel' | 'minecraft.broken:minecraft.gray_banner' | 'minecraft.mined:minecraft.gray_banner' | 'minecraft.broken:minecraft.gray_bed' | 'minecraft.mined:minecraft.gray_bed' | 'minecraft.broken:minecraft.gray_candle' | 'minecraft.mined:minecraft.gray_candle' | 'minecraft.broken:minecraft.gray_candle_cake' | 'minecraft.mined:minecraft.gray_candle_cake' | 'minecraft.broken:minecraft.gray_carpet' | 'minecraft.mined:minecraft.gray_carpet' | 'minecraft.broken:minecraft.gray_concrete' | 'minecraft.mined:minecraft.gray_concrete' | 'minecraft.broken:minecraft.gray_concrete_powder' | 'minecraft.mined:minecraft.gray_concrete_powder' | 'minecraft.broken:minecraft.gray_glazed_terracotta' | 'minecraft.mined:minecraft.gray_glazed_terracotta' | 'minecraft.broken:minecraft.gray_shulker_box' | 'minecraft.mined:minecraft.gray_shulker_box' | 'minecraft.broken:minecraft.gray_stained_glass' | 'minecraft.mined:minecraft.gray_stained_glass' | 'minecraft.broken:minecraft.gray_stained_glass_pane' | 'minecraft.mined:minecraft.gray_stained_glass_pane' | 'minecraft.broken:minecraft.gray_terracotta' | 'minecraft.mined:minecraft.gray_terracotta' | 'minecraft.broken:minecraft.gray_wall_banner' | 'minecraft.mined:minecraft.gray_wall_banner' | 'minecraft.broken:minecraft.gray_wool' | 'minecraft.mined:minecraft.gray_wool' | 'minecraft.broken:minecraft.green_banner' | 'minecraft.mined:minecraft.green_banner' | 'minecraft.broken:minecraft.green_bed' | 'minecraft.mined:minecraft.green_bed' | 'minecraft.broken:minecraft.green_candle' | 'minecraft.mined:minecraft.green_candle' | 'minecraft.broken:minecraft.green_candle_cake' | 'minecraft.mined:minecraft.green_candle_cake' | 'minecraft.broken:minecraft.green_carpet' | 'minecraft.mined:minecraft.green_carpet' | 'minecraft.broken:minecraft.green_concrete' | 'minecraft.mined:minecraft.green_concrete' | 'minecraft.broken:minecraft.green_concrete_powder' | 'minecraft.mined:minecraft.green_concrete_powder' | 'minecraft.broken:minecraft.green_glazed_terracotta' | 'minecraft.mined:minecraft.green_glazed_terracotta' | 'minecraft.broken:minecraft.green_shulker_box' | 'minecraft.mined:minecraft.green_shulker_box' | 'minecraft.broken:minecraft.green_stained_glass' | 'minecraft.mined:minecraft.green_stained_glass' | 'minecraft.broken:minecraft.green_stained_glass_pane' | 'minecraft.mined:minecraft.green_stained_glass_pane' | 'minecraft.broken:minecraft.green_terracotta' | 'minecraft.mined:minecraft.green_terracotta' | 'minecraft.broken:minecraft.green_wall_banner' | 'minecraft.mined:minecraft.green_wall_banner' | 'minecraft.broken:minecraft.green_wool' | 'minecraft.mined:minecraft.green_wool' | 'minecraft.broken:minecraft.grindstone' | 'minecraft.mined:minecraft.grindstone' | 'minecraft.broken:minecraft.hanging_roots' | 'minecraft.mined:minecraft.hanging_roots' | 'minecraft.broken:minecraft.hay_block' | 'minecraft.mined:minecraft.hay_block' | 'minecraft.broken:minecraft.heavy_weighted_pressure_plate' | 'minecraft.mined:minecraft.heavy_weighted_pressure_plate' | 'minecraft.broken:minecraft.honey_block' | 'minecraft.mined:minecraft.honey_block' | 'minecraft.broken:minecraft.honeycomb_block' | 'minecraft.mined:minecraft.honeycomb_block' | 'minecraft.broken:minecraft.hopper' | 'minecraft.mined:minecraft.hopper' | 'minecraft.broken:minecraft.horn_coral' | 'minecraft.mined:minecraft.horn_coral' | 'minecraft.broken:minecraft.horn_coral_block' | 'minecraft.mined:minecraft.horn_coral_block' | 'minecraft.broken:minecraft.horn_coral_fan' | 'minecraft.mined:minecraft.horn_coral_fan' | 'minecraft.broken:minecraft.horn_coral_wall_fan' | 'minecraft.mined:minecraft.horn_coral_wall_fan' | 'minecraft.broken:minecraft.ice' | 'minecraft.mined:minecraft.ice' | 'minecraft.broken:minecraft.infested_chiseled_stone_bricks' | 'minecraft.mined:minecraft.infested_chiseled_stone_bricks' | 'minecraft.broken:minecraft.infested_cobblestone' | 'minecraft.mined:minecraft.infested_cobblestone' | 'minecraft.broken:minecraft.infested_cracked_stone_bricks' | 'minecraft.mined:minecraft.infested_cracked_stone_bricks' | 'minecraft.broken:minecraft.infested_deepslate' | 'minecraft.mined:minecraft.infested_deepslate' | 'minecraft.broken:minecraft.infested_mossy_stone_bricks' | 'minecraft.mined:minecraft.infested_mossy_stone_bricks' | 'minecraft.broken:minecraft.infested_stone' | 'minecraft.mined:minecraft.infested_stone' | 'minecraft.broken:minecraft.infested_stone_bricks' | 'minecraft.mined:minecraft.infested_stone_bricks' | 'minecraft.broken:minecraft.iron_bars' | 'minecraft.mined:minecraft.iron_bars' | 'minecraft.broken:minecraft.iron_block' | 'minecraft.mined:minecraft.iron_block' | 'minecraft.broken:minecraft.iron_door' | 'minecraft.mined:minecraft.iron_door' | 'minecraft.broken:minecraft.iron_ore' | 'minecraft.mined:minecraft.iron_ore' | 'minecraft.broken:minecraft.iron_trapdoor' | 'minecraft.mined:minecraft.iron_trapdoor' | 'minecraft.broken:minecraft.jack_o_lantern' | 'minecraft.mined:minecraft.jack_o_lantern' | 'minecraft.broken:minecraft.jigsaw' | 'minecraft.mined:minecraft.jigsaw' | 'minecraft.broken:minecraft.jukebox' | 'minecraft.mined:minecraft.jukebox' | 'minecraft.broken:minecraft.jungle_button' | 'minecraft.mined:minecraft.jungle_button' | 'minecraft.broken:minecraft.jungle_door' | 'minecraft.mined:minecraft.jungle_door' | 'minecraft.broken:minecraft.jungle_fence' | 'minecraft.mined:minecraft.jungle_fence' | 'minecraft.broken:minecraft.jungle_fence_gate' | 'minecraft.mined:minecraft.jungle_fence_gate' | 'minecraft.broken:minecraft.jungle_hanging_sign' | 'minecraft.mined:minecraft.jungle_hanging_sign' | 'minecraft.broken:minecraft.jungle_leaves' | 'minecraft.mined:minecraft.jungle_leaves' | 'minecraft.broken:minecraft.jungle_log' | 'minecraft.mined:minecraft.jungle_log' | 'minecraft.broken:minecraft.jungle_planks' | 'minecraft.mined:minecraft.jungle_planks' | 'minecraft.broken:minecraft.jungle_pressure_plate' | 'minecraft.mined:minecraft.jungle_pressure_plate' | 'minecraft.broken:minecraft.jungle_sapling' | 'minecraft.mined:minecraft.jungle_sapling' | 'minecraft.broken:minecraft.jungle_sign' | 'minecraft.mined:minecraft.jungle_sign' | 'minecraft.broken:minecraft.jungle_slab' | 'minecraft.mined:minecraft.jungle_slab' | 'minecraft.broken:minecraft.jungle_stairs' | 'minecraft.mined:minecraft.jungle_stairs' | 'minecraft.broken:minecraft.jungle_trapdoor' | 'minecraft.mined:minecraft.jungle_trapdoor' | 'minecraft.broken:minecraft.jungle_wall_hanging_sign' | 'minecraft.mined:minecraft.jungle_wall_hanging_sign' | 'minecraft.broken:minecraft.jungle_wall_sign' | 'minecraft.mined:minecraft.jungle_wall_sign' | 'minecraft.broken:minecraft.jungle_wood' | 'minecraft.mined:minecraft.jungle_wood' | 'minecraft.broken:minecraft.kelp' | 'minecraft.mined:minecraft.kelp' | 'minecraft.broken:minecraft.kelp_plant' | 'minecraft.mined:minecraft.kelp_plant' | 'minecraft.broken:minecraft.ladder' | 'minecraft.mined:minecraft.ladder' | 'minecraft.broken:minecraft.lantern' | 'minecraft.mined:minecraft.lantern' | 'minecraft.broken:minecraft.lapis_block' | 'minecraft.mined:minecraft.lapis_block' | 'minecraft.broken:minecraft.lapis_ore' | 'minecraft.mined:minecraft.lapis_ore' | 'minecraft.broken:minecraft.large_amethyst_bud' | 'minecraft.mined:minecraft.large_amethyst_bud' | 'minecraft.broken:minecraft.large_fern' | 'minecraft.mined:minecraft.large_fern' | 'minecraft.broken:minecraft.lava' | 'minecraft.mined:minecraft.lava' | 'minecraft.broken:minecraft.lava_cauldron' | 'minecraft.mined:minecraft.lava_cauldron' | 'minecraft.broken:minecraft.lectern' | 'minecraft.mined:minecraft.lectern' | 'minecraft.broken:minecraft.lever' | 'minecraft.mined:minecraft.lever' | 'minecraft.broken:minecraft.light' | 'minecraft.mined:minecraft.light' | 'minecraft.broken:minecraft.light_blue_banner' | 'minecraft.mined:minecraft.light_blue_banner' | 'minecraft.broken:minecraft.light_blue_bed' | 'minecraft.mined:minecraft.light_blue_bed' | 'minecraft.broken:minecraft.light_blue_candle' | 'minecraft.mined:minecraft.light_blue_candle' | 'minecraft.broken:minecraft.light_blue_candle_cake' | 'minecraft.mined:minecraft.light_blue_candle_cake' | 'minecraft.broken:minecraft.light_blue_carpet' | 'minecraft.mined:minecraft.light_blue_carpet' | 'minecraft.broken:minecraft.light_blue_concrete' | 'minecraft.mined:minecraft.light_blue_concrete' | 'minecraft.broken:minecraft.light_blue_concrete_powder' | 'minecraft.mined:minecraft.light_blue_concrete_powder' | 'minecraft.broken:minecraft.light_blue_glazed_terracotta' | 'minecraft.mined:minecraft.light_blue_glazed_terracotta' | 'minecraft.broken:minecraft.light_blue_shulker_box' | 'minecraft.mined:minecraft.light_blue_shulker_box' | 'minecraft.broken:minecraft.light_blue_stained_glass' | 'minecraft.mined:minecraft.light_blue_stained_glass' | 'minecraft.broken:minecraft.light_blue_stained_glass_pane' | 'minecraft.mined:minecraft.light_blue_stained_glass_pane' | 'minecraft.broken:minecraft.light_blue_terracotta' | 'minecraft.mined:minecraft.light_blue_terracotta' | 'minecraft.broken:minecraft.light_blue_wall_banner' | 'minecraft.mined:minecraft.light_blue_wall_banner' | 'minecraft.broken:minecraft.light_blue_wool' | 'minecraft.mined:minecraft.light_blue_wool' | 'minecraft.broken:minecraft.light_gray_banner' | 'minecraft.mined:minecraft.light_gray_banner' | 'minecraft.broken:minecraft.light_gray_bed' | 'minecraft.mined:minecraft.light_gray_bed' | 'minecraft.broken:minecraft.light_gray_candle' | 'minecraft.mined:minecraft.light_gray_candle' | 'minecraft.broken:minecraft.light_gray_candle_cake' | 'minecraft.mined:minecraft.light_gray_candle_cake' | 'minecraft.broken:minecraft.light_gray_carpet' | 'minecraft.mined:minecraft.light_gray_carpet' | 'minecraft.broken:minecraft.light_gray_concrete' | 'minecraft.mined:minecraft.light_gray_concrete' | 'minecraft.broken:minecraft.light_gray_concrete_powder' | 'minecraft.mined:minecraft.light_gray_concrete_powder' | 'minecraft.broken:minecraft.light_gray_glazed_terracotta' | 'minecraft.mined:minecraft.light_gray_glazed_terracotta' | 'minecraft.broken:minecraft.light_gray_shulker_box' | 'minecraft.mined:minecraft.light_gray_shulker_box' | 'minecraft.broken:minecraft.light_gray_stained_glass' | 'minecraft.mined:minecraft.light_gray_stained_glass' | 'minecraft.broken:minecraft.light_gray_stained_glass_pane' | 'minecraft.mined:minecraft.light_gray_stained_glass_pane' | 'minecraft.broken:minecraft.light_gray_terracotta' | 'minecraft.mined:minecraft.light_gray_terracotta' | 'minecraft.broken:minecraft.light_gray_wall_banner' | 'minecraft.mined:minecraft.light_gray_wall_banner' | 'minecraft.broken:minecraft.light_gray_wool' | 'minecraft.mined:minecraft.light_gray_wool' | 'minecraft.broken:minecraft.light_weighted_pressure_plate' | 'minecraft.mined:minecraft.light_weighted_pressure_plate' | 'minecraft.broken:minecraft.lightning_rod' | 'minecraft.mined:minecraft.lightning_rod' | 'minecraft.broken:minecraft.lilac' | 'minecraft.mined:minecraft.lilac' | 'minecraft.broken:minecraft.lily_of_the_valley' | 'minecraft.mined:minecraft.lily_of_the_valley' | 'minecraft.broken:minecraft.lily_pad' | 'minecraft.mined:minecraft.lily_pad' | 'minecraft.broken:minecraft.lime_banner' | 'minecraft.mined:minecraft.lime_banner' | 'minecraft.broken:minecraft.lime_bed' | 'minecraft.mined:minecraft.lime_bed' | 'minecraft.broken:minecraft.lime_candle' | 'minecraft.mined:minecraft.lime_candle' | 'minecraft.broken:minecraft.lime_candle_cake' | 'minecraft.mined:minecraft.lime_candle_cake' | 'minecraft.broken:minecraft.lime_carpet' | 'minecraft.mined:minecraft.lime_carpet' | 'minecraft.broken:minecraft.lime_concrete' | 'minecraft.mined:minecraft.lime_concrete' | 'minecraft.broken:minecraft.lime_concrete_powder' | 'minecraft.mined:minecraft.lime_concrete_powder' | 'minecraft.broken:minecraft.lime_glazed_terracotta' | 'minecraft.mined:minecraft.lime_glazed_terracotta' | 'minecraft.broken:minecraft.lime_shulker_box' | 'minecraft.mined:minecraft.lime_shulker_box' | 'minecraft.broken:minecraft.lime_stained_glass' | 'minecraft.mined:minecraft.lime_stained_glass' | 'minecraft.broken:minecraft.lime_stained_glass_pane' | 'minecraft.mined:minecraft.lime_stained_glass_pane' | 'minecraft.broken:minecraft.lime_terracotta' | 'minecraft.mined:minecraft.lime_terracotta' | 'minecraft.broken:minecraft.lime_wall_banner' | 'minecraft.mined:minecraft.lime_wall_banner' | 'minecraft.broken:minecraft.lime_wool' | 'minecraft.mined:minecraft.lime_wool' | 'minecraft.broken:minecraft.lodestone' | 'minecraft.mined:minecraft.lodestone' | 'minecraft.broken:minecraft.loom' | 'minecraft.mined:minecraft.loom' | 'minecraft.broken:minecraft.magenta_banner' | 'minecraft.mined:minecraft.magenta_banner' | 'minecraft.broken:minecraft.magenta_bed' | 'minecraft.mined:minecraft.magenta_bed' | 'minecraft.broken:minecraft.magenta_candle' | 'minecraft.mined:minecraft.magenta_candle' | 'minecraft.broken:minecraft.magenta_candle_cake' | 'minecraft.mined:minecraft.magenta_candle_cake' | 'minecraft.broken:minecraft.magenta_carpet' | 'minecraft.mined:minecraft.magenta_carpet' | 'minecraft.broken:minecraft.magenta_concrete' | 'minecraft.mined:minecraft.magenta_concrete' | 'minecraft.broken:minecraft.magenta_concrete_powder' | 'minecraft.mined:minecraft.magenta_concrete_powder' | 'minecraft.broken:minecraft.magenta_glazed_terracotta' | 'minecraft.mined:minecraft.magenta_glazed_terracotta' | 'minecraft.broken:minecraft.magenta_shulker_box' | 'minecraft.mined:minecraft.magenta_shulker_box' | 'minecraft.broken:minecraft.magenta_stained_glass' | 'minecraft.mined:minecraft.magenta_stained_glass' | 'minecraft.broken:minecraft.magenta_stained_glass_pane' | 'minecraft.mined:minecraft.magenta_stained_glass_pane' | 'minecraft.broken:minecraft.magenta_terracotta' | 'minecraft.mined:minecraft.magenta_terracotta' | 'minecraft.broken:minecraft.magenta_wall_banner' | 'minecraft.mined:minecraft.magenta_wall_banner' | 'minecraft.broken:minecraft.magenta_wool' | 'minecraft.mined:minecraft.magenta_wool' | 'minecraft.broken:minecraft.magma_block' | 'minecraft.mined:minecraft.magma_block' | 'minecraft.broken:minecraft.mangrove_button' | 'minecraft.mined:minecraft.mangrove_button' | 'minecraft.broken:minecraft.mangrove_door' | 'minecraft.mined:minecraft.mangrove_door' | 'minecraft.broken:minecraft.mangrove_fence' | 'minecraft.mined:minecraft.mangrove_fence' | 'minecraft.broken:minecraft.mangrove_fence_gate' | 'minecraft.mined:minecraft.mangrove_fence_gate' | 'minecraft.broken:minecraft.mangrove_hanging_sign' | 'minecraft.mined:minecraft.mangrove_hanging_sign' | 'minecraft.broken:minecraft.mangrove_leaves' | 'minecraft.mined:minecraft.mangrove_leaves' | 'minecraft.broken:minecraft.mangrove_log' | 'minecraft.mined:minecraft.mangrove_log' | 'minecraft.broken:minecraft.mangrove_planks' | 'minecraft.mined:minecraft.mangrove_planks' | 'minecraft.broken:minecraft.mangrove_pressure_plate' | 'minecraft.mined:minecraft.mangrove_pressure_plate' | 'minecraft.broken:minecraft.mangrove_propagule' | 'minecraft.mined:minecraft.mangrove_propagule' | 'minecraft.broken:minecraft.mangrove_roots' | 'minecraft.mined:minecraft.mangrove_roots' | 'minecraft.broken:minecraft.mangrove_sign' | 'minecraft.mined:minecraft.mangrove_sign' | 'minecraft.broken:minecraft.mangrove_slab' | 'minecraft.mined:minecraft.mangrove_slab' | 'minecraft.broken:minecraft.mangrove_stairs' | 'minecraft.mined:minecraft.mangrove_stairs' | 'minecraft.broken:minecraft.mangrove_trapdoor' | 'minecraft.mined:minecraft.mangrove_trapdoor' | 'minecraft.broken:minecraft.mangrove_wall_hanging_sign' | 'minecraft.mined:minecraft.mangrove_wall_hanging_sign' | 'minecraft.broken:minecraft.mangrove_wall_sign' | 'minecraft.mined:minecraft.mangrove_wall_sign' | 'minecraft.broken:minecraft.mangrove_wood' | 'minecraft.mined:minecraft.mangrove_wood' | 'minecraft.broken:minecraft.medium_amethyst_bud' | 'minecraft.mined:minecraft.medium_amethyst_bud' | 'minecraft.broken:minecraft.melon' | 'minecraft.mined:minecraft.melon' | 'minecraft.broken:minecraft.melon_stem' | 'minecraft.mined:minecraft.melon_stem' | 'minecraft.broken:minecraft.moss_block' | 'minecraft.mined:minecraft.moss_block' | 'minecraft.broken:minecraft.moss_carpet' | 'minecraft.mined:minecraft.moss_carpet' | 'minecraft.broken:minecraft.mossy_cobblestone' | 'minecraft.mined:minecraft.mossy_cobblestone' | 'minecraft.broken:minecraft.mossy_cobblestone_slab' | 'minecraft.mined:minecraft.mossy_cobblestone_slab' | 'minecraft.broken:minecraft.mossy_cobblestone_stairs' | 'minecraft.mined:minecraft.mossy_cobblestone_stairs' | 'minecraft.broken:minecraft.mossy_cobblestone_wall' | 'minecraft.mined:minecraft.mossy_cobblestone_wall' | 'minecraft.broken:minecraft.mossy_stone_brick_slab' | 'minecraft.mined:minecraft.mossy_stone_brick_slab' | 'minecraft.broken:minecraft.mossy_stone_brick_stairs' | 'minecraft.mined:minecraft.mossy_stone_brick_stairs' | 'minecraft.broken:minecraft.mossy_stone_brick_wall' | 'minecraft.mined:minecraft.mossy_stone_brick_wall' | 'minecraft.broken:minecraft.mossy_stone_bricks' | 'minecraft.mined:minecraft.mossy_stone_bricks' | 'minecraft.broken:minecraft.moving_piston' | 'minecraft.mined:minecraft.moving_piston' | 'minecraft.broken:minecraft.mud' | 'minecraft.mined:minecraft.mud' | 'minecraft.broken:minecraft.mud_brick_slab' | 'minecraft.mined:minecraft.mud_brick_slab' | 'minecraft.broken:minecraft.mud_brick_stairs' | 'minecraft.mined:minecraft.mud_brick_stairs' | 'minecraft.broken:minecraft.mud_brick_wall' | 'minecraft.mined:minecraft.mud_brick_wall' | 'minecraft.broken:minecraft.mud_bricks' | 'minecraft.mined:minecraft.mud_bricks' | 'minecraft.broken:minecraft.muddy_mangrove_roots' | 'minecraft.mined:minecraft.muddy_mangrove_roots' | 'minecraft.broken:minecraft.mushroom_stem' | 'minecraft.mined:minecraft.mushroom_stem' | 'minecraft.broken:minecraft.mycelium' | 'minecraft.mined:minecraft.mycelium' | 'minecraft.broken:minecraft.nether_brick_fence' | 'minecraft.mined:minecraft.nether_brick_fence' | 'minecraft.broken:minecraft.nether_brick_slab' | 'minecraft.mined:minecraft.nether_brick_slab' | 'minecraft.broken:minecraft.nether_brick_stairs' | 'minecraft.mined:minecraft.nether_brick_stairs' | 'minecraft.broken:minecraft.nether_brick_wall' | 'minecraft.mined:minecraft.nether_brick_wall' | 'minecraft.broken:minecraft.nether_bricks' | 'minecraft.mined:minecraft.nether_bricks' | 'minecraft.broken:minecraft.nether_gold_ore' | 'minecraft.mined:minecraft.nether_gold_ore' | 'minecraft.broken:minecraft.nether_portal' | 'minecraft.mined:minecraft.nether_portal' | 'minecraft.broken:minecraft.nether_quartz_ore' | 'minecraft.mined:minecraft.nether_quartz_ore' | 'minecraft.broken:minecraft.nether_sprouts' | 'minecraft.mined:minecraft.nether_sprouts' | 'minecraft.broken:minecraft.nether_wart' | 'minecraft.mined:minecraft.nether_wart' | 'minecraft.broken:minecraft.nether_wart_block' | 'minecraft.mined:minecraft.nether_wart_block' | 'minecraft.broken:minecraft.netherite_block' | 'minecraft.mined:minecraft.netherite_block' | 'minecraft.broken:minecraft.netherrack' | 'minecraft.mined:minecraft.netherrack' | 'minecraft.broken:minecraft.note_block' | 'minecraft.mined:minecraft.note_block' | 'minecraft.broken:minecraft.oak_button' | 'minecraft.mined:minecraft.oak_button' | 'minecraft.broken:minecraft.oak_door' | 'minecraft.mined:minecraft.oak_door' | 'minecraft.broken:minecraft.oak_fence' | 'minecraft.mined:minecraft.oak_fence' | 'minecraft.broken:minecraft.oak_fence_gate' | 'minecraft.mined:minecraft.oak_fence_gate' | 'minecraft.broken:minecraft.oak_hanging_sign' | 'minecraft.mined:minecraft.oak_hanging_sign' | 'minecraft.broken:minecraft.oak_leaves' | 'minecraft.mined:minecraft.oak_leaves' | 'minecraft.broken:minecraft.oak_log' | 'minecraft.mined:minecraft.oak_log' | 'minecraft.broken:minecraft.oak_planks' | 'minecraft.mined:minecraft.oak_planks' | 'minecraft.broken:minecraft.oak_pressure_plate' | 'minecraft.mined:minecraft.oak_pressure_plate' | 'minecraft.broken:minecraft.oak_sapling' | 'minecraft.mined:minecraft.oak_sapling' | 'minecraft.broken:minecraft.oak_sign' | 'minecraft.mined:minecraft.oak_sign' | 'minecraft.broken:minecraft.oak_slab' | 'minecraft.mined:minecraft.oak_slab' | 'minecraft.broken:minecraft.oak_stairs' | 'minecraft.mined:minecraft.oak_stairs' | 'minecraft.broken:minecraft.oak_trapdoor' | 'minecraft.mined:minecraft.oak_trapdoor' | 'minecraft.broken:minecraft.oak_wall_hanging_sign' | 'minecraft.mined:minecraft.oak_wall_hanging_sign' | 'minecraft.broken:minecraft.oak_wall_sign' | 'minecraft.mined:minecraft.oak_wall_sign' | 'minecraft.broken:minecraft.oak_wood' | 'minecraft.mined:minecraft.oak_wood' | 'minecraft.broken:minecraft.observer' | 'minecraft.mined:minecraft.observer' | 'minecraft.broken:minecraft.obsidian' | 'minecraft.mined:minecraft.obsidian' | 'minecraft.broken:minecraft.ochre_froglight' | 'minecraft.mined:minecraft.ochre_froglight' | 'minecraft.broken:minecraft.orange_banner' | 'minecraft.mined:minecraft.orange_banner' | 'minecraft.broken:minecraft.orange_bed' | 'minecraft.mined:minecraft.orange_bed' | 'minecraft.broken:minecraft.orange_candle' | 'minecraft.mined:minecraft.orange_candle' | 'minecraft.broken:minecraft.orange_candle_cake' | 'minecraft.mined:minecraft.orange_candle_cake' | 'minecraft.broken:minecraft.orange_carpet' | 'minecraft.mined:minecraft.orange_carpet' | 'minecraft.broken:minecraft.orange_concrete' | 'minecraft.mined:minecraft.orange_concrete' | 'minecraft.broken:minecraft.orange_concrete_powder' | 'minecraft.mined:minecraft.orange_concrete_powder' | 'minecraft.broken:minecraft.orange_glazed_terracotta' | 'minecraft.mined:minecraft.orange_glazed_terracotta' | 'minecraft.broken:minecraft.orange_shulker_box' | 'minecraft.mined:minecraft.orange_shulker_box' | 'minecraft.broken:minecraft.orange_stained_glass' | 'minecraft.mined:minecraft.orange_stained_glass' | 'minecraft.broken:minecraft.orange_stained_glass_pane' | 'minecraft.mined:minecraft.orange_stained_glass_pane' | 'minecraft.broken:minecraft.orange_terracotta' | 'minecraft.mined:minecraft.orange_terracotta' | 'minecraft.broken:minecraft.orange_tulip' | 'minecraft.mined:minecraft.orange_tulip' | 'minecraft.broken:minecraft.orange_wall_banner' | 'minecraft.mined:minecraft.orange_wall_banner' | 'minecraft.broken:minecraft.orange_wool' | 'minecraft.mined:minecraft.orange_wool' | 'minecraft.broken:minecraft.oxeye_daisy' | 'minecraft.mined:minecraft.oxeye_daisy' | 'minecraft.broken:minecraft.oxidized_chiseled_copper' | 'minecraft.mined:minecraft.oxidized_chiseled_copper' | 'minecraft.broken:minecraft.oxidized_copper' | 'minecraft.mined:minecraft.oxidized_copper' | 'minecraft.broken:minecraft.oxidized_copper_bulb' | 'minecraft.mined:minecraft.oxidized_copper_bulb' | 'minecraft.broken:minecraft.oxidized_copper_door' | 'minecraft.mined:minecraft.oxidized_copper_door' | 'minecraft.broken:minecraft.oxidized_copper_grate' | 'minecraft.mined:minecraft.oxidized_copper_grate' | 'minecraft.broken:minecraft.oxidized_copper_trapdoor' | 'minecraft.mined:minecraft.oxidized_copper_trapdoor' | 'minecraft.broken:minecraft.oxidized_cut_copper' | 'minecraft.mined:minecraft.oxidized_cut_copper' | 'minecraft.broken:minecraft.oxidized_cut_copper_slab' | 'minecraft.mined:minecraft.oxidized_cut_copper_slab' | 'minecraft.broken:minecraft.oxidized_cut_copper_stairs' | 'minecraft.mined:minecraft.oxidized_cut_copper_stairs' | 'minecraft.broken:minecraft.packed_ice' | 'minecraft.mined:minecraft.packed_ice' | 'minecraft.broken:minecraft.packed_mud' | 'minecraft.mined:minecraft.packed_mud' | 'minecraft.broken:minecraft.pearlescent_froglight' | 'minecraft.mined:minecraft.pearlescent_froglight' | 'minecraft.broken:minecraft.peony' | 'minecraft.mined:minecraft.peony' | 'minecraft.broken:minecraft.petrified_oak_slab' | 'minecraft.mined:minecraft.petrified_oak_slab' | 'minecraft.broken:minecraft.piglin_head' | 'minecraft.mined:minecraft.piglin_head' | 'minecraft.broken:minecraft.piglin_wall_head' | 'minecraft.mined:minecraft.piglin_wall_head' | 'minecraft.broken:minecraft.pink_banner' | 'minecraft.mined:minecraft.pink_banner' | 'minecraft.broken:minecraft.pink_bed' | 'minecraft.mined:minecraft.pink_bed' | 'minecraft.broken:minecraft.pink_candle' | 'minecraft.mined:minecraft.pink_candle' | 'minecraft.broken:minecraft.pink_candle_cake' | 'minecraft.mined:minecraft.pink_candle_cake' | 'minecraft.broken:minecraft.pink_carpet' | 'minecraft.mined:minecraft.pink_carpet' | 'minecraft.broken:minecraft.pink_concrete' | 'minecraft.mined:minecraft.pink_concrete' | 'minecraft.broken:minecraft.pink_concrete_powder' | 'minecraft.mined:minecraft.pink_concrete_powder' | 'minecraft.broken:minecraft.pink_glazed_terracotta' | 'minecraft.mined:minecraft.pink_glazed_terracotta' | 'minecraft.broken:minecraft.pink_petals' | 'minecraft.mined:minecraft.pink_petals' | 'minecraft.broken:minecraft.pink_shulker_box' | 'minecraft.mined:minecraft.pink_shulker_box' | 'minecraft.broken:minecraft.pink_stained_glass' | 'minecraft.mined:minecraft.pink_stained_glass' | 'minecraft.broken:minecraft.pink_stained_glass_pane' | 'minecraft.mined:minecraft.pink_stained_glass_pane' | 'minecraft.broken:minecraft.pink_terracotta' | 'minecraft.mined:minecraft.pink_terracotta' | 'minecraft.broken:minecraft.pink_tulip' | 'minecraft.mined:minecraft.pink_tulip' | 'minecraft.broken:minecraft.pink_wall_banner' | 'minecraft.mined:minecraft.pink_wall_banner' | 'minecraft.broken:minecraft.pink_wool' | 'minecraft.mined:minecraft.pink_wool' | 'minecraft.broken:minecraft.piston' | 'minecraft.mined:minecraft.piston' | 'minecraft.broken:minecraft.piston_head' | 'minecraft.mined:minecraft.piston_head' | 'minecraft.broken:minecraft.pitcher_crop' | 'minecraft.mined:minecraft.pitcher_crop' | 'minecraft.broken:minecraft.pitcher_plant' | 'minecraft.mined:minecraft.pitcher_plant' | 'minecraft.broken:minecraft.player_head' | 'minecraft.mined:minecraft.player_head' | 'minecraft.broken:minecraft.player_wall_head' | 'minecraft.mined:minecraft.player_wall_head' | 'minecraft.broken:minecraft.podzol' | 'minecraft.mined:minecraft.podzol' | 'minecraft.broken:minecraft.pointed_dripstone' | 'minecraft.mined:minecraft.pointed_dripstone' | 'minecraft.broken:minecraft.polished_andesite' | 'minecraft.mined:minecraft.polished_andesite' | 'minecraft.broken:minecraft.polished_andesite_slab' | 'minecraft.mined:minecraft.polished_andesite_slab' | 'minecraft.broken:minecraft.polished_andesite_stairs' | 'minecraft.mined:minecraft.polished_andesite_stairs' | 'minecraft.broken:minecraft.polished_basalt' | 'minecraft.mined:minecraft.polished_basalt' | 'minecraft.broken:minecraft.polished_blackstone' | 'minecraft.mined:minecraft.polished_blackstone' | 'minecraft.broken:minecraft.polished_blackstone_brick_slab' | 'minecraft.mined:minecraft.polished_blackstone_brick_slab' | 'minecraft.broken:minecraft.polished_blackstone_brick_stairs' | 'minecraft.mined:minecraft.polished_blackstone_brick_stairs' | 'minecraft.broken:minecraft.polished_blackstone_brick_wall' | 'minecraft.mined:minecraft.polished_blackstone_brick_wall' | 'minecraft.broken:minecraft.polished_blackstone_bricks' | 'minecraft.mined:minecraft.polished_blackstone_bricks' | 'minecraft.broken:minecraft.polished_blackstone_button' | 'minecraft.mined:minecraft.polished_blackstone_button' | 'minecraft.broken:minecraft.polished_blackstone_pressure_plate' | 'minecraft.mined:minecraft.polished_blackstone_pressure_plate' | 'minecraft.broken:minecraft.polished_blackstone_slab' | 'minecraft.mined:minecraft.polished_blackstone_slab' | 'minecraft.broken:minecraft.polished_blackstone_stairs' | 'minecraft.mined:minecraft.polished_blackstone_stairs' | 'minecraft.broken:minecraft.polished_blackstone_wall' | 'minecraft.mined:minecraft.polished_blackstone_wall' | 'minecraft.broken:minecraft.polished_deepslate' | 'minecraft.mined:minecraft.polished_deepslate' | 'minecraft.broken:minecraft.polished_deepslate_slab' | 'minecraft.mined:minecraft.polished_deepslate_slab' | 'minecraft.broken:minecraft.polished_deepslate_stairs' | 'minecraft.mined:minecraft.polished_deepslate_stairs' | 'minecraft.broken:minecraft.polished_deepslate_wall' | 'minecraft.mined:minecraft.polished_deepslate_wall' | 'minecraft.broken:minecraft.polished_diorite' | 'minecraft.mined:minecraft.polished_diorite' | 'minecraft.broken:minecraft.polished_diorite_slab' | 'minecraft.mined:minecraft.polished_diorite_slab' | 'minecraft.broken:minecraft.polished_diorite_stairs' | 'minecraft.mined:minecraft.polished_diorite_stairs' | 'minecraft.broken:minecraft.polished_granite' | 'minecraft.mined:minecraft.polished_granite' | 'minecraft.broken:minecraft.polished_granite_slab' | 'minecraft.mined:minecraft.polished_granite_slab' | 'minecraft.broken:minecraft.polished_granite_stairs' | 'minecraft.mined:minecraft.polished_granite_stairs' | 'minecraft.broken:minecraft.polished_tuff' | 'minecraft.mined:minecraft.polished_tuff' | 'minecraft.broken:minecraft.polished_tuff_slab' | 'minecraft.mined:minecraft.polished_tuff_slab' | 'minecraft.broken:minecraft.polished_tuff_stairs' | 'minecraft.mined:minecraft.polished_tuff_stairs' | 'minecraft.broken:minecraft.polished_tuff_wall' | 'minecraft.mined:minecraft.polished_tuff_wall' | 'minecraft.broken:minecraft.poppy' | 'minecraft.mined:minecraft.poppy' | 'minecraft.broken:minecraft.potatoes' | 'minecraft.mined:minecraft.potatoes' | 'minecraft.broken:minecraft.potted_acacia_sapling' | 'minecraft.mined:minecraft.potted_acacia_sapling' | 'minecraft.broken:minecraft.potted_allium' | 'minecraft.mined:minecraft.potted_allium' | 'minecraft.broken:minecraft.potted_azalea_bush' | 'minecraft.mined:minecraft.potted_azalea_bush' | 'minecraft.broken:minecraft.potted_azure_bluet' | 'minecraft.mined:minecraft.potted_azure_bluet' | 'minecraft.broken:minecraft.potted_bamboo' | 'minecraft.mined:minecraft.potted_bamboo' | 'minecraft.broken:minecraft.potted_birch_sapling' | 'minecraft.mined:minecraft.potted_birch_sapling' | 'minecraft.broken:minecraft.potted_blue_orchid' | 'minecraft.mined:minecraft.potted_blue_orchid' | 'minecraft.broken:minecraft.potted_brown_mushroom' | 'minecraft.mined:minecraft.potted_brown_mushroom' | 'minecraft.broken:minecraft.potted_cactus' | 'minecraft.mined:minecraft.potted_cactus' | 'minecraft.broken:minecraft.potted_cherry_sapling' | 'minecraft.mined:minecraft.potted_cherry_sapling' | 'minecraft.broken:minecraft.potted_cornflower' | 'minecraft.mined:minecraft.potted_cornflower' | 'minecraft.broken:minecraft.potted_crimson_fungus' | 'minecraft.mined:minecraft.potted_crimson_fungus' | 'minecraft.broken:minecraft.potted_crimson_roots' | 'minecraft.mined:minecraft.potted_crimson_roots' | 'minecraft.broken:minecraft.potted_dandelion' | 'minecraft.mined:minecraft.potted_dandelion' | 'minecraft.broken:minecraft.potted_dark_oak_sapling' | 'minecraft.mined:minecraft.potted_dark_oak_sapling' | 'minecraft.broken:minecraft.potted_dead_bush' | 'minecraft.mined:minecraft.potted_dead_bush' | 'minecraft.broken:minecraft.potted_fern' | 'minecraft.mined:minecraft.potted_fern' | 'minecraft.broken:minecraft.potted_flowering_azalea_bush' | 'minecraft.mined:minecraft.potted_flowering_azalea_bush' | 'minecraft.broken:minecraft.potted_jungle_sapling' | 'minecraft.mined:minecraft.potted_jungle_sapling' | 'minecraft.broken:minecraft.potted_lily_of_the_valley' | 'minecraft.mined:minecraft.potted_lily_of_the_valley' | 'minecraft.broken:minecraft.potted_mangrove_propagule' | 'minecraft.mined:minecraft.potted_mangrove_propagule' | 'minecraft.broken:minecraft.potted_oak_sapling' | 'minecraft.mined:minecraft.potted_oak_sapling' | 'minecraft.broken:minecraft.potted_orange_tulip' | 'minecraft.mined:minecraft.potted_orange_tulip' | 'minecraft.broken:minecraft.potted_oxeye_daisy' | 'minecraft.mined:minecraft.potted_oxeye_daisy' | 'minecraft.broken:minecraft.potted_pink_tulip' | 'minecraft.mined:minecraft.potted_pink_tulip' | 'minecraft.broken:minecraft.potted_poppy' | 'minecraft.mined:minecraft.potted_poppy' | 'minecraft.broken:minecraft.potted_red_mushroom' | 'minecraft.mined:minecraft.potted_red_mushroom' | 'minecraft.broken:minecraft.potted_red_tulip' | 'minecraft.mined:minecraft.potted_red_tulip' | 'minecraft.broken:minecraft.potted_spruce_sapling' | 'minecraft.mined:minecraft.potted_spruce_sapling' | 'minecraft.broken:minecraft.potted_torchflower' | 'minecraft.mined:minecraft.potted_torchflower' | 'minecraft.broken:minecraft.potted_warped_fungus' | 'minecraft.mined:minecraft.potted_warped_fungus' | 'minecraft.broken:minecraft.potted_warped_roots' | 'minecraft.mined:minecraft.potted_warped_roots' | 'minecraft.broken:minecraft.potted_white_tulip' | 'minecraft.mined:minecraft.potted_white_tulip' | 'minecraft.broken:minecraft.potted_wither_rose' | 'minecraft.mined:minecraft.potted_wither_rose' | 'minecraft.broken:minecraft.powder_snow' | 'minecraft.mined:minecraft.powder_snow' | 'minecraft.broken:minecraft.powder_snow_cauldron' | 'minecraft.mined:minecraft.powder_snow_cauldron' | 'minecraft.broken:minecraft.powered_rail' | 'minecraft.mined:minecraft.powered_rail' | 'minecraft.broken:minecraft.prismarine' | 'minecraft.mined:minecraft.prismarine' | 'minecraft.broken:minecraft.prismarine_brick_slab' | 'minecraft.mined:minecraft.prismarine_brick_slab' | 'minecraft.broken:minecraft.prismarine_brick_stairs' | 'minecraft.mined:minecraft.prismarine_brick_stairs' | 'minecraft.broken:minecraft.prismarine_bricks' | 'minecraft.mined:minecraft.prismarine_bricks' | 'minecraft.broken:minecraft.prismarine_slab' | 'minecraft.mined:minecraft.prismarine_slab' | 'minecraft.broken:minecraft.prismarine_stairs' | 'minecraft.mined:minecraft.prismarine_stairs' | 'minecraft.broken:minecraft.prismarine_wall' | 'minecraft.mined:minecraft.prismarine_wall' | 'minecraft.broken:minecraft.pumpkin' | 'minecraft.mined:minecraft.pumpkin' | 'minecraft.broken:minecraft.pumpkin_stem' | 'minecraft.mined:minecraft.pumpkin_stem' | 'minecraft.broken:minecraft.purple_banner' | 'minecraft.mined:minecraft.purple_banner' | 'minecraft.broken:minecraft.purple_bed' | 'minecraft.mined:minecraft.purple_bed' | 'minecraft.broken:minecraft.purple_candle' | 'minecraft.mined:minecraft.purple_candle' | 'minecraft.broken:minecraft.purple_candle_cake' | 'minecraft.mined:minecraft.purple_candle_cake' | 'minecraft.broken:minecraft.purple_carpet' | 'minecraft.mined:minecraft.purple_carpet' | 'minecraft.broken:minecraft.purple_concrete' | 'minecraft.mined:minecraft.purple_concrete' | 'minecraft.broken:minecraft.purple_concrete_powder' | 'minecraft.mined:minecraft.purple_concrete_powder' | 'minecraft.broken:minecraft.purple_glazed_terracotta' | 'minecraft.mined:minecraft.purple_glazed_terracotta' | 'minecraft.broken:minecraft.purple_shulker_box' | 'minecraft.mined:minecraft.purple_shulker_box' | 'minecraft.broken:minecraft.purple_stained_glass' | 'minecraft.mined:minecraft.purple_stained_glass' | 'minecraft.broken:minecraft.purple_stained_glass_pane' | 'minecraft.mined:minecraft.purple_stained_glass_pane' | 'minecraft.broken:minecraft.purple_terracotta' | 'minecraft.mined:minecraft.purple_terracotta' | 'minecraft.broken:minecraft.purple_wall_banner' | 'minecraft.mined:minecraft.purple_wall_banner' | 'minecraft.broken:minecraft.purple_wool' | 'minecraft.mined:minecraft.purple_wool' | 'minecraft.broken:minecraft.purpur_block' | 'minecraft.mined:minecraft.purpur_block' | 'minecraft.broken:minecraft.purpur_pillar' | 'minecraft.mined:minecraft.purpur_pillar' | 'minecraft.broken:minecraft.purpur_slab' | 'minecraft.mined:minecraft.purpur_slab' | 'minecraft.broken:minecraft.purpur_stairs' | 'minecraft.mined:minecraft.purpur_stairs' | 'minecraft.broken:minecraft.quartz_block' | 'minecraft.mined:minecraft.quartz_block' | 'minecraft.broken:minecraft.quartz_bricks' | 'minecraft.mined:minecraft.quartz_bricks' | 'minecraft.broken:minecraft.quartz_pillar' | 'minecraft.mined:minecraft.quartz_pillar' | 'minecraft.broken:minecraft.quartz_slab' | 'minecraft.mined:minecraft.quartz_slab' | 'minecraft.broken:minecraft.quartz_stairs' | 'minecraft.mined:minecraft.quartz_stairs' | 'minecraft.broken:minecraft.rail' | 'minecraft.mined:minecraft.rail' | 'minecraft.broken:minecraft.raw_copper_block' | 'minecraft.mined:minecraft.raw_copper_block' | 'minecraft.broken:minecraft.raw_gold_block' | 'minecraft.mined:minecraft.raw_gold_block' | 'minecraft.broken:minecraft.raw_iron_block' | 'minecraft.mined:minecraft.raw_iron_block' | 'minecraft.broken:minecraft.red_banner' | 'minecraft.mined:minecraft.red_banner' | 'minecraft.broken:minecraft.red_bed' | 'minecraft.mined:minecraft.red_bed' | 'minecraft.broken:minecraft.red_candle' | 'minecraft.mined:minecraft.red_candle' | 'minecraft.broken:minecraft.red_candle_cake' | 'minecraft.mined:minecraft.red_candle_cake' | 'minecraft.broken:minecraft.red_carpet' | 'minecraft.mined:minecraft.red_carpet' | 'minecraft.broken:minecraft.red_concrete' | 'minecraft.mined:minecraft.red_concrete' | 'minecraft.broken:minecraft.red_concrete_powder' | 'minecraft.mined:minecraft.red_concrete_powder' | 'minecraft.broken:minecraft.red_glazed_terracotta' | 'minecraft.mined:minecraft.red_glazed_terracotta' | 'minecraft.broken:minecraft.red_mushroom' | 'minecraft.mined:minecraft.red_mushroom' | 'minecraft.broken:minecraft.red_mushroom_block' | 'minecraft.mined:minecraft.red_mushroom_block' | 'minecraft.broken:minecraft.red_nether_brick_slab' | 'minecraft.mined:minecraft.red_nether_brick_slab' | 'minecraft.broken:minecraft.red_nether_brick_stairs' | 'minecraft.mined:minecraft.red_nether_brick_stairs' | 'minecraft.broken:minecraft.red_nether_brick_wall' | 'minecraft.mined:minecraft.red_nether_brick_wall' | 'minecraft.broken:minecraft.red_nether_bricks' | 'minecraft.mined:minecraft.red_nether_bricks' | 'minecraft.broken:minecraft.red_sand' | 'minecraft.mined:minecraft.red_sand' | 'minecraft.broken:minecraft.red_sandstone' | 'minecraft.mined:minecraft.red_sandstone' | 'minecraft.broken:minecraft.red_sandstone_slab' | 'minecraft.mined:minecraft.red_sandstone_slab' | 'minecraft.broken:minecraft.red_sandstone_stairs' | 'minecraft.mined:minecraft.red_sandstone_stairs' | 'minecraft.broken:minecraft.red_sandstone_wall' | 'minecraft.mined:minecraft.red_sandstone_wall' | 'minecraft.broken:minecraft.red_shulker_box' | 'minecraft.mined:minecraft.red_shulker_box' | 'minecraft.broken:minecraft.red_stained_glass' | 'minecraft.mined:minecraft.red_stained_glass' | 'minecraft.broken:minecraft.red_stained_glass_pane' | 'minecraft.mined:minecraft.red_stained_glass_pane' | 'minecraft.broken:minecraft.red_terracotta' | 'minecraft.mined:minecraft.red_terracotta' | 'minecraft.broken:minecraft.red_tulip' | 'minecraft.mined:minecraft.red_tulip' | 'minecraft.broken:minecraft.red_wall_banner' | 'minecraft.mined:minecraft.red_wall_banner' | 'minecraft.broken:minecraft.red_wool' | 'minecraft.mined:minecraft.red_wool' | 'minecraft.broken:minecraft.redstone_block' | 'minecraft.mined:minecraft.redstone_block' | 'minecraft.broken:minecraft.redstone_lamp' | 'minecraft.mined:minecraft.redstone_lamp' | 'minecraft.broken:minecraft.redstone_ore' | 'minecraft.mined:minecraft.redstone_ore' | 'minecraft.broken:minecraft.redstone_torch' | 'minecraft.mined:minecraft.redstone_torch' | 'minecraft.broken:minecraft.redstone_wall_torch' | 'minecraft.mined:minecraft.redstone_wall_torch' | 'minecraft.broken:minecraft.redstone_wire' | 'minecraft.mined:minecraft.redstone_wire' | 'minecraft.broken:minecraft.reinforced_deepslate' | 'minecraft.mined:minecraft.reinforced_deepslate' | 'minecraft.broken:minecraft.repeater' | 'minecraft.mined:minecraft.repeater' | 'minecraft.broken:minecraft.repeating_command_block' | 'minecraft.mined:minecraft.repeating_command_block' | 'minecraft.broken:minecraft.respawn_anchor' | 'minecraft.mined:minecraft.respawn_anchor' | 'minecraft.broken:minecraft.rooted_dirt' | 'minecraft.mined:minecraft.rooted_dirt' | 'minecraft.broken:minecraft.rose_bush' | 'minecraft.mined:minecraft.rose_bush' | 'minecraft.broken:minecraft.sand' | 'minecraft.mined:minecraft.sand' | 'minecraft.broken:minecraft.sandstone' | 'minecraft.mined:minecraft.sandstone' | 'minecraft.broken:minecraft.sandstone_slab' | 'minecraft.mined:minecraft.sandstone_slab' | 'minecraft.broken:minecraft.sandstone_stairs' | 'minecraft.mined:minecraft.sandstone_stairs' | 'minecraft.broken:minecraft.sandstone_wall' | 'minecraft.mined:minecraft.sandstone_wall' | 'minecraft.broken:minecraft.scaffolding' | 'minecraft.mined:minecraft.scaffolding' | 'minecraft.broken:minecraft.sculk' | 'minecraft.mined:minecraft.sculk' | 'minecraft.broken:minecraft.sculk_catalyst' | 'minecraft.mined:minecraft.sculk_catalyst' | 'minecraft.broken:minecraft.sculk_sensor' | 'minecraft.mined:minecraft.sculk_sensor' | 'minecraft.broken:minecraft.sculk_shrieker' | 'minecraft.mined:minecraft.sculk_shrieker' | 'minecraft.broken:minecraft.sculk_vein' | 'minecraft.mined:minecraft.sculk_vein' | 'minecraft.broken:minecraft.sea_lantern' | 'minecraft.mined:minecraft.sea_lantern' | 'minecraft.broken:minecraft.sea_pickle' | 'minecraft.mined:minecraft.sea_pickle' | 'minecraft.broken:minecraft.seagrass' | 'minecraft.mined:minecraft.seagrass' | 'minecraft.broken:minecraft.shroomlight' | 'minecraft.mined:minecraft.shroomlight' | 'minecraft.broken:minecraft.shulker_box' | 'minecraft.mined:minecraft.shulker_box' | 'minecraft.broken:minecraft.skeleton_skull' | 'minecraft.mined:minecraft.skeleton_skull' | 'minecraft.broken:minecraft.skeleton_wall_skull' | 'minecraft.mined:minecraft.skeleton_wall_skull' | 'minecraft.broken:minecraft.slime_block' | 'minecraft.mined:minecraft.slime_block' | 'minecraft.broken:minecraft.small_amethyst_bud' | 'minecraft.mined:minecraft.small_amethyst_bud' | 'minecraft.broken:minecraft.small_dripleaf' | 'minecraft.mined:minecraft.small_dripleaf' | 'minecraft.broken:minecraft.smithing_table' | 'minecraft.mined:minecraft.smithing_table' | 'minecraft.broken:minecraft.smoker' | 'minecraft.mined:minecraft.smoker' | 'minecraft.broken:minecraft.smooth_basalt' | 'minecraft.mined:minecraft.smooth_basalt' | 'minecraft.broken:minecraft.smooth_quartz' | 'minecraft.mined:minecraft.smooth_quartz' | 'minecraft.broken:minecraft.smooth_quartz_slab' | 'minecraft.mined:minecraft.smooth_quartz_slab' | 'minecraft.broken:minecraft.smooth_quartz_stairs' | 'minecraft.mined:minecraft.smooth_quartz_stairs' | 'minecraft.broken:minecraft.smooth_red_sandstone' | 'minecraft.mined:minecraft.smooth_red_sandstone' | 'minecraft.broken:minecraft.smooth_red_sandstone_slab' | 'minecraft.mined:minecraft.smooth_red_sandstone_slab' | 'minecraft.broken:minecraft.smooth_red_sandstone_stairs' | 'minecraft.mined:minecraft.smooth_red_sandstone_stairs' | 'minecraft.broken:minecraft.smooth_sandstone' | 'minecraft.mined:minecraft.smooth_sandstone' | 'minecraft.broken:minecraft.smooth_sandstone_slab' | 'minecraft.mined:minecraft.smooth_sandstone_slab' | 'minecraft.broken:minecraft.smooth_sandstone_stairs' | 'minecraft.mined:minecraft.smooth_sandstone_stairs' | 'minecraft.broken:minecraft.smooth_stone' | 'minecraft.mined:minecraft.smooth_stone' | 'minecraft.broken:minecraft.smooth_stone_slab' | 'minecraft.mined:minecraft.smooth_stone_slab' | 'minecraft.broken:minecraft.sniffer_egg' | 'minecraft.mined:minecraft.sniffer_egg' | 'minecraft.broken:minecraft.snow' | 'minecraft.mined:minecraft.snow' | 'minecraft.broken:minecraft.snow_block' | 'minecraft.mined:minecraft.snow_block' | 'minecraft.broken:minecraft.soul_campfire' | 'minecraft.mined:minecraft.soul_campfire' | 'minecraft.broken:minecraft.soul_fire' | 'minecraft.mined:minecraft.soul_fire' | 'minecraft.broken:minecraft.soul_lantern' | 'minecraft.mined:minecraft.soul_lantern' | 'minecraft.broken:minecraft.soul_sand' | 'minecraft.mined:minecraft.soul_sand' | 'minecraft.broken:minecraft.soul_soil' | 'minecraft.mined:minecraft.soul_soil' | 'minecraft.broken:minecraft.soul_torch' | 'minecraft.mined:minecraft.soul_torch' | 'minecraft.broken:minecraft.soul_wall_torch' | 'minecraft.mined:minecraft.soul_wall_torch' | 'minecraft.broken:minecraft.spawner' | 'minecraft.mined:minecraft.spawner' | 'minecraft.broken:minecraft.sponge' | 'minecraft.mined:minecraft.sponge' | 'minecraft.broken:minecraft.spore_blossom' | 'minecraft.mined:minecraft.spore_blossom' | 'minecraft.broken:minecraft.spruce_button' | 'minecraft.mined:minecraft.spruce_button' | 'minecraft.broken:minecraft.spruce_door' | 'minecraft.mined:minecraft.spruce_door' | 'minecraft.broken:minecraft.spruce_fence' | 'minecraft.mined:minecraft.spruce_fence' | 'minecraft.broken:minecraft.spruce_fence_gate' | 'minecraft.mined:minecraft.spruce_fence_gate' | 'minecraft.broken:minecraft.spruce_hanging_sign' | 'minecraft.mined:minecraft.spruce_hanging_sign' | 'minecraft.broken:minecraft.spruce_leaves' | 'minecraft.mined:minecraft.spruce_leaves' | 'minecraft.broken:minecraft.spruce_log' | 'minecraft.mined:minecraft.spruce_log' | 'minecraft.broken:minecraft.spruce_planks' | 'minecraft.mined:minecraft.spruce_planks' | 'minecraft.broken:minecraft.spruce_pressure_plate' | 'minecraft.mined:minecraft.spruce_pressure_plate' | 'minecraft.broken:minecraft.spruce_sapling' | 'minecraft.mined:minecraft.spruce_sapling' | 'minecraft.broken:minecraft.spruce_sign' | 'minecraft.mined:minecraft.spruce_sign' | 'minecraft.broken:minecraft.spruce_slab' | 'minecraft.mined:minecraft.spruce_slab' | 'minecraft.broken:minecraft.spruce_stairs' | 'minecraft.mined:minecraft.spruce_stairs' | 'minecraft.broken:minecraft.spruce_trapdoor' | 'minecraft.mined:minecraft.spruce_trapdoor' | 'minecraft.broken:minecraft.spruce_wall_hanging_sign' | 'minecraft.mined:minecraft.spruce_wall_hanging_sign' | 'minecraft.broken:minecraft.spruce_wall_sign' | 'minecraft.mined:minecraft.spruce_wall_sign' | 'minecraft.broken:minecraft.spruce_wood' | 'minecraft.mined:minecraft.spruce_wood' | 'minecraft.broken:minecraft.sticky_piston' | 'minecraft.mined:minecraft.sticky_piston' | 'minecraft.broken:minecraft.stone' | 'minecraft.mined:minecraft.stone' | 'minecraft.broken:minecraft.stone_brick_slab' | 'minecraft.mined:minecraft.stone_brick_slab' | 'minecraft.broken:minecraft.stone_brick_stairs' | 'minecraft.mined:minecraft.stone_brick_stairs' | 'minecraft.broken:minecraft.stone_brick_wall' | 'minecraft.mined:minecraft.stone_brick_wall' | 'minecraft.broken:minecraft.stone_bricks' | 'minecraft.mined:minecraft.stone_bricks' | 'minecraft.broken:minecraft.stone_button' | 'minecraft.mined:minecraft.stone_button' | 'minecraft.broken:minecraft.stone_pressure_plate' | 'minecraft.mined:minecraft.stone_pressure_plate' | 'minecraft.broken:minecraft.stone_slab' | 'minecraft.mined:minecraft.stone_slab' | 'minecraft.broken:minecraft.stone_stairs' | 'minecraft.mined:minecraft.stone_stairs' | 'minecraft.broken:minecraft.stonecutter' | 'minecraft.mined:minecraft.stonecutter' | 'minecraft.broken:minecraft.stripped_acacia_log' | 'minecraft.mined:minecraft.stripped_acacia_log' | 'minecraft.broken:minecraft.stripped_acacia_wood' | 'minecraft.mined:minecraft.stripped_acacia_wood' | 'minecraft.broken:minecraft.stripped_bamboo_block' | 'minecraft.mined:minecraft.stripped_bamboo_block' | 'minecraft.broken:minecraft.stripped_birch_log' | 'minecraft.mined:minecraft.stripped_birch_log' | 'minecraft.broken:minecraft.stripped_birch_wood' | 'minecraft.mined:minecraft.stripped_birch_wood' | 'minecraft.broken:minecraft.stripped_cherry_log' | 'minecraft.mined:minecraft.stripped_cherry_log' | 'minecraft.broken:minecraft.stripped_cherry_wood' | 'minecraft.mined:minecraft.stripped_cherry_wood' | 'minecraft.broken:minecraft.stripped_crimson_hyphae' | 'minecraft.mined:minecraft.stripped_crimson_hyphae' | 'minecraft.broken:minecraft.stripped_crimson_stem' | 'minecraft.mined:minecraft.stripped_crimson_stem' | 'minecraft.broken:minecraft.stripped_dark_oak_log' | 'minecraft.mined:minecraft.stripped_dark_oak_log' | 'minecraft.broken:minecraft.stripped_dark_oak_wood' | 'minecraft.mined:minecraft.stripped_dark_oak_wood' | 'minecraft.broken:minecraft.stripped_jungle_log' | 'minecraft.mined:minecraft.stripped_jungle_log' | 'minecraft.broken:minecraft.stripped_jungle_wood' | 'minecraft.mined:minecraft.stripped_jungle_wood' | 'minecraft.broken:minecraft.stripped_mangrove_log' | 'minecraft.mined:minecraft.stripped_mangrove_log' | 'minecraft.broken:minecraft.stripped_mangrove_wood' | 'minecraft.mined:minecraft.stripped_mangrove_wood' | 'minecraft.broken:minecraft.stripped_oak_log' | 'minecraft.mined:minecraft.stripped_oak_log' | 'minecraft.broken:minecraft.stripped_oak_wood' | 'minecraft.mined:minecraft.stripped_oak_wood' | 'minecraft.broken:minecraft.stripped_spruce_log' | 'minecraft.mined:minecraft.stripped_spruce_log' | 'minecraft.broken:minecraft.stripped_spruce_wood' | 'minecraft.mined:minecraft.stripped_spruce_wood' | 'minecraft.broken:minecraft.stripped_warped_hyphae' | 'minecraft.mined:minecraft.stripped_warped_hyphae' | 'minecraft.broken:minecraft.stripped_warped_stem' | 'minecraft.mined:minecraft.stripped_warped_stem' | 'minecraft.broken:minecraft.structure_block' | 'minecraft.mined:minecraft.structure_block' | 'minecraft.broken:minecraft.structure_void' | 'minecraft.mined:minecraft.structure_void' | 'minecraft.broken:minecraft.sugar_cane' | 'minecraft.mined:minecraft.sugar_cane' | 'minecraft.broken:minecraft.sunflower' | 'minecraft.mined:minecraft.sunflower' | 'minecraft.broken:minecraft.suspicious_gravel' | 'minecraft.mined:minecraft.suspicious_gravel' | 'minecraft.broken:minecraft.suspicious_sand' | 'minecraft.mined:minecraft.suspicious_sand' | 'minecraft.broken:minecraft.sweet_berry_bush' | 'minecraft.mined:minecraft.sweet_berry_bush' | 'minecraft.broken:minecraft.tall_grass' | 'minecraft.mined:minecraft.tall_grass' | 'minecraft.broken:minecraft.tall_seagrass' | 'minecraft.mined:minecraft.tall_seagrass' | 'minecraft.broken:minecraft.target' | 'minecraft.mined:minecraft.target' | 'minecraft.broken:minecraft.terracotta' | 'minecraft.mined:minecraft.terracotta' | 'minecraft.broken:minecraft.tinted_glass' | 'minecraft.mined:minecraft.tinted_glass' | 'minecraft.broken:minecraft.tnt' | 'minecraft.mined:minecraft.tnt' | 'minecraft.broken:minecraft.torch' | 'minecraft.mined:minecraft.torch' | 'minecraft.broken:minecraft.torchflower' | 'minecraft.mined:minecraft.torchflower' | 'minecraft.broken:minecraft.torchflower_crop' | 'minecraft.mined:minecraft.torchflower_crop' | 'minecraft.broken:minecraft.trapped_chest' | 'minecraft.mined:minecraft.trapped_chest' | 'minecraft.broken:minecraft.trial_spawner' | 'minecraft.mined:minecraft.trial_spawner' | 'minecraft.broken:minecraft.tripwire' | 'minecraft.mined:minecraft.tripwire' | 'minecraft.broken:minecraft.tripwire_hook' | 'minecraft.mined:minecraft.tripwire_hook' | 'minecraft.broken:minecraft.tube_coral' | 'minecraft.mined:minecraft.tube_coral' | 'minecraft.broken:minecraft.tube_coral_block' | 'minecraft.mined:minecraft.tube_coral_block' | 'minecraft.broken:minecraft.tube_coral_fan' | 'minecraft.mined:minecraft.tube_coral_fan' | 'minecraft.broken:minecraft.tube_coral_wall_fan' | 'minecraft.mined:minecraft.tube_coral_wall_fan' | 'minecraft.broken:minecraft.tuff' | 'minecraft.mined:minecraft.tuff' | 'minecraft.broken:minecraft.tuff_brick_slab' | 'minecraft.mined:minecraft.tuff_brick_slab' | 'minecraft.broken:minecraft.tuff_brick_stairs' | 'minecraft.mined:minecraft.tuff_brick_stairs' | 'minecraft.broken:minecraft.tuff_brick_wall' | 'minecraft.mined:minecraft.tuff_brick_wall' | 'minecraft.broken:minecraft.tuff_bricks' | 'minecraft.mined:minecraft.tuff_bricks' | 'minecraft.broken:minecraft.tuff_slab' | 'minecraft.mined:minecraft.tuff_slab' | 'minecraft.broken:minecraft.tuff_stairs' | 'minecraft.mined:minecraft.tuff_stairs' | 'minecraft.broken:minecraft.tuff_wall' | 'minecraft.mined:minecraft.tuff_wall' | 'minecraft.broken:minecraft.turtle_egg' | 'minecraft.mined:minecraft.turtle_egg' | 'minecraft.broken:minecraft.twisting_vines' | 'minecraft.mined:minecraft.twisting_vines' | 'minecraft.broken:minecraft.twisting_vines_plant' | 'minecraft.mined:minecraft.twisting_vines_plant' | 'minecraft.broken:minecraft.verdant_froglight' | 'minecraft.mined:minecraft.verdant_froglight' | 'minecraft.broken:minecraft.vine' | 'minecraft.mined:minecraft.vine' | 'minecraft.broken:minecraft.void_air' | 'minecraft.mined:minecraft.void_air' | 'minecraft.broken:minecraft.wall_torch' | 'minecraft.mined:minecraft.wall_torch' | 'minecraft.broken:minecraft.warped_button' | 'minecraft.mined:minecraft.warped_button' | 'minecraft.broken:minecraft.warped_door' | 'minecraft.mined:minecraft.warped_door' | 'minecraft.broken:minecraft.warped_fence' | 'minecraft.mined:minecraft.warped_fence' | 'minecraft.broken:minecraft.warped_fence_gate' | 'minecraft.mined:minecraft.warped_fence_gate' | 'minecraft.broken:minecraft.warped_fungus' | 'minecraft.mined:minecraft.warped_fungus' | 'minecraft.broken:minecraft.warped_hanging_sign' | 'minecraft.mined:minecraft.warped_hanging_sign' | 'minecraft.broken:minecraft.warped_hyphae' | 'minecraft.mined:minecraft.warped_hyphae' | 'minecraft.broken:minecraft.warped_nylium' | 'minecraft.mined:minecraft.warped_nylium' | 'minecraft.broken:minecraft.warped_planks' | 'minecraft.mined:minecraft.warped_planks' | 'minecraft.broken:minecraft.warped_pressure_plate' | 'minecraft.mined:minecraft.warped_pressure_plate' | 'minecraft.broken:minecraft.warped_roots' | 'minecraft.mined:minecraft.warped_roots' | 'minecraft.broken:minecraft.warped_sign' | 'minecraft.mined:minecraft.warped_sign' | 'minecraft.broken:minecraft.warped_slab' | 'minecraft.mined:minecraft.warped_slab' | 'minecraft.broken:minecraft.warped_stairs' | 'minecraft.mined:minecraft.warped_stairs' | 'minecraft.broken:minecraft.warped_stem' | 'minecraft.mined:minecraft.warped_stem' | 'minecraft.broken:minecraft.warped_trapdoor' | 'minecraft.mined:minecraft.warped_trapdoor' | 'minecraft.broken:minecraft.warped_wall_hanging_sign' | 'minecraft.mined:minecraft.warped_wall_hanging_sign' | 'minecraft.broken:minecraft.warped_wall_sign' | 'minecraft.mined:minecraft.warped_wall_sign' | 'minecraft.broken:minecraft.warped_wart_block' | 'minecraft.mined:minecraft.warped_wart_block' | 'minecraft.broken:minecraft.water' | 'minecraft.mined:minecraft.water' | 'minecraft.broken:minecraft.water_cauldron' | 'minecraft.mined:minecraft.water_cauldron' | 'minecraft.broken:minecraft.waxed_chiseled_copper' | 'minecraft.mined:minecraft.waxed_chiseled_copper' | 'minecraft.broken:minecraft.waxed_copper_block' | 'minecraft.mined:minecraft.waxed_copper_block' | 'minecraft.broken:minecraft.waxed_copper_bulb' | 'minecraft.mined:minecraft.waxed_copper_bulb' | 'minecraft.broken:minecraft.waxed_copper_door' | 'minecraft.mined:minecraft.waxed_copper_door' | 'minecraft.broken:minecraft.waxed_copper_grate' | 'minecraft.mined:minecraft.waxed_copper_grate' | 'minecraft.broken:minecraft.waxed_copper_trapdoor' | 'minecraft.mined:minecraft.waxed_copper_trapdoor' | 'minecraft.broken:minecraft.waxed_cut_copper' | 'minecraft.mined:minecraft.waxed_cut_copper' | 'minecraft.broken:minecraft.waxed_cut_copper_slab' | 'minecraft.mined:minecraft.waxed_cut_copper_slab' | 'minecraft.broken:minecraft.waxed_cut_copper_stairs' | 'minecraft.mined:minecraft.waxed_cut_copper_stairs' | 'minecraft.broken:minecraft.waxed_exposed_chiseled_copper' | 'minecraft.mined:minecraft.waxed_exposed_chiseled_copper' | 'minecraft.broken:minecraft.waxed_exposed_copper' | 'minecraft.mined:minecraft.waxed_exposed_copper' | 'minecraft.broken:minecraft.waxed_exposed_copper_bulb' | 'minecraft.mined:minecraft.waxed_exposed_copper_bulb' | 'minecraft.broken:minecraft.waxed_exposed_copper_door' | 'minecraft.mined:minecraft.waxed_exposed_copper_door' | 'minecraft.broken:minecraft.waxed_exposed_copper_grate' | 'minecraft.mined:minecraft.waxed_exposed_copper_grate' | 'minecraft.broken:minecraft.waxed_exposed_copper_trapdoor' | 'minecraft.mined:minecraft.waxed_exposed_copper_trapdoor' | 'minecraft.broken:minecraft.waxed_exposed_cut_copper' | 'minecraft.mined:minecraft.waxed_exposed_cut_copper' | 'minecraft.broken:minecraft.waxed_exposed_cut_copper_slab' | 'minecraft.mined:minecraft.waxed_exposed_cut_copper_slab' | 'minecraft.broken:minecraft.waxed_exposed_cut_copper_stairs' | 'minecraft.mined:minecraft.waxed_exposed_cut_copper_stairs' | 'minecraft.broken:minecraft.waxed_oxidized_chiseled_copper' | 'minecraft.mined:minecraft.waxed_oxidized_chiseled_copper' | 'minecraft.broken:minecraft.waxed_oxidized_copper' | 'minecraft.mined:minecraft.waxed_oxidized_copper' | 'minecraft.broken:minecraft.waxed_oxidized_copper_bulb' | 'minecraft.mined:minecraft.waxed_oxidized_copper_bulb' | 'minecraft.broken:minecraft.waxed_oxidized_copper_door' | 'minecraft.mined:minecraft.waxed_oxidized_copper_door' | 'minecraft.broken:minecraft.waxed_oxidized_copper_grate' | 'minecraft.mined:minecraft.waxed_oxidized_copper_grate' | 'minecraft.broken:minecraft.waxed_oxidized_copper_trapdoor' | 'minecraft.mined:minecraft.waxed_oxidized_copper_trapdoor' | 'minecraft.broken:minecraft.waxed_oxidized_cut_copper' | 'minecraft.mined:minecraft.waxed_oxidized_cut_copper' | 'minecraft.broken:minecraft.waxed_oxidized_cut_copper_slab' | 'minecraft.mined:minecraft.waxed_oxidized_cut_copper_slab' | 'minecraft.broken:minecraft.waxed_oxidized_cut_copper_stairs' | 'minecraft.mined:minecraft.waxed_oxidized_cut_copper_stairs' | 'minecraft.broken:minecraft.waxed_weathered_chiseled_copper' | 'minecraft.mined:minecraft.waxed_weathered_chiseled_copper' | 'minecraft.broken:minecraft.waxed_weathered_copper' | 'minecraft.mined:minecraft.waxed_weathered_copper' | 'minecraft.broken:minecraft.waxed_weathered_copper_bulb' | 'minecraft.mined:minecraft.waxed_weathered_copper_bulb' | 'minecraft.broken:minecraft.waxed_weathered_copper_door' | 'minecraft.mined:minecraft.waxed_weathered_copper_door' | 'minecraft.broken:minecraft.waxed_weathered_copper_grate' | 'minecraft.mined:minecraft.waxed_weathered_copper_grate' | 'minecraft.broken:minecraft.waxed_weathered_copper_trapdoor' | 'minecraft.mined:minecraft.waxed_weathered_copper_trapdoor' | 'minecraft.broken:minecraft.waxed_weathered_cut_copper' | 'minecraft.mined:minecraft.waxed_weathered_cut_copper' | 'minecraft.broken:minecraft.waxed_weathered_cut_copper_slab' | 'minecraft.mined:minecraft.waxed_weathered_cut_copper_slab' | 'minecraft.broken:minecraft.waxed_weathered_cut_copper_stairs' | 'minecraft.mined:minecraft.waxed_weathered_cut_copper_stairs' | 'minecraft.broken:minecraft.weathered_chiseled_copper' | 'minecraft.mined:minecraft.weathered_chiseled_copper' | 'minecraft.broken:minecraft.weathered_copper' | 'minecraft.mined:minecraft.weathered_copper' | 'minecraft.broken:minecraft.weathered_copper_bulb' | 'minecraft.mined:minecraft.weathered_copper_bulb' | 'minecraft.broken:minecraft.weathered_copper_door' | 'minecraft.mined:minecraft.weathered_copper_door' | 'minecraft.broken:minecraft.weathered_copper_grate' | 'minecraft.mined:minecraft.weathered_copper_grate' | 'minecraft.broken:minecraft.weathered_copper_trapdoor' | 'minecraft.mined:minecraft.weathered_copper_trapdoor' | 'minecraft.broken:minecraft.weathered_cut_copper' | 'minecraft.mined:minecraft.weathered_cut_copper' | 'minecraft.broken:minecraft.weathered_cut_copper_slab' | 'minecraft.mined:minecraft.weathered_cut_copper_slab' | 'minecraft.broken:minecraft.weathered_cut_copper_stairs' | 'minecraft.mined:minecraft.weathered_cut_copper_stairs' | 'minecraft.broken:minecraft.weeping_vines' | 'minecraft.mined:minecraft.weeping_vines' | 'minecraft.broken:minecraft.weeping_vines_plant' | 'minecraft.mined:minecraft.weeping_vines_plant' | 'minecraft.broken:minecraft.wet_sponge' | 'minecraft.mined:minecraft.wet_sponge' | 'minecraft.broken:minecraft.wheat' | 'minecraft.mined:minecraft.wheat' | 'minecraft.broken:minecraft.white_banner' | 'minecraft.mined:minecraft.white_banner' | 'minecraft.broken:minecraft.white_bed' | 'minecraft.mined:minecraft.white_bed' | 'minecraft.broken:minecraft.white_candle' | 'minecraft.mined:minecraft.white_candle' | 'minecraft.broken:minecraft.white_candle_cake' | 'minecraft.mined:minecraft.white_candle_cake' | 'minecraft.broken:minecraft.white_carpet' | 'minecraft.mined:minecraft.white_carpet' | 'minecraft.broken:minecraft.white_concrete' | 'minecraft.mined:minecraft.white_concrete' | 'minecraft.broken:minecraft.white_concrete_powder' | 'minecraft.mined:minecraft.white_concrete_powder' | 'minecraft.broken:minecraft.white_glazed_terracotta' | 'minecraft.mined:minecraft.white_glazed_terracotta' | 'minecraft.broken:minecraft.white_shulker_box' | 'minecraft.mined:minecraft.white_shulker_box' | 'minecraft.broken:minecraft.white_stained_glass' | 'minecraft.mined:minecraft.white_stained_glass' | 'minecraft.broken:minecraft.white_stained_glass_pane' | 'minecraft.mined:minecraft.white_stained_glass_pane' | 'minecraft.broken:minecraft.white_terracotta' | 'minecraft.mined:minecraft.white_terracotta' | 'minecraft.broken:minecraft.white_tulip' | 'minecraft.mined:minecraft.white_tulip' | 'minecraft.broken:minecraft.white_wall_banner' | 'minecraft.mined:minecraft.white_wall_banner' | 'minecraft.broken:minecraft.white_wool' | 'minecraft.mined:minecraft.white_wool' | 'minecraft.broken:minecraft.wither_rose' | 'minecraft.mined:minecraft.wither_rose' | 'minecraft.broken:minecraft.wither_skeleton_skull' | 'minecraft.mined:minecraft.wither_skeleton_skull' | 'minecraft.broken:minecraft.wither_skeleton_wall_skull' | 'minecraft.mined:minecraft.wither_skeleton_wall_skull' | 'minecraft.broken:minecraft.yellow_banner' | 'minecraft.mined:minecraft.yellow_banner' | 'minecraft.broken:minecraft.yellow_bed' | 'minecraft.mined:minecraft.yellow_bed' | 'minecraft.broken:minecraft.yellow_candle' | 'minecraft.mined:minecraft.yellow_candle' | 'minecraft.broken:minecraft.yellow_candle_cake' | 'minecraft.mined:minecraft.yellow_candle_cake' | 'minecraft.broken:minecraft.yellow_carpet' | 'minecraft.mined:minecraft.yellow_carpet' | 'minecraft.broken:minecraft.yellow_concrete' | 'minecraft.mined:minecraft.yellow_concrete' | 'minecraft.broken:minecraft.yellow_concrete_powder' | 'minecraft.mined:minecraft.yellow_concrete_powder' | 'minecraft.broken:minecraft.yellow_glazed_terracotta' | 'minecraft.mined:minecraft.yellow_glazed_terracotta' | 'minecraft.broken:minecraft.yellow_shulker_box' | 'minecraft.mined:minecraft.yellow_shulker_box' | 'minecraft.broken:minecraft.yellow_stained_glass' | 'minecraft.mined:minecraft.yellow_stained_glass' | 'minecraft.broken:minecraft.yellow_stained_glass_pane' | 'minecraft.mined:minecraft.yellow_stained_glass_pane' | 'minecraft.broken:minecraft.yellow_terracotta' | 'minecraft.mined:minecraft.yellow_terracotta' | 'minecraft.broken:minecraft.yellow_wall_banner' | 'minecraft.mined:minecraft.yellow_wall_banner' | 'minecraft.broken:minecraft.yellow_wool' | 'minecraft.mined:minecraft.yellow_wool' | 'minecraft.broken:minecraft.zombie_head' | 'minecraft.mined:minecraft.zombie_head' | 'minecraft.broken:minecraft.zombie_wall_head' | 'minecraft.mined:minecraft.zombie_wall_head' | 'minecraft.killed:minecraft.allay' | 'minecraft.killed_by:minecraft.allay' | 'minecraft.killed:minecraft.area_effect_cloud' | 'minecraft.killed_by:minecraft.area_effect_cloud' | 'minecraft.killed:minecraft.armor_stand' | 'minecraft.killed_by:minecraft.armor_stand' | 'minecraft.killed:minecraft.arrow' | 'minecraft.killed_by:minecraft.arrow' | 'minecraft.killed:minecraft.axolotl' | 'minecraft.killed_by:minecraft.axolotl' | 'minecraft.killed:minecraft.bat' | 'minecraft.killed_by:minecraft.bat' | 'minecraft.killed:minecraft.bee' | 'minecraft.killed_by:minecraft.bee' | 'minecraft.killed:minecraft.blaze' | 'minecraft.killed_by:minecraft.blaze' | 'minecraft.killed:minecraft.block_display' | 'minecraft.killed_by:minecraft.block_display' | 'minecraft.killed:minecraft.boat' | 'minecraft.killed_by:minecraft.boat' | 'minecraft.killed:minecraft.breeze' | 'minecraft.killed_by:minecraft.breeze' | 'minecraft.killed:minecraft.camel' | 'minecraft.killed_by:minecraft.camel' | 'minecraft.killed:minecraft.cat' | 'minecraft.killed_by:minecraft.cat' | 'minecraft.killed:minecraft.cave_spider' | 'minecraft.killed_by:minecraft.cave_spider' | 'minecraft.killed:minecraft.chest_boat' | 'minecraft.killed_by:minecraft.chest_boat' | 'minecraft.killed:minecraft.chest_minecart' | 'minecraft.killed_by:minecraft.chest_minecart' | 'minecraft.killed:minecraft.chicken' | 'minecraft.killed_by:minecraft.chicken' | 'minecraft.killed:minecraft.cod' | 'minecraft.killed_by:minecraft.cod' | 'minecraft.killed:minecraft.command_block_minecart' | 'minecraft.killed_by:minecraft.command_block_minecart' | 'minecraft.killed:minecraft.cow' | 'minecraft.killed_by:minecraft.cow' | 'minecraft.killed:minecraft.creeper' | 'minecraft.killed_by:minecraft.creeper' | 'minecraft.killed:minecraft.dolphin' | 'minecraft.killed_by:minecraft.dolphin' | 'minecraft.killed:minecraft.donkey' | 'minecraft.killed_by:minecraft.donkey' | 'minecraft.killed:minecraft.dragon_fireball' | 'minecraft.killed_by:minecraft.dragon_fireball' | 'minecraft.killed:minecraft.drowned' | 'minecraft.killed_by:minecraft.drowned' | 'minecraft.killed:minecraft.egg' | 'minecraft.killed_by:minecraft.egg' | 'minecraft.killed:minecraft.elder_guardian' | 'minecraft.killed_by:minecraft.elder_guardian' | 'minecraft.killed:minecraft.end_crystal' | 'minecraft.killed_by:minecraft.end_crystal' | 'minecraft.killed:minecraft.ender_dragon' | 'minecraft.killed_by:minecraft.ender_dragon' | 'minecraft.killed:minecraft.ender_pearl' | 'minecraft.killed_by:minecraft.ender_pearl' | 'minecraft.killed:minecraft.enderman' | 'minecraft.killed_by:minecraft.enderman' | 'minecraft.killed:minecraft.endermite' | 'minecraft.killed_by:minecraft.endermite' | 'minecraft.killed:minecraft.evoker' | 'minecraft.killed_by:minecraft.evoker' | 'minecraft.killed:minecraft.evoker_fangs' | 'minecraft.killed_by:minecraft.evoker_fangs' | 'minecraft.killed:minecraft.experience_bottle' | 'minecraft.killed_by:minecraft.experience_bottle' | 'minecraft.killed:minecraft.experience_orb' | 'minecraft.killed_by:minecraft.experience_orb' | 'minecraft.killed:minecraft.eye_of_ender' | 'minecraft.killed_by:minecraft.eye_of_ender' | 'minecraft.killed:minecraft.falling_block' | 'minecraft.killed_by:minecraft.falling_block' | 'minecraft.killed:minecraft.fireball' | 'minecraft.killed_by:minecraft.fireball' | 'minecraft.killed:minecraft.firework_rocket' | 'minecraft.killed_by:minecraft.firework_rocket' | 'minecraft.killed:minecraft.fishing_bobber' | 'minecraft.killed_by:minecraft.fishing_bobber' | 'minecraft.killed:minecraft.fox' | 'minecraft.killed_by:minecraft.fox' | 'minecraft.killed:minecraft.frog' | 'minecraft.killed_by:minecraft.frog' | 'minecraft.killed:minecraft.furnace_minecart' | 'minecraft.killed_by:minecraft.furnace_minecart' | 'minecraft.killed:minecraft.ghast' | 'minecraft.killed_by:minecraft.ghast' | 'minecraft.killed:minecraft.giant' | 'minecraft.killed_by:minecraft.giant' | 'minecraft.killed:minecraft.glow_item_frame' | 'minecraft.killed_by:minecraft.glow_item_frame' | 'minecraft.killed:minecraft.glow_squid' | 'minecraft.killed_by:minecraft.glow_squid' | 'minecraft.killed:minecraft.goat' | 'minecraft.killed_by:minecraft.goat' | 'minecraft.killed:minecraft.guardian' | 'minecraft.killed_by:minecraft.guardian' | 'minecraft.killed:minecraft.hoglin' | 'minecraft.killed_by:minecraft.hoglin' | 'minecraft.killed:minecraft.hopper_minecart' | 'minecraft.killed_by:minecraft.hopper_minecart' | 'minecraft.killed:minecraft.horse' | 'minecraft.killed_by:minecraft.horse' | 'minecraft.killed:minecraft.husk' | 'minecraft.killed_by:minecraft.husk' | 'minecraft.killed:minecraft.illusioner' | 'minecraft.killed_by:minecraft.illusioner' | 'minecraft.killed:minecraft.interaction' | 'minecraft.killed_by:minecraft.interaction' | 'minecraft.killed:minecraft.iron_golem' | 'minecraft.killed_by:minecraft.iron_golem' | 'minecraft.killed:minecraft.item' | 'minecraft.killed_by:minecraft.item' | 'minecraft.killed:minecraft.item_display' | 'minecraft.killed_by:minecraft.item_display' | 'minecraft.killed:minecraft.item_frame' | 'minecraft.killed_by:minecraft.item_frame' | 'minecraft.killed:minecraft.leash_knot' | 'minecraft.killed_by:minecraft.leash_knot' | 'minecraft.killed:minecraft.lightning_bolt' | 'minecraft.killed_by:minecraft.lightning_bolt' | 'minecraft.killed:minecraft.llama' | 'minecraft.killed_by:minecraft.llama' | 'minecraft.killed:minecraft.llama_spit' | 'minecraft.killed_by:minecraft.llama_spit' | 'minecraft.killed:minecraft.magma_cube' | 'minecraft.killed_by:minecraft.magma_cube' | 'minecraft.killed:minecraft.marker' | 'minecraft.killed_by:minecraft.marker' | 'minecraft.killed:minecraft.minecart' | 'minecraft.killed_by:minecraft.minecart' | 'minecraft.killed:minecraft.mooshroom' | 'minecraft.killed_by:minecraft.mooshroom' | 'minecraft.killed:minecraft.mule' | 'minecraft.killed_by:minecraft.mule' | 'minecraft.killed:minecraft.ocelot' | 'minecraft.killed_by:minecraft.ocelot' | 'minecraft.killed:minecraft.painting' | 'minecraft.killed_by:minecraft.painting' | 'minecraft.killed:minecraft.panda' | 'minecraft.killed_by:minecraft.panda' | 'minecraft.killed:minecraft.parrot' | 'minecraft.killed_by:minecraft.parrot' | 'minecraft.killed:minecraft.phantom' | 'minecraft.killed_by:minecraft.phantom' | 'minecraft.killed:minecraft.pig' | 'minecraft.killed_by:minecraft.pig' | 'minecraft.killed:minecraft.piglin' | 'minecraft.killed_by:minecraft.piglin' | 'minecraft.killed:minecraft.piglin_brute' | 'minecraft.killed_by:minecraft.piglin_brute' | 'minecraft.killed:minecraft.pillager' | 'minecraft.killed_by:minecraft.pillager' | 'minecraft.killed:minecraft.player' | 'minecraft.killed_by:minecraft.player' | 'minecraft.killed:minecraft.polar_bear' | 'minecraft.killed_by:minecraft.polar_bear' | 'minecraft.killed:minecraft.potion' | 'minecraft.killed_by:minecraft.potion' | 'minecraft.killed:minecraft.pufferfish' | 'minecraft.killed_by:minecraft.pufferfish' | 'minecraft.killed:minecraft.rabbit' | 'minecraft.killed_by:minecraft.rabbit' | 'minecraft.killed:minecraft.ravager' | 'minecraft.killed_by:minecraft.ravager' | 'minecraft.killed:minecraft.salmon' | 'minecraft.killed_by:minecraft.salmon' | 'minecraft.killed:minecraft.sheep' | 'minecraft.killed_by:minecraft.sheep' | 'minecraft.killed:minecraft.shulker' | 'minecraft.killed_by:minecraft.shulker' | 'minecraft.killed:minecraft.shulker_bullet' | 'minecraft.killed_by:minecraft.shulker_bullet' | 'minecraft.killed:minecraft.silverfish' | 'minecraft.killed_by:minecraft.silverfish' | 'minecraft.killed:minecraft.skeleton' | 'minecraft.killed_by:minecraft.skeleton' | 'minecraft.killed:minecraft.skeleton_horse' | 'minecraft.killed_by:minecraft.skeleton_horse' | 'minecraft.killed:minecraft.slime' | 'minecraft.killed_by:minecraft.slime' | 'minecraft.killed:minecraft.small_fireball' | 'minecraft.killed_by:minecraft.small_fireball' | 'minecraft.killed:minecraft.sniffer' | 'minecraft.killed_by:minecraft.sniffer' | 'minecraft.killed:minecraft.snow_golem' | 'minecraft.killed_by:minecraft.snow_golem' | 'minecraft.killed:minecraft.snowball' | 'minecraft.killed_by:minecraft.snowball' | 'minecraft.killed:minecraft.spawner_minecart' | 'minecraft.killed_by:minecraft.spawner_minecart' | 'minecraft.killed:minecraft.spectral_arrow' | 'minecraft.killed_by:minecraft.spectral_arrow' | 'minecraft.killed:minecraft.spider' | 'minecraft.killed_by:minecraft.spider' | 'minecraft.killed:minecraft.squid' | 'minecraft.killed_by:minecraft.squid' | 'minecraft.killed:minecraft.stray' | 'minecraft.killed_by:minecraft.stray' | 'minecraft.killed:minecraft.strider' | 'minecraft.killed_by:minecraft.strider' | 'minecraft.killed:minecraft.tadpole' | 'minecraft.killed_by:minecraft.tadpole' | 'minecraft.killed:minecraft.text_display' | 'minecraft.killed_by:minecraft.text_display' | 'minecraft.killed:minecraft.tnt' | 'minecraft.killed_by:minecraft.tnt' | 'minecraft.killed:minecraft.tnt_minecart' | 'minecraft.killed_by:minecraft.tnt_minecart' | 'minecraft.killed:minecraft.trader_llama' | 'minecraft.killed_by:minecraft.trader_llama' | 'minecraft.killed:minecraft.trident' | 'minecraft.killed_by:minecraft.trident' | 'minecraft.killed:minecraft.tropical_fish' | 'minecraft.killed_by:minecraft.tropical_fish' | 'minecraft.killed:minecraft.turtle' | 'minecraft.killed_by:minecraft.turtle' | 'minecraft.killed:minecraft.vex' | 'minecraft.killed_by:minecraft.vex' | 'minecraft.killed:minecraft.villager' | 'minecraft.killed_by:minecraft.villager' | 'minecraft.killed:minecraft.vindicator' | 'minecraft.killed_by:minecraft.vindicator' | 'minecraft.killed:minecraft.wandering_trader' | 'minecraft.killed_by:minecraft.wandering_trader' | 'minecraft.killed:minecraft.warden' | 'minecraft.killed_by:minecraft.warden' | 'minecraft.killed:minecraft.wind_charge' | 'minecraft.killed_by:minecraft.wind_charge' | 'minecraft.killed:minecraft.witch' | 'minecraft.killed_by:minecraft.witch' | 'minecraft.killed:minecraft.wither' | 'minecraft.killed_by:minecraft.wither' | 'minecraft.killed:minecraft.wither_skeleton' | 'minecraft.killed_by:minecraft.wither_skeleton' | 'minecraft.killed:minecraft.wither_skull' | 'minecraft.killed_by:minecraft.wither_skull' | 'minecraft.killed:minecraft.wolf' | 'minecraft.killed_by:minecraft.wolf' | 'minecraft.killed:minecraft.zoglin' | 'minecraft.killed_by:minecraft.zoglin' | 'minecraft.killed:minecraft.zombie' | 'minecraft.killed_by:minecraft.zombie' | 'minecraft.killed:minecraft.zombie_horse' | 'minecraft.killed_by:minecraft.zombie_horse' | 'minecraft.killed:minecraft.zombie_villager' | 'minecraft.killed_by:minecraft.zombie_villager' | 'minecraft.killed:minecraft.zombified_piglin' | 'minecraft.killed_by:minecraft.zombified_piglin' | 'minecraft.custom:minecraft.animals_bred' | 'minecraft.custom:minecraft.aviate_one_cm' | 'minecraft.custom:minecraft.bell_ring' | 'minecraft.custom:minecraft.boat_one_cm' | 'minecraft.custom:minecraft.clean_armor' | 'minecraft.custom:minecraft.clean_banner' | 'minecraft.custom:minecraft.clean_shulker_box' | 'minecraft.custom:minecraft.climb_one_cm' | 'minecraft.custom:minecraft.crouch_one_cm' | 'minecraft.custom:minecraft.damage_absorbed' | 'minecraft.custom:minecraft.damage_blocked_by_shield' | 'minecraft.custom:minecraft.damage_dealt' | 'minecraft.custom:minecraft.damage_dealt_absorbed' | 'minecraft.custom:minecraft.damage_dealt_resisted' | 'minecraft.custom:minecraft.damage_resisted' | 'minecraft.custom:minecraft.damage_taken' | 'minecraft.custom:minecraft.deaths' | 'minecraft.custom:minecraft.drop' | 'minecraft.custom:minecraft.eat_cake_slice' | 'minecraft.custom:minecraft.enchant_item' | 'minecraft.custom:minecraft.fall_one_cm' | 'minecraft.custom:minecraft.fill_cauldron' | 'minecraft.custom:minecraft.fish_caught' | 'minecraft.custom:minecraft.fly_one_cm' | 'minecraft.custom:minecraft.horse_one_cm' | 'minecraft.custom:minecraft.inspect_dispenser' | 'minecraft.custom:minecraft.inspect_dropper' | 'minecraft.custom:minecraft.inspect_hopper' | 'minecraft.custom:minecraft.interact_with_anvil' | 'minecraft.custom:minecraft.interact_with_beacon' | 'minecraft.custom:minecraft.interact_with_blast_furnace' | 'minecraft.custom:minecraft.interact_with_brewingstand' | 'minecraft.custom:minecraft.interact_with_campfire' | 'minecraft.custom:minecraft.interact_with_cartography_table' | 'minecraft.custom:minecraft.interact_with_crafting_table' | 'minecraft.custom:minecraft.interact_with_furnace' | 'minecraft.custom:minecraft.interact_with_grindstone' | 'minecraft.custom:minecraft.interact_with_lectern' | 'minecraft.custom:minecraft.interact_with_loom' | 'minecraft.custom:minecraft.interact_with_smithing_table' | 'minecraft.custom:minecraft.interact_with_smoker' | 'minecraft.custom:minecraft.interact_with_stonecutter' | 'minecraft.custom:minecraft.jump' | 'minecraft.custom:minecraft.leave_game' | 'minecraft.custom:minecraft.minecart_one_cm' | 'minecraft.custom:minecraft.mob_kills' | 'minecraft.custom:minecraft.open_barrel' | 'minecraft.custom:minecraft.open_chest' | 'minecraft.custom:minecraft.open_enderchest' | 'minecraft.custom:minecraft.open_shulker_box' | 'minecraft.custom:minecraft.pig_one_cm' | 'minecraft.custom:minecraft.play_noteblock' | 'minecraft.custom:minecraft.play_record' | 'minecraft.custom:minecraft.play_time' | 'minecraft.custom:minecraft.player_kills' | 'minecraft.custom:minecraft.pot_flower' | 'minecraft.custom:minecraft.raid_trigger' | 'minecraft.custom:minecraft.raid_win' | 'minecraft.custom:minecraft.sleep_in_bed' | 'minecraft.custom:minecraft.sneak_time' | 'minecraft.custom:minecraft.sprint_one_cm' | 'minecraft.custom:minecraft.strider_one_cm' | 'minecraft.custom:minecraft.swim_one_cm' | 'minecraft.custom:minecraft.talked_to_villager' | 'minecraft.custom:minecraft.target_hit' | 'minecraft.custom:minecraft.time_since_death' | 'minecraft.custom:minecraft.time_since_rest' | 'minecraft.custom:minecraft.total_world_time' | 'minecraft.custom:minecraft.traded_with_villager' | 'minecraft.custom:minecraft.trigger_trapped_chest' | 'minecraft.custom:minecraft.tune_noteblock' | 'minecraft.custom:minecraft.use_cauldron' | 'minecraft.custom:minecraft.walk_on_water_one_cm' | 'minecraft.custom:minecraft.walk_one_cm' | 'minecraft.custom:minecraft.walk_under_water_one_cm' | 'minecraft.crafted:minecraft.acacia_boat' | 'minecraft.dropped:minecraft.acacia_boat' | 'minecraft.picked_up:minecraft.acacia_boat' | 'minecraft.used:minecraft.acacia_boat' | 'minecraft.crafted:minecraft.acacia_button' | 'minecraft.dropped:minecraft.acacia_button' | 'minecraft.picked_up:minecraft.acacia_button' | 'minecraft.used:minecraft.acacia_button' | 'minecraft.crafted:minecraft.acacia_chest_boat' | 'minecraft.dropped:minecraft.acacia_chest_boat' | 'minecraft.picked_up:minecraft.acacia_chest_boat' | 'minecraft.used:minecraft.acacia_chest_boat' | 'minecraft.crafted:minecraft.acacia_door' | 'minecraft.dropped:minecraft.acacia_door' | 'minecraft.picked_up:minecraft.acacia_door' | 'minecraft.used:minecraft.acacia_door' | 'minecraft.crafted:minecraft.acacia_fence' | 'minecraft.dropped:minecraft.acacia_fence' | 'minecraft.picked_up:minecraft.acacia_fence' | 'minecraft.used:minecraft.acacia_fence' | 'minecraft.crafted:minecraft.acacia_fence_gate' | 'minecraft.dropped:minecraft.acacia_fence_gate' | 'minecraft.picked_up:minecraft.acacia_fence_gate' | 'minecraft.used:minecraft.acacia_fence_gate' | 'minecraft.crafted:minecraft.acacia_hanging_sign' | 'minecraft.dropped:minecraft.acacia_hanging_sign' | 'minecraft.picked_up:minecraft.acacia_hanging_sign' | 'minecraft.used:minecraft.acacia_hanging_sign' | 'minecraft.crafted:minecraft.acacia_leaves' | 'minecraft.dropped:minecraft.acacia_leaves' | 'minecraft.picked_up:minecraft.acacia_leaves' | 'minecraft.used:minecraft.acacia_leaves' | 'minecraft.crafted:minecraft.acacia_log' | 'minecraft.dropped:minecraft.acacia_log' | 'minecraft.picked_up:minecraft.acacia_log' | 'minecraft.used:minecraft.acacia_log' | 'minecraft.crafted:minecraft.acacia_planks' | 'minecraft.dropped:minecraft.acacia_planks' | 'minecraft.picked_up:minecraft.acacia_planks' | 'minecraft.used:minecraft.acacia_planks' | 'minecraft.crafted:minecraft.acacia_pressure_plate' | 'minecraft.dropped:minecraft.acacia_pressure_plate' | 'minecraft.picked_up:minecraft.acacia_pressure_plate' | 'minecraft.used:minecraft.acacia_pressure_plate' | 'minecraft.crafted:minecraft.acacia_sapling' | 'minecraft.dropped:minecraft.acacia_sapling' | 'minecraft.picked_up:minecraft.acacia_sapling' | 'minecraft.used:minecraft.acacia_sapling' | 'minecraft.crafted:minecraft.acacia_sign' | 'minecraft.dropped:minecraft.acacia_sign' | 'minecraft.picked_up:minecraft.acacia_sign' | 'minecraft.used:minecraft.acacia_sign' | 'minecraft.crafted:minecraft.acacia_slab' | 'minecraft.dropped:minecraft.acacia_slab' | 'minecraft.picked_up:minecraft.acacia_slab' | 'minecraft.used:minecraft.acacia_slab' | 'minecraft.crafted:minecraft.acacia_stairs' | 'minecraft.dropped:minecraft.acacia_stairs' | 'minecraft.picked_up:minecraft.acacia_stairs' | 'minecraft.used:minecraft.acacia_stairs' | 'minecraft.crafted:minecraft.acacia_trapdoor' | 'minecraft.dropped:minecraft.acacia_trapdoor' | 'minecraft.picked_up:minecraft.acacia_trapdoor' | 'minecraft.used:minecraft.acacia_trapdoor' | 'minecraft.crafted:minecraft.acacia_wood' | 'minecraft.dropped:minecraft.acacia_wood' | 'minecraft.picked_up:minecraft.acacia_wood' | 'minecraft.used:minecraft.acacia_wood' | 'minecraft.crafted:minecraft.activator_rail' | 'minecraft.dropped:minecraft.activator_rail' | 'minecraft.picked_up:minecraft.activator_rail' | 'minecraft.used:minecraft.activator_rail' | 'minecraft.crafted:minecraft.air' | 'minecraft.dropped:minecraft.air' | 'minecraft.picked_up:minecraft.air' | 'minecraft.used:minecraft.air' | 'minecraft.crafted:minecraft.allay_spawn_egg' | 'minecraft.dropped:minecraft.allay_spawn_egg' | 'minecraft.picked_up:minecraft.allay_spawn_egg' | 'minecraft.used:minecraft.allay_spawn_egg' | 'minecraft.crafted:minecraft.allium' | 'minecraft.dropped:minecraft.allium' | 'minecraft.picked_up:minecraft.allium' | 'minecraft.used:minecraft.allium' | 'minecraft.crafted:minecraft.amethyst_block' | 'minecraft.dropped:minecraft.amethyst_block' | 'minecraft.picked_up:minecraft.amethyst_block' | 'minecraft.used:minecraft.amethyst_block' | 'minecraft.crafted:minecraft.amethyst_cluster' | 'minecraft.dropped:minecraft.amethyst_cluster' | 'minecraft.picked_up:minecraft.amethyst_cluster' | 'minecraft.used:minecraft.amethyst_cluster' | 'minecraft.crafted:minecraft.amethyst_shard' | 'minecraft.dropped:minecraft.amethyst_shard' | 'minecraft.picked_up:minecraft.amethyst_shard' | 'minecraft.used:minecraft.amethyst_shard' | 'minecraft.crafted:minecraft.ancient_debris' | 'minecraft.dropped:minecraft.ancient_debris' | 'minecraft.picked_up:minecraft.ancient_debris' | 'minecraft.used:minecraft.ancient_debris' | 'minecraft.crafted:minecraft.andesite' | 'minecraft.dropped:minecraft.andesite' | 'minecraft.picked_up:minecraft.andesite' | 'minecraft.used:minecraft.andesite' | 'minecraft.crafted:minecraft.andesite_slab' | 'minecraft.dropped:minecraft.andesite_slab' | 'minecraft.picked_up:minecraft.andesite_slab' | 'minecraft.used:minecraft.andesite_slab' | 'minecraft.crafted:minecraft.andesite_stairs' | 'minecraft.dropped:minecraft.andesite_stairs' | 'minecraft.picked_up:minecraft.andesite_stairs' | 'minecraft.used:minecraft.andesite_stairs' | 'minecraft.crafted:minecraft.andesite_wall' | 'minecraft.dropped:minecraft.andesite_wall' | 'minecraft.picked_up:minecraft.andesite_wall' | 'minecraft.used:minecraft.andesite_wall' | 'minecraft.crafted:minecraft.angler_pottery_sherd' | 'minecraft.dropped:minecraft.angler_pottery_sherd' | 'minecraft.picked_up:minecraft.angler_pottery_sherd' | 'minecraft.used:minecraft.angler_pottery_sherd' | 'minecraft.crafted:minecraft.anvil' | 'minecraft.dropped:minecraft.anvil' | 'minecraft.picked_up:minecraft.anvil' | 'minecraft.used:minecraft.anvil' | 'minecraft.crafted:minecraft.apple' | 'minecraft.dropped:minecraft.apple' | 'minecraft.picked_up:minecraft.apple' | 'minecraft.used:minecraft.apple' | 'minecraft.crafted:minecraft.archer_pottery_sherd' | 'minecraft.dropped:minecraft.archer_pottery_sherd' | 'minecraft.picked_up:minecraft.archer_pottery_sherd' | 'minecraft.used:minecraft.archer_pottery_sherd' | 'minecraft.crafted:minecraft.armor_stand' | 'minecraft.dropped:minecraft.armor_stand' | 'minecraft.picked_up:minecraft.armor_stand' | 'minecraft.used:minecraft.armor_stand' | 'minecraft.crafted:minecraft.arms_up_pottery_sherd' | 'minecraft.dropped:minecraft.arms_up_pottery_sherd' | 'minecraft.picked_up:minecraft.arms_up_pottery_sherd' | 'minecraft.used:minecraft.arms_up_pottery_sherd' | 'minecraft.crafted:minecraft.arrow' | 'minecraft.dropped:minecraft.arrow' | 'minecraft.picked_up:minecraft.arrow' | 'minecraft.used:minecraft.arrow' | 'minecraft.crafted:minecraft.axolotl_bucket' | 'minecraft.dropped:minecraft.axolotl_bucket' | 'minecraft.picked_up:minecraft.axolotl_bucket' | 'minecraft.used:minecraft.axolotl_bucket' | 'minecraft.crafted:minecraft.axolotl_spawn_egg' | 'minecraft.dropped:minecraft.axolotl_spawn_egg' | 'minecraft.picked_up:minecraft.axolotl_spawn_egg' | 'minecraft.used:minecraft.axolotl_spawn_egg' | 'minecraft.crafted:minecraft.azalea' | 'minecraft.dropped:minecraft.azalea' | 'minecraft.picked_up:minecraft.azalea' | 'minecraft.used:minecraft.azalea' | 'minecraft.crafted:minecraft.azalea_leaves' | 'minecraft.dropped:minecraft.azalea_leaves' | 'minecraft.picked_up:minecraft.azalea_leaves' | 'minecraft.used:minecraft.azalea_leaves' | 'minecraft.crafted:minecraft.azure_bluet' | 'minecraft.dropped:minecraft.azure_bluet' | 'minecraft.picked_up:minecraft.azure_bluet' | 'minecraft.used:minecraft.azure_bluet' | 'minecraft.crafted:minecraft.baked_potato' | 'minecraft.dropped:minecraft.baked_potato' | 'minecraft.picked_up:minecraft.baked_potato' | 'minecraft.used:minecraft.baked_potato' | 'minecraft.crafted:minecraft.bamboo' | 'minecraft.dropped:minecraft.bamboo' | 'minecraft.picked_up:minecraft.bamboo' | 'minecraft.used:minecraft.bamboo' | 'minecraft.crafted:minecraft.bamboo_block' | 'minecraft.dropped:minecraft.bamboo_block' | 'minecraft.picked_up:minecraft.bamboo_block' | 'minecraft.used:minecraft.bamboo_block' | 'minecraft.crafted:minecraft.bamboo_button' | 'minecraft.dropped:minecraft.bamboo_button' | 'minecraft.picked_up:minecraft.bamboo_button' | 'minecraft.used:minecraft.bamboo_button' | 'minecraft.crafted:minecraft.bamboo_chest_raft' | 'minecraft.dropped:minecraft.bamboo_chest_raft' | 'minecraft.picked_up:minecraft.bamboo_chest_raft' | 'minecraft.used:minecraft.bamboo_chest_raft' | 'minecraft.crafted:minecraft.bamboo_door' | 'minecraft.dropped:minecraft.bamboo_door' | 'minecraft.picked_up:minecraft.bamboo_door' | 'minecraft.used:minecraft.bamboo_door' | 'minecraft.crafted:minecraft.bamboo_fence' | 'minecraft.dropped:minecraft.bamboo_fence' | 'minecraft.picked_up:minecraft.bamboo_fence' | 'minecraft.used:minecraft.bamboo_fence' | 'minecraft.crafted:minecraft.bamboo_fence_gate' | 'minecraft.dropped:minecraft.bamboo_fence_gate' | 'minecraft.picked_up:minecraft.bamboo_fence_gate' | 'minecraft.used:minecraft.bamboo_fence_gate' | 'minecraft.crafted:minecraft.bamboo_hanging_sign' | 'minecraft.dropped:minecraft.bamboo_hanging_sign' | 'minecraft.picked_up:minecraft.bamboo_hanging_sign' | 'minecraft.used:minecraft.bamboo_hanging_sign' | 'minecraft.crafted:minecraft.bamboo_mosaic' | 'minecraft.dropped:minecraft.bamboo_mosaic' | 'minecraft.picked_up:minecraft.bamboo_mosaic' | 'minecraft.used:minecraft.bamboo_mosaic' | 'minecraft.crafted:minecraft.bamboo_mosaic_slab' | 'minecraft.dropped:minecraft.bamboo_mosaic_slab' | 'minecraft.picked_up:minecraft.bamboo_mosaic_slab' | 'minecraft.used:minecraft.bamboo_mosaic_slab' | 'minecraft.crafted:minecraft.bamboo_mosaic_stairs' | 'minecraft.dropped:minecraft.bamboo_mosaic_stairs' | 'minecraft.picked_up:minecraft.bamboo_mosaic_stairs' | 'minecraft.used:minecraft.bamboo_mosaic_stairs' | 'minecraft.crafted:minecraft.bamboo_planks' | 'minecraft.dropped:minecraft.bamboo_planks' | 'minecraft.picked_up:minecraft.bamboo_planks' | 'minecraft.used:minecraft.bamboo_planks' | 'minecraft.crafted:minecraft.bamboo_pressure_plate' | 'minecraft.dropped:minecraft.bamboo_pressure_plate' | 'minecraft.picked_up:minecraft.bamboo_pressure_plate' | 'minecraft.used:minecraft.bamboo_pressure_plate' | 'minecraft.crafted:minecraft.bamboo_raft' | 'minecraft.dropped:minecraft.bamboo_raft' | 'minecraft.picked_up:minecraft.bamboo_raft' | 'minecraft.used:minecraft.bamboo_raft' | 'minecraft.crafted:minecraft.bamboo_sign' | 'minecraft.dropped:minecraft.bamboo_sign' | 'minecraft.picked_up:minecraft.bamboo_sign' | 'minecraft.used:minecraft.bamboo_sign' | 'minecraft.crafted:minecraft.bamboo_slab' | 'minecraft.dropped:minecraft.bamboo_slab' | 'minecraft.picked_up:minecraft.bamboo_slab' | 'minecraft.used:minecraft.bamboo_slab' | 'minecraft.crafted:minecraft.bamboo_stairs' | 'minecraft.dropped:minecraft.bamboo_stairs' | 'minecraft.picked_up:minecraft.bamboo_stairs' | 'minecraft.used:minecraft.bamboo_stairs' | 'minecraft.crafted:minecraft.bamboo_trapdoor' | 'minecraft.dropped:minecraft.bamboo_trapdoor' | 'minecraft.picked_up:minecraft.bamboo_trapdoor' | 'minecraft.used:minecraft.bamboo_trapdoor' | 'minecraft.crafted:minecraft.barrel' | 'minecraft.dropped:minecraft.barrel' | 'minecraft.picked_up:minecraft.barrel' | 'minecraft.used:minecraft.barrel' | 'minecraft.crafted:minecraft.barrier' | 'minecraft.dropped:minecraft.barrier' | 'minecraft.picked_up:minecraft.barrier' | 'minecraft.used:minecraft.barrier' | 'minecraft.crafted:minecraft.basalt' | 'minecraft.dropped:minecraft.basalt' | 'minecraft.picked_up:minecraft.basalt' | 'minecraft.used:minecraft.basalt' | 'minecraft.crafted:minecraft.bat_spawn_egg' | 'minecraft.dropped:minecraft.bat_spawn_egg' | 'minecraft.picked_up:minecraft.bat_spawn_egg' | 'minecraft.used:minecraft.bat_spawn_egg' | 'minecraft.crafted:minecraft.beacon' | 'minecraft.dropped:minecraft.beacon' | 'minecraft.picked_up:minecraft.beacon' | 'minecraft.used:minecraft.beacon' | 'minecraft.crafted:minecraft.bedrock' | 'minecraft.dropped:minecraft.bedrock' | 'minecraft.picked_up:minecraft.bedrock' | 'minecraft.used:minecraft.bedrock' | 'minecraft.crafted:minecraft.bee_nest' | 'minecraft.dropped:minecraft.bee_nest' | 'minecraft.picked_up:minecraft.bee_nest' | 'minecraft.used:minecraft.bee_nest' | 'minecraft.crafted:minecraft.bee_spawn_egg' | 'minecraft.dropped:minecraft.bee_spawn_egg' | 'minecraft.picked_up:minecraft.bee_spawn_egg' | 'minecraft.used:minecraft.bee_spawn_egg' | 'minecraft.crafted:minecraft.beef' | 'minecraft.dropped:minecraft.beef' | 'minecraft.picked_up:minecraft.beef' | 'minecraft.used:minecraft.beef' | 'minecraft.crafted:minecraft.beehive' | 'minecraft.dropped:minecraft.beehive' | 'minecraft.picked_up:minecraft.beehive' | 'minecraft.used:minecraft.beehive' | 'minecraft.crafted:minecraft.beetroot' | 'minecraft.dropped:minecraft.beetroot' | 'minecraft.picked_up:minecraft.beetroot' | 'minecraft.used:minecraft.beetroot' | 'minecraft.crafted:minecraft.beetroot_seeds' | 'minecraft.dropped:minecraft.beetroot_seeds' | 'minecraft.picked_up:minecraft.beetroot_seeds' | 'minecraft.used:minecraft.beetroot_seeds' | 'minecraft.crafted:minecraft.beetroot_soup' | 'minecraft.dropped:minecraft.beetroot_soup' | 'minecraft.picked_up:minecraft.beetroot_soup' | 'minecraft.used:minecraft.beetroot_soup' | 'minecraft.crafted:minecraft.bell' | 'minecraft.dropped:minecraft.bell' | 'minecraft.picked_up:minecraft.bell' | 'minecraft.used:minecraft.bell' | 'minecraft.crafted:minecraft.big_dripleaf' | 'minecraft.dropped:minecraft.big_dripleaf' | 'minecraft.picked_up:minecraft.big_dripleaf' | 'minecraft.used:minecraft.big_dripleaf' | 'minecraft.crafted:minecraft.birch_boat' | 'minecraft.dropped:minecraft.birch_boat' | 'minecraft.picked_up:minecraft.birch_boat' | 'minecraft.used:minecraft.birch_boat' | 'minecraft.crafted:minecraft.birch_button' | 'minecraft.dropped:minecraft.birch_button' | 'minecraft.picked_up:minecraft.birch_button' | 'minecraft.used:minecraft.birch_button' | 'minecraft.crafted:minecraft.birch_chest_boat' | 'minecraft.dropped:minecraft.birch_chest_boat' | 'minecraft.picked_up:minecraft.birch_chest_boat' | 'minecraft.used:minecraft.birch_chest_boat' | 'minecraft.crafted:minecraft.birch_door' | 'minecraft.dropped:minecraft.birch_door' | 'minecraft.picked_up:minecraft.birch_door' | 'minecraft.used:minecraft.birch_door' | 'minecraft.crafted:minecraft.birch_fence' | 'minecraft.dropped:minecraft.birch_fence' | 'minecraft.picked_up:minecraft.birch_fence' | 'minecraft.used:minecraft.birch_fence' | 'minecraft.crafted:minecraft.birch_fence_gate' | 'minecraft.dropped:minecraft.birch_fence_gate' | 'minecraft.picked_up:minecraft.birch_fence_gate' | 'minecraft.used:minecraft.birch_fence_gate' | 'minecraft.crafted:minecraft.birch_hanging_sign' | 'minecraft.dropped:minecraft.birch_hanging_sign' | 'minecraft.picked_up:minecraft.birch_hanging_sign' | 'minecraft.used:minecraft.birch_hanging_sign' | 'minecraft.crafted:minecraft.birch_leaves' | 'minecraft.dropped:minecraft.birch_leaves' | 'minecraft.picked_up:minecraft.birch_leaves' | 'minecraft.used:minecraft.birch_leaves' | 'minecraft.crafted:minecraft.birch_log' | 'minecraft.dropped:minecraft.birch_log' | 'minecraft.picked_up:minecraft.birch_log' | 'minecraft.used:minecraft.birch_log' | 'minecraft.crafted:minecraft.birch_planks' | 'minecraft.dropped:minecraft.birch_planks' | 'minecraft.picked_up:minecraft.birch_planks' | 'minecraft.used:minecraft.birch_planks' | 'minecraft.crafted:minecraft.birch_pressure_plate' | 'minecraft.dropped:minecraft.birch_pressure_plate' | 'minecraft.picked_up:minecraft.birch_pressure_plate' | 'minecraft.used:minecraft.birch_pressure_plate' | 'minecraft.crafted:minecraft.birch_sapling' | 'minecraft.dropped:minecraft.birch_sapling' | 'minecraft.picked_up:minecraft.birch_sapling' | 'minecraft.used:minecraft.birch_sapling' | 'minecraft.crafted:minecraft.birch_sign' | 'minecraft.dropped:minecraft.birch_sign' | 'minecraft.picked_up:minecraft.birch_sign' | 'minecraft.used:minecraft.birch_sign' | 'minecraft.crafted:minecraft.birch_slab' | 'minecraft.dropped:minecraft.birch_slab' | 'minecraft.picked_up:minecraft.birch_slab' | 'minecraft.used:minecraft.birch_slab' | 'minecraft.crafted:minecraft.birch_stairs' | 'minecraft.dropped:minecraft.birch_stairs' | 'minecraft.picked_up:minecraft.birch_stairs' | 'minecraft.used:minecraft.birch_stairs' | 'minecraft.crafted:minecraft.birch_trapdoor' | 'minecraft.dropped:minecraft.birch_trapdoor' | 'minecraft.picked_up:minecraft.birch_trapdoor' | 'minecraft.used:minecraft.birch_trapdoor' | 'minecraft.crafted:minecraft.birch_wood' | 'minecraft.dropped:minecraft.birch_wood' | 'minecraft.picked_up:minecraft.birch_wood' | 'minecraft.used:minecraft.birch_wood' | 'minecraft.crafted:minecraft.black_banner' | 'minecraft.dropped:minecraft.black_banner' | 'minecraft.picked_up:minecraft.black_banner' | 'minecraft.used:minecraft.black_banner' | 'minecraft.crafted:minecraft.black_bed' | 'minecraft.dropped:minecraft.black_bed' | 'minecraft.picked_up:minecraft.black_bed' | 'minecraft.used:minecraft.black_bed' | 'minecraft.crafted:minecraft.black_candle' | 'minecraft.dropped:minecraft.black_candle' | 'minecraft.picked_up:minecraft.black_candle' | 'minecraft.used:minecraft.black_candle' | 'minecraft.crafted:minecraft.black_carpet' | 'minecraft.dropped:minecraft.black_carpet' | 'minecraft.picked_up:minecraft.black_carpet' | 'minecraft.used:minecraft.black_carpet' | 'minecraft.crafted:minecraft.black_concrete' | 'minecraft.dropped:minecraft.black_concrete' | 'minecraft.picked_up:minecraft.black_concrete' | 'minecraft.used:minecraft.black_concrete' | 'minecraft.crafted:minecraft.black_concrete_powder' | 'minecraft.dropped:minecraft.black_concrete_powder' | 'minecraft.picked_up:minecraft.black_concrete_powder' | 'minecraft.used:minecraft.black_concrete_powder' | 'minecraft.crafted:minecraft.black_dye' | 'minecraft.dropped:minecraft.black_dye' | 'minecraft.picked_up:minecraft.black_dye' | 'minecraft.used:minecraft.black_dye' | 'minecraft.crafted:minecraft.black_glazed_terracotta' | 'minecraft.dropped:minecraft.black_glazed_terracotta' | 'minecraft.picked_up:minecraft.black_glazed_terracotta' | 'minecraft.used:minecraft.black_glazed_terracotta' | 'minecraft.crafted:minecraft.black_shulker_box' | 'minecraft.dropped:minecraft.black_shulker_box' | 'minecraft.picked_up:minecraft.black_shulker_box' | 'minecraft.used:minecraft.black_shulker_box' | 'minecraft.crafted:minecraft.black_stained_glass' | 'minecraft.dropped:minecraft.black_stained_glass' | 'minecraft.picked_up:minecraft.black_stained_glass' | 'minecraft.used:minecraft.black_stained_glass' | 'minecraft.crafted:minecraft.black_stained_glass_pane' | 'minecraft.dropped:minecraft.black_stained_glass_pane' | 'minecraft.picked_up:minecraft.black_stained_glass_pane' | 'minecraft.used:minecraft.black_stained_glass_pane' | 'minecraft.crafted:minecraft.black_terracotta' | 'minecraft.dropped:minecraft.black_terracotta' | 'minecraft.picked_up:minecraft.black_terracotta' | 'minecraft.used:minecraft.black_terracotta' | 'minecraft.crafted:minecraft.black_wool' | 'minecraft.dropped:minecraft.black_wool' | 'minecraft.picked_up:minecraft.black_wool' | 'minecraft.used:minecraft.black_wool' | 'minecraft.crafted:minecraft.blackstone' | 'minecraft.dropped:minecraft.blackstone' | 'minecraft.picked_up:minecraft.blackstone' | 'minecraft.used:minecraft.blackstone' | 'minecraft.crafted:minecraft.blackstone_slab' | 'minecraft.dropped:minecraft.blackstone_slab' | 'minecraft.picked_up:minecraft.blackstone_slab' | 'minecraft.used:minecraft.blackstone_slab' | 'minecraft.crafted:minecraft.blackstone_stairs' | 'minecraft.dropped:minecraft.blackstone_stairs' | 'minecraft.picked_up:minecraft.blackstone_stairs' | 'minecraft.used:minecraft.blackstone_stairs' | 'minecraft.crafted:minecraft.blackstone_wall' | 'minecraft.dropped:minecraft.blackstone_wall' | 'minecraft.picked_up:minecraft.blackstone_wall' | 'minecraft.used:minecraft.blackstone_wall' | 'minecraft.crafted:minecraft.blade_pottery_sherd' | 'minecraft.dropped:minecraft.blade_pottery_sherd' | 'minecraft.picked_up:minecraft.blade_pottery_sherd' | 'minecraft.used:minecraft.blade_pottery_sherd' | 'minecraft.crafted:minecraft.blast_furnace' | 'minecraft.dropped:minecraft.blast_furnace' | 'minecraft.picked_up:minecraft.blast_furnace' | 'minecraft.used:minecraft.blast_furnace' | 'minecraft.crafted:minecraft.blaze_powder' | 'minecraft.dropped:minecraft.blaze_powder' | 'minecraft.picked_up:minecraft.blaze_powder' | 'minecraft.used:minecraft.blaze_powder' | 'minecraft.crafted:minecraft.blaze_rod' | 'minecraft.dropped:minecraft.blaze_rod' | 'minecraft.picked_up:minecraft.blaze_rod' | 'minecraft.used:minecraft.blaze_rod' | 'minecraft.crafted:minecraft.blaze_spawn_egg' | 'minecraft.dropped:minecraft.blaze_spawn_egg' | 'minecraft.picked_up:minecraft.blaze_spawn_egg' | 'minecraft.used:minecraft.blaze_spawn_egg' | 'minecraft.crafted:minecraft.blue_banner' | 'minecraft.dropped:minecraft.blue_banner' | 'minecraft.picked_up:minecraft.blue_banner' | 'minecraft.used:minecraft.blue_banner' | 'minecraft.crafted:minecraft.blue_bed' | 'minecraft.dropped:minecraft.blue_bed' | 'minecraft.picked_up:minecraft.blue_bed' | 'minecraft.used:minecraft.blue_bed' | 'minecraft.crafted:minecraft.blue_candle' | 'minecraft.dropped:minecraft.blue_candle' | 'minecraft.picked_up:minecraft.blue_candle' | 'minecraft.used:minecraft.blue_candle' | 'minecraft.crafted:minecraft.blue_carpet' | 'minecraft.dropped:minecraft.blue_carpet' | 'minecraft.picked_up:minecraft.blue_carpet' | 'minecraft.used:minecraft.blue_carpet' | 'minecraft.crafted:minecraft.blue_concrete' | 'minecraft.dropped:minecraft.blue_concrete' | 'minecraft.picked_up:minecraft.blue_concrete' | 'minecraft.used:minecraft.blue_concrete' | 'minecraft.crafted:minecraft.blue_concrete_powder' | 'minecraft.dropped:minecraft.blue_concrete_powder' | 'minecraft.picked_up:minecraft.blue_concrete_powder' | 'minecraft.used:minecraft.blue_concrete_powder' | 'minecraft.crafted:minecraft.blue_dye' | 'minecraft.dropped:minecraft.blue_dye' | 'minecraft.picked_up:minecraft.blue_dye' | 'minecraft.used:minecraft.blue_dye' | 'minecraft.crafted:minecraft.blue_glazed_terracotta' | 'minecraft.dropped:minecraft.blue_glazed_terracotta' | 'minecraft.picked_up:minecraft.blue_glazed_terracotta' | 'minecraft.used:minecraft.blue_glazed_terracotta' | 'minecraft.crafted:minecraft.blue_ice' | 'minecraft.dropped:minecraft.blue_ice' | 'minecraft.picked_up:minecraft.blue_ice' | 'minecraft.used:minecraft.blue_ice' | 'minecraft.crafted:minecraft.blue_orchid' | 'minecraft.dropped:minecraft.blue_orchid' | 'minecraft.picked_up:minecraft.blue_orchid' | 'minecraft.used:minecraft.blue_orchid' | 'minecraft.crafted:minecraft.blue_shulker_box' | 'minecraft.dropped:minecraft.blue_shulker_box' | 'minecraft.picked_up:minecraft.blue_shulker_box' | 'minecraft.used:minecraft.blue_shulker_box' | 'minecraft.crafted:minecraft.blue_stained_glass' | 'minecraft.dropped:minecraft.blue_stained_glass' | 'minecraft.picked_up:minecraft.blue_stained_glass' | 'minecraft.used:minecraft.blue_stained_glass' | 'minecraft.crafted:minecraft.blue_stained_glass_pane' | 'minecraft.dropped:minecraft.blue_stained_glass_pane' | 'minecraft.picked_up:minecraft.blue_stained_glass_pane' | 'minecraft.used:minecraft.blue_stained_glass_pane' | 'minecraft.crafted:minecraft.blue_terracotta' | 'minecraft.dropped:minecraft.blue_terracotta' | 'minecraft.picked_up:minecraft.blue_terracotta' | 'minecraft.used:minecraft.blue_terracotta' | 'minecraft.crafted:minecraft.blue_wool' | 'minecraft.dropped:minecraft.blue_wool' | 'minecraft.picked_up:minecraft.blue_wool' | 'minecraft.used:minecraft.blue_wool' | 'minecraft.crafted:minecraft.bone' | 'minecraft.dropped:minecraft.bone' | 'minecraft.picked_up:minecraft.bone' | 'minecraft.used:minecraft.bone' | 'minecraft.crafted:minecraft.bone_block' | 'minecraft.dropped:minecraft.bone_block' | 'minecraft.picked_up:minecraft.bone_block' | 'minecraft.used:minecraft.bone_block' | 'minecraft.crafted:minecraft.bone_meal' | 'minecraft.dropped:minecraft.bone_meal' | 'minecraft.picked_up:minecraft.bone_meal' | 'minecraft.used:minecraft.bone_meal' | 'minecraft.crafted:minecraft.book' | 'minecraft.dropped:minecraft.book' | 'minecraft.picked_up:minecraft.book' | 'minecraft.used:minecraft.book' | 'minecraft.crafted:minecraft.bookshelf' | 'minecraft.dropped:minecraft.bookshelf' | 'minecraft.picked_up:minecraft.bookshelf' | 'minecraft.used:minecraft.bookshelf' | 'minecraft.crafted:minecraft.bow' | 'minecraft.dropped:minecraft.bow' | 'minecraft.picked_up:minecraft.bow' | 'minecraft.used:minecraft.bow' | 'minecraft.crafted:minecraft.bowl' | 'minecraft.dropped:minecraft.bowl' | 'minecraft.picked_up:minecraft.bowl' | 'minecraft.used:minecraft.bowl' | 'minecraft.crafted:minecraft.brain_coral' | 'minecraft.dropped:minecraft.brain_coral' | 'minecraft.picked_up:minecraft.brain_coral' | 'minecraft.used:minecraft.brain_coral' | 'minecraft.crafted:minecraft.brain_coral_block' | 'minecraft.dropped:minecraft.brain_coral_block' | 'minecraft.picked_up:minecraft.brain_coral_block' | 'minecraft.used:minecraft.brain_coral_block' | 'minecraft.crafted:minecraft.brain_coral_fan' | 'minecraft.dropped:minecraft.brain_coral_fan' | 'minecraft.picked_up:minecraft.brain_coral_fan' | 'minecraft.used:minecraft.brain_coral_fan' | 'minecraft.crafted:minecraft.bread' | 'minecraft.dropped:minecraft.bread' | 'minecraft.picked_up:minecraft.bread' | 'minecraft.used:minecraft.bread' | 'minecraft.crafted:minecraft.breeze_spawn_egg' | 'minecraft.dropped:minecraft.breeze_spawn_egg' | 'minecraft.picked_up:minecraft.breeze_spawn_egg' | 'minecraft.used:minecraft.breeze_spawn_egg' | 'minecraft.crafted:minecraft.brewer_pottery_sherd' | 'minecraft.dropped:minecraft.brewer_pottery_sherd' | 'minecraft.picked_up:minecraft.brewer_pottery_sherd' | 'minecraft.used:minecraft.brewer_pottery_sherd' | 'minecraft.crafted:minecraft.brewing_stand' | 'minecraft.dropped:minecraft.brewing_stand' | 'minecraft.picked_up:minecraft.brewing_stand' | 'minecraft.used:minecraft.brewing_stand' | 'minecraft.crafted:minecraft.brick' | 'minecraft.dropped:minecraft.brick' | 'minecraft.picked_up:minecraft.brick' | 'minecraft.used:minecraft.brick' | 'minecraft.crafted:minecraft.brick_slab' | 'minecraft.dropped:minecraft.brick_slab' | 'minecraft.picked_up:minecraft.brick_slab' | 'minecraft.used:minecraft.brick_slab' | 'minecraft.crafted:minecraft.brick_stairs' | 'minecraft.dropped:minecraft.brick_stairs' | 'minecraft.picked_up:minecraft.brick_stairs' | 'minecraft.used:minecraft.brick_stairs' | 'minecraft.crafted:minecraft.brick_wall' | 'minecraft.dropped:minecraft.brick_wall' | 'minecraft.picked_up:minecraft.brick_wall' | 'minecraft.used:minecraft.brick_wall' | 'minecraft.crafted:minecraft.bricks' | 'minecraft.dropped:minecraft.bricks' | 'minecraft.picked_up:minecraft.bricks' | 'minecraft.used:minecraft.bricks' | 'minecraft.crafted:minecraft.brown_banner' | 'minecraft.dropped:minecraft.brown_banner' | 'minecraft.picked_up:minecraft.brown_banner' | 'minecraft.used:minecraft.brown_banner' | 'minecraft.crafted:minecraft.brown_bed' | 'minecraft.dropped:minecraft.brown_bed' | 'minecraft.picked_up:minecraft.brown_bed' | 'minecraft.used:minecraft.brown_bed' | 'minecraft.crafted:minecraft.brown_candle' | 'minecraft.dropped:minecraft.brown_candle' | 'minecraft.picked_up:minecraft.brown_candle' | 'minecraft.used:minecraft.brown_candle' | 'minecraft.crafted:minecraft.brown_carpet' | 'minecraft.dropped:minecraft.brown_carpet' | 'minecraft.picked_up:minecraft.brown_carpet' | 'minecraft.used:minecraft.brown_carpet' | 'minecraft.crafted:minecraft.brown_concrete' | 'minecraft.dropped:minecraft.brown_concrete' | 'minecraft.picked_up:minecraft.brown_concrete' | 'minecraft.used:minecraft.brown_concrete' | 'minecraft.crafted:minecraft.brown_concrete_powder' | 'minecraft.dropped:minecraft.brown_concrete_powder' | 'minecraft.picked_up:minecraft.brown_concrete_powder' | 'minecraft.used:minecraft.brown_concrete_powder' | 'minecraft.crafted:minecraft.brown_dye' | 'minecraft.dropped:minecraft.brown_dye' | 'minecraft.picked_up:minecraft.brown_dye' | 'minecraft.used:minecraft.brown_dye' | 'minecraft.crafted:minecraft.brown_glazed_terracotta' | 'minecraft.dropped:minecraft.brown_glazed_terracotta' | 'minecraft.picked_up:minecraft.brown_glazed_terracotta' | 'minecraft.used:minecraft.brown_glazed_terracotta' | 'minecraft.crafted:minecraft.brown_mushroom' | 'minecraft.dropped:minecraft.brown_mushroom' | 'minecraft.picked_up:minecraft.brown_mushroom' | 'minecraft.used:minecraft.brown_mushroom' | 'minecraft.crafted:minecraft.brown_mushroom_block' | 'minecraft.dropped:minecraft.brown_mushroom_block' | 'minecraft.picked_up:minecraft.brown_mushroom_block' | 'minecraft.used:minecraft.brown_mushroom_block' | 'minecraft.crafted:minecraft.brown_shulker_box' | 'minecraft.dropped:minecraft.brown_shulker_box' | 'minecraft.picked_up:minecraft.brown_shulker_box' | 'minecraft.used:minecraft.brown_shulker_box' | 'minecraft.crafted:minecraft.brown_stained_glass' | 'minecraft.dropped:minecraft.brown_stained_glass' | 'minecraft.picked_up:minecraft.brown_stained_glass' | 'minecraft.used:minecraft.brown_stained_glass' | 'minecraft.crafted:minecraft.brown_stained_glass_pane' | 'minecraft.dropped:minecraft.brown_stained_glass_pane' | 'minecraft.picked_up:minecraft.brown_stained_glass_pane' | 'minecraft.used:minecraft.brown_stained_glass_pane' | 'minecraft.crafted:minecraft.brown_terracotta' | 'minecraft.dropped:minecraft.brown_terracotta' | 'minecraft.picked_up:minecraft.brown_terracotta' | 'minecraft.used:minecraft.brown_terracotta' | 'minecraft.crafted:minecraft.brown_wool' | 'minecraft.dropped:minecraft.brown_wool' | 'minecraft.picked_up:minecraft.brown_wool' | 'minecraft.used:minecraft.brown_wool' | 'minecraft.crafted:minecraft.brush' | 'minecraft.dropped:minecraft.brush' | 'minecraft.picked_up:minecraft.brush' | 'minecraft.used:minecraft.brush' | 'minecraft.crafted:minecraft.bubble_coral' | 'minecraft.dropped:minecraft.bubble_coral' | 'minecraft.picked_up:minecraft.bubble_coral' | 'minecraft.used:minecraft.bubble_coral' | 'minecraft.crafted:minecraft.bubble_coral_block' | 'minecraft.dropped:minecraft.bubble_coral_block' | 'minecraft.picked_up:minecraft.bubble_coral_block' | 'minecraft.used:minecraft.bubble_coral_block' | 'minecraft.crafted:minecraft.bubble_coral_fan' | 'minecraft.dropped:minecraft.bubble_coral_fan' | 'minecraft.picked_up:minecraft.bubble_coral_fan' | 'minecraft.used:minecraft.bubble_coral_fan' | 'minecraft.crafted:minecraft.bucket' | 'minecraft.dropped:minecraft.bucket' | 'minecraft.picked_up:minecraft.bucket' | 'minecraft.used:minecraft.bucket' | 'minecraft.crafted:minecraft.budding_amethyst' | 'minecraft.dropped:minecraft.budding_amethyst' | 'minecraft.picked_up:minecraft.budding_amethyst' | 'minecraft.used:minecraft.budding_amethyst' | 'minecraft.crafted:minecraft.bundle' | 'minecraft.dropped:minecraft.bundle' | 'minecraft.picked_up:minecraft.bundle' | 'minecraft.used:minecraft.bundle' | 'minecraft.crafted:minecraft.burn_pottery_sherd' | 'minecraft.dropped:minecraft.burn_pottery_sherd' | 'minecraft.picked_up:minecraft.burn_pottery_sherd' | 'minecraft.used:minecraft.burn_pottery_sherd' | 'minecraft.crafted:minecraft.cactus' | 'minecraft.dropped:minecraft.cactus' | 'minecraft.picked_up:minecraft.cactus' | 'minecraft.used:minecraft.cactus' | 'minecraft.crafted:minecraft.cake' | 'minecraft.dropped:minecraft.cake' | 'minecraft.picked_up:minecraft.cake' | 'minecraft.used:minecraft.cake' | 'minecraft.crafted:minecraft.calcite' | 'minecraft.dropped:minecraft.calcite' | 'minecraft.picked_up:minecraft.calcite' | 'minecraft.used:minecraft.calcite' | 'minecraft.crafted:minecraft.calibrated_sculk_sensor' | 'minecraft.dropped:minecraft.calibrated_sculk_sensor' | 'minecraft.picked_up:minecraft.calibrated_sculk_sensor' | 'minecraft.used:minecraft.calibrated_sculk_sensor' | 'minecraft.crafted:minecraft.camel_spawn_egg' | 'minecraft.dropped:minecraft.camel_spawn_egg' | 'minecraft.picked_up:minecraft.camel_spawn_egg' | 'minecraft.used:minecraft.camel_spawn_egg' | 'minecraft.crafted:minecraft.campfire' | 'minecraft.dropped:minecraft.campfire' | 'minecraft.picked_up:minecraft.campfire' | 'minecraft.used:minecraft.campfire' | 'minecraft.crafted:minecraft.candle' | 'minecraft.dropped:minecraft.candle' | 'minecraft.picked_up:minecraft.candle' | 'minecraft.used:minecraft.candle' | 'minecraft.crafted:minecraft.carrot' | 'minecraft.dropped:minecraft.carrot' | 'minecraft.picked_up:minecraft.carrot' | 'minecraft.used:minecraft.carrot' | 'minecraft.crafted:minecraft.carrot_on_a_stick' | 'minecraft.dropped:minecraft.carrot_on_a_stick' | 'minecraft.picked_up:minecraft.carrot_on_a_stick' | 'minecraft.used:minecraft.carrot_on_a_stick' | 'minecraft.crafted:minecraft.cartography_table' | 'minecraft.dropped:minecraft.cartography_table' | 'minecraft.picked_up:minecraft.cartography_table' | 'minecraft.used:minecraft.cartography_table' | 'minecraft.crafted:minecraft.carved_pumpkin' | 'minecraft.dropped:minecraft.carved_pumpkin' | 'minecraft.picked_up:minecraft.carved_pumpkin' | 'minecraft.used:minecraft.carved_pumpkin' | 'minecraft.crafted:minecraft.cat_spawn_egg' | 'minecraft.dropped:minecraft.cat_spawn_egg' | 'minecraft.picked_up:minecraft.cat_spawn_egg' | 'minecraft.used:minecraft.cat_spawn_egg' | 'minecraft.crafted:minecraft.cauldron' | 'minecraft.dropped:minecraft.cauldron' | 'minecraft.picked_up:minecraft.cauldron' | 'minecraft.used:minecraft.cauldron' | 'minecraft.crafted:minecraft.cave_spider_spawn_egg' | 'minecraft.dropped:minecraft.cave_spider_spawn_egg' | 'minecraft.picked_up:minecraft.cave_spider_spawn_egg' | 'minecraft.used:minecraft.cave_spider_spawn_egg' | 'minecraft.crafted:minecraft.chain' | 'minecraft.dropped:minecraft.chain' | 'minecraft.picked_up:minecraft.chain' | 'minecraft.used:minecraft.chain' | 'minecraft.crafted:minecraft.chain_command_block' | 'minecraft.dropped:minecraft.chain_command_block' | 'minecraft.picked_up:minecraft.chain_command_block' | 'minecraft.used:minecraft.chain_command_block' | 'minecraft.crafted:minecraft.chainmail_boots' | 'minecraft.dropped:minecraft.chainmail_boots' | 'minecraft.picked_up:minecraft.chainmail_boots' | 'minecraft.used:minecraft.chainmail_boots' | 'minecraft.crafted:minecraft.chainmail_chestplate' | 'minecraft.dropped:minecraft.chainmail_chestplate' | 'minecraft.picked_up:minecraft.chainmail_chestplate' | 'minecraft.used:minecraft.chainmail_chestplate' | 'minecraft.crafted:minecraft.chainmail_helmet' | 'minecraft.dropped:minecraft.chainmail_helmet' | 'minecraft.picked_up:minecraft.chainmail_helmet' | 'minecraft.used:minecraft.chainmail_helmet' | 'minecraft.crafted:minecraft.chainmail_leggings' | 'minecraft.dropped:minecraft.chainmail_leggings' | 'minecraft.picked_up:minecraft.chainmail_leggings' | 'minecraft.used:minecraft.chainmail_leggings' | 'minecraft.crafted:minecraft.charcoal' | 'minecraft.dropped:minecraft.charcoal' | 'minecraft.picked_up:minecraft.charcoal' | 'minecraft.used:minecraft.charcoal' | 'minecraft.crafted:minecraft.cherry_boat' | 'minecraft.dropped:minecraft.cherry_boat' | 'minecraft.picked_up:minecraft.cherry_boat' | 'minecraft.used:minecraft.cherry_boat' | 'minecraft.crafted:minecraft.cherry_button' | 'minecraft.dropped:minecraft.cherry_button' | 'minecraft.picked_up:minecraft.cherry_button' | 'minecraft.used:minecraft.cherry_button' | 'minecraft.crafted:minecraft.cherry_chest_boat' | 'minecraft.dropped:minecraft.cherry_chest_boat' | 'minecraft.picked_up:minecraft.cherry_chest_boat' | 'minecraft.used:minecraft.cherry_chest_boat' | 'minecraft.crafted:minecraft.cherry_door' | 'minecraft.dropped:minecraft.cherry_door' | 'minecraft.picked_up:minecraft.cherry_door' | 'minecraft.used:minecraft.cherry_door' | 'minecraft.crafted:minecraft.cherry_fence' | 'minecraft.dropped:minecraft.cherry_fence' | 'minecraft.picked_up:minecraft.cherry_fence' | 'minecraft.used:minecraft.cherry_fence' | 'minecraft.crafted:minecraft.cherry_fence_gate' | 'minecraft.dropped:minecraft.cherry_fence_gate' | 'minecraft.picked_up:minecraft.cherry_fence_gate' | 'minecraft.used:minecraft.cherry_fence_gate' | 'minecraft.crafted:minecraft.cherry_hanging_sign' | 'minecraft.dropped:minecraft.cherry_hanging_sign' | 'minecraft.picked_up:minecraft.cherry_hanging_sign' | 'minecraft.used:minecraft.cherry_hanging_sign' | 'minecraft.crafted:minecraft.cherry_leaves' | 'minecraft.dropped:minecraft.cherry_leaves' | 'minecraft.picked_up:minecraft.cherry_leaves' | 'minecraft.used:minecraft.cherry_leaves' | 'minecraft.crafted:minecraft.cherry_log' | 'minecraft.dropped:minecraft.cherry_log' | 'minecraft.picked_up:minecraft.cherry_log' | 'minecraft.used:minecraft.cherry_log' | 'minecraft.crafted:minecraft.cherry_planks' | 'minecraft.dropped:minecraft.cherry_planks' | 'minecraft.picked_up:minecraft.cherry_planks' | 'minecraft.used:minecraft.cherry_planks' | 'minecraft.crafted:minecraft.cherry_pressure_plate' | 'minecraft.dropped:minecraft.cherry_pressure_plate' | 'minecraft.picked_up:minecraft.cherry_pressure_plate' | 'minecraft.used:minecraft.cherry_pressure_plate' | 'minecraft.crafted:minecraft.cherry_sapling' | 'minecraft.dropped:minecraft.cherry_sapling' | 'minecraft.picked_up:minecraft.cherry_sapling' | 'minecraft.used:minecraft.cherry_sapling' | 'minecraft.crafted:minecraft.cherry_sign' | 'minecraft.dropped:minecraft.cherry_sign' | 'minecraft.picked_up:minecraft.cherry_sign' | 'minecraft.used:minecraft.cherry_sign' | 'minecraft.crafted:minecraft.cherry_slab' | 'minecraft.dropped:minecraft.cherry_slab' | 'minecraft.picked_up:minecraft.cherry_slab' | 'minecraft.used:minecraft.cherry_slab' | 'minecraft.crafted:minecraft.cherry_stairs' | 'minecraft.dropped:minecraft.cherry_stairs' | 'minecraft.picked_up:minecraft.cherry_stairs' | 'minecraft.used:minecraft.cherry_stairs' | 'minecraft.crafted:minecraft.cherry_trapdoor' | 'minecraft.dropped:minecraft.cherry_trapdoor' | 'minecraft.picked_up:minecraft.cherry_trapdoor' | 'minecraft.used:minecraft.cherry_trapdoor' | 'minecraft.crafted:minecraft.cherry_wood' | 'minecraft.dropped:minecraft.cherry_wood' | 'minecraft.picked_up:minecraft.cherry_wood' | 'minecraft.used:minecraft.cherry_wood' | 'minecraft.crafted:minecraft.chest' | 'minecraft.dropped:minecraft.chest' | 'minecraft.picked_up:minecraft.chest' | 'minecraft.used:minecraft.chest' | 'minecraft.crafted:minecraft.chest_minecart' | 'minecraft.dropped:minecraft.chest_minecart' | 'minecraft.picked_up:minecraft.chest_minecart' | 'minecraft.used:minecraft.chest_minecart' | 'minecraft.crafted:minecraft.chicken' | 'minecraft.dropped:minecraft.chicken' | 'minecraft.picked_up:minecraft.chicken' | 'minecraft.used:minecraft.chicken' | 'minecraft.crafted:minecraft.chicken_spawn_egg' | 'minecraft.dropped:minecraft.chicken_spawn_egg' | 'minecraft.picked_up:minecraft.chicken_spawn_egg' | 'minecraft.used:minecraft.chicken_spawn_egg' | 'minecraft.crafted:minecraft.chipped_anvil' | 'minecraft.dropped:minecraft.chipped_anvil' | 'minecraft.picked_up:minecraft.chipped_anvil' | 'minecraft.used:minecraft.chipped_anvil' | 'minecraft.crafted:minecraft.chiseled_bookshelf' | 'minecraft.dropped:minecraft.chiseled_bookshelf' | 'minecraft.picked_up:minecraft.chiseled_bookshelf' | 'minecraft.used:minecraft.chiseled_bookshelf' | 'minecraft.crafted:minecraft.chiseled_copper' | 'minecraft.dropped:minecraft.chiseled_copper' | 'minecraft.picked_up:minecraft.chiseled_copper' | 'minecraft.used:minecraft.chiseled_copper' | 'minecraft.crafted:minecraft.chiseled_deepslate' | 'minecraft.dropped:minecraft.chiseled_deepslate' | 'minecraft.picked_up:minecraft.chiseled_deepslate' | 'minecraft.used:minecraft.chiseled_deepslate' | 'minecraft.crafted:minecraft.chiseled_nether_bricks' | 'minecraft.dropped:minecraft.chiseled_nether_bricks' | 'minecraft.picked_up:minecraft.chiseled_nether_bricks' | 'minecraft.used:minecraft.chiseled_nether_bricks' | 'minecraft.crafted:minecraft.chiseled_polished_blackstone' | 'minecraft.dropped:minecraft.chiseled_polished_blackstone' | 'minecraft.picked_up:minecraft.chiseled_polished_blackstone' | 'minecraft.used:minecraft.chiseled_polished_blackstone' | 'minecraft.crafted:minecraft.chiseled_quartz_block' | 'minecraft.dropped:minecraft.chiseled_quartz_block' | 'minecraft.picked_up:minecraft.chiseled_quartz_block' | 'minecraft.used:minecraft.chiseled_quartz_block' | 'minecraft.crafted:minecraft.chiseled_red_sandstone' | 'minecraft.dropped:minecraft.chiseled_red_sandstone' | 'minecraft.picked_up:minecraft.chiseled_red_sandstone' | 'minecraft.used:minecraft.chiseled_red_sandstone' | 'minecraft.crafted:minecraft.chiseled_sandstone' | 'minecraft.dropped:minecraft.chiseled_sandstone' | 'minecraft.picked_up:minecraft.chiseled_sandstone' | 'minecraft.used:minecraft.chiseled_sandstone' | 'minecraft.crafted:minecraft.chiseled_stone_bricks' | 'minecraft.dropped:minecraft.chiseled_stone_bricks' | 'minecraft.picked_up:minecraft.chiseled_stone_bricks' | 'minecraft.used:minecraft.chiseled_stone_bricks' | 'minecraft.crafted:minecraft.chiseled_tuff' | 'minecraft.dropped:minecraft.chiseled_tuff' | 'minecraft.picked_up:minecraft.chiseled_tuff' | 'minecraft.used:minecraft.chiseled_tuff' | 'minecraft.crafted:minecraft.chiseled_tuff_bricks' | 'minecraft.dropped:minecraft.chiseled_tuff_bricks' | 'minecraft.picked_up:minecraft.chiseled_tuff_bricks' | 'minecraft.used:minecraft.chiseled_tuff_bricks' | 'minecraft.crafted:minecraft.chorus_flower' | 'minecraft.dropped:minecraft.chorus_flower' | 'minecraft.picked_up:minecraft.chorus_flower' | 'minecraft.used:minecraft.chorus_flower' | 'minecraft.crafted:minecraft.chorus_fruit' | 'minecraft.dropped:minecraft.chorus_fruit' | 'minecraft.picked_up:minecraft.chorus_fruit' | 'minecraft.used:minecraft.chorus_fruit' | 'minecraft.crafted:minecraft.chorus_plant' | 'minecraft.dropped:minecraft.chorus_plant' | 'minecraft.picked_up:minecraft.chorus_plant' | 'minecraft.used:minecraft.chorus_plant' | 'minecraft.crafted:minecraft.clay' | 'minecraft.dropped:minecraft.clay' | 'minecraft.picked_up:minecraft.clay' | 'minecraft.used:minecraft.clay' | 'minecraft.crafted:minecraft.clay_ball' | 'minecraft.dropped:minecraft.clay_ball' | 'minecraft.picked_up:minecraft.clay_ball' | 'minecraft.used:minecraft.clay_ball' | 'minecraft.crafted:minecraft.clock' | 'minecraft.dropped:minecraft.clock' | 'minecraft.picked_up:minecraft.clock' | 'minecraft.used:minecraft.clock' | 'minecraft.crafted:minecraft.coal' | 'minecraft.dropped:minecraft.coal' | 'minecraft.picked_up:minecraft.coal' | 'minecraft.used:minecraft.coal' | 'minecraft.crafted:minecraft.coal_block' | 'minecraft.dropped:minecraft.coal_block' | 'minecraft.picked_up:minecraft.coal_block' | 'minecraft.used:minecraft.coal_block' | 'minecraft.crafted:minecraft.coal_ore' | 'minecraft.dropped:minecraft.coal_ore' | 'minecraft.picked_up:minecraft.coal_ore' | 'minecraft.used:minecraft.coal_ore' | 'minecraft.crafted:minecraft.coarse_dirt' | 'minecraft.dropped:minecraft.coarse_dirt' | 'minecraft.picked_up:minecraft.coarse_dirt' | 'minecraft.used:minecraft.coarse_dirt' | 'minecraft.crafted:minecraft.coast_armor_trim_smithing_template' | 'minecraft.dropped:minecraft.coast_armor_trim_smithing_template' | 'minecraft.picked_up:minecraft.coast_armor_trim_smithing_template' | 'minecraft.used:minecraft.coast_armor_trim_smithing_template' | 'minecraft.crafted:minecraft.cobbled_deepslate' | 'minecraft.dropped:minecraft.cobbled_deepslate' | 'minecraft.picked_up:minecraft.cobbled_deepslate' | 'minecraft.used:minecraft.cobbled_deepslate' | 'minecraft.crafted:minecraft.cobbled_deepslate_slab' | 'minecraft.dropped:minecraft.cobbled_deepslate_slab' | 'minecraft.picked_up:minecraft.cobbled_deepslate_slab' | 'minecraft.used:minecraft.cobbled_deepslate_slab' | 'minecraft.crafted:minecraft.cobbled_deepslate_stairs' | 'minecraft.dropped:minecraft.cobbled_deepslate_stairs' | 'minecraft.picked_up:minecraft.cobbled_deepslate_stairs' | 'minecraft.used:minecraft.cobbled_deepslate_stairs' | 'minecraft.crafted:minecraft.cobbled_deepslate_wall' | 'minecraft.dropped:minecraft.cobbled_deepslate_wall' | 'minecraft.picked_up:minecraft.cobbled_deepslate_wall' | 'minecraft.used:minecraft.cobbled_deepslate_wall' | 'minecraft.crafted:minecraft.cobblestone' | 'minecraft.dropped:minecraft.cobblestone' | 'minecraft.picked_up:minecraft.cobblestone' | 'minecraft.used:minecraft.cobblestone' | 'minecraft.crafted:minecraft.cobblestone_slab' | 'minecraft.dropped:minecraft.cobblestone_slab' | 'minecraft.picked_up:minecraft.cobblestone_slab' | 'minecraft.used:minecraft.cobblestone_slab' | 'minecraft.crafted:minecraft.cobblestone_stairs' | 'minecraft.dropped:minecraft.cobblestone_stairs' | 'minecraft.picked_up:minecraft.cobblestone_stairs' | 'minecraft.used:minecraft.cobblestone_stairs' | 'minecraft.crafted:minecraft.cobblestone_wall' | 'minecraft.dropped:minecraft.cobblestone_wall' | 'minecraft.picked_up:minecraft.cobblestone_wall' | 'minecraft.used:minecraft.cobblestone_wall' | 'minecraft.crafted:minecraft.cobweb' | 'minecraft.dropped:minecraft.cobweb' | 'minecraft.picked_up:minecraft.cobweb' | 'minecraft.used:minecraft.cobweb' | 'minecraft.crafted:minecraft.cocoa_beans' | 'minecraft.dropped:minecraft.cocoa_beans' | 'minecraft.picked_up:minecraft.cocoa_beans' | 'minecraft.used:minecraft.cocoa_beans' | 'minecraft.crafted:minecraft.cod' | 'minecraft.dropped:minecraft.cod' | 'minecraft.picked_up:minecraft.cod' | 'minecraft.used:minecraft.cod' | 'minecraft.crafted:minecraft.cod_bucket' | 'minecraft.dropped:minecraft.cod_bucket' | 'minecraft.picked_up:minecraft.cod_bucket' | 'minecraft.used:minecraft.cod_bucket' | 'minecraft.crafted:minecraft.cod_spawn_egg' | 'minecraft.dropped:minecraft.cod_spawn_egg' | 'minecraft.picked_up:minecraft.cod_spawn_egg' | 'minecraft.used:minecraft.cod_spawn_egg' | 'minecraft.crafted:minecraft.command_block' | 'minecraft.dropped:minecraft.command_block' | 'minecraft.picked_up:minecraft.command_block' | 'minecraft.used:minecraft.command_block' | 'minecraft.crafted:minecraft.command_block_minecart' | 'minecraft.dropped:minecraft.command_block_minecart' | 'minecraft.picked_up:minecraft.command_block_minecart' | 'minecraft.used:minecraft.command_block_minecart' | 'minecraft.crafted:minecraft.comparator' | 'minecraft.dropped:minecraft.comparator' | 'minecraft.picked_up:minecraft.comparator' | 'minecraft.used:minecraft.comparator' | 'minecraft.crafted:minecraft.compass' | 'minecraft.dropped:minecraft.compass' | 'minecraft.picked_up:minecraft.compass' | 'minecraft.used:minecraft.compass' | 'minecraft.crafted:minecraft.composter' | 'minecraft.dropped:minecraft.composter' | 'minecraft.picked_up:minecraft.composter' | 'minecraft.used:minecraft.composter' | 'minecraft.crafted:minecraft.conduit' | 'minecraft.dropped:minecraft.conduit' | 'minecraft.picked_up:minecraft.conduit' | 'minecraft.used:minecraft.conduit' | 'minecraft.crafted:minecraft.cooked_beef' | 'minecraft.dropped:minecraft.cooked_beef' | 'minecraft.picked_up:minecraft.cooked_beef' | 'minecraft.used:minecraft.cooked_beef' | 'minecraft.crafted:minecraft.cooked_chicken' | 'minecraft.dropped:minecraft.cooked_chicken' | 'minecraft.picked_up:minecraft.cooked_chicken' | 'minecraft.used:minecraft.cooked_chicken' | 'minecraft.crafted:minecraft.cooked_cod' | 'minecraft.dropped:minecraft.cooked_cod' | 'minecraft.picked_up:minecraft.cooked_cod' | 'minecraft.used:minecraft.cooked_cod' | 'minecraft.crafted:minecraft.cooked_mutton' | 'minecraft.dropped:minecraft.cooked_mutton' | 'minecraft.picked_up:minecraft.cooked_mutton' | 'minecraft.used:minecraft.cooked_mutton' | 'minecraft.crafted:minecraft.cooked_porkchop' | 'minecraft.dropped:minecraft.cooked_porkchop' | 'minecraft.picked_up:minecraft.cooked_porkchop' | 'minecraft.used:minecraft.cooked_porkchop' | 'minecraft.crafted:minecraft.cooked_rabbit' | 'minecraft.dropped:minecraft.cooked_rabbit' | 'minecraft.picked_up:minecraft.cooked_rabbit' | 'minecraft.used:minecraft.cooked_rabbit' | 'minecraft.crafted:minecraft.cooked_salmon' | 'minecraft.dropped:minecraft.cooked_salmon' | 'minecraft.picked_up:minecraft.cooked_salmon' | 'minecraft.used:minecraft.cooked_salmon' | 'minecraft.crafted:minecraft.cookie' | 'minecraft.dropped:minecraft.cookie' | 'minecraft.picked_up:minecraft.cookie' | 'minecraft.used:minecraft.cookie' | 'minecraft.crafted:minecraft.copper_block' | 'minecraft.dropped:minecraft.copper_block' | 'minecraft.picked_up:minecraft.copper_block' | 'minecraft.used:minecraft.copper_block' | 'minecraft.crafted:minecraft.copper_bulb' | 'minecraft.dropped:minecraft.copper_bulb' | 'minecraft.picked_up:minecraft.copper_bulb' | 'minecraft.used:minecraft.copper_bulb' | 'minecraft.crafted:minecraft.copper_door' | 'minecraft.dropped:minecraft.copper_door' | 'minecraft.picked_up:minecraft.copper_door' | 'minecraft.used:minecraft.copper_door' | 'minecraft.crafted:minecraft.copper_grate' | 'minecraft.dropped:minecraft.copper_grate' | 'minecraft.picked_up:minecraft.copper_grate' | 'minecraft.used:minecraft.copper_grate' | 'minecraft.crafted:minecraft.copper_ingot' | 'minecraft.dropped:minecraft.copper_ingot' | 'minecraft.picked_up:minecraft.copper_ingot' | 'minecraft.used:minecraft.copper_ingot' | 'minecraft.crafted:minecraft.copper_ore' | 'minecraft.dropped:minecraft.copper_ore' | 'minecraft.picked_up:minecraft.copper_ore' | 'minecraft.used:minecraft.copper_ore' | 'minecraft.crafted:minecraft.copper_trapdoor' | 'minecraft.dropped:minecraft.copper_trapdoor' | 'minecraft.picked_up:minecraft.copper_trapdoor' | 'minecraft.used:minecraft.copper_trapdoor' | 'minecraft.crafted:minecraft.cornflower' | 'minecraft.dropped:minecraft.cornflower' | 'minecraft.picked_up:minecraft.cornflower' | 'minecraft.used:minecraft.cornflower' | 'minecraft.crafted:minecraft.cow_spawn_egg' | 'minecraft.dropped:minecraft.cow_spawn_egg' | 'minecraft.picked_up:minecraft.cow_spawn_egg' | 'minecraft.used:minecraft.cow_spawn_egg' | 'minecraft.crafted:minecraft.cracked_deepslate_bricks' | 'minecraft.dropped:minecraft.cracked_deepslate_bricks' | 'minecraft.picked_up:minecraft.cracked_deepslate_bricks' | 'minecraft.used:minecraft.cracked_deepslate_bricks' | 'minecraft.crafted:minecraft.cracked_deepslate_tiles' | 'minecraft.dropped:minecraft.cracked_deepslate_tiles' | 'minecraft.picked_up:minecraft.cracked_deepslate_tiles' | 'minecraft.used:minecraft.cracked_deepslate_tiles' | 'minecraft.crafted:minecraft.cracked_nether_bricks' | 'minecraft.dropped:minecraft.cracked_nether_bricks' | 'minecraft.picked_up:minecraft.cracked_nether_bricks' | 'minecraft.used:minecraft.cracked_nether_bricks' | 'minecraft.crafted:minecraft.cracked_polished_blackstone_bricks' | 'minecraft.dropped:minecraft.cracked_polished_blackstone_bricks' | 'minecraft.picked_up:minecraft.cracked_polished_blackstone_bricks' | 'minecraft.used:minecraft.cracked_polished_blackstone_bricks' | 'minecraft.crafted:minecraft.cracked_stone_bricks' | 'minecraft.dropped:minecraft.cracked_stone_bricks' | 'minecraft.picked_up:minecraft.cracked_stone_bricks' | 'minecraft.used:minecraft.cracked_stone_bricks' | 'minecraft.crafted:minecraft.crafter' | 'minecraft.dropped:minecraft.crafter' | 'minecraft.picked_up:minecraft.crafter' | 'minecraft.used:minecraft.crafter' | 'minecraft.crafted:minecraft.crafting_table' | 'minecraft.dropped:minecraft.crafting_table' | 'minecraft.picked_up:minecraft.crafting_table' | 'minecraft.used:minecraft.crafting_table' | 'minecraft.crafted:minecraft.creeper_banner_pattern' | 'minecraft.dropped:minecraft.creeper_banner_pattern' | 'minecraft.picked_up:minecraft.creeper_banner_pattern' | 'minecraft.used:minecraft.creeper_banner_pattern' | 'minecraft.crafted:minecraft.creeper_head' | 'minecraft.dropped:minecraft.creeper_head' | 'minecraft.picked_up:minecraft.creeper_head' | 'minecraft.used:minecraft.creeper_head' | 'minecraft.crafted:minecraft.creeper_spawn_egg' | 'minecraft.dropped:minecraft.creeper_spawn_egg' | 'minecraft.picked_up:minecraft.creeper_spawn_egg' | 'minecraft.used:minecraft.creeper_spawn_egg' | 'minecraft.crafted:minecraft.crimson_button' | 'minecraft.dropped:minecraft.crimson_button' | 'minecraft.picked_up:minecraft.crimson_button' | 'minecraft.used:minecraft.crimson_button' | 'minecraft.crafted:minecraft.crimson_door' | 'minecraft.dropped:minecraft.crimson_door' | 'minecraft.picked_up:minecraft.crimson_door' | 'minecraft.used:minecraft.crimson_door' | 'minecraft.crafted:minecraft.crimson_fence' | 'minecraft.dropped:minecraft.crimson_fence' | 'minecraft.picked_up:minecraft.crimson_fence' | 'minecraft.used:minecraft.crimson_fence' | 'minecraft.crafted:minecraft.crimson_fence_gate' | 'minecraft.dropped:minecraft.crimson_fence_gate' | 'minecraft.picked_up:minecraft.crimson_fence_gate' | 'minecraft.used:minecraft.crimson_fence_gate' | 'minecraft.crafted:minecraft.crimson_fungus' | 'minecraft.dropped:minecraft.crimson_fungus' | 'minecraft.picked_up:minecraft.crimson_fungus' | 'minecraft.used:minecraft.crimson_fungus' | 'minecraft.crafted:minecraft.crimson_hanging_sign' | 'minecraft.dropped:minecraft.crimson_hanging_sign' | 'minecraft.picked_up:minecraft.crimson_hanging_sign' | 'minecraft.used:minecraft.crimson_hanging_sign' | 'minecraft.crafted:minecraft.crimson_hyphae' | 'minecraft.dropped:minecraft.crimson_hyphae' | 'minecraft.picked_up:minecraft.crimson_hyphae' | 'minecraft.used:minecraft.crimson_hyphae' | 'minecraft.crafted:minecraft.crimson_nylium' | 'minecraft.dropped:minecraft.crimson_nylium' | 'minecraft.picked_up:minecraft.crimson_nylium' | 'minecraft.used:minecraft.crimson_nylium' | 'minecraft.crafted:minecraft.crimson_planks' | 'minecraft.dropped:minecraft.crimson_planks' | 'minecraft.picked_up:minecraft.crimson_planks' | 'minecraft.used:minecraft.crimson_planks' | 'minecraft.crafted:minecraft.crimson_pressure_plate' | 'minecraft.dropped:minecraft.crimson_pressure_plate' | 'minecraft.picked_up:minecraft.crimson_pressure_plate' | 'minecraft.used:minecraft.crimson_pressure_plate' | 'minecraft.crafted:minecraft.crimson_roots' | 'minecraft.dropped:minecraft.crimson_roots' | 'minecraft.picked_up:minecraft.crimson_roots' | 'minecraft.used:minecraft.crimson_roots' | 'minecraft.crafted:minecraft.crimson_sign' | 'minecraft.dropped:minecraft.crimson_sign' | 'minecraft.picked_up:minecraft.crimson_sign' | 'minecraft.used:minecraft.crimson_sign' | 'minecraft.crafted:minecraft.crimson_slab' | 'minecraft.dropped:minecraft.crimson_slab' | 'minecraft.picked_up:minecraft.crimson_slab' | 'minecraft.used:minecraft.crimson_slab' | 'minecraft.crafted:minecraft.crimson_stairs' | 'minecraft.dropped:minecraft.crimson_stairs' | 'minecraft.picked_up:minecraft.crimson_stairs' | 'minecraft.used:minecraft.crimson_stairs' | 'minecraft.crafted:minecraft.crimson_stem' | 'minecraft.dropped:minecraft.crimson_stem' | 'minecraft.picked_up:minecraft.crimson_stem' | 'minecraft.used:minecraft.crimson_stem' | 'minecraft.crafted:minecraft.crimson_trapdoor' | 'minecraft.dropped:minecraft.crimson_trapdoor' | 'minecraft.picked_up:minecraft.crimson_trapdoor' | 'minecraft.used:minecraft.crimson_trapdoor' | 'minecraft.crafted:minecraft.crossbow' | 'minecraft.dropped:minecraft.crossbow' | 'minecraft.picked_up:minecraft.crossbow' | 'minecraft.used:minecraft.crossbow' | 'minecraft.crafted:minecraft.crying_obsidian' | 'minecraft.dropped:minecraft.crying_obsidian' | 'minecraft.picked_up:minecraft.crying_obsidian' | 'minecraft.used:minecraft.crying_obsidian' | 'minecraft.crafted:minecraft.cut_copper' | 'minecraft.dropped:minecraft.cut_copper' | 'minecraft.picked_up:minecraft.cut_copper' | 'minecraft.used:minecraft.cut_copper' | 'minecraft.crafted:minecraft.cut_copper_slab' | 'minecraft.dropped:minecraft.cut_copper_slab' | 'minecraft.picked_up:minecraft.cut_copper_slab' | 'minecraft.used:minecraft.cut_copper_slab' | 'minecraft.crafted:minecraft.cut_copper_stairs' | 'minecraft.dropped:minecraft.cut_copper_stairs' | 'minecraft.picked_up:minecraft.cut_copper_stairs' | 'minecraft.used:minecraft.cut_copper_stairs' | 'minecraft.crafted:minecraft.cut_red_sandstone' | 'minecraft.dropped:minecraft.cut_red_sandstone' | 'minecraft.picked_up:minecraft.cut_red_sandstone' | 'minecraft.used:minecraft.cut_red_sandstone' | 'minecraft.crafted:minecraft.cut_red_sandstone_slab' | 'minecraft.dropped:minecraft.cut_red_sandstone_slab' | 'minecraft.picked_up:minecraft.cut_red_sandstone_slab' | 'minecraft.used:minecraft.cut_red_sandstone_slab' | 'minecraft.crafted:minecraft.cut_sandstone' | 'minecraft.dropped:minecraft.cut_sandstone' | 'minecraft.picked_up:minecraft.cut_sandstone' | 'minecraft.used:minecraft.cut_sandstone' | 'minecraft.crafted:minecraft.cut_sandstone_slab' | 'minecraft.dropped:minecraft.cut_sandstone_slab' | 'minecraft.picked_up:minecraft.cut_sandstone_slab' | 'minecraft.used:minecraft.cut_sandstone_slab' | 'minecraft.crafted:minecraft.cyan_banner' | 'minecraft.dropped:minecraft.cyan_banner' | 'minecraft.picked_up:minecraft.cyan_banner' | 'minecraft.used:minecraft.cyan_banner' | 'minecraft.crafted:minecraft.cyan_bed' | 'minecraft.dropped:minecraft.cyan_bed' | 'minecraft.picked_up:minecraft.cyan_bed' | 'minecraft.used:minecraft.cyan_bed' | 'minecraft.crafted:minecraft.cyan_candle' | 'minecraft.dropped:minecraft.cyan_candle' | 'minecraft.picked_up:minecraft.cyan_candle' | 'minecraft.used:minecraft.cyan_candle' | 'minecraft.crafted:minecraft.cyan_carpet' | 'minecraft.dropped:minecraft.cyan_carpet' | 'minecraft.picked_up:minecraft.cyan_carpet' | 'minecraft.used:minecraft.cyan_carpet' | 'minecraft.crafted:minecraft.cyan_concrete' | 'minecraft.dropped:minecraft.cyan_concrete' | 'minecraft.picked_up:minecraft.cyan_concrete' | 'minecraft.used:minecraft.cyan_concrete' | 'minecraft.crafted:minecraft.cyan_concrete_powder' | 'minecraft.dropped:minecraft.cyan_concrete_powder' | 'minecraft.picked_up:minecraft.cyan_concrete_powder' | 'minecraft.used:minecraft.cyan_concrete_powder' | 'minecraft.crafted:minecraft.cyan_dye' | 'minecraft.dropped:minecraft.cyan_dye' | 'minecraft.picked_up:minecraft.cyan_dye' | 'minecraft.used:minecraft.cyan_dye' | 'minecraft.crafted:minecraft.cyan_glazed_terracotta' | 'minecraft.dropped:minecraft.cyan_glazed_terracotta' | 'minecraft.picked_up:minecraft.cyan_glazed_terracotta' | 'minecraft.used:minecraft.cyan_glazed_terracotta' | 'minecraft.crafted:minecraft.cyan_shulker_box' | 'minecraft.dropped:minecraft.cyan_shulker_box' | 'minecraft.picked_up:minecraft.cyan_shulker_box' | 'minecraft.used:minecraft.cyan_shulker_box' | 'minecraft.crafted:minecraft.cyan_stained_glass' | 'minecraft.dropped:minecraft.cyan_stained_glass' | 'minecraft.picked_up:minecraft.cyan_stained_glass' | 'minecraft.used:minecraft.cyan_stained_glass' | 'minecraft.crafted:minecraft.cyan_stained_glass_pane' | 'minecraft.dropped:minecraft.cyan_stained_glass_pane' | 'minecraft.picked_up:minecraft.cyan_stained_glass_pane' | 'minecraft.used:minecraft.cyan_stained_glass_pane' | 'minecraft.crafted:minecraft.cyan_terracotta' | 'minecraft.dropped:minecraft.cyan_terracotta' | 'minecraft.picked_up:minecraft.cyan_terracotta' | 'minecraft.used:minecraft.cyan_terracotta' | 'minecraft.crafted:minecraft.cyan_wool' | 'minecraft.dropped:minecraft.cyan_wool' | 'minecraft.picked_up:minecraft.cyan_wool' | 'minecraft.used:minecraft.cyan_wool' | 'minecraft.crafted:minecraft.damaged_anvil' | 'minecraft.dropped:minecraft.damaged_anvil' | 'minecraft.picked_up:minecraft.damaged_anvil' | 'minecraft.used:minecraft.damaged_anvil' | 'minecraft.crafted:minecraft.dandelion' | 'minecraft.dropped:minecraft.dandelion' | 'minecraft.picked_up:minecraft.dandelion' | 'minecraft.used:minecraft.dandelion' | 'minecraft.crafted:minecraft.danger_pottery_sherd' | 'minecraft.dropped:minecraft.danger_pottery_sherd' | 'minecraft.picked_up:minecraft.danger_pottery_sherd' | 'minecraft.used:minecraft.danger_pottery_sherd' | 'minecraft.crafted:minecraft.dark_oak_boat' | 'minecraft.dropped:minecraft.dark_oak_boat' | 'minecraft.picked_up:minecraft.dark_oak_boat' | 'minecraft.used:minecraft.dark_oak_boat' | 'minecraft.crafted:minecraft.dark_oak_button' | 'minecraft.dropped:minecraft.dark_oak_button' | 'minecraft.picked_up:minecraft.dark_oak_button' | 'minecraft.used:minecraft.dark_oak_button' | 'minecraft.crafted:minecraft.dark_oak_chest_boat' | 'minecraft.dropped:minecraft.dark_oak_chest_boat' | 'minecraft.picked_up:minecraft.dark_oak_chest_boat' | 'minecraft.used:minecraft.dark_oak_chest_boat' | 'minecraft.crafted:minecraft.dark_oak_door' | 'minecraft.dropped:minecraft.dark_oak_door' | 'minecraft.picked_up:minecraft.dark_oak_door' | 'minecraft.used:minecraft.dark_oak_door' | 'minecraft.crafted:minecraft.dark_oak_fence' | 'minecraft.dropped:minecraft.dark_oak_fence' | 'minecraft.picked_up:minecraft.dark_oak_fence' | 'minecraft.used:minecraft.dark_oak_fence' | 'minecraft.crafted:minecraft.dark_oak_fence_gate' | 'minecraft.dropped:minecraft.dark_oak_fence_gate' | 'minecraft.picked_up:minecraft.dark_oak_fence_gate' | 'minecraft.used:minecraft.dark_oak_fence_gate' | 'minecraft.crafted:minecraft.dark_oak_hanging_sign' | 'minecraft.dropped:minecraft.dark_oak_hanging_sign' | 'minecraft.picked_up:minecraft.dark_oak_hanging_sign' | 'minecraft.used:minecraft.dark_oak_hanging_sign' | 'minecraft.crafted:minecraft.dark_oak_leaves' | 'minecraft.dropped:minecraft.dark_oak_leaves' | 'minecraft.picked_up:minecraft.dark_oak_leaves' | 'minecraft.used:minecraft.dark_oak_leaves' | 'minecraft.crafted:minecraft.dark_oak_log' | 'minecraft.dropped:minecraft.dark_oak_log' | 'minecraft.picked_up:minecraft.dark_oak_log' | 'minecraft.used:minecraft.dark_oak_log' | 'minecraft.crafted:minecraft.dark_oak_planks' | 'minecraft.dropped:minecraft.dark_oak_planks' | 'minecraft.picked_up:minecraft.dark_oak_planks' | 'minecraft.used:minecraft.dark_oak_planks' | 'minecraft.crafted:minecraft.dark_oak_pressure_plate' | 'minecraft.dropped:minecraft.dark_oak_pressure_plate' | 'minecraft.picked_up:minecraft.dark_oak_pressure_plate' | 'minecraft.used:minecraft.dark_oak_pressure_plate' | 'minecraft.crafted:minecraft.dark_oak_sapling' | 'minecraft.dropped:minecraft.dark_oak_sapling' | 'minecraft.picked_up:minecraft.dark_oak_sapling' | 'minecraft.used:minecraft.dark_oak_sapling' | 'minecraft.crafted:minecraft.dark_oak_sign' | 'minecraft.dropped:minecraft.dark_oak_sign' | 'minecraft.picked_up:minecraft.dark_oak_sign' | 'minecraft.used:minecraft.dark_oak_sign' | 'minecraft.crafted:minecraft.dark_oak_slab' | 'minecraft.dropped:minecraft.dark_oak_slab' | 'minecraft.picked_up:minecraft.dark_oak_slab' | 'minecraft.used:minecraft.dark_oak_slab' | 'minecraft.crafted:minecraft.dark_oak_stairs' | 'minecraft.dropped:minecraft.dark_oak_stairs' | 'minecraft.picked_up:minecraft.dark_oak_stairs' | 'minecraft.used:minecraft.dark_oak_stairs' | 'minecraft.crafted:minecraft.dark_oak_trapdoor' | 'minecraft.dropped:minecraft.dark_oak_trapdoor' | 'minecraft.picked_up:minecraft.dark_oak_trapdoor' | 'minecraft.used:minecraft.dark_oak_trapdoor' | 'minecraft.crafted:minecraft.dark_oak_wood' | 'minecraft.dropped:minecraft.dark_oak_wood' | 'minecraft.picked_up:minecraft.dark_oak_wood' | 'minecraft.used:minecraft.dark_oak_wood' | 'minecraft.crafted:minecraft.dark_prismarine' | 'minecraft.dropped:minecraft.dark_prismarine' | 'minecraft.picked_up:minecraft.dark_prismarine' | 'minecraft.used:minecraft.dark_prismarine' | 'minecraft.crafted:minecraft.dark_prismarine_slab' | 'minecraft.dropped:minecraft.dark_prismarine_slab' | 'minecraft.picked_up:minecraft.dark_prismarine_slab' | 'minecraft.used:minecraft.dark_prismarine_slab' | 'minecraft.crafted:minecraft.dark_prismarine_stairs' | 'minecraft.dropped:minecraft.dark_prismarine_stairs' | 'minecraft.picked_up:minecraft.dark_prismarine_stairs' | 'minecraft.used:minecraft.dark_prismarine_stairs' | 'minecraft.crafted:minecraft.daylight_detector' | 'minecraft.dropped:minecraft.daylight_detector' | 'minecraft.picked_up:minecraft.daylight_detector' | 'minecraft.used:minecraft.daylight_detector' | 'minecraft.crafted:minecraft.dead_brain_coral' | 'minecraft.dropped:minecraft.dead_brain_coral' | 'minecraft.picked_up:minecraft.dead_brain_coral' | 'minecraft.used:minecraft.dead_brain_coral' | 'minecraft.crafted:minecraft.dead_brain_coral_block' | 'minecraft.dropped:minecraft.dead_brain_coral_block' | 'minecraft.picked_up:minecraft.dead_brain_coral_block' | 'minecraft.used:minecraft.dead_brain_coral_block' | 'minecraft.crafted:minecraft.dead_brain_coral_fan' | 'minecraft.dropped:minecraft.dead_brain_coral_fan' | 'minecraft.picked_up:minecraft.dead_brain_coral_fan' | 'minecraft.used:minecraft.dead_brain_coral_fan' | 'minecraft.crafted:minecraft.dead_bubble_coral' | 'minecraft.dropped:minecraft.dead_bubble_coral' | 'minecraft.picked_up:minecraft.dead_bubble_coral' | 'minecraft.used:minecraft.dead_bubble_coral' | 'minecraft.crafted:minecraft.dead_bubble_coral_block' | 'minecraft.dropped:minecraft.dead_bubble_coral_block' | 'minecraft.picked_up:minecraft.dead_bubble_coral_block' | 'minecraft.used:minecraft.dead_bubble_coral_block' | 'minecraft.crafted:minecraft.dead_bubble_coral_fan' | 'minecraft.dropped:minecraft.dead_bubble_coral_fan' | 'minecraft.picked_up:minecraft.dead_bubble_coral_fan' | 'minecraft.used:minecraft.dead_bubble_coral_fan' | 'minecraft.crafted:minecraft.dead_bush' | 'minecraft.dropped:minecraft.dead_bush' | 'minecraft.picked_up:minecraft.dead_bush' | 'minecraft.used:minecraft.dead_bush' | 'minecraft.crafted:minecraft.dead_fire_coral' | 'minecraft.dropped:minecraft.dead_fire_coral' | 'minecraft.picked_up:minecraft.dead_fire_coral' | 'minecraft.used:minecraft.dead_fire_coral' | 'minecraft.crafted:minecraft.dead_fire_coral_block' | 'minecraft.dropped:minecraft.dead_fire_coral_block' | 'minecraft.picked_up:minecraft.dead_fire_coral_block' | 'minecraft.used:minecraft.dead_fire_coral_block' | 'minecraft.crafted:minecraft.dead_fire_coral_fan' | 'minecraft.dropped:minecraft.dead_fire_coral_fan' | 'minecraft.picked_up:minecraft.dead_fire_coral_fan' | 'minecraft.used:minecraft.dead_fire_coral_fan' | 'minecraft.crafted:minecraft.dead_horn_coral' | 'minecraft.dropped:minecraft.dead_horn_coral' | 'minecraft.picked_up:minecraft.dead_horn_coral' | 'minecraft.used:minecraft.dead_horn_coral' | 'minecraft.crafted:minecraft.dead_horn_coral_block' | 'minecraft.dropped:minecraft.dead_horn_coral_block' | 'minecraft.picked_up:minecraft.dead_horn_coral_block' | 'minecraft.used:minecraft.dead_horn_coral_block' | 'minecraft.crafted:minecraft.dead_horn_coral_fan' | 'minecraft.dropped:minecraft.dead_horn_coral_fan' | 'minecraft.picked_up:minecraft.dead_horn_coral_fan' | 'minecraft.used:minecraft.dead_horn_coral_fan' | 'minecraft.crafted:minecraft.dead_tube_coral' | 'minecraft.dropped:minecraft.dead_tube_coral' | 'minecraft.picked_up:minecraft.dead_tube_coral' | 'minecraft.used:minecraft.dead_tube_coral' | 'minecraft.crafted:minecraft.dead_tube_coral_block' | 'minecraft.dropped:minecraft.dead_tube_coral_block' | 'minecraft.picked_up:minecraft.dead_tube_coral_block' | 'minecraft.used:minecraft.dead_tube_coral_block' | 'minecraft.crafted:minecraft.dead_tube_coral_fan' | 'minecraft.dropped:minecraft.dead_tube_coral_fan' | 'minecraft.picked_up:minecraft.dead_tube_coral_fan' | 'minecraft.used:minecraft.dead_tube_coral_fan' | 'minecraft.crafted:minecraft.debug_stick' | 'minecraft.dropped:minecraft.debug_stick' | 'minecraft.picked_up:minecraft.debug_stick' | 'minecraft.used:minecraft.debug_stick' | 'minecraft.crafted:minecraft.decorated_pot' | 'minecraft.dropped:minecraft.decorated_pot' | 'minecraft.picked_up:minecraft.decorated_pot' | 'minecraft.used:minecraft.decorated_pot' | 'minecraft.crafted:minecraft.deepslate' | 'minecraft.dropped:minecraft.deepslate' | 'minecraft.picked_up:minecraft.deepslate' | 'minecraft.used:minecraft.deepslate' | 'minecraft.crafted:minecraft.deepslate_brick_slab' | 'minecraft.dropped:minecraft.deepslate_brick_slab' | 'minecraft.picked_up:minecraft.deepslate_brick_slab' | 'minecraft.used:minecraft.deepslate_brick_slab' | 'minecraft.crafted:minecraft.deepslate_brick_stairs' | 'minecraft.dropped:minecraft.deepslate_brick_stairs' | 'minecraft.picked_up:minecraft.deepslate_brick_stairs' | 'minecraft.used:minecraft.deepslate_brick_stairs' | 'minecraft.crafted:minecraft.deepslate_brick_wall' | 'minecraft.dropped:minecraft.deepslate_brick_wall' | 'minecraft.picked_up:minecraft.deepslate_brick_wall' | 'minecraft.used:minecraft.deepslate_brick_wall' | 'minecraft.crafted:minecraft.deepslate_bricks' | 'minecraft.dropped:minecraft.deepslate_bricks' | 'minecraft.picked_up:minecraft.deepslate_bricks' | 'minecraft.used:minecraft.deepslate_bricks' | 'minecraft.crafted:minecraft.deepslate_coal_ore' | 'minecraft.dropped:minecraft.deepslate_coal_ore' | 'minecraft.picked_up:minecraft.deepslate_coal_ore' | 'minecraft.used:minecraft.deepslate_coal_ore' | 'minecraft.crafted:minecraft.deepslate_copper_ore' | 'minecraft.dropped:minecraft.deepslate_copper_ore' | 'minecraft.picked_up:minecraft.deepslate_copper_ore' | 'minecraft.used:minecraft.deepslate_copper_ore' | 'minecraft.crafted:minecraft.deepslate_diamond_ore' | 'minecraft.dropped:minecraft.deepslate_diamond_ore' | 'minecraft.picked_up:minecraft.deepslate_diamond_ore' | 'minecraft.used:minecraft.deepslate_diamond_ore' | 'minecraft.crafted:minecraft.deepslate_emerald_ore' | 'minecraft.dropped:minecraft.deepslate_emerald_ore' | 'minecraft.picked_up:minecraft.deepslate_emerald_ore' | 'minecraft.used:minecraft.deepslate_emerald_ore' | 'minecraft.crafted:minecraft.deepslate_gold_ore' | 'minecraft.dropped:minecraft.deepslate_gold_ore' | 'minecraft.picked_up:minecraft.deepslate_gold_ore' | 'minecraft.used:minecraft.deepslate_gold_ore' | 'minecraft.crafted:minecraft.deepslate_iron_ore' | 'minecraft.dropped:minecraft.deepslate_iron_ore' | 'minecraft.picked_up:minecraft.deepslate_iron_ore' | 'minecraft.used:minecraft.deepslate_iron_ore' | 'minecraft.crafted:minecraft.deepslate_lapis_ore' | 'minecraft.dropped:minecraft.deepslate_lapis_ore' | 'minecraft.picked_up:minecraft.deepslate_lapis_ore' | 'minecraft.used:minecraft.deepslate_lapis_ore' | 'minecraft.crafted:minecraft.deepslate_redstone_ore' | 'minecraft.dropped:minecraft.deepslate_redstone_ore' | 'minecraft.picked_up:minecraft.deepslate_redstone_ore' | 'minecraft.used:minecraft.deepslate_redstone_ore' | 'minecraft.crafted:minecraft.deepslate_tile_slab' | 'minecraft.dropped:minecraft.deepslate_tile_slab' | 'minecraft.picked_up:minecraft.deepslate_tile_slab' | 'minecraft.used:minecraft.deepslate_tile_slab' | 'minecraft.crafted:minecraft.deepslate_tile_stairs' | 'minecraft.dropped:minecraft.deepslate_tile_stairs' | 'minecraft.picked_up:minecraft.deepslate_tile_stairs' | 'minecraft.used:minecraft.deepslate_tile_stairs' | 'minecraft.crafted:minecraft.deepslate_tile_wall' | 'minecraft.dropped:minecraft.deepslate_tile_wall' | 'minecraft.picked_up:minecraft.deepslate_tile_wall' | 'minecraft.used:minecraft.deepslate_tile_wall' | 'minecraft.crafted:minecraft.deepslate_tiles' | 'minecraft.dropped:minecraft.deepslate_tiles' | 'minecraft.picked_up:minecraft.deepslate_tiles' | 'minecraft.used:minecraft.deepslate_tiles' | 'minecraft.crafted:minecraft.detector_rail' | 'minecraft.dropped:minecraft.detector_rail' | 'minecraft.picked_up:minecraft.detector_rail' | 'minecraft.used:minecraft.detector_rail' | 'minecraft.crafted:minecraft.diamond' | 'minecraft.dropped:minecraft.diamond' | 'minecraft.picked_up:minecraft.diamond' | 'minecraft.used:minecraft.diamond' | 'minecraft.crafted:minecraft.diamond_axe' | 'minecraft.dropped:minecraft.diamond_axe' | 'minecraft.picked_up:minecraft.diamond_axe' | 'minecraft.used:minecraft.diamond_axe' | 'minecraft.crafted:minecraft.diamond_block' | 'minecraft.dropped:minecraft.diamond_block' | 'minecraft.picked_up:minecraft.diamond_block' | 'minecraft.used:minecraft.diamond_block' | 'minecraft.crafted:minecraft.diamond_boots' | 'minecraft.dropped:minecraft.diamond_boots' | 'minecraft.picked_up:minecraft.diamond_boots' | 'minecraft.used:minecraft.diamond_boots' | 'minecraft.crafted:minecraft.diamond_chestplate' | 'minecraft.dropped:minecraft.diamond_chestplate' | 'minecraft.picked_up:minecraft.diamond_chestplate' | 'minecraft.used:minecraft.diamond_chestplate' | 'minecraft.crafted:minecraft.diamond_helmet' | 'minecraft.dropped:minecraft.diamond_helmet' | 'minecraft.picked_up:minecraft.diamond_helmet' | 'minecraft.used:minecraft.diamond_helmet' | 'minecraft.crafted:minecraft.diamond_hoe' | 'minecraft.dropped:minecraft.diamond_hoe' | 'minecraft.picked_up:minecraft.diamond_hoe' | 'minecraft.used:minecraft.diamond_hoe' | 'minecraft.crafted:minecraft.diamond_horse_armor' | 'minecraft.dropped:minecraft.diamond_horse_armor' | 'minecraft.picked_up:minecraft.diamond_horse_armor' | 'minecraft.used:minecraft.diamond_horse_armor' | 'minecraft.crafted:minecraft.diamond_leggings' | 'minecraft.dropped:minecraft.diamond_leggings' | 'minecraft.picked_up:minecraft.diamond_leggings' | 'minecraft.used:minecraft.diamond_leggings' | 'minecraft.crafted:minecraft.diamond_ore' | 'minecraft.dropped:minecraft.diamond_ore' | 'minecraft.picked_up:minecraft.diamond_ore' | 'minecraft.used:minecraft.diamond_ore' | 'minecraft.crafted:minecraft.diamond_pickaxe' | 'minecraft.dropped:minecraft.diamond_pickaxe' | 'minecraft.picked_up:minecraft.diamond_pickaxe' | 'minecraft.used:minecraft.diamond_pickaxe' | 'minecraft.crafted:minecraft.diamond_shovel' | 'minecraft.dropped:minecraft.diamond_shovel' | 'minecraft.picked_up:minecraft.diamond_shovel' | 'minecraft.used:minecraft.diamond_shovel' | 'minecraft.crafted:minecraft.diamond_sword' | 'minecraft.dropped:minecraft.diamond_sword' | 'minecraft.picked_up:minecraft.diamond_sword' | 'minecraft.used:minecraft.diamond_sword' | 'minecraft.crafted:minecraft.diorite' | 'minecraft.dropped:minecraft.diorite' | 'minecraft.picked_up:minecraft.diorite' | 'minecraft.used:minecraft.diorite' | 'minecraft.crafted:minecraft.diorite_slab' | 'minecraft.dropped:minecraft.diorite_slab' | 'minecraft.picked_up:minecraft.diorite_slab' | 'minecraft.used:minecraft.diorite_slab' | 'minecraft.crafted:minecraft.diorite_stairs' | 'minecraft.dropped:minecraft.diorite_stairs' | 'minecraft.picked_up:minecraft.diorite_stairs' | 'minecraft.used:minecraft.diorite_stairs' | 'minecraft.crafted:minecraft.diorite_wall' | 'minecraft.dropped:minecraft.diorite_wall' | 'minecraft.picked_up:minecraft.diorite_wall' | 'minecraft.used:minecraft.diorite_wall' | 'minecraft.crafted:minecraft.dirt' | 'minecraft.dropped:minecraft.dirt' | 'minecraft.picked_up:minecraft.dirt' | 'minecraft.used:minecraft.dirt' | 'minecraft.crafted:minecraft.dirt_path' | 'minecraft.dropped:minecraft.dirt_path' | 'minecraft.picked_up:minecraft.dirt_path' | 'minecraft.used:minecraft.dirt_path' | 'minecraft.crafted:minecraft.disc_fragment_5' | 'minecraft.dropped:minecraft.disc_fragment_5' | 'minecraft.picked_up:minecraft.disc_fragment_5' | 'minecraft.used:minecraft.disc_fragment_5' | 'minecraft.crafted:minecraft.dispenser' | 'minecraft.dropped:minecraft.dispenser' | 'minecraft.picked_up:minecraft.dispenser' | 'minecraft.used:minecraft.dispenser' | 'minecraft.crafted:minecraft.dolphin_spawn_egg' | 'minecraft.dropped:minecraft.dolphin_spawn_egg' | 'minecraft.picked_up:minecraft.dolphin_spawn_egg' | 'minecraft.used:minecraft.dolphin_spawn_egg' | 'minecraft.crafted:minecraft.donkey_spawn_egg' | 'minecraft.dropped:minecraft.donkey_spawn_egg' | 'minecraft.picked_up:minecraft.donkey_spawn_egg' | 'minecraft.used:minecraft.donkey_spawn_egg' | 'minecraft.crafted:minecraft.dragon_breath' | 'minecraft.dropped:minecraft.dragon_breath' | 'minecraft.picked_up:minecraft.dragon_breath' | 'minecraft.used:minecraft.dragon_breath' | 'minecraft.crafted:minecraft.dragon_egg' | 'minecraft.dropped:minecraft.dragon_egg' | 'minecraft.picked_up:minecraft.dragon_egg' | 'minecraft.used:minecraft.dragon_egg' | 'minecraft.crafted:minecraft.dragon_head' | 'minecraft.dropped:minecraft.dragon_head' | 'minecraft.picked_up:minecraft.dragon_head' | 'minecraft.used:minecraft.dragon_head' | 'minecraft.crafted:minecraft.dried_kelp' | 'minecraft.dropped:minecraft.dried_kelp' | 'minecraft.picked_up:minecraft.dried_kelp' | 'minecraft.used:minecraft.dried_kelp' | 'minecraft.crafted:minecraft.dried_kelp_block' | 'minecraft.dropped:minecraft.dried_kelp_block' | 'minecraft.picked_up:minecraft.dried_kelp_block' | 'minecraft.used:minecraft.dried_kelp_block' | 'minecraft.crafted:minecraft.dripstone_block' | 'minecraft.dropped:minecraft.dripstone_block' | 'minecraft.picked_up:minecraft.dripstone_block' | 'minecraft.used:minecraft.dripstone_block' | 'minecraft.crafted:minecraft.dropper' | 'minecraft.dropped:minecraft.dropper' | 'minecraft.picked_up:minecraft.dropper' | 'minecraft.used:minecraft.dropper' | 'minecraft.crafted:minecraft.drowned_spawn_egg' | 'minecraft.dropped:minecraft.drowned_spawn_egg' | 'minecraft.picked_up:minecraft.drowned_spawn_egg' | 'minecraft.used:minecraft.drowned_spawn_egg' | 'minecraft.crafted:minecraft.dune_armor_trim_smithing_template' | 'minecraft.dropped:minecraft.dune_armor_trim_smithing_template' | 'minecraft.picked_up:minecraft.dune_armor_trim_smithing_template' | 'minecraft.used:minecraft.dune_armor_trim_smithing_template' | 'minecraft.crafted:minecraft.echo_shard' | 'minecraft.dropped:minecraft.echo_shard' | 'minecraft.picked_up:minecraft.echo_shard' | 'minecraft.used:minecraft.echo_shard' | 'minecraft.crafted:minecraft.egg' | 'minecraft.dropped:minecraft.egg' | 'minecraft.picked_up:minecraft.egg' | 'minecraft.used:minecraft.egg' | 'minecraft.crafted:minecraft.elder_guardian_spawn_egg' | 'minecraft.dropped:minecraft.elder_guardian_spawn_egg' | 'minecraft.picked_up:minecraft.elder_guardian_spawn_egg' | 'minecraft.used:minecraft.elder_guardian_spawn_egg' | 'minecraft.crafted:minecraft.elytra' | 'minecraft.dropped:minecraft.elytra' | 'minecraft.picked_up:minecraft.elytra' | 'minecraft.used:minecraft.elytra' | 'minecraft.crafted:minecraft.emerald' | 'minecraft.dropped:minecraft.emerald' | 'minecraft.picked_up:minecraft.emerald' | 'minecraft.used:minecraft.emerald' | 'minecraft.crafted:minecraft.emerald_block' | 'minecraft.dropped:minecraft.emerald_block' | 'minecraft.picked_up:minecraft.emerald_block' | 'minecraft.used:minecraft.emerald_block' | 'minecraft.crafted:minecraft.emerald_ore' | 'minecraft.dropped:minecraft.emerald_ore' | 'minecraft.picked_up:minecraft.emerald_ore' | 'minecraft.used:minecraft.emerald_ore' | 'minecraft.crafted:minecraft.enchanted_book' | 'minecraft.dropped:minecraft.enchanted_book' | 'minecraft.picked_up:minecraft.enchanted_book' | 'minecraft.used:minecraft.enchanted_book' | 'minecraft.crafted:minecraft.enchanted_golden_apple' | 'minecraft.dropped:minecraft.enchanted_golden_apple' | 'minecraft.picked_up:minecraft.enchanted_golden_apple' | 'minecraft.used:minecraft.enchanted_golden_apple' | 'minecraft.crafted:minecraft.enchanting_table' | 'minecraft.dropped:minecraft.enchanting_table' | 'minecraft.picked_up:minecraft.enchanting_table' | 'minecraft.used:minecraft.enchanting_table' | 'minecraft.crafted:minecraft.end_crystal' | 'minecraft.dropped:minecraft.end_crystal' | 'minecraft.picked_up:minecraft.end_crystal' | 'minecraft.used:minecraft.end_crystal' | 'minecraft.crafted:minecraft.end_portal_frame' | 'minecraft.dropped:minecraft.end_portal_frame' | 'minecraft.picked_up:minecraft.end_portal_frame' | 'minecraft.used:minecraft.end_portal_frame' | 'minecraft.crafted:minecraft.end_rod' | 'minecraft.dropped:minecraft.end_rod' | 'minecraft.picked_up:minecraft.end_rod' | 'minecraft.used:minecraft.end_rod' | 'minecraft.crafted:minecraft.end_stone' | 'minecraft.dropped:minecraft.end_stone' | 'minecraft.picked_up:minecraft.end_stone' | 'minecraft.used:minecraft.end_stone' | 'minecraft.crafted:minecraft.end_stone_brick_slab' | 'minecraft.dropped:minecraft.end_stone_brick_slab' | 'minecraft.picked_up:minecraft.end_stone_brick_slab' | 'minecraft.used:minecraft.end_stone_brick_slab' | 'minecraft.crafted:minecraft.end_stone_brick_stairs' | 'minecraft.dropped:minecraft.end_stone_brick_stairs' | 'minecraft.picked_up:minecraft.end_stone_brick_stairs' | 'minecraft.used:minecraft.end_stone_brick_stairs' | 'minecraft.crafted:minecraft.end_stone_brick_wall' | 'minecraft.dropped:minecraft.end_stone_brick_wall' | 'minecraft.picked_up:minecraft.end_stone_brick_wall' | 'minecraft.used:minecraft.end_stone_brick_wall' | 'minecraft.crafted:minecraft.end_stone_bricks' | 'minecraft.dropped:minecraft.end_stone_bricks' | 'minecraft.picked_up:minecraft.end_stone_bricks' | 'minecraft.used:minecraft.end_stone_bricks' | 'minecraft.crafted:minecraft.ender_chest' | 'minecraft.dropped:minecraft.ender_chest' | 'minecraft.picked_up:minecraft.ender_chest' | 'minecraft.used:minecraft.ender_chest' | 'minecraft.crafted:minecraft.ender_dragon_spawn_egg' | 'minecraft.dropped:minecraft.ender_dragon_spawn_egg' | 'minecraft.picked_up:minecraft.ender_dragon_spawn_egg' | 'minecraft.used:minecraft.ender_dragon_spawn_egg' | 'minecraft.crafted:minecraft.ender_eye' | 'minecraft.dropped:minecraft.ender_eye' | 'minecraft.picked_up:minecraft.ender_eye' | 'minecraft.used:minecraft.ender_eye' | 'minecraft.crafted:minecraft.ender_pearl' | 'minecraft.dropped:minecraft.ender_pearl' | 'minecraft.picked_up:minecraft.ender_pearl' | 'minecraft.used:minecraft.ender_pearl' | 'minecraft.crafted:minecraft.enderman_spawn_egg' | 'minecraft.dropped:minecraft.enderman_spawn_egg' | 'minecraft.picked_up:minecraft.enderman_spawn_egg' | 'minecraft.used:minecraft.enderman_spawn_egg' | 'minecraft.crafted:minecraft.endermite_spawn_egg' | 'minecraft.dropped:minecraft.endermite_spawn_egg' | 'minecraft.picked_up:minecraft.endermite_spawn_egg' | 'minecraft.used:minecraft.endermite_spawn_egg' | 'minecraft.crafted:minecraft.evoker_spawn_egg' | 'minecraft.dropped:minecraft.evoker_spawn_egg' | 'minecraft.picked_up:minecraft.evoker_spawn_egg' | 'minecraft.used:minecraft.evoker_spawn_egg' | 'minecraft.crafted:minecraft.experience_bottle' | 'minecraft.dropped:minecraft.experience_bottle' | 'minecraft.picked_up:minecraft.experience_bottle' | 'minecraft.used:minecraft.experience_bottle' | 'minecraft.crafted:minecraft.explorer_pottery_sherd' | 'minecraft.dropped:minecraft.explorer_pottery_sherd' | 'minecraft.picked_up:minecraft.explorer_pottery_sherd' | 'minecraft.used:minecraft.explorer_pottery_sherd' | 'minecraft.crafted:minecraft.exposed_chiseled_copper' | 'minecraft.dropped:minecraft.exposed_chiseled_copper' | 'minecraft.picked_up:minecraft.exposed_chiseled_copper' | 'minecraft.used:minecraft.exposed_chiseled_copper' | 'minecraft.crafted:minecraft.exposed_copper' | 'minecraft.dropped:minecraft.exposed_copper' | 'minecraft.picked_up:minecraft.exposed_copper' | 'minecraft.used:minecraft.exposed_copper' | 'minecraft.crafted:minecraft.exposed_copper_bulb' | 'minecraft.dropped:minecraft.exposed_copper_bulb' | 'minecraft.picked_up:minecraft.exposed_copper_bulb' | 'minecraft.used:minecraft.exposed_copper_bulb' | 'minecraft.crafted:minecraft.exposed_copper_door' | 'minecraft.dropped:minecraft.exposed_copper_door' | 'minecraft.picked_up:minecraft.exposed_copper_door' | 'minecraft.used:minecraft.exposed_copper_door' | 'minecraft.crafted:minecraft.exposed_copper_grate' | 'minecraft.dropped:minecraft.exposed_copper_grate' | 'minecraft.picked_up:minecraft.exposed_copper_grate' | 'minecraft.used:minecraft.exposed_copper_grate' | 'minecraft.crafted:minecraft.exposed_copper_trapdoor' | 'minecraft.dropped:minecraft.exposed_copper_trapdoor' | 'minecraft.picked_up:minecraft.exposed_copper_trapdoor' | 'minecraft.used:minecraft.exposed_copper_trapdoor' | 'minecraft.crafted:minecraft.exposed_cut_copper' | 'minecraft.dropped:minecraft.exposed_cut_copper' | 'minecraft.picked_up:minecraft.exposed_cut_copper' | 'minecraft.used:minecraft.exposed_cut_copper' | 'minecraft.crafted:minecraft.exposed_cut_copper_slab' | 'minecraft.dropped:minecraft.exposed_cut_copper_slab' | 'minecraft.picked_up:minecraft.exposed_cut_copper_slab' | 'minecraft.used:minecraft.exposed_cut_copper_slab' | 'minecraft.crafted:minecraft.exposed_cut_copper_stairs' | 'minecraft.dropped:minecraft.exposed_cut_copper_stairs' | 'minecraft.picked_up:minecraft.exposed_cut_copper_stairs' | 'minecraft.used:minecraft.exposed_cut_copper_stairs' | 'minecraft.crafted:minecraft.eye_armor_trim_smithing_template' | 'minecraft.dropped:minecraft.eye_armor_trim_smithing_template' | 'minecraft.picked_up:minecraft.eye_armor_trim_smithing_template' | 'minecraft.used:minecraft.eye_armor_trim_smithing_template' | 'minecraft.crafted:minecraft.farmland' | 'minecraft.dropped:minecraft.farmland' | 'minecraft.picked_up:minecraft.farmland' | 'minecraft.used:minecraft.farmland' | 'minecraft.crafted:minecraft.feather' | 'minecraft.dropped:minecraft.feather' | 'minecraft.picked_up:minecraft.feather' | 'minecraft.used:minecraft.feather' | 'minecraft.crafted:minecraft.fermented_spider_eye' | 'minecraft.dropped:minecraft.fermented_spider_eye' | 'minecraft.picked_up:minecraft.fermented_spider_eye' | 'minecraft.used:minecraft.fermented_spider_eye' | 'minecraft.crafted:minecraft.fern' | 'minecraft.dropped:minecraft.fern' | 'minecraft.picked_up:minecraft.fern' | 'minecraft.used:minecraft.fern' | 'minecraft.crafted:minecraft.filled_map' | 'minecraft.dropped:minecraft.filled_map' | 'minecraft.picked_up:minecraft.filled_map' | 'minecraft.used:minecraft.filled_map' | 'minecraft.crafted:minecraft.fire_charge' | 'minecraft.dropped:minecraft.fire_charge' | 'minecraft.picked_up:minecraft.fire_charge' | 'minecraft.used:minecraft.fire_charge' | 'minecraft.crafted:minecraft.fire_coral' | 'minecraft.dropped:minecraft.fire_coral' | 'minecraft.picked_up:minecraft.fire_coral' | 'minecraft.used:minecraft.fire_coral' | 'minecraft.crafted:minecraft.fire_coral_block' | 'minecraft.dropped:minecraft.fire_coral_block' | 'minecraft.picked_up:minecraft.fire_coral_block' | 'minecraft.used:minecraft.fire_coral_block' | 'minecraft.crafted:minecraft.fire_coral_fan' | 'minecraft.dropped:minecraft.fire_coral_fan' | 'minecraft.picked_up:minecraft.fire_coral_fan' | 'minecraft.used:minecraft.fire_coral_fan' | 'minecraft.crafted:minecraft.firework_rocket' | 'minecraft.dropped:minecraft.firework_rocket' | 'minecraft.picked_up:minecraft.firework_rocket' | 'minecraft.used:minecraft.firework_rocket' | 'minecraft.crafted:minecraft.firework_star' | 'minecraft.dropped:minecraft.firework_star' | 'minecraft.picked_up:minecraft.firework_star' | 'minecraft.used:minecraft.firework_star' | 'minecraft.crafted:minecraft.fishing_rod' | 'minecraft.dropped:minecraft.fishing_rod' | 'minecraft.picked_up:minecraft.fishing_rod' | 'minecraft.used:minecraft.fishing_rod' | 'minecraft.crafted:minecraft.fletching_table' | 'minecraft.dropped:minecraft.fletching_table' | 'minecraft.picked_up:minecraft.fletching_table' | 'minecraft.used:minecraft.fletching_table' | 'minecraft.crafted:minecraft.flint' | 'minecraft.dropped:minecraft.flint' | 'minecraft.picked_up:minecraft.flint' | 'minecraft.used:minecraft.flint' | 'minecraft.crafted:minecraft.flint_and_steel' | 'minecraft.dropped:minecraft.flint_and_steel' | 'minecraft.picked_up:minecraft.flint_and_steel' | 'minecraft.used:minecraft.flint_and_steel' | 'minecraft.crafted:minecraft.flower_banner_pattern' | 'minecraft.dropped:minecraft.flower_banner_pattern' | 'minecraft.picked_up:minecraft.flower_banner_pattern' | 'minecraft.used:minecraft.flower_banner_pattern' | 'minecraft.crafted:minecraft.flower_pot' | 'minecraft.dropped:minecraft.flower_pot' | 'minecraft.picked_up:minecraft.flower_pot' | 'minecraft.used:minecraft.flower_pot' | 'minecraft.crafted:minecraft.flowering_azalea' | 'minecraft.dropped:minecraft.flowering_azalea' | 'minecraft.picked_up:minecraft.flowering_azalea' | 'minecraft.used:minecraft.flowering_azalea' | 'minecraft.crafted:minecraft.flowering_azalea_leaves' | 'minecraft.dropped:minecraft.flowering_azalea_leaves' | 'minecraft.picked_up:minecraft.flowering_azalea_leaves' | 'minecraft.used:minecraft.flowering_azalea_leaves' | 'minecraft.crafted:minecraft.fox_spawn_egg' | 'minecraft.dropped:minecraft.fox_spawn_egg' | 'minecraft.picked_up:minecraft.fox_spawn_egg' | 'minecraft.used:minecraft.fox_spawn_egg' | 'minecraft.crafted:minecraft.friend_pottery_sherd' | 'minecraft.dropped:minecraft.friend_pottery_sherd' | 'minecraft.picked_up:minecraft.friend_pottery_sherd' | 'minecraft.used:minecraft.friend_pottery_sherd' | 'minecraft.crafted:minecraft.frog_spawn_egg' | 'minecraft.dropped:minecraft.frog_spawn_egg' | 'minecraft.picked_up:minecraft.frog_spawn_egg' | 'minecraft.used:minecraft.frog_spawn_egg' | 'minecraft.crafted:minecraft.frogspawn' | 'minecraft.dropped:minecraft.frogspawn' | 'minecraft.picked_up:minecraft.frogspawn' | 'minecraft.used:minecraft.frogspawn' | 'minecraft.crafted:minecraft.furnace' | 'minecraft.dropped:minecraft.furnace' | 'minecraft.picked_up:minecraft.furnace' | 'minecraft.used:minecraft.furnace' | 'minecraft.crafted:minecraft.furnace_minecart' | 'minecraft.dropped:minecraft.furnace_minecart' | 'minecraft.picked_up:minecraft.furnace_minecart' | 'minecraft.used:minecraft.furnace_minecart' | 'minecraft.crafted:minecraft.ghast_spawn_egg' | 'minecraft.dropped:minecraft.ghast_spawn_egg' | 'minecraft.picked_up:minecraft.ghast_spawn_egg' | 'minecraft.used:minecraft.ghast_spawn_egg' | 'minecraft.crafted:minecraft.ghast_tear' | 'minecraft.dropped:minecraft.ghast_tear' | 'minecraft.picked_up:minecraft.ghast_tear' | 'minecraft.used:minecraft.ghast_tear' | 'minecraft.crafted:minecraft.gilded_blackstone' | 'minecraft.dropped:minecraft.gilded_blackstone' | 'minecraft.picked_up:minecraft.gilded_blackstone' | 'minecraft.used:minecraft.gilded_blackstone' | 'minecraft.crafted:minecraft.glass' | 'minecraft.dropped:minecraft.glass' | 'minecraft.picked_up:minecraft.glass' | 'minecraft.used:minecraft.glass' | 'minecraft.crafted:minecraft.glass_bottle' | 'minecraft.dropped:minecraft.glass_bottle' | 'minecraft.picked_up:minecraft.glass_bottle' | 'minecraft.used:minecraft.glass_bottle' | 'minecraft.crafted:minecraft.glass_pane' | 'minecraft.dropped:minecraft.glass_pane' | 'minecraft.picked_up:minecraft.glass_pane' | 'minecraft.used:minecraft.glass_pane' | 'minecraft.crafted:minecraft.glistering_melon_slice' | 'minecraft.dropped:minecraft.glistering_melon_slice' | 'minecraft.picked_up:minecraft.glistering_melon_slice' | 'minecraft.used:minecraft.glistering_melon_slice' | 'minecraft.crafted:minecraft.globe_banner_pattern' | 'minecraft.dropped:minecraft.globe_banner_pattern' | 'minecraft.picked_up:minecraft.globe_banner_pattern' | 'minecraft.used:minecraft.globe_banner_pattern' | 'minecraft.crafted:minecraft.glow_berries' | 'minecraft.dropped:minecraft.glow_berries' | 'minecraft.picked_up:minecraft.glow_berries' | 'minecraft.used:minecraft.glow_berries' | 'minecraft.crafted:minecraft.glow_ink_sac' | 'minecraft.dropped:minecraft.glow_ink_sac' | 'minecraft.picked_up:minecraft.glow_ink_sac' | 'minecraft.used:minecraft.glow_ink_sac' | 'minecraft.crafted:minecraft.glow_item_frame' | 'minecraft.dropped:minecraft.glow_item_frame' | 'minecraft.picked_up:minecraft.glow_item_frame' | 'minecraft.used:minecraft.glow_item_frame' | 'minecraft.crafted:minecraft.glow_lichen' | 'minecraft.dropped:minecraft.glow_lichen' | 'minecraft.picked_up:minecraft.glow_lichen' | 'minecraft.used:minecraft.glow_lichen' | 'minecraft.crafted:minecraft.glow_squid_spawn_egg' | 'minecraft.dropped:minecraft.glow_squid_spawn_egg' | 'minecraft.picked_up:minecraft.glow_squid_spawn_egg' | 'minecraft.used:minecraft.glow_squid_spawn_egg' | 'minecraft.crafted:minecraft.glowstone' | 'minecraft.dropped:minecraft.glowstone' | 'minecraft.picked_up:minecraft.glowstone' | 'minecraft.used:minecraft.glowstone' | 'minecraft.crafted:minecraft.glowstone_dust' | 'minecraft.dropped:minecraft.glowstone_dust' | 'minecraft.picked_up:minecraft.glowstone_dust' | 'minecraft.used:minecraft.glowstone_dust' | 'minecraft.crafted:minecraft.goat_horn' | 'minecraft.dropped:minecraft.goat_horn' | 'minecraft.picked_up:minecraft.goat_horn' | 'minecraft.used:minecraft.goat_horn' | 'minecraft.crafted:minecraft.goat_spawn_egg' | 'minecraft.dropped:minecraft.goat_spawn_egg' | 'minecraft.picked_up:minecraft.goat_spawn_egg' | 'minecraft.used:minecraft.goat_spawn_egg' | 'minecraft.crafted:minecraft.gold_block' | 'minecraft.dropped:minecraft.gold_block' | 'minecraft.picked_up:minecraft.gold_block' | 'minecraft.used:minecraft.gold_block' | 'minecraft.crafted:minecraft.gold_ingot' | 'minecraft.dropped:minecraft.gold_ingot' | 'minecraft.picked_up:minecraft.gold_ingot' | 'minecraft.used:minecraft.gold_ingot' | 'minecraft.crafted:minecraft.gold_nugget' | 'minecraft.dropped:minecraft.gold_nugget' | 'minecraft.picked_up:minecraft.gold_nugget' | 'minecraft.used:minecraft.gold_nugget' | 'minecraft.crafted:minecraft.gold_ore' | 'minecraft.dropped:minecraft.gold_ore' | 'minecraft.picked_up:minecraft.gold_ore' | 'minecraft.used:minecraft.gold_ore' | 'minecraft.crafted:minecraft.golden_apple' | 'minecraft.dropped:minecraft.golden_apple' | 'minecraft.picked_up:minecraft.golden_apple' | 'minecraft.used:minecraft.golden_apple' | 'minecraft.crafted:minecraft.golden_axe' | 'minecraft.dropped:minecraft.golden_axe' | 'minecraft.picked_up:minecraft.golden_axe' | 'minecraft.used:minecraft.golden_axe' | 'minecraft.crafted:minecraft.golden_boots' | 'minecraft.dropped:minecraft.golden_boots' | 'minecraft.picked_up:minecraft.golden_boots' | 'minecraft.used:minecraft.golden_boots' | 'minecraft.crafted:minecraft.golden_carrot' | 'minecraft.dropped:minecraft.golden_carrot' | 'minecraft.picked_up:minecraft.golden_carrot' | 'minecraft.used:minecraft.golden_carrot' | 'minecraft.crafted:minecraft.golden_chestplate' | 'minecraft.dropped:minecraft.golden_chestplate' | 'minecraft.picked_up:minecraft.golden_chestplate' | 'minecraft.used:minecraft.golden_chestplate' | 'minecraft.crafted:minecraft.golden_helmet' | 'minecraft.dropped:minecraft.golden_helmet' | 'minecraft.picked_up:minecraft.golden_helmet' | 'minecraft.used:minecraft.golden_helmet' | 'minecraft.crafted:minecraft.golden_hoe' | 'minecraft.dropped:minecraft.golden_hoe' | 'minecraft.picked_up:minecraft.golden_hoe' | 'minecraft.used:minecraft.golden_hoe' | 'minecraft.crafted:minecraft.golden_horse_armor' | 'minecraft.dropped:minecraft.golden_horse_armor' | 'minecraft.picked_up:minecraft.golden_horse_armor' | 'minecraft.used:minecraft.golden_horse_armor' | 'minecraft.crafted:minecraft.golden_leggings' | 'minecraft.dropped:minecraft.golden_leggings' | 'minecraft.picked_up:minecraft.golden_leggings' | 'minecraft.used:minecraft.golden_leggings' | 'minecraft.crafted:minecraft.golden_pickaxe' | 'minecraft.dropped:minecraft.golden_pickaxe' | 'minecraft.picked_up:minecraft.golden_pickaxe' | 'minecraft.used:minecraft.golden_pickaxe' | 'minecraft.crafted:minecraft.golden_shovel' | 'minecraft.dropped:minecraft.golden_shovel' | 'minecraft.picked_up:minecraft.golden_shovel' | 'minecraft.used:minecraft.golden_shovel' | 'minecraft.crafted:minecraft.golden_sword' | 'minecraft.dropped:minecraft.golden_sword' | 'minecraft.picked_up:minecraft.golden_sword' | 'minecraft.used:minecraft.golden_sword' | 'minecraft.crafted:minecraft.granite' | 'minecraft.dropped:minecraft.granite' | 'minecraft.picked_up:minecraft.granite' | 'minecraft.used:minecraft.granite' | 'minecraft.crafted:minecraft.granite_slab' | 'minecraft.dropped:minecraft.granite_slab' | 'minecraft.picked_up:minecraft.granite_slab' | 'minecraft.used:minecraft.granite_slab' | 'minecraft.crafted:minecraft.granite_stairs' | 'minecraft.dropped:minecraft.granite_stairs' | 'minecraft.picked_up:minecraft.granite_stairs' | 'minecraft.used:minecraft.granite_stairs' | 'minecraft.crafted:minecraft.granite_wall' | 'minecraft.dropped:minecraft.granite_wall' | 'minecraft.picked_up:minecraft.granite_wall' | 'minecraft.used:minecraft.granite_wall' | 'minecraft.crafted:minecraft.grass' | 'minecraft.dropped:minecraft.grass' | 'minecraft.picked_up:minecraft.grass' | 'minecraft.used:minecraft.grass' | 'minecraft.crafted:minecraft.grass_block' | 'minecraft.dropped:minecraft.grass_block' | 'minecraft.picked_up:minecraft.grass_block' | 'minecraft.used:minecraft.grass_block' | 'minecraft.crafted:minecraft.gravel' | 'minecraft.dropped:minecraft.gravel' | 'minecraft.picked_up:minecraft.gravel' | 'minecraft.used:minecraft.gravel' | 'minecraft.crafted:minecraft.gray_banner' | 'minecraft.dropped:minecraft.gray_banner' | 'minecraft.picked_up:minecraft.gray_banner' | 'minecraft.used:minecraft.gray_banner' | 'minecraft.crafted:minecraft.gray_bed' | 'minecraft.dropped:minecraft.gray_bed' | 'minecraft.picked_up:minecraft.gray_bed' | 'minecraft.used:minecraft.gray_bed' | 'minecraft.crafted:minecraft.gray_candle' | 'minecraft.dropped:minecraft.gray_candle' | 'minecraft.picked_up:minecraft.gray_candle' | 'minecraft.used:minecraft.gray_candle' | 'minecraft.crafted:minecraft.gray_carpet' | 'minecraft.dropped:minecraft.gray_carpet' | 'minecraft.picked_up:minecraft.gray_carpet' | 'minecraft.used:minecraft.gray_carpet' | 'minecraft.crafted:minecraft.gray_concrete' | 'minecraft.dropped:minecraft.gray_concrete' | 'minecraft.picked_up:minecraft.gray_concrete' | 'minecraft.used:minecraft.gray_concrete' | 'minecraft.crafted:minecraft.gray_concrete_powder' | 'minecraft.dropped:minecraft.gray_concrete_powder' | 'minecraft.picked_up:minecraft.gray_concrete_powder' | 'minecraft.used:minecraft.gray_concrete_powder' | 'minecraft.crafted:minecraft.gray_dye' | 'minecraft.dropped:minecraft.gray_dye' | 'minecraft.picked_up:minecraft.gray_dye' | 'minecraft.used:minecraft.gray_dye' | 'minecraft.crafted:minecraft.gray_glazed_terracotta' | 'minecraft.dropped:minecraft.gray_glazed_terracotta' | 'minecraft.picked_up:minecraft.gray_glazed_terracotta' | 'minecraft.used:minecraft.gray_glazed_terracotta' | 'minecraft.crafted:minecraft.gray_shulker_box' | 'minecraft.dropped:minecraft.gray_shulker_box' | 'minecraft.picked_up:minecraft.gray_shulker_box' | 'minecraft.used:minecraft.gray_shulker_box' | 'minecraft.crafted:minecraft.gray_stained_glass' | 'minecraft.dropped:minecraft.gray_stained_glass' | 'minecraft.picked_up:minecraft.gray_stained_glass' | 'minecraft.used:minecraft.gray_stained_glass' | 'minecraft.crafted:minecraft.gray_stained_glass_pane' | 'minecraft.dropped:minecraft.gray_stained_glass_pane' | 'minecraft.picked_up:minecraft.gray_stained_glass_pane' | 'minecraft.used:minecraft.gray_stained_glass_pane' | 'minecraft.crafted:minecraft.gray_terracotta' | 'minecraft.dropped:minecraft.gray_terracotta' | 'minecraft.picked_up:minecraft.gray_terracotta' | 'minecraft.used:minecraft.gray_terracotta' | 'minecraft.crafted:minecraft.gray_wool' | 'minecraft.dropped:minecraft.gray_wool' | 'minecraft.picked_up:minecraft.gray_wool' | 'minecraft.used:minecraft.gray_wool' | 'minecraft.crafted:minecraft.green_banner' | 'minecraft.dropped:minecraft.green_banner' | 'minecraft.picked_up:minecraft.green_banner' | 'minecraft.used:minecraft.green_banner' | 'minecraft.crafted:minecraft.green_bed' | 'minecraft.dropped:minecraft.green_bed' | 'minecraft.picked_up:minecraft.green_bed' | 'minecraft.used:minecraft.green_bed' | 'minecraft.crafted:minecraft.green_candle' | 'minecraft.dropped:minecraft.green_candle' | 'minecraft.picked_up:minecraft.green_candle' | 'minecraft.used:minecraft.green_candle' | 'minecraft.crafted:minecraft.green_carpet' | 'minecraft.dropped:minecraft.green_carpet' | 'minecraft.picked_up:minecraft.green_carpet' | 'minecraft.used:minecraft.green_carpet' | 'minecraft.crafted:minecraft.green_concrete' | 'minecraft.dropped:minecraft.green_concrete' | 'minecraft.picked_up:minecraft.green_concrete' | 'minecraft.used:minecraft.green_concrete' | 'minecraft.crafted:minecraft.green_concrete_powder' | 'minecraft.dropped:minecraft.green_concrete_powder' | 'minecraft.picked_up:minecraft.green_concrete_powder' | 'minecraft.used:minecraft.green_concrete_powder' | 'minecraft.crafted:minecraft.green_dye' | 'minecraft.dropped:minecraft.green_dye' | 'minecraft.picked_up:minecraft.green_dye' | 'minecraft.used:minecraft.green_dye' | 'minecraft.crafted:minecraft.green_glazed_terracotta' | 'minecraft.dropped:minecraft.green_glazed_terracotta' | 'minecraft.picked_up:minecraft.green_glazed_terracotta' | 'minecraft.used:minecraft.green_glazed_terracotta' | 'minecraft.crafted:minecraft.green_shulker_box' | 'minecraft.dropped:minecraft.green_shulker_box' | 'minecraft.picked_up:minecraft.green_shulker_box' | 'minecraft.used:minecraft.green_shulker_box' | 'minecraft.crafted:minecraft.green_stained_glass' | 'minecraft.dropped:minecraft.green_stained_glass' | 'minecraft.picked_up:minecraft.green_stained_glass' | 'minecraft.used:minecraft.green_stained_glass' | 'minecraft.crafted:minecraft.green_stained_glass_pane' | 'minecraft.dropped:minecraft.green_stained_glass_pane' | 'minecraft.picked_up:minecraft.green_stained_glass_pane' | 'minecraft.used:minecraft.green_stained_glass_pane' | 'minecraft.crafted:minecraft.green_terracotta' | 'minecraft.dropped:minecraft.green_terracotta' | 'minecraft.picked_up:minecraft.green_terracotta' | 'minecraft.used:minecraft.green_terracotta' | 'minecraft.crafted:minecraft.green_wool' | 'minecraft.dropped:minecraft.green_wool' | 'minecraft.picked_up:minecraft.green_wool' | 'minecraft.used:minecraft.green_wool' | 'minecraft.crafted:minecraft.grindstone' | 'minecraft.dropped:minecraft.grindstone' | 'minecraft.picked_up:minecraft.grindstone' | 'minecraft.used:minecraft.grindstone' | 'minecraft.crafted:minecraft.guardian_spawn_egg' | 'minecraft.dropped:minecraft.guardian_spawn_egg' | 'minecraft.picked_up:minecraft.guardian_spawn_egg' | 'minecraft.used:minecraft.guardian_spawn_egg' | 'minecraft.crafted:minecraft.gunpowder' | 'minecraft.dropped:minecraft.gunpowder' | 'minecraft.picked_up:minecraft.gunpowder' | 'minecraft.used:minecraft.gunpowder' | 'minecraft.crafted:minecraft.hanging_roots' | 'minecraft.dropped:minecraft.hanging_roots' | 'minecraft.picked_up:minecraft.hanging_roots' | 'minecraft.used:minecraft.hanging_roots' | 'minecraft.crafted:minecraft.hay_block' | 'minecraft.dropped:minecraft.hay_block' | 'minecraft.picked_up:minecraft.hay_block' | 'minecraft.used:minecraft.hay_block' | 'minecraft.crafted:minecraft.heart_of_the_sea' | 'minecraft.dropped:minecraft.heart_of_the_sea' | 'minecraft.picked_up:minecraft.heart_of_the_sea' | 'minecraft.used:minecraft.heart_of_the_sea' | 'minecraft.crafted:minecraft.heart_pottery_sherd' | 'minecraft.dropped:minecraft.heart_pottery_sherd' | 'minecraft.picked_up:minecraft.heart_pottery_sherd' | 'minecraft.used:minecraft.heart_pottery_sherd' | 'minecraft.crafted:minecraft.heartbreak_pottery_sherd' | 'minecraft.dropped:minecraft.heartbreak_pottery_sherd' | 'minecraft.picked_up:minecraft.heartbreak_pottery_sherd' | 'minecraft.used:minecraft.heartbreak_pottery_sherd' | 'minecraft.crafted:minecraft.heavy_weighted_pressure_plate' | 'minecraft.dropped:minecraft.heavy_weighted_pressure_plate' | 'minecraft.picked_up:minecraft.heavy_weighted_pressure_plate' | 'minecraft.used:minecraft.heavy_weighted_pressure_plate' | 'minecraft.crafted:minecraft.hoglin_spawn_egg' | 'minecraft.dropped:minecraft.hoglin_spawn_egg' | 'minecraft.picked_up:minecraft.hoglin_spawn_egg' | 'minecraft.used:minecraft.hoglin_spawn_egg' | 'minecraft.crafted:minecraft.honey_block' | 'minecraft.dropped:minecraft.honey_block' | 'minecraft.picked_up:minecraft.honey_block' | 'minecraft.used:minecraft.honey_block' | 'minecraft.crafted:minecraft.honey_bottle' | 'minecraft.dropped:minecraft.honey_bottle' | 'minecraft.picked_up:minecraft.honey_bottle' | 'minecraft.used:minecraft.honey_bottle' | 'minecraft.crafted:minecraft.honeycomb' | 'minecraft.dropped:minecraft.honeycomb' | 'minecraft.picked_up:minecraft.honeycomb' | 'minecraft.used:minecraft.honeycomb' | 'minecraft.crafted:minecraft.honeycomb_block' | 'minecraft.dropped:minecraft.honeycomb_block' | 'minecraft.picked_up:minecraft.honeycomb_block' | 'minecraft.used:minecraft.honeycomb_block' | 'minecraft.crafted:minecraft.hopper' | 'minecraft.dropped:minecraft.hopper' | 'minecraft.picked_up:minecraft.hopper' | 'minecraft.used:minecraft.hopper' | 'minecraft.crafted:minecraft.hopper_minecart' | 'minecraft.dropped:minecraft.hopper_minecart' | 'minecraft.picked_up:minecraft.hopper_minecart' | 'minecraft.used:minecraft.hopper_minecart' | 'minecraft.crafted:minecraft.horn_coral' | 'minecraft.dropped:minecraft.horn_coral' | 'minecraft.picked_up:minecraft.horn_coral' | 'minecraft.used:minecraft.horn_coral' | 'minecraft.crafted:minecraft.horn_coral_block' | 'minecraft.dropped:minecraft.horn_coral_block' | 'minecraft.picked_up:minecraft.horn_coral_block' | 'minecraft.used:minecraft.horn_coral_block' | 'minecraft.crafted:minecraft.horn_coral_fan' | 'minecraft.dropped:minecraft.horn_coral_fan' | 'minecraft.picked_up:minecraft.horn_coral_fan' | 'minecraft.used:minecraft.horn_coral_fan' | 'minecraft.crafted:minecraft.horse_spawn_egg' | 'minecraft.dropped:minecraft.horse_spawn_egg' | 'minecraft.picked_up:minecraft.horse_spawn_egg' | 'minecraft.used:minecraft.horse_spawn_egg' | 'minecraft.crafted:minecraft.host_armor_trim_smithing_template' | 'minecraft.dropped:minecraft.host_armor_trim_smithing_template' | 'minecraft.picked_up:minecraft.host_armor_trim_smithing_template' | 'minecraft.used:minecraft.host_armor_trim_smithing_template' | 'minecraft.crafted:minecraft.howl_pottery_sherd' | 'minecraft.dropped:minecraft.howl_pottery_sherd' | 'minecraft.picked_up:minecraft.howl_pottery_sherd' | 'minecraft.used:minecraft.howl_pottery_sherd' | 'minecraft.crafted:minecraft.husk_spawn_egg' | 'minecraft.dropped:minecraft.husk_spawn_egg' | 'minecraft.picked_up:minecraft.husk_spawn_egg' | 'minecraft.used:minecraft.husk_spawn_egg' | 'minecraft.crafted:minecraft.ice' | 'minecraft.dropped:minecraft.ice' | 'minecraft.picked_up:minecraft.ice' | 'minecraft.used:minecraft.ice' | 'minecraft.crafted:minecraft.infested_chiseled_stone_bricks' | 'minecraft.dropped:minecraft.infested_chiseled_stone_bricks' | 'minecraft.picked_up:minecraft.infested_chiseled_stone_bricks' | 'minecraft.used:minecraft.infested_chiseled_stone_bricks' | 'minecraft.crafted:minecraft.infested_cobblestone' | 'minecraft.dropped:minecraft.infested_cobblestone' | 'minecraft.picked_up:minecraft.infested_cobblestone' | 'minecraft.used:minecraft.infested_cobblestone' | 'minecraft.crafted:minecraft.infested_cracked_stone_bricks' | 'minecraft.dropped:minecraft.infested_cracked_stone_bricks' | 'minecraft.picked_up:minecraft.infested_cracked_stone_bricks' | 'minecraft.used:minecraft.infested_cracked_stone_bricks' | 'minecraft.crafted:minecraft.infested_deepslate' | 'minecraft.dropped:minecraft.infested_deepslate' | 'minecraft.picked_up:minecraft.infested_deepslate' | 'minecraft.used:minecraft.infested_deepslate' | 'minecraft.crafted:minecraft.infested_mossy_stone_bricks' | 'minecraft.dropped:minecraft.infested_mossy_stone_bricks' | 'minecraft.picked_up:minecraft.infested_mossy_stone_bricks' | 'minecraft.used:minecraft.infested_mossy_stone_bricks' | 'minecraft.crafted:minecraft.infested_stone' | 'minecraft.dropped:minecraft.infested_stone' | 'minecraft.picked_up:minecraft.infested_stone' | 'minecraft.used:minecraft.infested_stone' | 'minecraft.crafted:minecraft.infested_stone_bricks' | 'minecraft.dropped:minecraft.infested_stone_bricks' | 'minecraft.picked_up:minecraft.infested_stone_bricks' | 'minecraft.used:minecraft.infested_stone_bricks' | 'minecraft.crafted:minecraft.ink_sac' | 'minecraft.dropped:minecraft.ink_sac' | 'minecraft.picked_up:minecraft.ink_sac' | 'minecraft.used:minecraft.ink_sac' | 'minecraft.crafted:minecraft.iron_axe' | 'minecraft.dropped:minecraft.iron_axe' | 'minecraft.picked_up:minecraft.iron_axe' | 'minecraft.used:minecraft.iron_axe' | 'minecraft.crafted:minecraft.iron_bars' | 'minecraft.dropped:minecraft.iron_bars' | 'minecraft.picked_up:minecraft.iron_bars' | 'minecraft.used:minecraft.iron_bars' | 'minecraft.crafted:minecraft.iron_block' | 'minecraft.dropped:minecraft.iron_block' | 'minecraft.picked_up:minecraft.iron_block' | 'minecraft.used:minecraft.iron_block' | 'minecraft.crafted:minecraft.iron_boots' | 'minecraft.dropped:minecraft.iron_boots' | 'minecraft.picked_up:minecraft.iron_boots' | 'minecraft.used:minecraft.iron_boots' | 'minecraft.crafted:minecraft.iron_chestplate' | 'minecraft.dropped:minecraft.iron_chestplate' | 'minecraft.picked_up:minecraft.iron_chestplate' | 'minecraft.used:minecraft.iron_chestplate' | 'minecraft.crafted:minecraft.iron_door' | 'minecraft.dropped:minecraft.iron_door' | 'minecraft.picked_up:minecraft.iron_door' | 'minecraft.used:minecraft.iron_door' | 'minecraft.crafted:minecraft.iron_golem_spawn_egg' | 'minecraft.dropped:minecraft.iron_golem_spawn_egg' | 'minecraft.picked_up:minecraft.iron_golem_spawn_egg' | 'minecraft.used:minecraft.iron_golem_spawn_egg' | 'minecraft.crafted:minecraft.iron_helmet' | 'minecraft.dropped:minecraft.iron_helmet' | 'minecraft.picked_up:minecraft.iron_helmet' | 'minecraft.used:minecraft.iron_helmet' | 'minecraft.crafted:minecraft.iron_hoe' | 'minecraft.dropped:minecraft.iron_hoe' | 'minecraft.picked_up:minecraft.iron_hoe' | 'minecraft.used:minecraft.iron_hoe' | 'minecraft.crafted:minecraft.iron_horse_armor' | 'minecraft.dropped:minecraft.iron_horse_armor' | 'minecraft.picked_up:minecraft.iron_horse_armor' | 'minecraft.used:minecraft.iron_horse_armor' | 'minecraft.crafted:minecraft.iron_ingot' | 'minecraft.dropped:minecraft.iron_ingot' | 'minecraft.picked_up:minecraft.iron_ingot' | 'minecraft.used:minecraft.iron_ingot' | 'minecraft.crafted:minecraft.iron_leggings' | 'minecraft.dropped:minecraft.iron_leggings' | 'minecraft.picked_up:minecraft.iron_leggings' | 'minecraft.used:minecraft.iron_leggings' | 'minecraft.crafted:minecraft.iron_nugget' | 'minecraft.dropped:minecraft.iron_nugget' | 'minecraft.picked_up:minecraft.iron_nugget' | 'minecraft.used:minecraft.iron_nugget' | 'minecraft.crafted:minecraft.iron_ore' | 'minecraft.dropped:minecraft.iron_ore' | 'minecraft.picked_up:minecraft.iron_ore' | 'minecraft.used:minecraft.iron_ore' | 'minecraft.crafted:minecraft.iron_pickaxe' | 'minecraft.dropped:minecraft.iron_pickaxe' | 'minecraft.picked_up:minecraft.iron_pickaxe' | 'minecraft.used:minecraft.iron_pickaxe' | 'minecraft.crafted:minecraft.iron_shovel' | 'minecraft.dropped:minecraft.iron_shovel' | 'minecraft.picked_up:minecraft.iron_shovel' | 'minecraft.used:minecraft.iron_shovel' | 'minecraft.crafted:minecraft.iron_sword' | 'minecraft.dropped:minecraft.iron_sword' | 'minecraft.picked_up:minecraft.iron_sword' | 'minecraft.used:minecraft.iron_sword' | 'minecraft.crafted:minecraft.iron_trapdoor' | 'minecraft.dropped:minecraft.iron_trapdoor' | 'minecraft.picked_up:minecraft.iron_trapdoor' | 'minecraft.used:minecraft.iron_trapdoor' | 'minecraft.crafted:minecraft.item_frame' | 'minecraft.dropped:minecraft.item_frame' | 'minecraft.picked_up:minecraft.item_frame' | 'minecraft.used:minecraft.item_frame' | 'minecraft.crafted:minecraft.jack_o_lantern' | 'minecraft.dropped:minecraft.jack_o_lantern' | 'minecraft.picked_up:minecraft.jack_o_lantern' | 'minecraft.used:minecraft.jack_o_lantern' | 'minecraft.crafted:minecraft.jigsaw' | 'minecraft.dropped:minecraft.jigsaw' | 'minecraft.picked_up:minecraft.jigsaw' | 'minecraft.used:minecraft.jigsaw' | 'minecraft.crafted:minecraft.jukebox' | 'minecraft.dropped:minecraft.jukebox' | 'minecraft.picked_up:minecraft.jukebox' | 'minecraft.used:minecraft.jukebox' | 'minecraft.crafted:minecraft.jungle_boat' | 'minecraft.dropped:minecraft.jungle_boat' | 'minecraft.picked_up:minecraft.jungle_boat' | 'minecraft.used:minecraft.jungle_boat' | 'minecraft.crafted:minecraft.jungle_button' | 'minecraft.dropped:minecraft.jungle_button' | 'minecraft.picked_up:minecraft.jungle_button' | 'minecraft.used:minecraft.jungle_button' | 'minecraft.crafted:minecraft.jungle_chest_boat' | 'minecraft.dropped:minecraft.jungle_chest_boat' | 'minecraft.picked_up:minecraft.jungle_chest_boat' | 'minecraft.used:minecraft.jungle_chest_boat' | 'minecraft.crafted:minecraft.jungle_door' | 'minecraft.dropped:minecraft.jungle_door' | 'minecraft.picked_up:minecraft.jungle_door' | 'minecraft.used:minecraft.jungle_door' | 'minecraft.crafted:minecraft.jungle_fence' | 'minecraft.dropped:minecraft.jungle_fence' | 'minecraft.picked_up:minecraft.jungle_fence' | 'minecraft.used:minecraft.jungle_fence' | 'minecraft.crafted:minecraft.jungle_fence_gate' | 'minecraft.dropped:minecraft.jungle_fence_gate' | 'minecraft.picked_up:minecraft.jungle_fence_gate' | 'minecraft.used:minecraft.jungle_fence_gate' | 'minecraft.crafted:minecraft.jungle_hanging_sign' | 'minecraft.dropped:minecraft.jungle_hanging_sign' | 'minecraft.picked_up:minecraft.jungle_hanging_sign' | 'minecraft.used:minecraft.jungle_hanging_sign' | 'minecraft.crafted:minecraft.jungle_leaves' | 'minecraft.dropped:minecraft.jungle_leaves' | 'minecraft.picked_up:minecraft.jungle_leaves' | 'minecraft.used:minecraft.jungle_leaves' | 'minecraft.crafted:minecraft.jungle_log' | 'minecraft.dropped:minecraft.jungle_log' | 'minecraft.picked_up:minecraft.jungle_log' | 'minecraft.used:minecraft.jungle_log' | 'minecraft.crafted:minecraft.jungle_planks' | 'minecraft.dropped:minecraft.jungle_planks' | 'minecraft.picked_up:minecraft.jungle_planks' | 'minecraft.used:minecraft.jungle_planks' | 'minecraft.crafted:minecraft.jungle_pressure_plate' | 'minecraft.dropped:minecraft.jungle_pressure_plate' | 'minecraft.picked_up:minecraft.jungle_pressure_plate' | 'minecraft.used:minecraft.jungle_pressure_plate' | 'minecraft.crafted:minecraft.jungle_sapling' | 'minecraft.dropped:minecraft.jungle_sapling' | 'minecraft.picked_up:minecraft.jungle_sapling' | 'minecraft.used:minecraft.jungle_sapling' | 'minecraft.crafted:minecraft.jungle_sign' | 'minecraft.dropped:minecraft.jungle_sign' | 'minecraft.picked_up:minecraft.jungle_sign' | 'minecraft.used:minecraft.jungle_sign' | 'minecraft.crafted:minecraft.jungle_slab' | 'minecraft.dropped:minecraft.jungle_slab' | 'minecraft.picked_up:minecraft.jungle_slab' | 'minecraft.used:minecraft.jungle_slab' | 'minecraft.crafted:minecraft.jungle_stairs' | 'minecraft.dropped:minecraft.jungle_stairs' | 'minecraft.picked_up:minecraft.jungle_stairs' | 'minecraft.used:minecraft.jungle_stairs' | 'minecraft.crafted:minecraft.jungle_trapdoor' | 'minecraft.dropped:minecraft.jungle_trapdoor' | 'minecraft.picked_up:minecraft.jungle_trapdoor' | 'minecraft.used:minecraft.jungle_trapdoor' | 'minecraft.crafted:minecraft.jungle_wood' | 'minecraft.dropped:minecraft.jungle_wood' | 'minecraft.picked_up:minecraft.jungle_wood' | 'minecraft.used:minecraft.jungle_wood' | 'minecraft.crafted:minecraft.kelp' | 'minecraft.dropped:minecraft.kelp' | 'minecraft.picked_up:minecraft.kelp' | 'minecraft.used:minecraft.kelp' | 'minecraft.crafted:minecraft.knowledge_book' | 'minecraft.dropped:minecraft.knowledge_book' | 'minecraft.picked_up:minecraft.knowledge_book' | 'minecraft.used:minecraft.knowledge_book' | 'minecraft.crafted:minecraft.ladder' | 'minecraft.dropped:minecraft.ladder' | 'minecraft.picked_up:minecraft.ladder' | 'minecraft.used:minecraft.ladder' | 'minecraft.crafted:minecraft.lantern' | 'minecraft.dropped:minecraft.lantern' | 'minecraft.picked_up:minecraft.lantern' | 'minecraft.used:minecraft.lantern' | 'minecraft.crafted:minecraft.lapis_block' | 'minecraft.dropped:minecraft.lapis_block' | 'minecraft.picked_up:minecraft.lapis_block' | 'minecraft.used:minecraft.lapis_block' | 'minecraft.crafted:minecraft.lapis_lazuli' | 'minecraft.dropped:minecraft.lapis_lazuli' | 'minecraft.picked_up:minecraft.lapis_lazuli' | 'minecraft.used:minecraft.lapis_lazuli' | 'minecraft.crafted:minecraft.lapis_ore' | 'minecraft.dropped:minecraft.lapis_ore' | 'minecraft.picked_up:minecraft.lapis_ore' | 'minecraft.used:minecraft.lapis_ore' | 'minecraft.crafted:minecraft.large_amethyst_bud' | 'minecraft.dropped:minecraft.large_amethyst_bud' | 'minecraft.picked_up:minecraft.large_amethyst_bud' | 'minecraft.used:minecraft.large_amethyst_bud' | 'minecraft.crafted:minecraft.large_fern' | 'minecraft.dropped:minecraft.large_fern' | 'minecraft.picked_up:minecraft.large_fern' | 'minecraft.used:minecraft.large_fern' | 'minecraft.crafted:minecraft.lava_bucket' | 'minecraft.dropped:minecraft.lava_bucket' | 'minecraft.picked_up:minecraft.lava_bucket' | 'minecraft.used:minecraft.lava_bucket' | 'minecraft.crafted:minecraft.lead' | 'minecraft.dropped:minecraft.lead' | 'minecraft.picked_up:minecraft.lead' | 'minecraft.used:minecraft.lead' | 'minecraft.crafted:minecraft.leather' | 'minecraft.dropped:minecraft.leather' | 'minecraft.picked_up:minecraft.leather' | 'minecraft.used:minecraft.leather' | 'minecraft.crafted:minecraft.leather_boots' | 'minecraft.dropped:minecraft.leather_boots' | 'minecraft.picked_up:minecraft.leather_boots' | 'minecraft.used:minecraft.leather_boots' | 'minecraft.crafted:minecraft.leather_chestplate' | 'minecraft.dropped:minecraft.leather_chestplate' | 'minecraft.picked_up:minecraft.leather_chestplate' | 'minecraft.used:minecraft.leather_chestplate' | 'minecraft.crafted:minecraft.leather_helmet' | 'minecraft.dropped:minecraft.leather_helmet' | 'minecraft.picked_up:minecraft.leather_helmet' | 'minecraft.used:minecraft.leather_helmet' | 'minecraft.crafted:minecraft.leather_horse_armor' | 'minecraft.dropped:minecraft.leather_horse_armor' | 'minecraft.picked_up:minecraft.leather_horse_armor' | 'minecraft.used:minecraft.leather_horse_armor' | 'minecraft.crafted:minecraft.leather_leggings' | 'minecraft.dropped:minecraft.leather_leggings' | 'minecraft.picked_up:minecraft.leather_leggings' | 'minecraft.used:minecraft.leather_leggings' | 'minecraft.crafted:minecraft.lectern' | 'minecraft.dropped:minecraft.lectern' | 'minecraft.picked_up:minecraft.lectern' | 'minecraft.used:minecraft.lectern' | 'minecraft.crafted:minecraft.lever' | 'minecraft.dropped:minecraft.lever' | 'minecraft.picked_up:minecraft.lever' | 'minecraft.used:minecraft.lever' | 'minecraft.crafted:minecraft.light' | 'minecraft.dropped:minecraft.light' | 'minecraft.picked_up:minecraft.light' | 'minecraft.used:minecraft.light' | 'minecraft.crafted:minecraft.light_blue_banner' | 'minecraft.dropped:minecraft.light_blue_banner' | 'minecraft.picked_up:minecraft.light_blue_banner' | 'minecraft.used:minecraft.light_blue_banner' | 'minecraft.crafted:minecraft.light_blue_bed' | 'minecraft.dropped:minecraft.light_blue_bed' | 'minecraft.picked_up:minecraft.light_blue_bed' | 'minecraft.used:minecraft.light_blue_bed' | 'minecraft.crafted:minecraft.light_blue_candle' | 'minecraft.dropped:minecraft.light_blue_candle' | 'minecraft.picked_up:minecraft.light_blue_candle' | 'minecraft.used:minecraft.light_blue_candle' | 'minecraft.crafted:minecraft.light_blue_carpet' | 'minecraft.dropped:minecraft.light_blue_carpet' | 'minecraft.picked_up:minecraft.light_blue_carpet' | 'minecraft.used:minecraft.light_blue_carpet' | 'minecraft.crafted:minecraft.light_blue_concrete' | 'minecraft.dropped:minecraft.light_blue_concrete' | 'minecraft.picked_up:minecraft.light_blue_concrete' | 'minecraft.used:minecraft.light_blue_concrete' | 'minecraft.crafted:minecraft.light_blue_concrete_powder' | 'minecraft.dropped:minecraft.light_blue_concrete_powder' | 'minecraft.picked_up:minecraft.light_blue_concrete_powder' | 'minecraft.used:minecraft.light_blue_concrete_powder' | 'minecraft.crafted:minecraft.light_blue_dye' | 'minecraft.dropped:minecraft.light_blue_dye' | 'minecraft.picked_up:minecraft.light_blue_dye' | 'minecraft.used:minecraft.light_blue_dye' | 'minecraft.crafted:minecraft.light_blue_glazed_terracotta' | 'minecraft.dropped:minecraft.light_blue_glazed_terracotta' | 'minecraft.picked_up:minecraft.light_blue_glazed_terracotta' | 'minecraft.used:minecraft.light_blue_glazed_terracotta' | 'minecraft.crafted:minecraft.light_blue_shulker_box' | 'minecraft.dropped:minecraft.light_blue_shulker_box' | 'minecraft.picked_up:minecraft.light_blue_shulker_box' | 'minecraft.used:minecraft.light_blue_shulker_box' | 'minecraft.crafted:minecraft.light_blue_stained_glass' | 'minecraft.dropped:minecraft.light_blue_stained_glass' | 'minecraft.picked_up:minecraft.light_blue_stained_glass' | 'minecraft.used:minecraft.light_blue_stained_glass' | 'minecraft.crafted:minecraft.light_blue_stained_glass_pane' | 'minecraft.dropped:minecraft.light_blue_stained_glass_pane' | 'minecraft.picked_up:minecraft.light_blue_stained_glass_pane' | 'minecraft.used:minecraft.light_blue_stained_glass_pane' | 'minecraft.crafted:minecraft.light_blue_terracotta' | 'minecraft.dropped:minecraft.light_blue_terracotta' | 'minecraft.picked_up:minecraft.light_blue_terracotta' | 'minecraft.used:minecraft.light_blue_terracotta' | 'minecraft.crafted:minecraft.light_blue_wool' | 'minecraft.dropped:minecraft.light_blue_wool' | 'minecraft.picked_up:minecraft.light_blue_wool' | 'minecraft.used:minecraft.light_blue_wool' | 'minecraft.crafted:minecraft.light_gray_banner' | 'minecraft.dropped:minecraft.light_gray_banner' | 'minecraft.picked_up:minecraft.light_gray_banner' | 'minecraft.used:minecraft.light_gray_banner' | 'minecraft.crafted:minecraft.light_gray_bed' | 'minecraft.dropped:minecraft.light_gray_bed' | 'minecraft.picked_up:minecraft.light_gray_bed' | 'minecraft.used:minecraft.light_gray_bed' | 'minecraft.crafted:minecraft.light_gray_candle' | 'minecraft.dropped:minecraft.light_gray_candle' | 'minecraft.picked_up:minecraft.light_gray_candle' | 'minecraft.used:minecraft.light_gray_candle' | 'minecraft.crafted:minecraft.light_gray_carpet' | 'minecraft.dropped:minecraft.light_gray_carpet' | 'minecraft.picked_up:minecraft.light_gray_carpet' | 'minecraft.used:minecraft.light_gray_carpet' | 'minecraft.crafted:minecraft.light_gray_concrete' | 'minecraft.dropped:minecraft.light_gray_concrete' | 'minecraft.picked_up:minecraft.light_gray_concrete' | 'minecraft.used:minecraft.light_gray_concrete' | 'minecraft.crafted:minecraft.light_gray_concrete_powder' | 'minecraft.dropped:minecraft.light_gray_concrete_powder' | 'minecraft.picked_up:minecraft.light_gray_concrete_powder' | 'minecraft.used:minecraft.light_gray_concrete_powder' | 'minecraft.crafted:minecraft.light_gray_dye' | 'minecraft.dropped:minecraft.light_gray_dye' | 'minecraft.picked_up:minecraft.light_gray_dye' | 'minecraft.used:minecraft.light_gray_dye' | 'minecraft.crafted:minecraft.light_gray_glazed_terracotta' | 'minecraft.dropped:minecraft.light_gray_glazed_terracotta' | 'minecraft.picked_up:minecraft.light_gray_glazed_terracotta' | 'minecraft.used:minecraft.light_gray_glazed_terracotta' | 'minecraft.crafted:minecraft.light_gray_shulker_box' | 'minecraft.dropped:minecraft.light_gray_shulker_box' | 'minecraft.picked_up:minecraft.light_gray_shulker_box' | 'minecraft.used:minecraft.light_gray_shulker_box' | 'minecraft.crafted:minecraft.light_gray_stained_glass' | 'minecraft.dropped:minecraft.light_gray_stained_glass' | 'minecraft.picked_up:minecraft.light_gray_stained_glass' | 'minecraft.used:minecraft.light_gray_stained_glass' | 'minecraft.crafted:minecraft.light_gray_stained_glass_pane' | 'minecraft.dropped:minecraft.light_gray_stained_glass_pane' | 'minecraft.picked_up:minecraft.light_gray_stained_glass_pane' | 'minecraft.used:minecraft.light_gray_stained_glass_pane' | 'minecraft.crafted:minecraft.light_gray_terracotta' | 'minecraft.dropped:minecraft.light_gray_terracotta' | 'minecraft.picked_up:minecraft.light_gray_terracotta' | 'minecraft.used:minecraft.light_gray_terracotta' | 'minecraft.crafted:minecraft.light_gray_wool' | 'minecraft.dropped:minecraft.light_gray_wool' | 'minecraft.picked_up:minecraft.light_gray_wool' | 'minecraft.used:minecraft.light_gray_wool' | 'minecraft.crafted:minecraft.light_weighted_pressure_plate' | 'minecraft.dropped:minecraft.light_weighted_pressure_plate' | 'minecraft.picked_up:minecraft.light_weighted_pressure_plate' | 'minecraft.used:minecraft.light_weighted_pressure_plate' | 'minecraft.crafted:minecraft.lightning_rod' | 'minecraft.dropped:minecraft.lightning_rod' | 'minecraft.picked_up:minecraft.lightning_rod' | 'minecraft.used:minecraft.lightning_rod' | 'minecraft.crafted:minecraft.lilac' | 'minecraft.dropped:minecraft.lilac' | 'minecraft.picked_up:minecraft.lilac' | 'minecraft.used:minecraft.lilac' | 'minecraft.crafted:minecraft.lily_of_the_valley' | 'minecraft.dropped:minecraft.lily_of_the_valley' | 'minecraft.picked_up:minecraft.lily_of_the_valley' | 'minecraft.used:minecraft.lily_of_the_valley' | 'minecraft.crafted:minecraft.lily_pad' | 'minecraft.dropped:minecraft.lily_pad' | 'minecraft.picked_up:minecraft.lily_pad' | 'minecraft.used:minecraft.lily_pad' | 'minecraft.crafted:minecraft.lime_banner' | 'minecraft.dropped:minecraft.lime_banner' | 'minecraft.picked_up:minecraft.lime_banner' | 'minecraft.used:minecraft.lime_banner' | 'minecraft.crafted:minecraft.lime_bed' | 'minecraft.dropped:minecraft.lime_bed' | 'minecraft.picked_up:minecraft.lime_bed' | 'minecraft.used:minecraft.lime_bed' | 'minecraft.crafted:minecraft.lime_candle' | 'minecraft.dropped:minecraft.lime_candle' | 'minecraft.picked_up:minecraft.lime_candle' | 'minecraft.used:minecraft.lime_candle' | 'minecraft.crafted:minecraft.lime_carpet' | 'minecraft.dropped:minecraft.lime_carpet' | 'minecraft.picked_up:minecraft.lime_carpet' | 'minecraft.used:minecraft.lime_carpet' | 'minecraft.crafted:minecraft.lime_concrete' | 'minecraft.dropped:minecraft.lime_concrete' | 'minecraft.picked_up:minecraft.lime_concrete' | 'minecraft.used:minecraft.lime_concrete' | 'minecraft.crafted:minecraft.lime_concrete_powder' | 'minecraft.dropped:minecraft.lime_concrete_powder' | 'minecraft.picked_up:minecraft.lime_concrete_powder' | 'minecraft.used:minecraft.lime_concrete_powder' | 'minecraft.crafted:minecraft.lime_dye' | 'minecraft.dropped:minecraft.lime_dye' | 'minecraft.picked_up:minecraft.lime_dye' | 'minecraft.used:minecraft.lime_dye' | 'minecraft.crafted:minecraft.lime_glazed_terracotta' | 'minecraft.dropped:minecraft.lime_glazed_terracotta' | 'minecraft.picked_up:minecraft.lime_glazed_terracotta' | 'minecraft.used:minecraft.lime_glazed_terracotta' | 'minecraft.crafted:minecraft.lime_shulker_box' | 'minecraft.dropped:minecraft.lime_shulker_box' | 'minecraft.picked_up:minecraft.lime_shulker_box' | 'minecraft.used:minecraft.lime_shulker_box' | 'minecraft.crafted:minecraft.lime_stained_glass' | 'minecraft.dropped:minecraft.lime_stained_glass' | 'minecraft.picked_up:minecraft.lime_stained_glass' | 'minecraft.used:minecraft.lime_stained_glass' | 'minecraft.crafted:minecraft.lime_stained_glass_pane' | 'minecraft.dropped:minecraft.lime_stained_glass_pane' | 'minecraft.picked_up:minecraft.lime_stained_glass_pane' | 'minecraft.used:minecraft.lime_stained_glass_pane' | 'minecraft.crafted:minecraft.lime_terracotta' | 'minecraft.dropped:minecraft.lime_terracotta' | 'minecraft.picked_up:minecraft.lime_terracotta' | 'minecraft.used:minecraft.lime_terracotta' | 'minecraft.crafted:minecraft.lime_wool' | 'minecraft.dropped:minecraft.lime_wool' | 'minecraft.picked_up:minecraft.lime_wool' | 'minecraft.used:minecraft.lime_wool' | 'minecraft.crafted:minecraft.lingering_potion' | 'minecraft.dropped:minecraft.lingering_potion' | 'minecraft.picked_up:minecraft.lingering_potion' | 'minecraft.used:minecraft.lingering_potion' | 'minecraft.crafted:minecraft.llama_spawn_egg' | 'minecraft.dropped:minecraft.llama_spawn_egg' | 'minecraft.picked_up:minecraft.llama_spawn_egg' | 'minecraft.used:minecraft.llama_spawn_egg' | 'minecraft.crafted:minecraft.lodestone' | 'minecraft.dropped:minecraft.lodestone' | 'minecraft.picked_up:minecraft.lodestone' | 'minecraft.used:minecraft.lodestone' | 'minecraft.crafted:minecraft.loom' | 'minecraft.dropped:minecraft.loom' | 'minecraft.picked_up:minecraft.loom' | 'minecraft.used:minecraft.loom' | 'minecraft.crafted:minecraft.magenta_banner' | 'minecraft.dropped:minecraft.magenta_banner' | 'minecraft.picked_up:minecraft.magenta_banner' | 'minecraft.used:minecraft.magenta_banner' | 'minecraft.crafted:minecraft.magenta_bed' | 'minecraft.dropped:minecraft.magenta_bed' | 'minecraft.picked_up:minecraft.magenta_bed' | 'minecraft.used:minecraft.magenta_bed' | 'minecraft.crafted:minecraft.magenta_candle' | 'minecraft.dropped:minecraft.magenta_candle' | 'minecraft.picked_up:minecraft.magenta_candle' | 'minecraft.used:minecraft.magenta_candle' | 'minecraft.crafted:minecraft.magenta_carpet' | 'minecraft.dropped:minecraft.magenta_carpet' | 'minecraft.picked_up:minecraft.magenta_carpet' | 'minecraft.used:minecraft.magenta_carpet' | 'minecraft.crafted:minecraft.magenta_concrete' | 'minecraft.dropped:minecraft.magenta_concrete' | 'minecraft.picked_up:minecraft.magenta_concrete' | 'minecraft.used:minecraft.magenta_concrete' | 'minecraft.crafted:minecraft.magenta_concrete_powder' | 'minecraft.dropped:minecraft.magenta_concrete_powder' | 'minecraft.picked_up:minecraft.magenta_concrete_powder' | 'minecraft.used:minecraft.magenta_concrete_powder' | 'minecraft.crafted:minecraft.magenta_dye' | 'minecraft.dropped:minecraft.magenta_dye' | 'minecraft.picked_up:minecraft.magenta_dye' | 'minecraft.used:minecraft.magenta_dye' | 'minecraft.crafted:minecraft.magenta_glazed_terracotta' | 'minecraft.dropped:minecraft.magenta_glazed_terracotta' | 'minecraft.picked_up:minecraft.magenta_glazed_terracotta' | 'minecraft.used:minecraft.magenta_glazed_terracotta' | 'minecraft.crafted:minecraft.magenta_shulker_box' | 'minecraft.dropped:minecraft.magenta_shulker_box' | 'minecraft.picked_up:minecraft.magenta_shulker_box' | 'minecraft.used:minecraft.magenta_shulker_box' | 'minecraft.crafted:minecraft.magenta_stained_glass' | 'minecraft.dropped:minecraft.magenta_stained_glass' | 'minecraft.picked_up:minecraft.magenta_stained_glass' | 'minecraft.used:minecraft.magenta_stained_glass' | 'minecraft.crafted:minecraft.magenta_stained_glass_pane' | 'minecraft.dropped:minecraft.magenta_stained_glass_pane' | 'minecraft.picked_up:minecraft.magenta_stained_glass_pane' | 'minecraft.used:minecraft.magenta_stained_glass_pane' | 'minecraft.crafted:minecraft.magenta_terracotta' | 'minecraft.dropped:minecraft.magenta_terracotta' | 'minecraft.picked_up:minecraft.magenta_terracotta' | 'minecraft.used:minecraft.magenta_terracotta' | 'minecraft.crafted:minecraft.magenta_wool' | 'minecraft.dropped:minecraft.magenta_wool' | 'minecraft.picked_up:minecraft.magenta_wool' | 'minecraft.used:minecraft.magenta_wool' | 'minecraft.crafted:minecraft.magma_block' | 'minecraft.dropped:minecraft.magma_block' | 'minecraft.picked_up:minecraft.magma_block' | 'minecraft.used:minecraft.magma_block' | 'minecraft.crafted:minecraft.magma_cream' | 'minecraft.dropped:minecraft.magma_cream' | 'minecraft.picked_up:minecraft.magma_cream' | 'minecraft.used:minecraft.magma_cream' | 'minecraft.crafted:minecraft.magma_cube_spawn_egg' | 'minecraft.dropped:minecraft.magma_cube_spawn_egg' | 'minecraft.picked_up:minecraft.magma_cube_spawn_egg' | 'minecraft.used:minecraft.magma_cube_spawn_egg' | 'minecraft.crafted:minecraft.mangrove_boat' | 'minecraft.dropped:minecraft.mangrove_boat' | 'minecraft.picked_up:minecraft.mangrove_boat' | 'minecraft.used:minecraft.mangrove_boat' | 'minecraft.crafted:minecraft.mangrove_button' | 'minecraft.dropped:minecraft.mangrove_button' | 'minecraft.picked_up:minecraft.mangrove_button' | 'minecraft.used:minecraft.mangrove_button' | 'minecraft.crafted:minecraft.mangrove_chest_boat' | 'minecraft.dropped:minecraft.mangrove_chest_boat' | 'minecraft.picked_up:minecraft.mangrove_chest_boat' | 'minecraft.used:minecraft.mangrove_chest_boat' | 'minecraft.crafted:minecraft.mangrove_door' | 'minecraft.dropped:minecraft.mangrove_door' | 'minecraft.picked_up:minecraft.mangrove_door' | 'minecraft.used:minecraft.mangrove_door' | 'minecraft.crafted:minecraft.mangrove_fence' | 'minecraft.dropped:minecraft.mangrove_fence' | 'minecraft.picked_up:minecraft.mangrove_fence' | 'minecraft.used:minecraft.mangrove_fence' | 'minecraft.crafted:minecraft.mangrove_fence_gate' | 'minecraft.dropped:minecraft.mangrove_fence_gate' | 'minecraft.picked_up:minecraft.mangrove_fence_gate' | 'minecraft.used:minecraft.mangrove_fence_gate' | 'minecraft.crafted:minecraft.mangrove_hanging_sign' | 'minecraft.dropped:minecraft.mangrove_hanging_sign' | 'minecraft.picked_up:minecraft.mangrove_hanging_sign' | 'minecraft.used:minecraft.mangrove_hanging_sign' | 'minecraft.crafted:minecraft.mangrove_leaves' | 'minecraft.dropped:minecraft.mangrove_leaves' | 'minecraft.picked_up:minecraft.mangrove_leaves' | 'minecraft.used:minecraft.mangrove_leaves' | 'minecraft.crafted:minecraft.mangrove_log' | 'minecraft.dropped:minecraft.mangrove_log' | 'minecraft.picked_up:minecraft.mangrove_log' | 'minecraft.used:minecraft.mangrove_log' | 'minecraft.crafted:minecraft.mangrove_planks' | 'minecraft.dropped:minecraft.mangrove_planks' | 'minecraft.picked_up:minecraft.mangrove_planks' | 'minecraft.used:minecraft.mangrove_planks' | 'minecraft.crafted:minecraft.mangrove_pressure_plate' | 'minecraft.dropped:minecraft.mangrove_pressure_plate' | 'minecraft.picked_up:minecraft.mangrove_pressure_plate' | 'minecraft.used:minecraft.mangrove_pressure_plate' | 'minecraft.crafted:minecraft.mangrove_propagule' | 'minecraft.dropped:minecraft.mangrove_propagule' | 'minecraft.picked_up:minecraft.mangrove_propagule' | 'minecraft.used:minecraft.mangrove_propagule' | 'minecraft.crafted:minecraft.mangrove_roots' | 'minecraft.dropped:minecraft.mangrove_roots' | 'minecraft.picked_up:minecraft.mangrove_roots' | 'minecraft.used:minecraft.mangrove_roots' | 'minecraft.crafted:minecraft.mangrove_sign' | 'minecraft.dropped:minecraft.mangrove_sign' | 'minecraft.picked_up:minecraft.mangrove_sign' | 'minecraft.used:minecraft.mangrove_sign' | 'minecraft.crafted:minecraft.mangrove_slab' | 'minecraft.dropped:minecraft.mangrove_slab' | 'minecraft.picked_up:minecraft.mangrove_slab' | 'minecraft.used:minecraft.mangrove_slab' | 'minecraft.crafted:minecraft.mangrove_stairs' | 'minecraft.dropped:minecraft.mangrove_stairs' | 'minecraft.picked_up:minecraft.mangrove_stairs' | 'minecraft.used:minecraft.mangrove_stairs' | 'minecraft.crafted:minecraft.mangrove_trapdoor' | 'minecraft.dropped:minecraft.mangrove_trapdoor' | 'minecraft.picked_up:minecraft.mangrove_trapdoor' | 'minecraft.used:minecraft.mangrove_trapdoor' | 'minecraft.crafted:minecraft.mangrove_wood' | 'minecraft.dropped:minecraft.mangrove_wood' | 'minecraft.picked_up:minecraft.mangrove_wood' | 'minecraft.used:minecraft.mangrove_wood' | 'minecraft.crafted:minecraft.map' | 'minecraft.dropped:minecraft.map' | 'minecraft.picked_up:minecraft.map' | 'minecraft.used:minecraft.map' | 'minecraft.crafted:minecraft.medium_amethyst_bud' | 'minecraft.dropped:minecraft.medium_amethyst_bud' | 'minecraft.picked_up:minecraft.medium_amethyst_bud' | 'minecraft.used:minecraft.medium_amethyst_bud' | 'minecraft.crafted:minecraft.melon' | 'minecraft.dropped:minecraft.melon' | 'minecraft.picked_up:minecraft.melon' | 'minecraft.used:minecraft.melon' | 'minecraft.crafted:minecraft.melon_seeds' | 'minecraft.dropped:minecraft.melon_seeds' | 'minecraft.picked_up:minecraft.melon_seeds' | 'minecraft.used:minecraft.melon_seeds' | 'minecraft.crafted:minecraft.melon_slice' | 'minecraft.dropped:minecraft.melon_slice' | 'minecraft.picked_up:minecraft.melon_slice' | 'minecraft.used:minecraft.melon_slice' | 'minecraft.crafted:minecraft.milk_bucket' | 'minecraft.dropped:minecraft.milk_bucket' | 'minecraft.picked_up:minecraft.milk_bucket' | 'minecraft.used:minecraft.milk_bucket' | 'minecraft.crafted:minecraft.minecart' | 'minecraft.dropped:minecraft.minecart' | 'minecraft.picked_up:minecraft.minecart' | 'minecraft.used:minecraft.minecart' | 'minecraft.crafted:minecraft.miner_pottery_sherd' | 'minecraft.dropped:minecraft.miner_pottery_sherd' | 'minecraft.picked_up:minecraft.miner_pottery_sherd' | 'minecraft.used:minecraft.miner_pottery_sherd' | 'minecraft.crafted:minecraft.mojang_banner_pattern' | 'minecraft.dropped:minecraft.mojang_banner_pattern' | 'minecraft.picked_up:minecraft.mojang_banner_pattern' | 'minecraft.used:minecraft.mojang_banner_pattern' | 'minecraft.crafted:minecraft.mooshroom_spawn_egg' | 'minecraft.dropped:minecraft.mooshroom_spawn_egg' | 'minecraft.picked_up:minecraft.mooshroom_spawn_egg' | 'minecraft.used:minecraft.mooshroom_spawn_egg' | 'minecraft.crafted:minecraft.moss_block' | 'minecraft.dropped:minecraft.moss_block' | 'minecraft.picked_up:minecraft.moss_block' | 'minecraft.used:minecraft.moss_block' | 'minecraft.crafted:minecraft.moss_carpet' | 'minecraft.dropped:minecraft.moss_carpet' | 'minecraft.picked_up:minecraft.moss_carpet' | 'minecraft.used:minecraft.moss_carpet' | 'minecraft.crafted:minecraft.mossy_cobblestone' | 'minecraft.dropped:minecraft.mossy_cobblestone' | 'minecraft.picked_up:minecraft.mossy_cobblestone' | 'minecraft.used:minecraft.mossy_cobblestone' | 'minecraft.crafted:minecraft.mossy_cobblestone_slab' | 'minecraft.dropped:minecraft.mossy_cobblestone_slab' | 'minecraft.picked_up:minecraft.mossy_cobblestone_slab' | 'minecraft.used:minecraft.mossy_cobblestone_slab' | 'minecraft.crafted:minecraft.mossy_cobblestone_stairs' | 'minecraft.dropped:minecraft.mossy_cobblestone_stairs' | 'minecraft.picked_up:minecraft.mossy_cobblestone_stairs' | 'minecraft.used:minecraft.mossy_cobblestone_stairs' | 'minecraft.crafted:minecraft.mossy_cobblestone_wall' | 'minecraft.dropped:minecraft.mossy_cobblestone_wall' | 'minecraft.picked_up:minecraft.mossy_cobblestone_wall' | 'minecraft.used:minecraft.mossy_cobblestone_wall' | 'minecraft.crafted:minecraft.mossy_stone_brick_slab' | 'minecraft.dropped:minecraft.mossy_stone_brick_slab' | 'minecraft.picked_up:minecraft.mossy_stone_brick_slab' | 'minecraft.used:minecraft.mossy_stone_brick_slab' | 'minecraft.crafted:minecraft.mossy_stone_brick_stairs' | 'minecraft.dropped:minecraft.mossy_stone_brick_stairs' | 'minecraft.picked_up:minecraft.mossy_stone_brick_stairs' | 'minecraft.used:minecraft.mossy_stone_brick_stairs' | 'minecraft.crafted:minecraft.mossy_stone_brick_wall' | 'minecraft.dropped:minecraft.mossy_stone_brick_wall' | 'minecraft.picked_up:minecraft.mossy_stone_brick_wall' | 'minecraft.used:minecraft.mossy_stone_brick_wall' | 'minecraft.crafted:minecraft.mossy_stone_bricks' | 'minecraft.dropped:minecraft.mossy_stone_bricks' | 'minecraft.picked_up:minecraft.mossy_stone_bricks' | 'minecraft.used:minecraft.mossy_stone_bricks' | 'minecraft.crafted:minecraft.mourner_pottery_sherd' | 'minecraft.dropped:minecraft.mourner_pottery_sherd' | 'minecraft.picked_up:minecraft.mourner_pottery_sherd' | 'minecraft.used:minecraft.mourner_pottery_sherd' | 'minecraft.crafted:minecraft.mud' | 'minecraft.dropped:minecraft.mud' | 'minecraft.picked_up:minecraft.mud' | 'minecraft.used:minecraft.mud' | 'minecraft.crafted:minecraft.mud_brick_slab' | 'minecraft.dropped:minecraft.mud_brick_slab' | 'minecraft.picked_up:minecraft.mud_brick_slab' | 'minecraft.used:minecraft.mud_brick_slab' | 'minecraft.crafted:minecraft.mud_brick_stairs' | 'minecraft.dropped:minecraft.mud_brick_stairs' | 'minecraft.picked_up:minecraft.mud_brick_stairs' | 'minecraft.used:minecraft.mud_brick_stairs' | 'minecraft.crafted:minecraft.mud_brick_wall' | 'minecraft.dropped:minecraft.mud_brick_wall' | 'minecraft.picked_up:minecraft.mud_brick_wall' | 'minecraft.used:minecraft.mud_brick_wall' | 'minecraft.crafted:minecraft.mud_bricks' | 'minecraft.dropped:minecraft.mud_bricks' | 'minecraft.picked_up:minecraft.mud_bricks' | 'minecraft.used:minecraft.mud_bricks' | 'minecraft.crafted:minecraft.muddy_mangrove_roots' | 'minecraft.dropped:minecraft.muddy_mangrove_roots' | 'minecraft.picked_up:minecraft.muddy_mangrove_roots' | 'minecraft.used:minecraft.muddy_mangrove_roots' | 'minecraft.crafted:minecraft.mule_spawn_egg' | 'minecraft.dropped:minecraft.mule_spawn_egg' | 'minecraft.picked_up:minecraft.mule_spawn_egg' | 'minecraft.used:minecraft.mule_spawn_egg' | 'minecraft.crafted:minecraft.mushroom_stem' | 'minecraft.dropped:minecraft.mushroom_stem' | 'minecraft.picked_up:minecraft.mushroom_stem' | 'minecraft.used:minecraft.mushroom_stem' | 'minecraft.crafted:minecraft.mushroom_stew' | 'minecraft.dropped:minecraft.mushroom_stew' | 'minecraft.picked_up:minecraft.mushroom_stew' | 'minecraft.used:minecraft.mushroom_stew' | 'minecraft.crafted:minecraft.music_disc_11' | 'minecraft.dropped:minecraft.music_disc_11' | 'minecraft.picked_up:minecraft.music_disc_11' | 'minecraft.used:minecraft.music_disc_11' | 'minecraft.crafted:minecraft.music_disc_13' | 'minecraft.dropped:minecraft.music_disc_13' | 'minecraft.picked_up:minecraft.music_disc_13' | 'minecraft.used:minecraft.music_disc_13' | 'minecraft.crafted:minecraft.music_disc_5' | 'minecraft.dropped:minecraft.music_disc_5' | 'minecraft.picked_up:minecraft.music_disc_5' | 'minecraft.used:minecraft.music_disc_5' | 'minecraft.crafted:minecraft.music_disc_blocks' | 'minecraft.dropped:minecraft.music_disc_blocks' | 'minecraft.picked_up:minecraft.music_disc_blocks' | 'minecraft.used:minecraft.music_disc_blocks' | 'minecraft.crafted:minecraft.music_disc_cat' | 'minecraft.dropped:minecraft.music_disc_cat' | 'minecraft.picked_up:minecraft.music_disc_cat' | 'minecraft.used:minecraft.music_disc_cat' | 'minecraft.crafted:minecraft.music_disc_chirp' | 'minecraft.dropped:minecraft.music_disc_chirp' | 'minecraft.picked_up:minecraft.music_disc_chirp' | 'minecraft.used:minecraft.music_disc_chirp' | 'minecraft.crafted:minecraft.music_disc_far' | 'minecraft.dropped:minecraft.music_disc_far' | 'minecraft.picked_up:minecraft.music_disc_far' | 'minecraft.used:minecraft.music_disc_far' | 'minecraft.crafted:minecraft.music_disc_mall' | 'minecraft.dropped:minecraft.music_disc_mall' | 'minecraft.picked_up:minecraft.music_disc_mall' | 'minecraft.used:minecraft.music_disc_mall' | 'minecraft.crafted:minecraft.music_disc_mellohi' | 'minecraft.dropped:minecraft.music_disc_mellohi' | 'minecraft.picked_up:minecraft.music_disc_mellohi' | 'minecraft.used:minecraft.music_disc_mellohi' | 'minecraft.crafted:minecraft.music_disc_otherside' | 'minecraft.dropped:minecraft.music_disc_otherside' | 'minecraft.picked_up:minecraft.music_disc_otherside' | 'minecraft.used:minecraft.music_disc_otherside' | 'minecraft.crafted:minecraft.music_disc_pigstep' | 'minecraft.dropped:minecraft.music_disc_pigstep' | 'minecraft.picked_up:minecraft.music_disc_pigstep' | 'minecraft.used:minecraft.music_disc_pigstep' | 'minecraft.crafted:minecraft.music_disc_relic' | 'minecraft.dropped:minecraft.music_disc_relic' | 'minecraft.picked_up:minecraft.music_disc_relic' | 'minecraft.used:minecraft.music_disc_relic' | 'minecraft.crafted:minecraft.music_disc_stal' | 'minecraft.dropped:minecraft.music_disc_stal' | 'minecraft.picked_up:minecraft.music_disc_stal' | 'minecraft.used:minecraft.music_disc_stal' | 'minecraft.crafted:minecraft.music_disc_strad' | 'minecraft.dropped:minecraft.music_disc_strad' | 'minecraft.picked_up:minecraft.music_disc_strad' | 'minecraft.used:minecraft.music_disc_strad' | 'minecraft.crafted:minecraft.music_disc_wait' | 'minecraft.dropped:minecraft.music_disc_wait' | 'minecraft.picked_up:minecraft.music_disc_wait' | 'minecraft.used:minecraft.music_disc_wait' | 'minecraft.crafted:minecraft.music_disc_ward' | 'minecraft.dropped:minecraft.music_disc_ward' | 'minecraft.picked_up:minecraft.music_disc_ward' | 'minecraft.used:minecraft.music_disc_ward' | 'minecraft.crafted:minecraft.mutton' | 'minecraft.dropped:minecraft.mutton' | 'minecraft.picked_up:minecraft.mutton' | 'minecraft.used:minecraft.mutton' | 'minecraft.crafted:minecraft.mycelium' | 'minecraft.dropped:minecraft.mycelium' | 'minecraft.picked_up:minecraft.mycelium' | 'minecraft.used:minecraft.mycelium' | 'minecraft.crafted:minecraft.name_tag' | 'minecraft.dropped:minecraft.name_tag' | 'minecraft.picked_up:minecraft.name_tag' | 'minecraft.used:minecraft.name_tag' | 'minecraft.crafted:minecraft.nautilus_shell' | 'minecraft.dropped:minecraft.nautilus_shell' | 'minecraft.picked_up:minecraft.nautilus_shell' | 'minecraft.used:minecraft.nautilus_shell' | 'minecraft.crafted:minecraft.nether_brick' | 'minecraft.dropped:minecraft.nether_brick' | 'minecraft.picked_up:minecraft.nether_brick' | 'minecraft.used:minecraft.nether_brick' | 'minecraft.crafted:minecraft.nether_brick_fence' | 'minecraft.dropped:minecraft.nether_brick_fence' | 'minecraft.picked_up:minecraft.nether_brick_fence' | 'minecraft.used:minecraft.nether_brick_fence' | 'minecraft.crafted:minecraft.nether_brick_slab' | 'minecraft.dropped:minecraft.nether_brick_slab' | 'minecraft.picked_up:minecraft.nether_brick_slab' | 'minecraft.used:minecraft.nether_brick_slab' | 'minecraft.crafted:minecraft.nether_brick_stairs' | 'minecraft.dropped:minecraft.nether_brick_stairs' | 'minecraft.picked_up:minecraft.nether_brick_stairs' | 'minecraft.used:minecraft.nether_brick_stairs' | 'minecraft.crafted:minecraft.nether_brick_wall' | 'minecraft.dropped:minecraft.nether_brick_wall' | 'minecraft.picked_up:minecraft.nether_brick_wall' | 'minecraft.used:minecraft.nether_brick_wall' | 'minecraft.crafted:minecraft.nether_bricks' | 'minecraft.dropped:minecraft.nether_bricks' | 'minecraft.picked_up:minecraft.nether_bricks' | 'minecraft.used:minecraft.nether_bricks' | 'minecraft.crafted:minecraft.nether_gold_ore' | 'minecraft.dropped:minecraft.nether_gold_ore' | 'minecraft.picked_up:minecraft.nether_gold_ore' | 'minecraft.used:minecraft.nether_gold_ore' | 'minecraft.crafted:minecraft.nether_quartz_ore' | 'minecraft.dropped:minecraft.nether_quartz_ore' | 'minecraft.picked_up:minecraft.nether_quartz_ore' | 'minecraft.used:minecraft.nether_quartz_ore' | 'minecraft.crafted:minecraft.nether_sprouts' | 'minecraft.dropped:minecraft.nether_sprouts' | 'minecraft.picked_up:minecraft.nether_sprouts' | 'minecraft.used:minecraft.nether_sprouts' | 'minecraft.crafted:minecraft.nether_star' | 'minecraft.dropped:minecraft.nether_star' | 'minecraft.picked_up:minecraft.nether_star' | 'minecraft.used:minecraft.nether_star' | 'minecraft.crafted:minecraft.nether_wart' | 'minecraft.dropped:minecraft.nether_wart' | 'minecraft.picked_up:minecraft.nether_wart' | 'minecraft.used:minecraft.nether_wart' | 'minecraft.crafted:minecraft.nether_wart_block' | 'minecraft.dropped:minecraft.nether_wart_block' | 'minecraft.picked_up:minecraft.nether_wart_block' | 'minecraft.used:minecraft.nether_wart_block' | 'minecraft.crafted:minecraft.netherite_axe' | 'minecraft.dropped:minecraft.netherite_axe' | 'minecraft.picked_up:minecraft.netherite_axe' | 'minecraft.used:minecraft.netherite_axe' | 'minecraft.crafted:minecraft.netherite_block' | 'minecraft.dropped:minecraft.netherite_block' | 'minecraft.picked_up:minecraft.netherite_block' | 'minecraft.used:minecraft.netherite_block' | 'minecraft.crafted:minecraft.netherite_boots' | 'minecraft.dropped:minecraft.netherite_boots' | 'minecraft.picked_up:minecraft.netherite_boots' | 'minecraft.used:minecraft.netherite_boots' | 'minecraft.crafted:minecraft.netherite_chestplate' | 'minecraft.dropped:minecraft.netherite_chestplate' | 'minecraft.picked_up:minecraft.netherite_chestplate' | 'minecraft.used:minecraft.netherite_chestplate' | 'minecraft.crafted:minecraft.netherite_helmet' | 'minecraft.dropped:minecraft.netherite_helmet' | 'minecraft.picked_up:minecraft.netherite_helmet' | 'minecraft.used:minecraft.netherite_helmet' | 'minecraft.crafted:minecraft.netherite_hoe' | 'minecraft.dropped:minecraft.netherite_hoe' | 'minecraft.picked_up:minecraft.netherite_hoe' | 'minecraft.used:minecraft.netherite_hoe' | 'minecraft.crafted:minecraft.netherite_ingot' | 'minecraft.dropped:minecraft.netherite_ingot' | 'minecraft.picked_up:minecraft.netherite_ingot' | 'minecraft.used:minecraft.netherite_ingot' | 'minecraft.crafted:minecraft.netherite_leggings' | 'minecraft.dropped:minecraft.netherite_leggings' | 'minecraft.picked_up:minecraft.netherite_leggings' | 'minecraft.used:minecraft.netherite_leggings' | 'minecraft.crafted:minecraft.netherite_pickaxe' | 'minecraft.dropped:minecraft.netherite_pickaxe' | 'minecraft.picked_up:minecraft.netherite_pickaxe' | 'minecraft.used:minecraft.netherite_pickaxe' | 'minecraft.crafted:minecraft.netherite_scrap' | 'minecraft.dropped:minecraft.netherite_scrap' | 'minecraft.picked_up:minecraft.netherite_scrap' | 'minecraft.used:minecraft.netherite_scrap' | 'minecraft.crafted:minecraft.netherite_shovel' | 'minecraft.dropped:minecraft.netherite_shovel' | 'minecraft.picked_up:minecraft.netherite_shovel' | 'minecraft.used:minecraft.netherite_shovel' | 'minecraft.crafted:minecraft.netherite_sword' | 'minecraft.dropped:minecraft.netherite_sword' | 'minecraft.picked_up:minecraft.netherite_sword' | 'minecraft.used:minecraft.netherite_sword' | 'minecraft.crafted:minecraft.netherite_upgrade_smithing_template' | 'minecraft.dropped:minecraft.netherite_upgrade_smithing_template' | 'minecraft.picked_up:minecraft.netherite_upgrade_smithing_template' | 'minecraft.used:minecraft.netherite_upgrade_smithing_template' | 'minecraft.crafted:minecraft.netherrack' | 'minecraft.dropped:minecraft.netherrack' | 'minecraft.picked_up:minecraft.netherrack' | 'minecraft.used:minecraft.netherrack' | 'minecraft.crafted:minecraft.note_block' | 'minecraft.dropped:minecraft.note_block' | 'minecraft.picked_up:minecraft.note_block' | 'minecraft.used:minecraft.note_block' | 'minecraft.crafted:minecraft.oak_boat' | 'minecraft.dropped:minecraft.oak_boat' | 'minecraft.picked_up:minecraft.oak_boat' | 'minecraft.used:minecraft.oak_boat' | 'minecraft.crafted:minecraft.oak_button' | 'minecraft.dropped:minecraft.oak_button' | 'minecraft.picked_up:minecraft.oak_button' | 'minecraft.used:minecraft.oak_button' | 'minecraft.crafted:minecraft.oak_chest_boat' | 'minecraft.dropped:minecraft.oak_chest_boat' | 'minecraft.picked_up:minecraft.oak_chest_boat' | 'minecraft.used:minecraft.oak_chest_boat' | 'minecraft.crafted:minecraft.oak_door' | 'minecraft.dropped:minecraft.oak_door' | 'minecraft.picked_up:minecraft.oak_door' | 'minecraft.used:minecraft.oak_door' | 'minecraft.crafted:minecraft.oak_fence' | 'minecraft.dropped:minecraft.oak_fence' | 'minecraft.picked_up:minecraft.oak_fence' | 'minecraft.used:minecraft.oak_fence' | 'minecraft.crafted:minecraft.oak_fence_gate' | 'minecraft.dropped:minecraft.oak_fence_gate' | 'minecraft.picked_up:minecraft.oak_fence_gate' | 'minecraft.used:minecraft.oak_fence_gate' | 'minecraft.crafted:minecraft.oak_hanging_sign' | 'minecraft.dropped:minecraft.oak_hanging_sign' | 'minecraft.picked_up:minecraft.oak_hanging_sign' | 'minecraft.used:minecraft.oak_hanging_sign' | 'minecraft.crafted:minecraft.oak_leaves' | 'minecraft.dropped:minecraft.oak_leaves' | 'minecraft.picked_up:minecraft.oak_leaves' | 'minecraft.used:minecraft.oak_leaves' | 'minecraft.crafted:minecraft.oak_log' | 'minecraft.dropped:minecraft.oak_log' | 'minecraft.picked_up:minecraft.oak_log' | 'minecraft.used:minecraft.oak_log' | 'minecraft.crafted:minecraft.oak_planks' | 'minecraft.dropped:minecraft.oak_planks' | 'minecraft.picked_up:minecraft.oak_planks' | 'minecraft.used:minecraft.oak_planks' | 'minecraft.crafted:minecraft.oak_pressure_plate' | 'minecraft.dropped:minecraft.oak_pressure_plate' | 'minecraft.picked_up:minecraft.oak_pressure_plate' | 'minecraft.used:minecraft.oak_pressure_plate' | 'minecraft.crafted:minecraft.oak_sapling' | 'minecraft.dropped:minecraft.oak_sapling' | 'minecraft.picked_up:minecraft.oak_sapling' | 'minecraft.used:minecraft.oak_sapling' | 'minecraft.crafted:minecraft.oak_sign' | 'minecraft.dropped:minecraft.oak_sign' | 'minecraft.picked_up:minecraft.oak_sign' | 'minecraft.used:minecraft.oak_sign' | 'minecraft.crafted:minecraft.oak_slab' | 'minecraft.dropped:minecraft.oak_slab' | 'minecraft.picked_up:minecraft.oak_slab' | 'minecraft.used:minecraft.oak_slab' | 'minecraft.crafted:minecraft.oak_stairs' | 'minecraft.dropped:minecraft.oak_stairs' | 'minecraft.picked_up:minecraft.oak_stairs' | 'minecraft.used:minecraft.oak_stairs' | 'minecraft.crafted:minecraft.oak_trapdoor' | 'minecraft.dropped:minecraft.oak_trapdoor' | 'minecraft.picked_up:minecraft.oak_trapdoor' | 'minecraft.used:minecraft.oak_trapdoor' | 'minecraft.crafted:minecraft.oak_wood' | 'minecraft.dropped:minecraft.oak_wood' | 'minecraft.picked_up:minecraft.oak_wood' | 'minecraft.used:minecraft.oak_wood' | 'minecraft.crafted:minecraft.observer' | 'minecraft.dropped:minecraft.observer' | 'minecraft.picked_up:minecraft.observer' | 'minecraft.used:minecraft.observer' | 'minecraft.crafted:minecraft.obsidian' | 'minecraft.dropped:minecraft.obsidian' | 'minecraft.picked_up:minecraft.obsidian' | 'minecraft.used:minecraft.obsidian' | 'minecraft.crafted:minecraft.ocelot_spawn_egg' | 'minecraft.dropped:minecraft.ocelot_spawn_egg' | 'minecraft.picked_up:minecraft.ocelot_spawn_egg' | 'minecraft.used:minecraft.ocelot_spawn_egg' | 'minecraft.crafted:minecraft.ochre_froglight' | 'minecraft.dropped:minecraft.ochre_froglight' | 'minecraft.picked_up:minecraft.ochre_froglight' | 'minecraft.used:minecraft.ochre_froglight' | 'minecraft.crafted:minecraft.orange_banner' | 'minecraft.dropped:minecraft.orange_banner' | 'minecraft.picked_up:minecraft.orange_banner' | 'minecraft.used:minecraft.orange_banner' | 'minecraft.crafted:minecraft.orange_bed' | 'minecraft.dropped:minecraft.orange_bed' | 'minecraft.picked_up:minecraft.orange_bed' | 'minecraft.used:minecraft.orange_bed' | 'minecraft.crafted:minecraft.orange_candle' | 'minecraft.dropped:minecraft.orange_candle' | 'minecraft.picked_up:minecraft.orange_candle' | 'minecraft.used:minecraft.orange_candle' | 'minecraft.crafted:minecraft.orange_carpet' | 'minecraft.dropped:minecraft.orange_carpet' | 'minecraft.picked_up:minecraft.orange_carpet' | 'minecraft.used:minecraft.orange_carpet' | 'minecraft.crafted:minecraft.orange_concrete' | 'minecraft.dropped:minecraft.orange_concrete' | 'minecraft.picked_up:minecraft.orange_concrete' | 'minecraft.used:minecraft.orange_concrete' | 'minecraft.crafted:minecraft.orange_concrete_powder' | 'minecraft.dropped:minecraft.orange_concrete_powder' | 'minecraft.picked_up:minecraft.orange_concrete_powder' | 'minecraft.used:minecraft.orange_concrete_powder' | 'minecraft.crafted:minecraft.orange_dye' | 'minecraft.dropped:minecraft.orange_dye' | 'minecraft.picked_up:minecraft.orange_dye' | 'minecraft.used:minecraft.orange_dye' | 'minecraft.crafted:minecraft.orange_glazed_terracotta' | 'minecraft.dropped:minecraft.orange_glazed_terracotta' | 'minecraft.picked_up:minecraft.orange_glazed_terracotta' | 'minecraft.used:minecraft.orange_glazed_terracotta' | 'minecraft.crafted:minecraft.orange_shulker_box' | 'minecraft.dropped:minecraft.orange_shulker_box' | 'minecraft.picked_up:minecraft.orange_shulker_box' | 'minecraft.used:minecraft.orange_shulker_box' | 'minecraft.crafted:minecraft.orange_stained_glass' | 'minecraft.dropped:minecraft.orange_stained_glass' | 'minecraft.picked_up:minecraft.orange_stained_glass' | 'minecraft.used:minecraft.orange_stained_glass' | 'minecraft.crafted:minecraft.orange_stained_glass_pane' | 'minecraft.dropped:minecraft.orange_stained_glass_pane' | 'minecraft.picked_up:minecraft.orange_stained_glass_pane' | 'minecraft.used:minecraft.orange_stained_glass_pane' | 'minecraft.crafted:minecraft.orange_terracotta' | 'minecraft.dropped:minecraft.orange_terracotta' | 'minecraft.picked_up:minecraft.orange_terracotta' | 'minecraft.used:minecraft.orange_terracotta' | 'minecraft.crafted:minecraft.orange_tulip' | 'minecraft.dropped:minecraft.orange_tulip' | 'minecraft.picked_up:minecraft.orange_tulip' | 'minecraft.used:minecraft.orange_tulip' | 'minecraft.crafted:minecraft.orange_wool' | 'minecraft.dropped:minecraft.orange_wool' | 'minecraft.picked_up:minecraft.orange_wool' | 'minecraft.used:minecraft.orange_wool' | 'minecraft.crafted:minecraft.oxeye_daisy' | 'minecraft.dropped:minecraft.oxeye_daisy' | 'minecraft.picked_up:minecraft.oxeye_daisy' | 'minecraft.used:minecraft.oxeye_daisy' | 'minecraft.crafted:minecraft.oxidized_chiseled_copper' | 'minecraft.dropped:minecraft.oxidized_chiseled_copper' | 'minecraft.picked_up:minecraft.oxidized_chiseled_copper' | 'minecraft.used:minecraft.oxidized_chiseled_copper' | 'minecraft.crafted:minecraft.oxidized_copper' | 'minecraft.dropped:minecraft.oxidized_copper' | 'minecraft.picked_up:minecraft.oxidized_copper' | 'minecraft.used:minecraft.oxidized_copper' | 'minecraft.crafted:minecraft.oxidized_copper_bulb' | 'minecraft.dropped:minecraft.oxidized_copper_bulb' | 'minecraft.picked_up:minecraft.oxidized_copper_bulb' | 'minecraft.used:minecraft.oxidized_copper_bulb' | 'minecraft.crafted:minecraft.oxidized_copper_door' | 'minecraft.dropped:minecraft.oxidized_copper_door' | 'minecraft.picked_up:minecraft.oxidized_copper_door' | 'minecraft.used:minecraft.oxidized_copper_door' | 'minecraft.crafted:minecraft.oxidized_copper_grate' | 'minecraft.dropped:minecraft.oxidized_copper_grate' | 'minecraft.picked_up:minecraft.oxidized_copper_grate' | 'minecraft.used:minecraft.oxidized_copper_grate' | 'minecraft.crafted:minecraft.oxidized_copper_trapdoor' | 'minecraft.dropped:minecraft.oxidized_copper_trapdoor' | 'minecraft.picked_up:minecraft.oxidized_copper_trapdoor' | 'minecraft.used:minecraft.oxidized_copper_trapdoor' | 'minecraft.crafted:minecraft.oxidized_cut_copper' | 'minecraft.dropped:minecraft.oxidized_cut_copper' | 'minecraft.picked_up:minecraft.oxidized_cut_copper' | 'minecraft.used:minecraft.oxidized_cut_copper' | 'minecraft.crafted:minecraft.oxidized_cut_copper_slab' | 'minecraft.dropped:minecraft.oxidized_cut_copper_slab' | 'minecraft.picked_up:minecraft.oxidized_cut_copper_slab' | 'minecraft.used:minecraft.oxidized_cut_copper_slab' | 'minecraft.crafted:minecraft.oxidized_cut_copper_stairs' | 'minecraft.dropped:minecraft.oxidized_cut_copper_stairs' | 'minecraft.picked_up:minecraft.oxidized_cut_copper_stairs' | 'minecraft.used:minecraft.oxidized_cut_copper_stairs' | 'minecraft.crafted:minecraft.packed_ice' | 'minecraft.dropped:minecraft.packed_ice' | 'minecraft.picked_up:minecraft.packed_ice' | 'minecraft.used:minecraft.packed_ice' | 'minecraft.crafted:minecraft.packed_mud' | 'minecraft.dropped:minecraft.packed_mud' | 'minecraft.picked_up:minecraft.packed_mud' | 'minecraft.used:minecraft.packed_mud' | 'minecraft.crafted:minecraft.painting' | 'minecraft.dropped:minecraft.painting' | 'minecraft.picked_up:minecraft.painting' | 'minecraft.used:minecraft.painting' | 'minecraft.crafted:minecraft.panda_spawn_egg' | 'minecraft.dropped:minecraft.panda_spawn_egg' | 'minecraft.picked_up:minecraft.panda_spawn_egg' | 'minecraft.used:minecraft.panda_spawn_egg' | 'minecraft.crafted:minecraft.paper' | 'minecraft.dropped:minecraft.paper' | 'minecraft.picked_up:minecraft.paper' | 'minecraft.used:minecraft.paper' | 'minecraft.crafted:minecraft.parrot_spawn_egg' | 'minecraft.dropped:minecraft.parrot_spawn_egg' | 'minecraft.picked_up:minecraft.parrot_spawn_egg' | 'minecraft.used:minecraft.parrot_spawn_egg' | 'minecraft.crafted:minecraft.pearlescent_froglight' | 'minecraft.dropped:minecraft.pearlescent_froglight' | 'minecraft.picked_up:minecraft.pearlescent_froglight' | 'minecraft.used:minecraft.pearlescent_froglight' | 'minecraft.crafted:minecraft.peony' | 'minecraft.dropped:minecraft.peony' | 'minecraft.picked_up:minecraft.peony' | 'minecraft.used:minecraft.peony' | 'minecraft.crafted:minecraft.petrified_oak_slab' | 'minecraft.dropped:minecraft.petrified_oak_slab' | 'minecraft.picked_up:minecraft.petrified_oak_slab' | 'minecraft.used:minecraft.petrified_oak_slab' | 'minecraft.crafted:minecraft.phantom_membrane' | 'minecraft.dropped:minecraft.phantom_membrane' | 'minecraft.picked_up:minecraft.phantom_membrane' | 'minecraft.used:minecraft.phantom_membrane' | 'minecraft.crafted:minecraft.phantom_spawn_egg' | 'minecraft.dropped:minecraft.phantom_spawn_egg' | 'minecraft.picked_up:minecraft.phantom_spawn_egg' | 'minecraft.used:minecraft.phantom_spawn_egg' | 'minecraft.crafted:minecraft.pig_spawn_egg' | 'minecraft.dropped:minecraft.pig_spawn_egg' | 'minecraft.picked_up:minecraft.pig_spawn_egg' | 'minecraft.used:minecraft.pig_spawn_egg' | 'minecraft.crafted:minecraft.piglin_banner_pattern' | 'minecraft.dropped:minecraft.piglin_banner_pattern' | 'minecraft.picked_up:minecraft.piglin_banner_pattern' | 'minecraft.used:minecraft.piglin_banner_pattern' | 'minecraft.crafted:minecraft.piglin_brute_spawn_egg' | 'minecraft.dropped:minecraft.piglin_brute_spawn_egg' | 'minecraft.picked_up:minecraft.piglin_brute_spawn_egg' | 'minecraft.used:minecraft.piglin_brute_spawn_egg' | 'minecraft.crafted:minecraft.piglin_head' | 'minecraft.dropped:minecraft.piglin_head' | 'minecraft.picked_up:minecraft.piglin_head' | 'minecraft.used:minecraft.piglin_head' | 'minecraft.crafted:minecraft.piglin_spawn_egg' | 'minecraft.dropped:minecraft.piglin_spawn_egg' | 'minecraft.picked_up:minecraft.piglin_spawn_egg' | 'minecraft.used:minecraft.piglin_spawn_egg' | 'minecraft.crafted:minecraft.pillager_spawn_egg' | 'minecraft.dropped:minecraft.pillager_spawn_egg' | 'minecraft.picked_up:minecraft.pillager_spawn_egg' | 'minecraft.used:minecraft.pillager_spawn_egg' | 'minecraft.crafted:minecraft.pink_banner' | 'minecraft.dropped:minecraft.pink_banner' | 'minecraft.picked_up:minecraft.pink_banner' | 'minecraft.used:minecraft.pink_banner' | 'minecraft.crafted:minecraft.pink_bed' | 'minecraft.dropped:minecraft.pink_bed' | 'minecraft.picked_up:minecraft.pink_bed' | 'minecraft.used:minecraft.pink_bed' | 'minecraft.crafted:minecraft.pink_candle' | 'minecraft.dropped:minecraft.pink_candle' | 'minecraft.picked_up:minecraft.pink_candle' | 'minecraft.used:minecraft.pink_candle' | 'minecraft.crafted:minecraft.pink_carpet' | 'minecraft.dropped:minecraft.pink_carpet' | 'minecraft.picked_up:minecraft.pink_carpet' | 'minecraft.used:minecraft.pink_carpet' | 'minecraft.crafted:minecraft.pink_concrete' | 'minecraft.dropped:minecraft.pink_concrete' | 'minecraft.picked_up:minecraft.pink_concrete' | 'minecraft.used:minecraft.pink_concrete' | 'minecraft.crafted:minecraft.pink_concrete_powder' | 'minecraft.dropped:minecraft.pink_concrete_powder' | 'minecraft.picked_up:minecraft.pink_concrete_powder' | 'minecraft.used:minecraft.pink_concrete_powder' | 'minecraft.crafted:minecraft.pink_dye' | 'minecraft.dropped:minecraft.pink_dye' | 'minecraft.picked_up:minecraft.pink_dye' | 'minecraft.used:minecraft.pink_dye' | 'minecraft.crafted:minecraft.pink_glazed_terracotta' | 'minecraft.dropped:minecraft.pink_glazed_terracotta' | 'minecraft.picked_up:minecraft.pink_glazed_terracotta' | 'minecraft.used:minecraft.pink_glazed_terracotta' | 'minecraft.crafted:minecraft.pink_petals' | 'minecraft.dropped:minecraft.pink_petals' | 'minecraft.picked_up:minecraft.pink_petals' | 'minecraft.used:minecraft.pink_petals' | 'minecraft.crafted:minecraft.pink_shulker_box' | 'minecraft.dropped:minecraft.pink_shulker_box' | 'minecraft.picked_up:minecraft.pink_shulker_box' | 'minecraft.used:minecraft.pink_shulker_box' | 'minecraft.crafted:minecraft.pink_stained_glass' | 'minecraft.dropped:minecraft.pink_stained_glass' | 'minecraft.picked_up:minecraft.pink_stained_glass' | 'minecraft.used:minecraft.pink_stained_glass' | 'minecraft.crafted:minecraft.pink_stained_glass_pane' | 'minecraft.dropped:minecraft.pink_stained_glass_pane' | 'minecraft.picked_up:minecraft.pink_stained_glass_pane' | 'minecraft.used:minecraft.pink_stained_glass_pane' | 'minecraft.crafted:minecraft.pink_terracotta' | 'minecraft.dropped:minecraft.pink_terracotta' | 'minecraft.picked_up:minecraft.pink_terracotta' | 'minecraft.used:minecraft.pink_terracotta' | 'minecraft.crafted:minecraft.pink_tulip' | 'minecraft.dropped:minecraft.pink_tulip' | 'minecraft.picked_up:minecraft.pink_tulip' | 'minecraft.used:minecraft.pink_tulip' | 'minecraft.crafted:minecraft.pink_wool' | 'minecraft.dropped:minecraft.pink_wool' | 'minecraft.picked_up:minecraft.pink_wool' | 'minecraft.used:minecraft.pink_wool' | 'minecraft.crafted:minecraft.piston' | 'minecraft.dropped:minecraft.piston' | 'minecraft.picked_up:minecraft.piston' | 'minecraft.used:minecraft.piston' | 'minecraft.crafted:minecraft.pitcher_plant' | 'minecraft.dropped:minecraft.pitcher_plant' | 'minecraft.picked_up:minecraft.pitcher_plant' | 'minecraft.used:minecraft.pitcher_plant' | 'minecraft.crafted:minecraft.pitcher_pod' | 'minecraft.dropped:minecraft.pitcher_pod' | 'minecraft.picked_up:minecraft.pitcher_pod' | 'minecraft.used:minecraft.pitcher_pod' | 'minecraft.crafted:minecraft.player_head' | 'minecraft.dropped:minecraft.player_head' | 'minecraft.picked_up:minecraft.player_head' | 'minecraft.used:minecraft.player_head' | 'minecraft.crafted:minecraft.plenty_pottery_sherd' | 'minecraft.dropped:minecraft.plenty_pottery_sherd' | 'minecraft.picked_up:minecraft.plenty_pottery_sherd' | 'minecraft.used:minecraft.plenty_pottery_sherd' | 'minecraft.crafted:minecraft.podzol' | 'minecraft.dropped:minecraft.podzol' | 'minecraft.picked_up:minecraft.podzol' | 'minecraft.used:minecraft.podzol' | 'minecraft.crafted:minecraft.pointed_dripstone' | 'minecraft.dropped:minecraft.pointed_dripstone' | 'minecraft.picked_up:minecraft.pointed_dripstone' | 'minecraft.used:minecraft.pointed_dripstone' | 'minecraft.crafted:minecraft.poisonous_potato' | 'minecraft.dropped:minecraft.poisonous_potato' | 'minecraft.picked_up:minecraft.poisonous_potato' | 'minecraft.used:minecraft.poisonous_potato' | 'minecraft.crafted:minecraft.polar_bear_spawn_egg' | 'minecraft.dropped:minecraft.polar_bear_spawn_egg' | 'minecraft.picked_up:minecraft.polar_bear_spawn_egg' | 'minecraft.used:minecraft.polar_bear_spawn_egg' | 'minecraft.crafted:minecraft.polished_andesite' | 'minecraft.dropped:minecraft.polished_andesite' | 'minecraft.picked_up:minecraft.polished_andesite' | 'minecraft.used:minecraft.polished_andesite' | 'minecraft.crafted:minecraft.polished_andesite_slab' | 'minecraft.dropped:minecraft.polished_andesite_slab' | 'minecraft.picked_up:minecraft.polished_andesite_slab' | 'minecraft.used:minecraft.polished_andesite_slab' | 'minecraft.crafted:minecraft.polished_andesite_stairs' | 'minecraft.dropped:minecraft.polished_andesite_stairs' | 'minecraft.picked_up:minecraft.polished_andesite_stairs' | 'minecraft.used:minecraft.polished_andesite_stairs' | 'minecraft.crafted:minecraft.polished_basalt' | 'minecraft.dropped:minecraft.polished_basalt' | 'minecraft.picked_up:minecraft.polished_basalt' | 'minecraft.used:minecraft.polished_basalt' | 'minecraft.crafted:minecraft.polished_blackstone' | 'minecraft.dropped:minecraft.polished_blackstone' | 'minecraft.picked_up:minecraft.polished_blackstone' | 'minecraft.used:minecraft.polished_blackstone' | 'minecraft.crafted:minecraft.polished_blackstone_brick_slab' | 'minecraft.dropped:minecraft.polished_blackstone_brick_slab' | 'minecraft.picked_up:minecraft.polished_blackstone_brick_slab' | 'minecraft.used:minecraft.polished_blackstone_brick_slab' | 'minecraft.crafted:minecraft.polished_blackstone_brick_stairs' | 'minecraft.dropped:minecraft.polished_blackstone_brick_stairs' | 'minecraft.picked_up:minecraft.polished_blackstone_brick_stairs' | 'minecraft.used:minecraft.polished_blackstone_brick_stairs' | 'minecraft.crafted:minecraft.polished_blackstone_brick_wall' | 'minecraft.dropped:minecraft.polished_blackstone_brick_wall' | 'minecraft.picked_up:minecraft.polished_blackstone_brick_wall' | 'minecraft.used:minecraft.polished_blackstone_brick_wall' | 'minecraft.crafted:minecraft.polished_blackstone_bricks' | 'minecraft.dropped:minecraft.polished_blackstone_bricks' | 'minecraft.picked_up:minecraft.polished_blackstone_bricks' | 'minecraft.used:minecraft.polished_blackstone_bricks' | 'minecraft.crafted:minecraft.polished_blackstone_button' | 'minecraft.dropped:minecraft.polished_blackstone_button' | 'minecraft.picked_up:minecraft.polished_blackstone_button' | 'minecraft.used:minecraft.polished_blackstone_button' | 'minecraft.crafted:minecraft.polished_blackstone_pressure_plate' | 'minecraft.dropped:minecraft.polished_blackstone_pressure_plate' | 'minecraft.picked_up:minecraft.polished_blackstone_pressure_plate' | 'minecraft.used:minecraft.polished_blackstone_pressure_plate' | 'minecraft.crafted:minecraft.polished_blackstone_slab' | 'minecraft.dropped:minecraft.polished_blackstone_slab' | 'minecraft.picked_up:minecraft.polished_blackstone_slab' | 'minecraft.used:minecraft.polished_blackstone_slab' | 'minecraft.crafted:minecraft.polished_blackstone_stairs' | 'minecraft.dropped:minecraft.polished_blackstone_stairs' | 'minecraft.picked_up:minecraft.polished_blackstone_stairs' | 'minecraft.used:minecraft.polished_blackstone_stairs' | 'minecraft.crafted:minecraft.polished_blackstone_wall' | 'minecraft.dropped:minecraft.polished_blackstone_wall' | 'minecraft.picked_up:minecraft.polished_blackstone_wall' | 'minecraft.used:minecraft.polished_blackstone_wall' | 'minecraft.crafted:minecraft.polished_deepslate' | 'minecraft.dropped:minecraft.polished_deepslate' | 'minecraft.picked_up:minecraft.polished_deepslate' | 'minecraft.used:minecraft.polished_deepslate' | 'minecraft.crafted:minecraft.polished_deepslate_slab' | 'minecraft.dropped:minecraft.polished_deepslate_slab' | 'minecraft.picked_up:minecraft.polished_deepslate_slab' | 'minecraft.used:minecraft.polished_deepslate_slab' | 'minecraft.crafted:minecraft.polished_deepslate_stairs' | 'minecraft.dropped:minecraft.polished_deepslate_stairs' | 'minecraft.picked_up:minecraft.polished_deepslate_stairs' | 'minecraft.used:minecraft.polished_deepslate_stairs' | 'minecraft.crafted:minecraft.polished_deepslate_wall' | 'minecraft.dropped:minecraft.polished_deepslate_wall' | 'minecraft.picked_up:minecraft.polished_deepslate_wall' | 'minecraft.used:minecraft.polished_deepslate_wall' | 'minecraft.crafted:minecraft.polished_diorite' | 'minecraft.dropped:minecraft.polished_diorite' | 'minecraft.picked_up:minecraft.polished_diorite' | 'minecraft.used:minecraft.polished_diorite' | 'minecraft.crafted:minecraft.polished_diorite_slab' | 'minecraft.dropped:minecraft.polished_diorite_slab' | 'minecraft.picked_up:minecraft.polished_diorite_slab' | 'minecraft.used:minecraft.polished_diorite_slab' | 'minecraft.crafted:minecraft.polished_diorite_stairs' | 'minecraft.dropped:minecraft.polished_diorite_stairs' | 'minecraft.picked_up:minecraft.polished_diorite_stairs' | 'minecraft.used:minecraft.polished_diorite_stairs' | 'minecraft.crafted:minecraft.polished_granite' | 'minecraft.dropped:minecraft.polished_granite' | 'minecraft.picked_up:minecraft.polished_granite' | 'minecraft.used:minecraft.polished_granite' | 'minecraft.crafted:minecraft.polished_granite_slab' | 'minecraft.dropped:minecraft.polished_granite_slab' | 'minecraft.picked_up:minecraft.polished_granite_slab' | 'minecraft.used:minecraft.polished_granite_slab' | 'minecraft.crafted:minecraft.polished_granite_stairs' | 'minecraft.dropped:minecraft.polished_granite_stairs' | 'minecraft.picked_up:minecraft.polished_granite_stairs' | 'minecraft.used:minecraft.polished_granite_stairs' | 'minecraft.crafted:minecraft.polished_tuff' | 'minecraft.dropped:minecraft.polished_tuff' | 'minecraft.picked_up:minecraft.polished_tuff' | 'minecraft.used:minecraft.polished_tuff' | 'minecraft.crafted:minecraft.polished_tuff_slab' | 'minecraft.dropped:minecraft.polished_tuff_slab' | 'minecraft.picked_up:minecraft.polished_tuff_slab' | 'minecraft.used:minecraft.polished_tuff_slab' | 'minecraft.crafted:minecraft.polished_tuff_stairs' | 'minecraft.dropped:minecraft.polished_tuff_stairs' | 'minecraft.picked_up:minecraft.polished_tuff_stairs' | 'minecraft.used:minecraft.polished_tuff_stairs' | 'minecraft.crafted:minecraft.polished_tuff_wall' | 'minecraft.dropped:minecraft.polished_tuff_wall' | 'minecraft.picked_up:minecraft.polished_tuff_wall' | 'minecraft.used:minecraft.polished_tuff_wall' | 'minecraft.crafted:minecraft.popped_chorus_fruit' | 'minecraft.dropped:minecraft.popped_chorus_fruit' | 'minecraft.picked_up:minecraft.popped_chorus_fruit' | 'minecraft.used:minecraft.popped_chorus_fruit' | 'minecraft.crafted:minecraft.poppy' | 'minecraft.dropped:minecraft.poppy' | 'minecraft.picked_up:minecraft.poppy' | 'minecraft.used:minecraft.poppy' | 'minecraft.crafted:minecraft.porkchop' | 'minecraft.dropped:minecraft.porkchop' | 'minecraft.picked_up:minecraft.porkchop' | 'minecraft.used:minecraft.porkchop' | 'minecraft.crafted:minecraft.potato' | 'minecraft.dropped:minecraft.potato' | 'minecraft.picked_up:minecraft.potato' | 'minecraft.used:minecraft.potato' | 'minecraft.crafted:minecraft.potion' | 'minecraft.dropped:minecraft.potion' | 'minecraft.picked_up:minecraft.potion' | 'minecraft.used:minecraft.potion' | 'minecraft.crafted:minecraft.powder_snow_bucket' | 'minecraft.dropped:minecraft.powder_snow_bucket' | 'minecraft.picked_up:minecraft.powder_snow_bucket' | 'minecraft.used:minecraft.powder_snow_bucket' | 'minecraft.crafted:minecraft.powered_rail' | 'minecraft.dropped:minecraft.powered_rail' | 'minecraft.picked_up:minecraft.powered_rail' | 'minecraft.used:minecraft.powered_rail' | 'minecraft.crafted:minecraft.prismarine' | 'minecraft.dropped:minecraft.prismarine' | 'minecraft.picked_up:minecraft.prismarine' | 'minecraft.used:minecraft.prismarine' | 'minecraft.crafted:minecraft.prismarine_brick_slab' | 'minecraft.dropped:minecraft.prismarine_brick_slab' | 'minecraft.picked_up:minecraft.prismarine_brick_slab' | 'minecraft.used:minecraft.prismarine_brick_slab' | 'minecraft.crafted:minecraft.prismarine_brick_stairs' | 'minecraft.dropped:minecraft.prismarine_brick_stairs' | 'minecraft.picked_up:minecraft.prismarine_brick_stairs' | 'minecraft.used:minecraft.prismarine_brick_stairs' | 'minecraft.crafted:minecraft.prismarine_bricks' | 'minecraft.dropped:minecraft.prismarine_bricks' | 'minecraft.picked_up:minecraft.prismarine_bricks' | 'minecraft.used:minecraft.prismarine_bricks' | 'minecraft.crafted:minecraft.prismarine_crystals' | 'minecraft.dropped:minecraft.prismarine_crystals' | 'minecraft.picked_up:minecraft.prismarine_crystals' | 'minecraft.used:minecraft.prismarine_crystals' | 'minecraft.crafted:minecraft.prismarine_shard' | 'minecraft.dropped:minecraft.prismarine_shard' | 'minecraft.picked_up:minecraft.prismarine_shard' | 'minecraft.used:minecraft.prismarine_shard' | 'minecraft.crafted:minecraft.prismarine_slab' | 'minecraft.dropped:minecraft.prismarine_slab' | 'minecraft.picked_up:minecraft.prismarine_slab' | 'minecraft.used:minecraft.prismarine_slab' | 'minecraft.crafted:minecraft.prismarine_stairs' | 'minecraft.dropped:minecraft.prismarine_stairs' | 'minecraft.picked_up:minecraft.prismarine_stairs' | 'minecraft.used:minecraft.prismarine_stairs' | 'minecraft.crafted:minecraft.prismarine_wall' | 'minecraft.dropped:minecraft.prismarine_wall' | 'minecraft.picked_up:minecraft.prismarine_wall' | 'minecraft.used:minecraft.prismarine_wall' | 'minecraft.crafted:minecraft.prize_pottery_sherd' | 'minecraft.dropped:minecraft.prize_pottery_sherd' | 'minecraft.picked_up:minecraft.prize_pottery_sherd' | 'minecraft.used:minecraft.prize_pottery_sherd' | 'minecraft.crafted:minecraft.pufferfish' | 'minecraft.dropped:minecraft.pufferfish' | 'minecraft.picked_up:minecraft.pufferfish' | 'minecraft.used:minecraft.pufferfish' | 'minecraft.crafted:minecraft.pufferfish_bucket' | 'minecraft.dropped:minecraft.pufferfish_bucket' | 'minecraft.picked_up:minecraft.pufferfish_bucket' | 'minecraft.used:minecraft.pufferfish_bucket' | 'minecraft.crafted:minecraft.pufferfish_spawn_egg' | 'minecraft.dropped:minecraft.pufferfish_spawn_egg' | 'minecraft.picked_up:minecraft.pufferfish_spawn_egg' | 'minecraft.used:minecraft.pufferfish_spawn_egg' | 'minecraft.crafted:minecraft.pumpkin' | 'minecraft.dropped:minecraft.pumpkin' | 'minecraft.picked_up:minecraft.pumpkin' | 'minecraft.used:minecraft.pumpkin' | 'minecraft.crafted:minecraft.pumpkin_pie' | 'minecraft.dropped:minecraft.pumpkin_pie' | 'minecraft.picked_up:minecraft.pumpkin_pie' | 'minecraft.used:minecraft.pumpkin_pie' | 'minecraft.crafted:minecraft.pumpkin_seeds' | 'minecraft.dropped:minecraft.pumpkin_seeds' | 'minecraft.picked_up:minecraft.pumpkin_seeds' | 'minecraft.used:minecraft.pumpkin_seeds' | 'minecraft.crafted:minecraft.purple_banner' | 'minecraft.dropped:minecraft.purple_banner' | 'minecraft.picked_up:minecraft.purple_banner' | 'minecraft.used:minecraft.purple_banner' | 'minecraft.crafted:minecraft.purple_bed' | 'minecraft.dropped:minecraft.purple_bed' | 'minecraft.picked_up:minecraft.purple_bed' | 'minecraft.used:minecraft.purple_bed' | 'minecraft.crafted:minecraft.purple_candle' | 'minecraft.dropped:minecraft.purple_candle' | 'minecraft.picked_up:minecraft.purple_candle' | 'minecraft.used:minecraft.purple_candle' | 'minecraft.crafted:minecraft.purple_carpet' | 'minecraft.dropped:minecraft.purple_carpet' | 'minecraft.picked_up:minecraft.purple_carpet' | 'minecraft.used:minecraft.purple_carpet' | 'minecraft.crafted:minecraft.purple_concrete' | 'minecraft.dropped:minecraft.purple_concrete' | 'minecraft.picked_up:minecraft.purple_concrete' | 'minecraft.used:minecraft.purple_concrete' | 'minecraft.crafted:minecraft.purple_concrete_powder' | 'minecraft.dropped:minecraft.purple_concrete_powder' | 'minecraft.picked_up:minecraft.purple_concrete_powder' | 'minecraft.used:minecraft.purple_concrete_powder' | 'minecraft.crafted:minecraft.purple_dye' | 'minecraft.dropped:minecraft.purple_dye' | 'minecraft.picked_up:minecraft.purple_dye' | 'minecraft.used:minecraft.purple_dye' | 'minecraft.crafted:minecraft.purple_glazed_terracotta' | 'minecraft.dropped:minecraft.purple_glazed_terracotta' | 'minecraft.picked_up:minecraft.purple_glazed_terracotta' | 'minecraft.used:minecraft.purple_glazed_terracotta' | 'minecraft.crafted:minecraft.purple_shulker_box' | 'minecraft.dropped:minecraft.purple_shulker_box' | 'minecraft.picked_up:minecraft.purple_shulker_box' | 'minecraft.used:minecraft.purple_shulker_box' | 'minecraft.crafted:minecraft.purple_stained_glass' | 'minecraft.dropped:minecraft.purple_stained_glass' | 'minecraft.picked_up:minecraft.purple_stained_glass' | 'minecraft.used:minecraft.purple_stained_glass' | 'minecraft.crafted:minecraft.purple_stained_glass_pane' | 'minecraft.dropped:minecraft.purple_stained_glass_pane' | 'minecraft.picked_up:minecraft.purple_stained_glass_pane' | 'minecraft.used:minecraft.purple_stained_glass_pane' | 'minecraft.crafted:minecraft.purple_terracotta' | 'minecraft.dropped:minecraft.purple_terracotta' | 'minecraft.picked_up:minecraft.purple_terracotta' | 'minecraft.used:minecraft.purple_terracotta' | 'minecraft.crafted:minecraft.purple_wool' | 'minecraft.dropped:minecraft.purple_wool' | 'minecraft.picked_up:minecraft.purple_wool' | 'minecraft.used:minecraft.purple_wool' | 'minecraft.crafted:minecraft.purpur_block' | 'minecraft.dropped:minecraft.purpur_block' | 'minecraft.picked_up:minecraft.purpur_block' | 'minecraft.used:minecraft.purpur_block' | 'minecraft.crafted:minecraft.purpur_pillar' | 'minecraft.dropped:minecraft.purpur_pillar' | 'minecraft.picked_up:minecraft.purpur_pillar' | 'minecraft.used:minecraft.purpur_pillar' | 'minecraft.crafted:minecraft.purpur_slab' | 'minecraft.dropped:minecraft.purpur_slab' | 'minecraft.picked_up:minecraft.purpur_slab' | 'minecraft.used:minecraft.purpur_slab' | 'minecraft.crafted:minecraft.purpur_stairs' | 'minecraft.dropped:minecraft.purpur_stairs' | 'minecraft.picked_up:minecraft.purpur_stairs' | 'minecraft.used:minecraft.purpur_stairs' | 'minecraft.crafted:minecraft.quartz' | 'minecraft.dropped:minecraft.quartz' | 'minecraft.picked_up:minecraft.quartz' | 'minecraft.used:minecraft.quartz' | 'minecraft.crafted:minecraft.quartz_block' | 'minecraft.dropped:minecraft.quartz_block' | 'minecraft.picked_up:minecraft.quartz_block' | 'minecraft.used:minecraft.quartz_block' | 'minecraft.crafted:minecraft.quartz_bricks' | 'minecraft.dropped:minecraft.quartz_bricks' | 'minecraft.picked_up:minecraft.quartz_bricks' | 'minecraft.used:minecraft.quartz_bricks' | 'minecraft.crafted:minecraft.quartz_pillar' | 'minecraft.dropped:minecraft.quartz_pillar' | 'minecraft.picked_up:minecraft.quartz_pillar' | 'minecraft.used:minecraft.quartz_pillar' | 'minecraft.crafted:minecraft.quartz_slab' | 'minecraft.dropped:minecraft.quartz_slab' | 'minecraft.picked_up:minecraft.quartz_slab' | 'minecraft.used:minecraft.quartz_slab' | 'minecraft.crafted:minecraft.quartz_stairs' | 'minecraft.dropped:minecraft.quartz_stairs' | 'minecraft.picked_up:minecraft.quartz_stairs' | 'minecraft.used:minecraft.quartz_stairs' | 'minecraft.crafted:minecraft.rabbit' | 'minecraft.dropped:minecraft.rabbit' | 'minecraft.picked_up:minecraft.rabbit' | 'minecraft.used:minecraft.rabbit' | 'minecraft.crafted:minecraft.rabbit_foot' | 'minecraft.dropped:minecraft.rabbit_foot' | 'minecraft.picked_up:minecraft.rabbit_foot' | 'minecraft.used:minecraft.rabbit_foot' | 'minecraft.crafted:minecraft.rabbit_hide' | 'minecraft.dropped:minecraft.rabbit_hide' | 'minecraft.picked_up:minecraft.rabbit_hide' | 'minecraft.used:minecraft.rabbit_hide' | 'minecraft.crafted:minecraft.rabbit_spawn_egg' | 'minecraft.dropped:minecraft.rabbit_spawn_egg' | 'minecraft.picked_up:minecraft.rabbit_spawn_egg' | 'minecraft.used:minecraft.rabbit_spawn_egg' | 'minecraft.crafted:minecraft.rabbit_stew' | 'minecraft.dropped:minecraft.rabbit_stew' | 'minecraft.picked_up:minecraft.rabbit_stew' | 'minecraft.used:minecraft.rabbit_stew' | 'minecraft.crafted:minecraft.rail' | 'minecraft.dropped:minecraft.rail' | 'minecraft.picked_up:minecraft.rail' | 'minecraft.used:minecraft.rail' | 'minecraft.crafted:minecraft.raiser_armor_trim_smithing_template' | 'minecraft.dropped:minecraft.raiser_armor_trim_smithing_template' | 'minecraft.picked_up:minecraft.raiser_armor_trim_smithing_template' | 'minecraft.used:minecraft.raiser_armor_trim_smithing_template' | 'minecraft.crafted:minecraft.ravager_spawn_egg' | 'minecraft.dropped:minecraft.ravager_spawn_egg' | 'minecraft.picked_up:minecraft.ravager_spawn_egg' | 'minecraft.used:minecraft.ravager_spawn_egg' | 'minecraft.crafted:minecraft.raw_copper' | 'minecraft.dropped:minecraft.raw_copper' | 'minecraft.picked_up:minecraft.raw_copper' | 'minecraft.used:minecraft.raw_copper' | 'minecraft.crafted:minecraft.raw_copper_block' | 'minecraft.dropped:minecraft.raw_copper_block' | 'minecraft.picked_up:minecraft.raw_copper_block' | 'minecraft.used:minecraft.raw_copper_block' | 'minecraft.crafted:minecraft.raw_gold' | 'minecraft.dropped:minecraft.raw_gold' | 'minecraft.picked_up:minecraft.raw_gold' | 'minecraft.used:minecraft.raw_gold' | 'minecraft.crafted:minecraft.raw_gold_block' | 'minecraft.dropped:minecraft.raw_gold_block' | 'minecraft.picked_up:minecraft.raw_gold_block' | 'minecraft.used:minecraft.raw_gold_block' | 'minecraft.crafted:minecraft.raw_iron' | 'minecraft.dropped:minecraft.raw_iron' | 'minecraft.picked_up:minecraft.raw_iron' | 'minecraft.used:minecraft.raw_iron' | 'minecraft.crafted:minecraft.raw_iron_block' | 'minecraft.dropped:minecraft.raw_iron_block' | 'minecraft.picked_up:minecraft.raw_iron_block' | 'minecraft.used:minecraft.raw_iron_block' | 'minecraft.crafted:minecraft.recovery_compass' | 'minecraft.dropped:minecraft.recovery_compass' | 'minecraft.picked_up:minecraft.recovery_compass' | 'minecraft.used:minecraft.recovery_compass' | 'minecraft.crafted:minecraft.red_banner' | 'minecraft.dropped:minecraft.red_banner' | 'minecraft.picked_up:minecraft.red_banner' | 'minecraft.used:minecraft.red_banner' | 'minecraft.crafted:minecraft.red_bed' | 'minecraft.dropped:minecraft.red_bed' | 'minecraft.picked_up:minecraft.red_bed' | 'minecraft.used:minecraft.red_bed' | 'minecraft.crafted:minecraft.red_candle' | 'minecraft.dropped:minecraft.red_candle' | 'minecraft.picked_up:minecraft.red_candle' | 'minecraft.used:minecraft.red_candle' | 'minecraft.crafted:minecraft.red_carpet' | 'minecraft.dropped:minecraft.red_carpet' | 'minecraft.picked_up:minecraft.red_carpet' | 'minecraft.used:minecraft.red_carpet' | 'minecraft.crafted:minecraft.red_concrete' | 'minecraft.dropped:minecraft.red_concrete' | 'minecraft.picked_up:minecraft.red_concrete' | 'minecraft.used:minecraft.red_concrete' | 'minecraft.crafted:minecraft.red_concrete_powder' | 'minecraft.dropped:minecraft.red_concrete_powder' | 'minecraft.picked_up:minecraft.red_concrete_powder' | 'minecraft.used:minecraft.red_concrete_powder' | 'minecraft.crafted:minecraft.red_dye' | 'minecraft.dropped:minecraft.red_dye' | 'minecraft.picked_up:minecraft.red_dye' | 'minecraft.used:minecraft.red_dye' | 'minecraft.crafted:minecraft.red_glazed_terracotta' | 'minecraft.dropped:minecraft.red_glazed_terracotta' | 'minecraft.picked_up:minecraft.red_glazed_terracotta' | 'minecraft.used:minecraft.red_glazed_terracotta' | 'minecraft.crafted:minecraft.red_mushroom' | 'minecraft.dropped:minecraft.red_mushroom' | 'minecraft.picked_up:minecraft.red_mushroom' | 'minecraft.used:minecraft.red_mushroom' | 'minecraft.crafted:minecraft.red_mushroom_block' | 'minecraft.dropped:minecraft.red_mushroom_block' | 'minecraft.picked_up:minecraft.red_mushroom_block' | 'minecraft.used:minecraft.red_mushroom_block' | 'minecraft.crafted:minecraft.red_nether_brick_slab' | 'minecraft.dropped:minecraft.red_nether_brick_slab' | 'minecraft.picked_up:minecraft.red_nether_brick_slab' | 'minecraft.used:minecraft.red_nether_brick_slab' | 'minecraft.crafted:minecraft.red_nether_brick_stairs' | 'minecraft.dropped:minecraft.red_nether_brick_stairs' | 'minecraft.picked_up:minecraft.red_nether_brick_stairs' | 'minecraft.used:minecraft.red_nether_brick_stairs' | 'minecraft.crafted:minecraft.red_nether_brick_wall' | 'minecraft.dropped:minecraft.red_nether_brick_wall' | 'minecraft.picked_up:minecraft.red_nether_brick_wall' | 'minecraft.used:minecraft.red_nether_brick_wall' | 'minecraft.crafted:minecraft.red_nether_bricks' | 'minecraft.dropped:minecraft.red_nether_bricks' | 'minecraft.picked_up:minecraft.red_nether_bricks' | 'minecraft.used:minecraft.red_nether_bricks' | 'minecraft.crafted:minecraft.red_sand' | 'minecraft.dropped:minecraft.red_sand' | 'minecraft.picked_up:minecraft.red_sand' | 'minecraft.used:minecraft.red_sand' | 'minecraft.crafted:minecraft.red_sandstone' | 'minecraft.dropped:minecraft.red_sandstone' | 'minecraft.picked_up:minecraft.red_sandstone' | 'minecraft.used:minecraft.red_sandstone' | 'minecraft.crafted:minecraft.red_sandstone_slab' | 'minecraft.dropped:minecraft.red_sandstone_slab' | 'minecraft.picked_up:minecraft.red_sandstone_slab' | 'minecraft.used:minecraft.red_sandstone_slab' | 'minecraft.crafted:minecraft.red_sandstone_stairs' | 'minecraft.dropped:minecraft.red_sandstone_stairs' | 'minecraft.picked_up:minecraft.red_sandstone_stairs' | 'minecraft.used:minecraft.red_sandstone_stairs' | 'minecraft.crafted:minecraft.red_sandstone_wall' | 'minecraft.dropped:minecraft.red_sandstone_wall' | 'minecraft.picked_up:minecraft.red_sandstone_wall' | 'minecraft.used:minecraft.red_sandstone_wall' | 'minecraft.crafted:minecraft.red_shulker_box' | 'minecraft.dropped:minecraft.red_shulker_box' | 'minecraft.picked_up:minecraft.red_shulker_box' | 'minecraft.used:minecraft.red_shulker_box' | 'minecraft.crafted:minecraft.red_stained_glass' | 'minecraft.dropped:minecraft.red_stained_glass' | 'minecraft.picked_up:minecraft.red_stained_glass' | 'minecraft.used:minecraft.red_stained_glass' | 'minecraft.crafted:minecraft.red_stained_glass_pane' | 'minecraft.dropped:minecraft.red_stained_glass_pane' | 'minecraft.picked_up:minecraft.red_stained_glass_pane' | 'minecraft.used:minecraft.red_stained_glass_pane' | 'minecraft.crafted:minecraft.red_terracotta' | 'minecraft.dropped:minecraft.red_terracotta' | 'minecraft.picked_up:minecraft.red_terracotta' | 'minecraft.used:minecraft.red_terracotta' | 'minecraft.crafted:minecraft.red_tulip' | 'minecraft.dropped:minecraft.red_tulip' | 'minecraft.picked_up:minecraft.red_tulip' | 'minecraft.used:minecraft.red_tulip' | 'minecraft.crafted:minecraft.red_wool' | 'minecraft.dropped:minecraft.red_wool' | 'minecraft.picked_up:minecraft.red_wool' | 'minecraft.used:minecraft.red_wool' | 'minecraft.crafted:minecraft.redstone' | 'minecraft.dropped:minecraft.redstone' | 'minecraft.picked_up:minecraft.redstone' | 'minecraft.used:minecraft.redstone' | 'minecraft.crafted:minecraft.redstone_block' | 'minecraft.dropped:minecraft.redstone_block' | 'minecraft.picked_up:minecraft.redstone_block' | 'minecraft.used:minecraft.redstone_block' | 'minecraft.crafted:minecraft.redstone_lamp' | 'minecraft.dropped:minecraft.redstone_lamp' | 'minecraft.picked_up:minecraft.redstone_lamp' | 'minecraft.used:minecraft.redstone_lamp' | 'minecraft.crafted:minecraft.redstone_ore' | 'minecraft.dropped:minecraft.redstone_ore' | 'minecraft.picked_up:minecraft.redstone_ore' | 'minecraft.used:minecraft.redstone_ore' | 'minecraft.crafted:minecraft.redstone_torch' | 'minecraft.dropped:minecraft.redstone_torch' | 'minecraft.picked_up:minecraft.redstone_torch' | 'minecraft.used:minecraft.redstone_torch' | 'minecraft.crafted:minecraft.reinforced_deepslate' | 'minecraft.dropped:minecraft.reinforced_deepslate' | 'minecraft.picked_up:minecraft.reinforced_deepslate' | 'minecraft.used:minecraft.reinforced_deepslate' | 'minecraft.crafted:minecraft.repeater' | 'minecraft.dropped:minecraft.repeater' | 'minecraft.picked_up:minecraft.repeater' | 'minecraft.used:minecraft.repeater' | 'minecraft.crafted:minecraft.repeating_command_block' | 'minecraft.dropped:minecraft.repeating_command_block' | 'minecraft.picked_up:minecraft.repeating_command_block' | 'minecraft.used:minecraft.repeating_command_block' | 'minecraft.crafted:minecraft.respawn_anchor' | 'minecraft.dropped:minecraft.respawn_anchor' | 'minecraft.picked_up:minecraft.respawn_anchor' | 'minecraft.used:minecraft.respawn_anchor' | 'minecraft.crafted:minecraft.rib_armor_trim_smithing_template' | 'minecraft.dropped:minecraft.rib_armor_trim_smithing_template' | 'minecraft.picked_up:minecraft.rib_armor_trim_smithing_template' | 'minecraft.used:minecraft.rib_armor_trim_smithing_template' | 'minecraft.crafted:minecraft.rooted_dirt' | 'minecraft.dropped:minecraft.rooted_dirt' | 'minecraft.picked_up:minecraft.rooted_dirt' | 'minecraft.used:minecraft.rooted_dirt' | 'minecraft.crafted:minecraft.rose_bush' | 'minecraft.dropped:minecraft.rose_bush' | 'minecraft.picked_up:minecraft.rose_bush' | 'minecraft.used:minecraft.rose_bush' | 'minecraft.crafted:minecraft.rotten_flesh' | 'minecraft.dropped:minecraft.rotten_flesh' | 'minecraft.picked_up:minecraft.rotten_flesh' | 'minecraft.used:minecraft.rotten_flesh' | 'minecraft.crafted:minecraft.saddle' | 'minecraft.dropped:minecraft.saddle' | 'minecraft.picked_up:minecraft.saddle' | 'minecraft.used:minecraft.saddle' | 'minecraft.crafted:minecraft.salmon' | 'minecraft.dropped:minecraft.salmon' | 'minecraft.picked_up:minecraft.salmon' | 'minecraft.used:minecraft.salmon' | 'minecraft.crafted:minecraft.salmon_bucket' | 'minecraft.dropped:minecraft.salmon_bucket' | 'minecraft.picked_up:minecraft.salmon_bucket' | 'minecraft.used:minecraft.salmon_bucket' | 'minecraft.crafted:minecraft.salmon_spawn_egg' | 'minecraft.dropped:minecraft.salmon_spawn_egg' | 'minecraft.picked_up:minecraft.salmon_spawn_egg' | 'minecraft.used:minecraft.salmon_spawn_egg' | 'minecraft.crafted:minecraft.sand' | 'minecraft.dropped:minecraft.sand' | 'minecraft.picked_up:minecraft.sand' | 'minecraft.used:minecraft.sand' | 'minecraft.crafted:minecraft.sandstone' | 'minecraft.dropped:minecraft.sandstone' | 'minecraft.picked_up:minecraft.sandstone' | 'minecraft.used:minecraft.sandstone' | 'minecraft.crafted:minecraft.sandstone_slab' | 'minecraft.dropped:minecraft.sandstone_slab' | 'minecraft.picked_up:minecraft.sandstone_slab' | 'minecraft.used:minecraft.sandstone_slab' | 'minecraft.crafted:minecraft.sandstone_stairs' | 'minecraft.dropped:minecraft.sandstone_stairs' | 'minecraft.picked_up:minecraft.sandstone_stairs' | 'minecraft.used:minecraft.sandstone_stairs' | 'minecraft.crafted:minecraft.sandstone_wall' | 'minecraft.dropped:minecraft.sandstone_wall' | 'minecraft.picked_up:minecraft.sandstone_wall' | 'minecraft.used:minecraft.sandstone_wall' | 'minecraft.crafted:minecraft.scaffolding' | 'minecraft.dropped:minecraft.scaffolding' | 'minecraft.picked_up:minecraft.scaffolding' | 'minecraft.used:minecraft.scaffolding' | 'minecraft.crafted:minecraft.sculk' | 'minecraft.dropped:minecraft.sculk' | 'minecraft.picked_up:minecraft.sculk' | 'minecraft.used:minecraft.sculk' | 'minecraft.crafted:minecraft.sculk_catalyst' | 'minecraft.dropped:minecraft.sculk_catalyst' | 'minecraft.picked_up:minecraft.sculk_catalyst' | 'minecraft.used:minecraft.sculk_catalyst' | 'minecraft.crafted:minecraft.sculk_sensor' | 'minecraft.dropped:minecraft.sculk_sensor' | 'minecraft.picked_up:minecraft.sculk_sensor' | 'minecraft.used:minecraft.sculk_sensor' | 'minecraft.crafted:minecraft.sculk_shrieker' | 'minecraft.dropped:minecraft.sculk_shrieker' | 'minecraft.picked_up:minecraft.sculk_shrieker' | 'minecraft.used:minecraft.sculk_shrieker' | 'minecraft.crafted:minecraft.sculk_vein' | 'minecraft.dropped:minecraft.sculk_vein' | 'minecraft.picked_up:minecraft.sculk_vein' | 'minecraft.used:minecraft.sculk_vein' | 'minecraft.crafted:minecraft.scute' | 'minecraft.dropped:minecraft.scute' | 'minecraft.picked_up:minecraft.scute' | 'minecraft.used:minecraft.scute' | 'minecraft.crafted:minecraft.sea_lantern' | 'minecraft.dropped:minecraft.sea_lantern' | 'minecraft.picked_up:minecraft.sea_lantern' | 'minecraft.used:minecraft.sea_lantern' | 'minecraft.crafted:minecraft.sea_pickle' | 'minecraft.dropped:minecraft.sea_pickle' | 'minecraft.picked_up:minecraft.sea_pickle' | 'minecraft.used:minecraft.sea_pickle' | 'minecraft.crafted:minecraft.seagrass' | 'minecraft.dropped:minecraft.seagrass' | 'minecraft.picked_up:minecraft.seagrass' | 'minecraft.used:minecraft.seagrass' | 'minecraft.crafted:minecraft.sentry_armor_trim_smithing_template' | 'minecraft.dropped:minecraft.sentry_armor_trim_smithing_template' | 'minecraft.picked_up:minecraft.sentry_armor_trim_smithing_template' | 'minecraft.used:minecraft.sentry_armor_trim_smithing_template' | 'minecraft.crafted:minecraft.shaper_armor_trim_smithing_template' | 'minecraft.dropped:minecraft.shaper_armor_trim_smithing_template' | 'minecraft.picked_up:minecraft.shaper_armor_trim_smithing_template' | 'minecraft.used:minecraft.shaper_armor_trim_smithing_template' | 'minecraft.crafted:minecraft.sheaf_pottery_sherd' | 'minecraft.dropped:minecraft.sheaf_pottery_sherd' | 'minecraft.picked_up:minecraft.sheaf_pottery_sherd' | 'minecraft.used:minecraft.sheaf_pottery_sherd' | 'minecraft.crafted:minecraft.shears' | 'minecraft.dropped:minecraft.shears' | 'minecraft.picked_up:minecraft.shears' | 'minecraft.used:minecraft.shears' | 'minecraft.crafted:minecraft.sheep_spawn_egg' | 'minecraft.dropped:minecraft.sheep_spawn_egg' | 'minecraft.picked_up:minecraft.sheep_spawn_egg' | 'minecraft.used:minecraft.sheep_spawn_egg' | 'minecraft.crafted:minecraft.shelter_pottery_sherd' | 'minecraft.dropped:minecraft.shelter_pottery_sherd' | 'minecraft.picked_up:minecraft.shelter_pottery_sherd' | 'minecraft.used:minecraft.shelter_pottery_sherd' | 'minecraft.crafted:minecraft.shield' | 'minecraft.dropped:minecraft.shield' | 'minecraft.picked_up:minecraft.shield' | 'minecraft.used:minecraft.shield' | 'minecraft.crafted:minecraft.shroomlight' | 'minecraft.dropped:minecraft.shroomlight' | 'minecraft.picked_up:minecraft.shroomlight' | 'minecraft.used:minecraft.shroomlight' | 'minecraft.crafted:minecraft.shulker_box' | 'minecraft.dropped:minecraft.shulker_box' | 'minecraft.picked_up:minecraft.shulker_box' | 'minecraft.used:minecraft.shulker_box' | 'minecraft.crafted:minecraft.shulker_shell' | 'minecraft.dropped:minecraft.shulker_shell' | 'minecraft.picked_up:minecraft.shulker_shell' | 'minecraft.used:minecraft.shulker_shell' | 'minecraft.crafted:minecraft.shulker_spawn_egg' | 'minecraft.dropped:minecraft.shulker_spawn_egg' | 'minecraft.picked_up:minecraft.shulker_spawn_egg' | 'minecraft.used:minecraft.shulker_spawn_egg' | 'minecraft.crafted:minecraft.silence_armor_trim_smithing_template' | 'minecraft.dropped:minecraft.silence_armor_trim_smithing_template' | 'minecraft.picked_up:minecraft.silence_armor_trim_smithing_template' | 'minecraft.used:minecraft.silence_armor_trim_smithing_template' | 'minecraft.crafted:minecraft.silverfish_spawn_egg' | 'minecraft.dropped:minecraft.silverfish_spawn_egg' | 'minecraft.picked_up:minecraft.silverfish_spawn_egg' | 'minecraft.used:minecraft.silverfish_spawn_egg' | 'minecraft.crafted:minecraft.skeleton_horse_spawn_egg' | 'minecraft.dropped:minecraft.skeleton_horse_spawn_egg' | 'minecraft.picked_up:minecraft.skeleton_horse_spawn_egg' | 'minecraft.used:minecraft.skeleton_horse_spawn_egg' | 'minecraft.crafted:minecraft.skeleton_skull' | 'minecraft.dropped:minecraft.skeleton_skull' | 'minecraft.picked_up:minecraft.skeleton_skull' | 'minecraft.used:minecraft.skeleton_skull' | 'minecraft.crafted:minecraft.skeleton_spawn_egg' | 'minecraft.dropped:minecraft.skeleton_spawn_egg' | 'minecraft.picked_up:minecraft.skeleton_spawn_egg' | 'minecraft.used:minecraft.skeleton_spawn_egg' | 'minecraft.crafted:minecraft.skull_banner_pattern' | 'minecraft.dropped:minecraft.skull_banner_pattern' | 'minecraft.picked_up:minecraft.skull_banner_pattern' | 'minecraft.used:minecraft.skull_banner_pattern' | 'minecraft.crafted:minecraft.skull_pottery_sherd' | 'minecraft.dropped:minecraft.skull_pottery_sherd' | 'minecraft.picked_up:minecraft.skull_pottery_sherd' | 'minecraft.used:minecraft.skull_pottery_sherd' | 'minecraft.crafted:minecraft.slime_ball' | 'minecraft.dropped:minecraft.slime_ball' | 'minecraft.picked_up:minecraft.slime_ball' | 'minecraft.used:minecraft.slime_ball' | 'minecraft.crafted:minecraft.slime_block' | 'minecraft.dropped:minecraft.slime_block' | 'minecraft.picked_up:minecraft.slime_block' | 'minecraft.used:minecraft.slime_block' | 'minecraft.crafted:minecraft.slime_spawn_egg' | 'minecraft.dropped:minecraft.slime_spawn_egg' | 'minecraft.picked_up:minecraft.slime_spawn_egg' | 'minecraft.used:minecraft.slime_spawn_egg' | 'minecraft.crafted:minecraft.small_amethyst_bud' | 'minecraft.dropped:minecraft.small_amethyst_bud' | 'minecraft.picked_up:minecraft.small_amethyst_bud' | 'minecraft.used:minecraft.small_amethyst_bud' | 'minecraft.crafted:minecraft.small_dripleaf' | 'minecraft.dropped:minecraft.small_dripleaf' | 'minecraft.picked_up:minecraft.small_dripleaf' | 'minecraft.used:minecraft.small_dripleaf' | 'minecraft.crafted:minecraft.smithing_table' | 'minecraft.dropped:minecraft.smithing_table' | 'minecraft.picked_up:minecraft.smithing_table' | 'minecraft.used:minecraft.smithing_table' | 'minecraft.crafted:minecraft.smoker' | 'minecraft.dropped:minecraft.smoker' | 'minecraft.picked_up:minecraft.smoker' | 'minecraft.used:minecraft.smoker' | 'minecraft.crafted:minecraft.smooth_basalt' | 'minecraft.dropped:minecraft.smooth_basalt' | 'minecraft.picked_up:minecraft.smooth_basalt' | 'minecraft.used:minecraft.smooth_basalt' | 'minecraft.crafted:minecraft.smooth_quartz' | 'minecraft.dropped:minecraft.smooth_quartz' | 'minecraft.picked_up:minecraft.smooth_quartz' | 'minecraft.used:minecraft.smooth_quartz' | 'minecraft.crafted:minecraft.smooth_quartz_slab' | 'minecraft.dropped:minecraft.smooth_quartz_slab' | 'minecraft.picked_up:minecraft.smooth_quartz_slab' | 'minecraft.used:minecraft.smooth_quartz_slab' | 'minecraft.crafted:minecraft.smooth_quartz_stairs' | 'minecraft.dropped:minecraft.smooth_quartz_stairs' | 'minecraft.picked_up:minecraft.smooth_quartz_stairs' | 'minecraft.used:minecraft.smooth_quartz_stairs' | 'minecraft.crafted:minecraft.smooth_red_sandstone' | 'minecraft.dropped:minecraft.smooth_red_sandstone' | 'minecraft.picked_up:minecraft.smooth_red_sandstone' | 'minecraft.used:minecraft.smooth_red_sandstone' | 'minecraft.crafted:minecraft.smooth_red_sandstone_slab' | 'minecraft.dropped:minecraft.smooth_red_sandstone_slab' | 'minecraft.picked_up:minecraft.smooth_red_sandstone_slab' | 'minecraft.used:minecraft.smooth_red_sandstone_slab' | 'minecraft.crafted:minecraft.smooth_red_sandstone_stairs' | 'minecraft.dropped:minecraft.smooth_red_sandstone_stairs' | 'minecraft.picked_up:minecraft.smooth_red_sandstone_stairs' | 'minecraft.used:minecraft.smooth_red_sandstone_stairs' | 'minecraft.crafted:minecraft.smooth_sandstone' | 'minecraft.dropped:minecraft.smooth_sandstone' | 'minecraft.picked_up:minecraft.smooth_sandstone' | 'minecraft.used:minecraft.smooth_sandstone' | 'minecraft.crafted:minecraft.smooth_sandstone_slab' | 'minecraft.dropped:minecraft.smooth_sandstone_slab' | 'minecraft.picked_up:minecraft.smooth_sandstone_slab' | 'minecraft.used:minecraft.smooth_sandstone_slab' | 'minecraft.crafted:minecraft.smooth_sandstone_stairs' | 'minecraft.dropped:minecraft.smooth_sandstone_stairs' | 'minecraft.picked_up:minecraft.smooth_sandstone_stairs' | 'minecraft.used:minecraft.smooth_sandstone_stairs' | 'minecraft.crafted:minecraft.smooth_stone' | 'minecraft.dropped:minecraft.smooth_stone' | 'minecraft.picked_up:minecraft.smooth_stone' | 'minecraft.used:minecraft.smooth_stone' | 'minecraft.crafted:minecraft.smooth_stone_slab' | 'minecraft.dropped:minecraft.smooth_stone_slab' | 'minecraft.picked_up:minecraft.smooth_stone_slab' | 'minecraft.used:minecraft.smooth_stone_slab' | 'minecraft.crafted:minecraft.sniffer_egg' | 'minecraft.dropped:minecraft.sniffer_egg' | 'minecraft.picked_up:minecraft.sniffer_egg' | 'minecraft.used:minecraft.sniffer_egg' | 'minecraft.crafted:minecraft.sniffer_spawn_egg' | 'minecraft.dropped:minecraft.sniffer_spawn_egg' | 'minecraft.picked_up:minecraft.sniffer_spawn_egg' | 'minecraft.used:minecraft.sniffer_spawn_egg' | 'minecraft.crafted:minecraft.snort_pottery_sherd' | 'minecraft.dropped:minecraft.snort_pottery_sherd' | 'minecraft.picked_up:minecraft.snort_pottery_sherd' | 'minecraft.used:minecraft.snort_pottery_sherd' | 'minecraft.crafted:minecraft.snout_armor_trim_smithing_template' | 'minecraft.dropped:minecraft.snout_armor_trim_smithing_template' | 'minecraft.picked_up:minecraft.snout_armor_trim_smithing_template' | 'minecraft.used:minecraft.snout_armor_trim_smithing_template' | 'minecraft.crafted:minecraft.snow' | 'minecraft.dropped:minecraft.snow' | 'minecraft.picked_up:minecraft.snow' | 'minecraft.used:minecraft.snow' | 'minecraft.crafted:minecraft.snow_block' | 'minecraft.dropped:minecraft.snow_block' | 'minecraft.picked_up:minecraft.snow_block' | 'minecraft.used:minecraft.snow_block' | 'minecraft.crafted:minecraft.snow_golem_spawn_egg' | 'minecraft.dropped:minecraft.snow_golem_spawn_egg' | 'minecraft.picked_up:minecraft.snow_golem_spawn_egg' | 'minecraft.used:minecraft.snow_golem_spawn_egg' | 'minecraft.crafted:minecraft.snowball' | 'minecraft.dropped:minecraft.snowball' | 'minecraft.picked_up:minecraft.snowball' | 'minecraft.used:minecraft.snowball' | 'minecraft.crafted:minecraft.soul_campfire' | 'minecraft.dropped:minecraft.soul_campfire' | 'minecraft.picked_up:minecraft.soul_campfire' | 'minecraft.used:minecraft.soul_campfire' | 'minecraft.crafted:minecraft.soul_lantern' | 'minecraft.dropped:minecraft.soul_lantern' | 'minecraft.picked_up:minecraft.soul_lantern' | 'minecraft.used:minecraft.soul_lantern' | 'minecraft.crafted:minecraft.soul_sand' | 'minecraft.dropped:minecraft.soul_sand' | 'minecraft.picked_up:minecraft.soul_sand' | 'minecraft.used:minecraft.soul_sand' | 'minecraft.crafted:minecraft.soul_soil' | 'minecraft.dropped:minecraft.soul_soil' | 'minecraft.picked_up:minecraft.soul_soil' | 'minecraft.used:minecraft.soul_soil' | 'minecraft.crafted:minecraft.soul_torch' | 'minecraft.dropped:minecraft.soul_torch' | 'minecraft.picked_up:minecraft.soul_torch' | 'minecraft.used:minecraft.soul_torch' | 'minecraft.crafted:minecraft.spawner' | 'minecraft.dropped:minecraft.spawner' | 'minecraft.picked_up:minecraft.spawner' | 'minecraft.used:minecraft.spawner' | 'minecraft.crafted:minecraft.spectral_arrow' | 'minecraft.dropped:minecraft.spectral_arrow' | 'minecraft.picked_up:minecraft.spectral_arrow' | 'minecraft.used:minecraft.spectral_arrow' | 'minecraft.crafted:minecraft.spider_eye' | 'minecraft.dropped:minecraft.spider_eye' | 'minecraft.picked_up:minecraft.spider_eye' | 'minecraft.used:minecraft.spider_eye' | 'minecraft.crafted:minecraft.spider_spawn_egg' | 'minecraft.dropped:minecraft.spider_spawn_egg' | 'minecraft.picked_up:minecraft.spider_spawn_egg' | 'minecraft.used:minecraft.spider_spawn_egg' | 'minecraft.crafted:minecraft.spire_armor_trim_smithing_template' | 'minecraft.dropped:minecraft.spire_armor_trim_smithing_template' | 'minecraft.picked_up:minecraft.spire_armor_trim_smithing_template' | 'minecraft.used:minecraft.spire_armor_trim_smithing_template' | 'minecraft.crafted:minecraft.splash_potion' | 'minecraft.dropped:minecraft.splash_potion' | 'minecraft.picked_up:minecraft.splash_potion' | 'minecraft.used:minecraft.splash_potion' | 'minecraft.crafted:minecraft.sponge' | 'minecraft.dropped:minecraft.sponge' | 'minecraft.picked_up:minecraft.sponge' | 'minecraft.used:minecraft.sponge' | 'minecraft.crafted:minecraft.spore_blossom' | 'minecraft.dropped:minecraft.spore_blossom' | 'minecraft.picked_up:minecraft.spore_blossom' | 'minecraft.used:minecraft.spore_blossom' | 'minecraft.crafted:minecraft.spruce_boat' | 'minecraft.dropped:minecraft.spruce_boat' | 'minecraft.picked_up:minecraft.spruce_boat' | 'minecraft.used:minecraft.spruce_boat' | 'minecraft.crafted:minecraft.spruce_button' | 'minecraft.dropped:minecraft.spruce_button' | 'minecraft.picked_up:minecraft.spruce_button' | 'minecraft.used:minecraft.spruce_button' | 'minecraft.crafted:minecraft.spruce_chest_boat' | 'minecraft.dropped:minecraft.spruce_chest_boat' | 'minecraft.picked_up:minecraft.spruce_chest_boat' | 'minecraft.used:minecraft.spruce_chest_boat' | 'minecraft.crafted:minecraft.spruce_door' | 'minecraft.dropped:minecraft.spruce_door' | 'minecraft.picked_up:minecraft.spruce_door' | 'minecraft.used:minecraft.spruce_door' | 'minecraft.crafted:minecraft.spruce_fence' | 'minecraft.dropped:minecraft.spruce_fence' | 'minecraft.picked_up:minecraft.spruce_fence' | 'minecraft.used:minecraft.spruce_fence' | 'minecraft.crafted:minecraft.spruce_fence_gate' | 'minecraft.dropped:minecraft.spruce_fence_gate' | 'minecraft.picked_up:minecraft.spruce_fence_gate' | 'minecraft.used:minecraft.spruce_fence_gate' | 'minecraft.crafted:minecraft.spruce_hanging_sign' | 'minecraft.dropped:minecraft.spruce_hanging_sign' | 'minecraft.picked_up:minecraft.spruce_hanging_sign' | 'minecraft.used:minecraft.spruce_hanging_sign' | 'minecraft.crafted:minecraft.spruce_leaves' | 'minecraft.dropped:minecraft.spruce_leaves' | 'minecraft.picked_up:minecraft.spruce_leaves' | 'minecraft.used:minecraft.spruce_leaves' | 'minecraft.crafted:minecraft.spruce_log' | 'minecraft.dropped:minecraft.spruce_log' | 'minecraft.picked_up:minecraft.spruce_log' | 'minecraft.used:minecraft.spruce_log' | 'minecraft.crafted:minecraft.spruce_planks' | 'minecraft.dropped:minecraft.spruce_planks' | 'minecraft.picked_up:minecraft.spruce_planks' | 'minecraft.used:minecraft.spruce_planks' | 'minecraft.crafted:minecraft.spruce_pressure_plate' | 'minecraft.dropped:minecraft.spruce_pressure_plate' | 'minecraft.picked_up:minecraft.spruce_pressure_plate' | 'minecraft.used:minecraft.spruce_pressure_plate' | 'minecraft.crafted:minecraft.spruce_sapling' | 'minecraft.dropped:minecraft.spruce_sapling' | 'minecraft.picked_up:minecraft.spruce_sapling' | 'minecraft.used:minecraft.spruce_sapling' | 'minecraft.crafted:minecraft.spruce_sign' | 'minecraft.dropped:minecraft.spruce_sign' | 'minecraft.picked_up:minecraft.spruce_sign' | 'minecraft.used:minecraft.spruce_sign' | 'minecraft.crafted:minecraft.spruce_slab' | 'minecraft.dropped:minecraft.spruce_slab' | 'minecraft.picked_up:minecraft.spruce_slab' | 'minecraft.used:minecraft.spruce_slab' | 'minecraft.crafted:minecraft.spruce_stairs' | 'minecraft.dropped:minecraft.spruce_stairs' | 'minecraft.picked_up:minecraft.spruce_stairs' | 'minecraft.used:minecraft.spruce_stairs' | 'minecraft.crafted:minecraft.spruce_trapdoor' | 'minecraft.dropped:minecraft.spruce_trapdoor' | 'minecraft.picked_up:minecraft.spruce_trapdoor' | 'minecraft.used:minecraft.spruce_trapdoor' | 'minecraft.crafted:minecraft.spruce_wood' | 'minecraft.dropped:minecraft.spruce_wood' | 'minecraft.picked_up:minecraft.spruce_wood' | 'minecraft.used:minecraft.spruce_wood' | 'minecraft.crafted:minecraft.spyglass' | 'minecraft.dropped:minecraft.spyglass' | 'minecraft.picked_up:minecraft.spyglass' | 'minecraft.used:minecraft.spyglass' | 'minecraft.crafted:minecraft.squid_spawn_egg' | 'minecraft.dropped:minecraft.squid_spawn_egg' | 'minecraft.picked_up:minecraft.squid_spawn_egg' | 'minecraft.used:minecraft.squid_spawn_egg' | 'minecraft.crafted:minecraft.stick' | 'minecraft.dropped:minecraft.stick' | 'minecraft.picked_up:minecraft.stick' | 'minecraft.used:minecraft.stick' | 'minecraft.crafted:minecraft.sticky_piston' | 'minecraft.dropped:minecraft.sticky_piston' | 'minecraft.picked_up:minecraft.sticky_piston' | 'minecraft.used:minecraft.sticky_piston' | 'minecraft.crafted:minecraft.stone' | 'minecraft.dropped:minecraft.stone' | 'minecraft.picked_up:minecraft.stone' | 'minecraft.used:minecraft.stone' | 'minecraft.crafted:minecraft.stone_axe' | 'minecraft.dropped:minecraft.stone_axe' | 'minecraft.picked_up:minecraft.stone_axe' | 'minecraft.used:minecraft.stone_axe' | 'minecraft.crafted:minecraft.stone_brick_slab' | 'minecraft.dropped:minecraft.stone_brick_slab' | 'minecraft.picked_up:minecraft.stone_brick_slab' | 'minecraft.used:minecraft.stone_brick_slab' | 'minecraft.crafted:minecraft.stone_brick_stairs' | 'minecraft.dropped:minecraft.stone_brick_stairs' | 'minecraft.picked_up:minecraft.stone_brick_stairs' | 'minecraft.used:minecraft.stone_brick_stairs' | 'minecraft.crafted:minecraft.stone_brick_wall' | 'minecraft.dropped:minecraft.stone_brick_wall' | 'minecraft.picked_up:minecraft.stone_brick_wall' | 'minecraft.used:minecraft.stone_brick_wall' | 'minecraft.crafted:minecraft.stone_bricks' | 'minecraft.dropped:minecraft.stone_bricks' | 'minecraft.picked_up:minecraft.stone_bricks' | 'minecraft.used:minecraft.stone_bricks' | 'minecraft.crafted:minecraft.stone_button' | 'minecraft.dropped:minecraft.stone_button' | 'minecraft.picked_up:minecraft.stone_button' | 'minecraft.used:minecraft.stone_button' | 'minecraft.crafted:minecraft.stone_hoe' | 'minecraft.dropped:minecraft.stone_hoe' | 'minecraft.picked_up:minecraft.stone_hoe' | 'minecraft.used:minecraft.stone_hoe' | 'minecraft.crafted:minecraft.stone_pickaxe' | 'minecraft.dropped:minecraft.stone_pickaxe' | 'minecraft.picked_up:minecraft.stone_pickaxe' | 'minecraft.used:minecraft.stone_pickaxe' | 'minecraft.crafted:minecraft.stone_pressure_plate' | 'minecraft.dropped:minecraft.stone_pressure_plate' | 'minecraft.picked_up:minecraft.stone_pressure_plate' | 'minecraft.used:minecraft.stone_pressure_plate' | 'minecraft.crafted:minecraft.stone_shovel' | 'minecraft.dropped:minecraft.stone_shovel' | 'minecraft.picked_up:minecraft.stone_shovel' | 'minecraft.used:minecraft.stone_shovel' | 'minecraft.crafted:minecraft.stone_slab' | 'minecraft.dropped:minecraft.stone_slab' | 'minecraft.picked_up:minecraft.stone_slab' | 'minecraft.used:minecraft.stone_slab' | 'minecraft.crafted:minecraft.stone_stairs' | 'minecraft.dropped:minecraft.stone_stairs' | 'minecraft.picked_up:minecraft.stone_stairs' | 'minecraft.used:minecraft.stone_stairs' | 'minecraft.crafted:minecraft.stone_sword' | 'minecraft.dropped:minecraft.stone_sword' | 'minecraft.picked_up:minecraft.stone_sword' | 'minecraft.used:minecraft.stone_sword' | 'minecraft.crafted:minecraft.stonecutter' | 'minecraft.dropped:minecraft.stonecutter' | 'minecraft.picked_up:minecraft.stonecutter' | 'minecraft.used:minecraft.stonecutter' | 'minecraft.crafted:minecraft.stray_spawn_egg' | 'minecraft.dropped:minecraft.stray_spawn_egg' | 'minecraft.picked_up:minecraft.stray_spawn_egg' | 'minecraft.used:minecraft.stray_spawn_egg' | 'minecraft.crafted:minecraft.strider_spawn_egg' | 'minecraft.dropped:minecraft.strider_spawn_egg' | 'minecraft.picked_up:minecraft.strider_spawn_egg' | 'minecraft.used:minecraft.strider_spawn_egg' | 'minecraft.crafted:minecraft.string' | 'minecraft.dropped:minecraft.string' | 'minecraft.picked_up:minecraft.string' | 'minecraft.used:minecraft.string' | 'minecraft.crafted:minecraft.stripped_acacia_log' | 'minecraft.dropped:minecraft.stripped_acacia_log' | 'minecraft.picked_up:minecraft.stripped_acacia_log' | 'minecraft.used:minecraft.stripped_acacia_log' | 'minecraft.crafted:minecraft.stripped_acacia_wood' | 'minecraft.dropped:minecraft.stripped_acacia_wood' | 'minecraft.picked_up:minecraft.stripped_acacia_wood' | 'minecraft.used:minecraft.stripped_acacia_wood' | 'minecraft.crafted:minecraft.stripped_bamboo_block' | 'minecraft.dropped:minecraft.stripped_bamboo_block' | 'minecraft.picked_up:minecraft.stripped_bamboo_block' | 'minecraft.used:minecraft.stripped_bamboo_block' | 'minecraft.crafted:minecraft.stripped_birch_log' | 'minecraft.dropped:minecraft.stripped_birch_log' | 'minecraft.picked_up:minecraft.stripped_birch_log' | 'minecraft.used:minecraft.stripped_birch_log' | 'minecraft.crafted:minecraft.stripped_birch_wood' | 'minecraft.dropped:minecraft.stripped_birch_wood' | 'minecraft.picked_up:minecraft.stripped_birch_wood' | 'minecraft.used:minecraft.stripped_birch_wood' | 'minecraft.crafted:minecraft.stripped_cherry_log' | 'minecraft.dropped:minecraft.stripped_cherry_log' | 'minecraft.picked_up:minecraft.stripped_cherry_log' | 'minecraft.used:minecraft.stripped_cherry_log' | 'minecraft.crafted:minecraft.stripped_cherry_wood' | 'minecraft.dropped:minecraft.stripped_cherry_wood' | 'minecraft.picked_up:minecraft.stripped_cherry_wood' | 'minecraft.used:minecraft.stripped_cherry_wood' | 'minecraft.crafted:minecraft.stripped_crimson_hyphae' | 'minecraft.dropped:minecraft.stripped_crimson_hyphae' | 'minecraft.picked_up:minecraft.stripped_crimson_hyphae' | 'minecraft.used:minecraft.stripped_crimson_hyphae' | 'minecraft.crafted:minecraft.stripped_crimson_stem' | 'minecraft.dropped:minecraft.stripped_crimson_stem' | 'minecraft.picked_up:minecraft.stripped_crimson_stem' | 'minecraft.used:minecraft.stripped_crimson_stem' | 'minecraft.crafted:minecraft.stripped_dark_oak_log' | 'minecraft.dropped:minecraft.stripped_dark_oak_log' | 'minecraft.picked_up:minecraft.stripped_dark_oak_log' | 'minecraft.used:minecraft.stripped_dark_oak_log' | 'minecraft.crafted:minecraft.stripped_dark_oak_wood' | 'minecraft.dropped:minecraft.stripped_dark_oak_wood' | 'minecraft.picked_up:minecraft.stripped_dark_oak_wood' | 'minecraft.used:minecraft.stripped_dark_oak_wood' | 'minecraft.crafted:minecraft.stripped_jungle_log' | 'minecraft.dropped:minecraft.stripped_jungle_log' | 'minecraft.picked_up:minecraft.stripped_jungle_log' | 'minecraft.used:minecraft.stripped_jungle_log' | 'minecraft.crafted:minecraft.stripped_jungle_wood' | 'minecraft.dropped:minecraft.stripped_jungle_wood' | 'minecraft.picked_up:minecraft.stripped_jungle_wood' | 'minecraft.used:minecraft.stripped_jungle_wood' | 'minecraft.crafted:minecraft.stripped_mangrove_log' | 'minecraft.dropped:minecraft.stripped_mangrove_log' | 'minecraft.picked_up:minecraft.stripped_mangrove_log' | 'minecraft.used:minecraft.stripped_mangrove_log' | 'minecraft.crafted:minecraft.stripped_mangrove_wood' | 'minecraft.dropped:minecraft.stripped_mangrove_wood' | 'minecraft.picked_up:minecraft.stripped_mangrove_wood' | 'minecraft.used:minecraft.stripped_mangrove_wood' | 'minecraft.crafted:minecraft.stripped_oak_log' | 'minecraft.dropped:minecraft.stripped_oak_log' | 'minecraft.picked_up:minecraft.stripped_oak_log' | 'minecraft.used:minecraft.stripped_oak_log' | 'minecraft.crafted:minecraft.stripped_oak_wood' | 'minecraft.dropped:minecraft.stripped_oak_wood' | 'minecraft.picked_up:minecraft.stripped_oak_wood' | 'minecraft.used:minecraft.stripped_oak_wood' | 'minecraft.crafted:minecraft.stripped_spruce_log' | 'minecraft.dropped:minecraft.stripped_spruce_log' | 'minecraft.picked_up:minecraft.stripped_spruce_log' | 'minecraft.used:minecraft.stripped_spruce_log' | 'minecraft.crafted:minecraft.stripped_spruce_wood' | 'minecraft.dropped:minecraft.stripped_spruce_wood' | 'minecraft.picked_up:minecraft.stripped_spruce_wood' | 'minecraft.used:minecraft.stripped_spruce_wood' | 'minecraft.crafted:minecraft.stripped_warped_hyphae' | 'minecraft.dropped:minecraft.stripped_warped_hyphae' | 'minecraft.picked_up:minecraft.stripped_warped_hyphae' | 'minecraft.used:minecraft.stripped_warped_hyphae' | 'minecraft.crafted:minecraft.stripped_warped_stem' | 'minecraft.dropped:minecraft.stripped_warped_stem' | 'minecraft.picked_up:minecraft.stripped_warped_stem' | 'minecraft.used:minecraft.stripped_warped_stem' | 'minecraft.crafted:minecraft.structure_block' | 'minecraft.dropped:minecraft.structure_block' | 'minecraft.picked_up:minecraft.structure_block' | 'minecraft.used:minecraft.structure_block' | 'minecraft.crafted:minecraft.structure_void' | 'minecraft.dropped:minecraft.structure_void' | 'minecraft.picked_up:minecraft.structure_void' | 'minecraft.used:minecraft.structure_void' | 'minecraft.crafted:minecraft.sugar' | 'minecraft.dropped:minecraft.sugar' | 'minecraft.picked_up:minecraft.sugar' | 'minecraft.used:minecraft.sugar' | 'minecraft.crafted:minecraft.sugar_cane' | 'minecraft.dropped:minecraft.sugar_cane' | 'minecraft.picked_up:minecraft.sugar_cane' | 'minecraft.used:minecraft.sugar_cane' | 'minecraft.crafted:minecraft.sunflower' | 'minecraft.dropped:minecraft.sunflower' | 'minecraft.picked_up:minecraft.sunflower' | 'minecraft.used:minecraft.sunflower' | 'minecraft.crafted:minecraft.suspicious_gravel' | 'minecraft.dropped:minecraft.suspicious_gravel' | 'minecraft.picked_up:minecraft.suspicious_gravel' | 'minecraft.used:minecraft.suspicious_gravel' | 'minecraft.crafted:minecraft.suspicious_sand' | 'minecraft.dropped:minecraft.suspicious_sand' | 'minecraft.picked_up:minecraft.suspicious_sand' | 'minecraft.used:minecraft.suspicious_sand' | 'minecraft.crafted:minecraft.suspicious_stew' | 'minecraft.dropped:minecraft.suspicious_stew' | 'minecraft.picked_up:minecraft.suspicious_stew' | 'minecraft.used:minecraft.suspicious_stew' | 'minecraft.crafted:minecraft.sweet_berries' | 'minecraft.dropped:minecraft.sweet_berries' | 'minecraft.picked_up:minecraft.sweet_berries' | 'minecraft.used:minecraft.sweet_berries' | 'minecraft.crafted:minecraft.tadpole_bucket' | 'minecraft.dropped:minecraft.tadpole_bucket' | 'minecraft.picked_up:minecraft.tadpole_bucket' | 'minecraft.used:minecraft.tadpole_bucket' | 'minecraft.crafted:minecraft.tadpole_spawn_egg' | 'minecraft.dropped:minecraft.tadpole_spawn_egg' | 'minecraft.picked_up:minecraft.tadpole_spawn_egg' | 'minecraft.used:minecraft.tadpole_spawn_egg' | 'minecraft.crafted:minecraft.tall_grass' | 'minecraft.dropped:minecraft.tall_grass' | 'minecraft.picked_up:minecraft.tall_grass' | 'minecraft.used:minecraft.tall_grass' | 'minecraft.crafted:minecraft.target' | 'minecraft.dropped:minecraft.target' | 'minecraft.picked_up:minecraft.target' | 'minecraft.used:minecraft.target' | 'minecraft.crafted:minecraft.terracotta' | 'minecraft.dropped:minecraft.terracotta' | 'minecraft.picked_up:minecraft.terracotta' | 'minecraft.used:minecraft.terracotta' | 'minecraft.crafted:minecraft.tide_armor_trim_smithing_template' | 'minecraft.dropped:minecraft.tide_armor_trim_smithing_template' | 'minecraft.picked_up:minecraft.tide_armor_trim_smithing_template' | 'minecraft.used:minecraft.tide_armor_trim_smithing_template' | 'minecraft.crafted:minecraft.tinted_glass' | 'minecraft.dropped:minecraft.tinted_glass' | 'minecraft.picked_up:minecraft.tinted_glass' | 'minecraft.used:minecraft.tinted_glass' | 'minecraft.crafted:minecraft.tipped_arrow' | 'minecraft.dropped:minecraft.tipped_arrow' | 'minecraft.picked_up:minecraft.tipped_arrow' | 'minecraft.used:minecraft.tipped_arrow' | 'minecraft.crafted:minecraft.tnt' | 'minecraft.dropped:minecraft.tnt' | 'minecraft.picked_up:minecraft.tnt' | 'minecraft.used:minecraft.tnt' | 'minecraft.crafted:minecraft.tnt_minecart' | 'minecraft.dropped:minecraft.tnt_minecart' | 'minecraft.picked_up:minecraft.tnt_minecart' | 'minecraft.used:minecraft.tnt_minecart' | 'minecraft.crafted:minecraft.torch' | 'minecraft.dropped:minecraft.torch' | 'minecraft.picked_up:minecraft.torch' | 'minecraft.used:minecraft.torch' | 'minecraft.crafted:minecraft.torchflower' | 'minecraft.dropped:minecraft.torchflower' | 'minecraft.picked_up:minecraft.torchflower' | 'minecraft.used:minecraft.torchflower' | 'minecraft.crafted:minecraft.torchflower_seeds' | 'minecraft.dropped:minecraft.torchflower_seeds' | 'minecraft.picked_up:minecraft.torchflower_seeds' | 'minecraft.used:minecraft.torchflower_seeds' | 'minecraft.crafted:minecraft.totem_of_undying' | 'minecraft.dropped:minecraft.totem_of_undying' | 'minecraft.picked_up:minecraft.totem_of_undying' | 'minecraft.used:minecraft.totem_of_undying' | 'minecraft.crafted:minecraft.trader_llama_spawn_egg' | 'minecraft.dropped:minecraft.trader_llama_spawn_egg' | 'minecraft.picked_up:minecraft.trader_llama_spawn_egg' | 'minecraft.used:minecraft.trader_llama_spawn_egg' | 'minecraft.crafted:minecraft.trapped_chest' | 'minecraft.dropped:minecraft.trapped_chest' | 'minecraft.picked_up:minecraft.trapped_chest' | 'minecraft.used:minecraft.trapped_chest' | 'minecraft.crafted:minecraft.trial_key' | 'minecraft.dropped:minecraft.trial_key' | 'minecraft.picked_up:minecraft.trial_key' | 'minecraft.used:minecraft.trial_key' | 'minecraft.crafted:minecraft.trial_spawner' | 'minecraft.dropped:minecraft.trial_spawner' | 'minecraft.picked_up:minecraft.trial_spawner' | 'minecraft.used:minecraft.trial_spawner' | 'minecraft.crafted:minecraft.trident' | 'minecraft.dropped:minecraft.trident' | 'minecraft.picked_up:minecraft.trident' | 'minecraft.used:minecraft.trident' | 'minecraft.crafted:minecraft.tripwire_hook' | 'minecraft.dropped:minecraft.tripwire_hook' | 'minecraft.picked_up:minecraft.tripwire_hook' | 'minecraft.used:minecraft.tripwire_hook' | 'minecraft.crafted:minecraft.tropical_fish' | 'minecraft.dropped:minecraft.tropical_fish' | 'minecraft.picked_up:minecraft.tropical_fish' | 'minecraft.used:minecraft.tropical_fish' | 'minecraft.crafted:minecraft.tropical_fish_bucket' | 'minecraft.dropped:minecraft.tropical_fish_bucket' | 'minecraft.picked_up:minecraft.tropical_fish_bucket' | 'minecraft.used:minecraft.tropical_fish_bucket' | 'minecraft.crafted:minecraft.tropical_fish_spawn_egg' | 'minecraft.dropped:minecraft.tropical_fish_spawn_egg' | 'minecraft.picked_up:minecraft.tropical_fish_spawn_egg' | 'minecraft.used:minecraft.tropical_fish_spawn_egg' | 'minecraft.crafted:minecraft.tube_coral' | 'minecraft.dropped:minecraft.tube_coral' | 'minecraft.picked_up:minecraft.tube_coral' | 'minecraft.used:minecraft.tube_coral' | 'minecraft.crafted:minecraft.tube_coral_block' | 'minecraft.dropped:minecraft.tube_coral_block' | 'minecraft.picked_up:minecraft.tube_coral_block' | 'minecraft.used:minecraft.tube_coral_block' | 'minecraft.crafted:minecraft.tube_coral_fan' | 'minecraft.dropped:minecraft.tube_coral_fan' | 'minecraft.picked_up:minecraft.tube_coral_fan' | 'minecraft.used:minecraft.tube_coral_fan' | 'minecraft.crafted:minecraft.tuff' | 'minecraft.dropped:minecraft.tuff' | 'minecraft.picked_up:minecraft.tuff' | 'minecraft.used:minecraft.tuff' | 'minecraft.crafted:minecraft.tuff_brick_slab' | 'minecraft.dropped:minecraft.tuff_brick_slab' | 'minecraft.picked_up:minecraft.tuff_brick_slab' | 'minecraft.used:minecraft.tuff_brick_slab' | 'minecraft.crafted:minecraft.tuff_brick_stairs' | 'minecraft.dropped:minecraft.tuff_brick_stairs' | 'minecraft.picked_up:minecraft.tuff_brick_stairs' | 'minecraft.used:minecraft.tuff_brick_stairs' | 'minecraft.crafted:minecraft.tuff_brick_wall' | 'minecraft.dropped:minecraft.tuff_brick_wall' | 'minecraft.picked_up:minecraft.tuff_brick_wall' | 'minecraft.used:minecraft.tuff_brick_wall' | 'minecraft.crafted:minecraft.tuff_bricks' | 'minecraft.dropped:minecraft.tuff_bricks' | 'minecraft.picked_up:minecraft.tuff_bricks' | 'minecraft.used:minecraft.tuff_bricks' | 'minecraft.crafted:minecraft.tuff_slab' | 'minecraft.dropped:minecraft.tuff_slab' | 'minecraft.picked_up:minecraft.tuff_slab' | 'minecraft.used:minecraft.tuff_slab' | 'minecraft.crafted:minecraft.tuff_stairs' | 'minecraft.dropped:minecraft.tuff_stairs' | 'minecraft.picked_up:minecraft.tuff_stairs' | 'minecraft.used:minecraft.tuff_stairs' | 'minecraft.crafted:minecraft.tuff_wall' | 'minecraft.dropped:minecraft.tuff_wall' | 'minecraft.picked_up:minecraft.tuff_wall' | 'minecraft.used:minecraft.tuff_wall' | 'minecraft.crafted:minecraft.turtle_egg' | 'minecraft.dropped:minecraft.turtle_egg' | 'minecraft.picked_up:minecraft.turtle_egg' | 'minecraft.used:minecraft.turtle_egg' | 'minecraft.crafted:minecraft.turtle_helmet' | 'minecraft.dropped:minecraft.turtle_helmet' | 'minecraft.picked_up:minecraft.turtle_helmet' | 'minecraft.used:minecraft.turtle_helmet' | 'minecraft.crafted:minecraft.turtle_spawn_egg' | 'minecraft.dropped:minecraft.turtle_spawn_egg' | 'minecraft.picked_up:minecraft.turtle_spawn_egg' | 'minecraft.used:minecraft.turtle_spawn_egg' | 'minecraft.crafted:minecraft.twisting_vines' | 'minecraft.dropped:minecraft.twisting_vines' | 'minecraft.picked_up:minecraft.twisting_vines' | 'minecraft.used:minecraft.twisting_vines' | 'minecraft.crafted:minecraft.verdant_froglight' | 'minecraft.dropped:minecraft.verdant_froglight' | 'minecraft.picked_up:minecraft.verdant_froglight' | 'minecraft.used:minecraft.verdant_froglight' | 'minecraft.crafted:minecraft.vex_armor_trim_smithing_template' | 'minecraft.dropped:minecraft.vex_armor_trim_smithing_template' | 'minecraft.picked_up:minecraft.vex_armor_trim_smithing_template' | 'minecraft.used:minecraft.vex_armor_trim_smithing_template' | 'minecraft.crafted:minecraft.vex_spawn_egg' | 'minecraft.dropped:minecraft.vex_spawn_egg' | 'minecraft.picked_up:minecraft.vex_spawn_egg' | 'minecraft.used:minecraft.vex_spawn_egg' | 'minecraft.crafted:minecraft.villager_spawn_egg' | 'minecraft.dropped:minecraft.villager_spawn_egg' | 'minecraft.picked_up:minecraft.villager_spawn_egg' | 'minecraft.used:minecraft.villager_spawn_egg' | 'minecraft.crafted:minecraft.vindicator_spawn_egg' | 'minecraft.dropped:minecraft.vindicator_spawn_egg' | 'minecraft.picked_up:minecraft.vindicator_spawn_egg' | 'minecraft.used:minecraft.vindicator_spawn_egg' | 'minecraft.crafted:minecraft.vine' | 'minecraft.dropped:minecraft.vine' | 'minecraft.picked_up:minecraft.vine' | 'minecraft.used:minecraft.vine' | 'minecraft.crafted:minecraft.wandering_trader_spawn_egg' | 'minecraft.dropped:minecraft.wandering_trader_spawn_egg' | 'minecraft.picked_up:minecraft.wandering_trader_spawn_egg' | 'minecraft.used:minecraft.wandering_trader_spawn_egg' | 'minecraft.crafted:minecraft.ward_armor_trim_smithing_template' | 'minecraft.dropped:minecraft.ward_armor_trim_smithing_template' | 'minecraft.picked_up:minecraft.ward_armor_trim_smithing_template' | 'minecraft.used:minecraft.ward_armor_trim_smithing_template' | 'minecraft.crafted:minecraft.warden_spawn_egg' | 'minecraft.dropped:minecraft.warden_spawn_egg' | 'minecraft.picked_up:minecraft.warden_spawn_egg' | 'minecraft.used:minecraft.warden_spawn_egg' | 'minecraft.crafted:minecraft.warped_button' | 'minecraft.dropped:minecraft.warped_button' | 'minecraft.picked_up:minecraft.warped_button' | 'minecraft.used:minecraft.warped_button' | 'minecraft.crafted:minecraft.warped_door' | 'minecraft.dropped:minecraft.warped_door' | 'minecraft.picked_up:minecraft.warped_door' | 'minecraft.used:minecraft.warped_door' | 'minecraft.crafted:minecraft.warped_fence' | 'minecraft.dropped:minecraft.warped_fence' | 'minecraft.picked_up:minecraft.warped_fence' | 'minecraft.used:minecraft.warped_fence' | 'minecraft.crafted:minecraft.warped_fence_gate' | 'minecraft.dropped:minecraft.warped_fence_gate' | 'minecraft.picked_up:minecraft.warped_fence_gate' | 'minecraft.used:minecraft.warped_fence_gate' | 'minecraft.crafted:minecraft.warped_fungus' | 'minecraft.dropped:minecraft.warped_fungus' | 'minecraft.picked_up:minecraft.warped_fungus' | 'minecraft.used:minecraft.warped_fungus' | 'minecraft.crafted:minecraft.warped_fungus_on_a_stick' | 'minecraft.dropped:minecraft.warped_fungus_on_a_stick' | 'minecraft.picked_up:minecraft.warped_fungus_on_a_stick' | 'minecraft.used:minecraft.warped_fungus_on_a_stick' | 'minecraft.crafted:minecraft.warped_hanging_sign' | 'minecraft.dropped:minecraft.warped_hanging_sign' | 'minecraft.picked_up:minecraft.warped_hanging_sign' | 'minecraft.used:minecraft.warped_hanging_sign' | 'minecraft.crafted:minecraft.warped_hyphae' | 'minecraft.dropped:minecraft.warped_hyphae' | 'minecraft.picked_up:minecraft.warped_hyphae' | 'minecraft.used:minecraft.warped_hyphae' | 'minecraft.crafted:minecraft.warped_nylium' | 'minecraft.dropped:minecraft.warped_nylium' | 'minecraft.picked_up:minecraft.warped_nylium' | 'minecraft.used:minecraft.warped_nylium' | 'minecraft.crafted:minecraft.warped_planks' | 'minecraft.dropped:minecraft.warped_planks' | 'minecraft.picked_up:minecraft.warped_planks' | 'minecraft.used:minecraft.warped_planks' | 'minecraft.crafted:minecraft.warped_pressure_plate' | 'minecraft.dropped:minecraft.warped_pressure_plate' | 'minecraft.picked_up:minecraft.warped_pressure_plate' | 'minecraft.used:minecraft.warped_pressure_plate' | 'minecraft.crafted:minecraft.warped_roots' | 'minecraft.dropped:minecraft.warped_roots' | 'minecraft.picked_up:minecraft.warped_roots' | 'minecraft.used:minecraft.warped_roots' | 'minecraft.crafted:minecraft.warped_sign' | 'minecraft.dropped:minecraft.warped_sign' | 'minecraft.picked_up:minecraft.warped_sign' | 'minecraft.used:minecraft.warped_sign' | 'minecraft.crafted:minecraft.warped_slab' | 'minecraft.dropped:minecraft.warped_slab' | 'minecraft.picked_up:minecraft.warped_slab' | 'minecraft.used:minecraft.warped_slab' | 'minecraft.crafted:minecraft.warped_stairs' | 'minecraft.dropped:minecraft.warped_stairs' | 'minecraft.picked_up:minecraft.warped_stairs' | 'minecraft.used:minecraft.warped_stairs' | 'minecraft.crafted:minecraft.warped_stem' | 'minecraft.dropped:minecraft.warped_stem' | 'minecraft.picked_up:minecraft.warped_stem' | 'minecraft.used:minecraft.warped_stem' | 'minecraft.crafted:minecraft.warped_trapdoor' | 'minecraft.dropped:minecraft.warped_trapdoor' | 'minecraft.picked_up:minecraft.warped_trapdoor' | 'minecraft.used:minecraft.warped_trapdoor' | 'minecraft.crafted:minecraft.warped_wart_block' | 'minecraft.dropped:minecraft.warped_wart_block' | 'minecraft.picked_up:minecraft.warped_wart_block' | 'minecraft.used:minecraft.warped_wart_block' | 'minecraft.crafted:minecraft.water_bucket' | 'minecraft.dropped:minecraft.water_bucket' | 'minecraft.picked_up:minecraft.water_bucket' | 'minecraft.used:minecraft.water_bucket' | 'minecraft.crafted:minecraft.waxed_chiseled_copper' | 'minecraft.dropped:minecraft.waxed_chiseled_copper' | 'minecraft.picked_up:minecraft.waxed_chiseled_copper' | 'minecraft.used:minecraft.waxed_chiseled_copper' | 'minecraft.crafted:minecraft.waxed_copper_block' | 'minecraft.dropped:minecraft.waxed_copper_block' | 'minecraft.picked_up:minecraft.waxed_copper_block' | 'minecraft.used:minecraft.waxed_copper_block' | 'minecraft.crafted:minecraft.waxed_copper_bulb' | 'minecraft.dropped:minecraft.waxed_copper_bulb' | 'minecraft.picked_up:minecraft.waxed_copper_bulb' | 'minecraft.used:minecraft.waxed_copper_bulb' | 'minecraft.crafted:minecraft.waxed_copper_door' | 'minecraft.dropped:minecraft.waxed_copper_door' | 'minecraft.picked_up:minecraft.waxed_copper_door' | 'minecraft.used:minecraft.waxed_copper_door' | 'minecraft.crafted:minecraft.waxed_copper_grate' | 'minecraft.dropped:minecraft.waxed_copper_grate' | 'minecraft.picked_up:minecraft.waxed_copper_grate' | 'minecraft.used:minecraft.waxed_copper_grate' | 'minecraft.crafted:minecraft.waxed_copper_trapdoor' | 'minecraft.dropped:minecraft.waxed_copper_trapdoor' | 'minecraft.picked_up:minecraft.waxed_copper_trapdoor' | 'minecraft.used:minecraft.waxed_copper_trapdoor' | 'minecraft.crafted:minecraft.waxed_cut_copper' | 'minecraft.dropped:minecraft.waxed_cut_copper' | 'minecraft.picked_up:minecraft.waxed_cut_copper' | 'minecraft.used:minecraft.waxed_cut_copper' | 'minecraft.crafted:minecraft.waxed_cut_copper_slab' | 'minecraft.dropped:minecraft.waxed_cut_copper_slab' | 'minecraft.picked_up:minecraft.waxed_cut_copper_slab' | 'minecraft.used:minecraft.waxed_cut_copper_slab' | 'minecraft.crafted:minecraft.waxed_cut_copper_stairs' | 'minecraft.dropped:minecraft.waxed_cut_copper_stairs' | 'minecraft.picked_up:minecraft.waxed_cut_copper_stairs' | 'minecraft.used:minecraft.waxed_cut_copper_stairs' | 'minecraft.crafted:minecraft.waxed_exposed_chiseled_copper' | 'minecraft.dropped:minecraft.waxed_exposed_chiseled_copper' | 'minecraft.picked_up:minecraft.waxed_exposed_chiseled_copper' | 'minecraft.used:minecraft.waxed_exposed_chiseled_copper' | 'minecraft.crafted:minecraft.waxed_exposed_copper' | 'minecraft.dropped:minecraft.waxed_exposed_copper' | 'minecraft.picked_up:minecraft.waxed_exposed_copper' | 'minecraft.used:minecraft.waxed_exposed_copper' | 'minecraft.crafted:minecraft.waxed_exposed_copper_bulb' | 'minecraft.dropped:minecraft.waxed_exposed_copper_bulb' | 'minecraft.picked_up:minecraft.waxed_exposed_copper_bulb' | 'minecraft.used:minecraft.waxed_exposed_copper_bulb' | 'minecraft.crafted:minecraft.waxed_exposed_copper_door' | 'minecraft.dropped:minecraft.waxed_exposed_copper_door' | 'minecraft.picked_up:minecraft.waxed_exposed_copper_door' | 'minecraft.used:minecraft.waxed_exposed_copper_door' | 'minecraft.crafted:minecraft.waxed_exposed_copper_grate' | 'minecraft.dropped:minecraft.waxed_exposed_copper_grate' | 'minecraft.picked_up:minecraft.waxed_exposed_copper_grate' | 'minecraft.used:minecraft.waxed_exposed_copper_grate' | 'minecraft.crafted:minecraft.waxed_exposed_copper_trapdoor' | 'minecraft.dropped:minecraft.waxed_exposed_copper_trapdoor' | 'minecraft.picked_up:minecraft.waxed_exposed_copper_trapdoor' | 'minecraft.used:minecraft.waxed_exposed_copper_trapdoor' | 'minecraft.crafted:minecraft.waxed_exposed_cut_copper' | 'minecraft.dropped:minecraft.waxed_exposed_cut_copper' | 'minecraft.picked_up:minecraft.waxed_exposed_cut_copper' | 'minecraft.used:minecraft.waxed_exposed_cut_copper' | 'minecraft.crafted:minecraft.waxed_exposed_cut_copper_slab' | 'minecraft.dropped:minecraft.waxed_exposed_cut_copper_slab' | 'minecraft.picked_up:minecraft.waxed_exposed_cut_copper_slab' | 'minecraft.used:minecraft.waxed_exposed_cut_copper_slab' | 'minecraft.crafted:minecraft.waxed_exposed_cut_copper_stairs' | 'minecraft.dropped:minecraft.waxed_exposed_cut_copper_stairs' | 'minecraft.picked_up:minecraft.waxed_exposed_cut_copper_stairs' | 'minecraft.used:minecraft.waxed_exposed_cut_copper_stairs' | 'minecraft.crafted:minecraft.waxed_oxidized_chiseled_copper' | 'minecraft.dropped:minecraft.waxed_oxidized_chiseled_copper' | 'minecraft.picked_up:minecraft.waxed_oxidized_chiseled_copper' | 'minecraft.used:minecraft.waxed_oxidized_chiseled_copper' | 'minecraft.crafted:minecraft.waxed_oxidized_copper' | 'minecraft.dropped:minecraft.waxed_oxidized_copper' | 'minecraft.picked_up:minecraft.waxed_oxidized_copper' | 'minecraft.used:minecraft.waxed_oxidized_copper' | 'minecraft.crafted:minecraft.waxed_oxidized_copper_bulb' | 'minecraft.dropped:minecraft.waxed_oxidized_copper_bulb' | 'minecraft.picked_up:minecraft.waxed_oxidized_copper_bulb' | 'minecraft.used:minecraft.waxed_oxidized_copper_bulb' | 'minecraft.crafted:minecraft.waxed_oxidized_copper_door' | 'minecraft.dropped:minecraft.waxed_oxidized_copper_door' | 'minecraft.picked_up:minecraft.waxed_oxidized_copper_door' | 'minecraft.used:minecraft.waxed_oxidized_copper_door' | 'minecraft.crafted:minecraft.waxed_oxidized_copper_grate' | 'minecraft.dropped:minecraft.waxed_oxidized_copper_grate' | 'minecraft.picked_up:minecraft.waxed_oxidized_copper_grate' | 'minecraft.used:minecraft.waxed_oxidized_copper_grate' | 'minecraft.crafted:minecraft.waxed_oxidized_copper_trapdoor' | 'minecraft.dropped:minecraft.waxed_oxidized_copper_trapdoor' | 'minecraft.picked_up:minecraft.waxed_oxidized_copper_trapdoor' | 'minecraft.used:minecraft.waxed_oxidized_copper_trapdoor' | 'minecraft.crafted:minecraft.waxed_oxidized_cut_copper' | 'minecraft.dropped:minecraft.waxed_oxidized_cut_copper' | 'minecraft.picked_up:minecraft.waxed_oxidized_cut_copper' | 'minecraft.used:minecraft.waxed_oxidized_cut_copper' | 'minecraft.crafted:minecraft.waxed_oxidized_cut_copper_slab' | 'minecraft.dropped:minecraft.waxed_oxidized_cut_copper_slab' | 'minecraft.picked_up:minecraft.waxed_oxidized_cut_copper_slab' | 'minecraft.used:minecraft.waxed_oxidized_cut_copper_slab' | 'minecraft.crafted:minecraft.waxed_oxidized_cut_copper_stairs' | 'minecraft.dropped:minecraft.waxed_oxidized_cut_copper_stairs' | 'minecraft.picked_up:minecraft.waxed_oxidized_cut_copper_stairs' | 'minecraft.used:minecraft.waxed_oxidized_cut_copper_stairs' | 'minecraft.crafted:minecraft.waxed_weathered_chiseled_copper' | 'minecraft.dropped:minecraft.waxed_weathered_chiseled_copper' | 'minecraft.picked_up:minecraft.waxed_weathered_chiseled_copper' | 'minecraft.used:minecraft.waxed_weathered_chiseled_copper' | 'minecraft.crafted:minecraft.waxed_weathered_copper' | 'minecraft.dropped:minecraft.waxed_weathered_copper' | 'minecraft.picked_up:minecraft.waxed_weathered_copper' | 'minecraft.used:minecraft.waxed_weathered_copper' | 'minecraft.crafted:minecraft.waxed_weathered_copper_bulb' | 'minecraft.dropped:minecraft.waxed_weathered_copper_bulb' | 'minecraft.picked_up:minecraft.waxed_weathered_copper_bulb' | 'minecraft.used:minecraft.waxed_weathered_copper_bulb' | 'minecraft.crafted:minecraft.waxed_weathered_copper_door' | 'minecraft.dropped:minecraft.waxed_weathered_copper_door' | 'minecraft.picked_up:minecraft.waxed_weathered_copper_door' | 'minecraft.used:minecraft.waxed_weathered_copper_door' | 'minecraft.crafted:minecraft.waxed_weathered_copper_grate' | 'minecraft.dropped:minecraft.waxed_weathered_copper_grate' | 'minecraft.picked_up:minecraft.waxed_weathered_copper_grate' | 'minecraft.used:minecraft.waxed_weathered_copper_grate' | 'minecraft.crafted:minecraft.waxed_weathered_copper_trapdoor' | 'minecraft.dropped:minecraft.waxed_weathered_copper_trapdoor' | 'minecraft.picked_up:minecraft.waxed_weathered_copper_trapdoor' | 'minecraft.used:minecraft.waxed_weathered_copper_trapdoor' | 'minecraft.crafted:minecraft.waxed_weathered_cut_copper' | 'minecraft.dropped:minecraft.waxed_weathered_cut_copper' | 'minecraft.picked_up:minecraft.waxed_weathered_cut_copper' | 'minecraft.used:minecraft.waxed_weathered_cut_copper' | 'minecraft.crafted:minecraft.waxed_weathered_cut_copper_slab' | 'minecraft.dropped:minecraft.waxed_weathered_cut_copper_slab' | 'minecraft.picked_up:minecraft.waxed_weathered_cut_copper_slab' | 'minecraft.used:minecraft.waxed_weathered_cut_copper_slab' | 'minecraft.crafted:minecraft.waxed_weathered_cut_copper_stairs' | 'minecraft.dropped:minecraft.waxed_weathered_cut_copper_stairs' | 'minecraft.picked_up:minecraft.waxed_weathered_cut_copper_stairs' | 'minecraft.used:minecraft.waxed_weathered_cut_copper_stairs' | 'minecraft.crafted:minecraft.wayfinder_armor_trim_smithing_template' | 'minecraft.dropped:minecraft.wayfinder_armor_trim_smithing_template' | 'minecraft.picked_up:minecraft.wayfinder_armor_trim_smithing_template' | 'minecraft.used:minecraft.wayfinder_armor_trim_smithing_template' | 'minecraft.crafted:minecraft.weathered_chiseled_copper' | 'minecraft.dropped:minecraft.weathered_chiseled_copper' | 'minecraft.picked_up:minecraft.weathered_chiseled_copper' | 'minecraft.used:minecraft.weathered_chiseled_copper' | 'minecraft.crafted:minecraft.weathered_copper' | 'minecraft.dropped:minecraft.weathered_copper' | 'minecraft.picked_up:minecraft.weathered_copper' | 'minecraft.used:minecraft.weathered_copper' | 'minecraft.crafted:minecraft.weathered_copper_bulb' | 'minecraft.dropped:minecraft.weathered_copper_bulb' | 'minecraft.picked_up:minecraft.weathered_copper_bulb' | 'minecraft.used:minecraft.weathered_copper_bulb' | 'minecraft.crafted:minecraft.weathered_copper_door' | 'minecraft.dropped:minecraft.weathered_copper_door' | 'minecraft.picked_up:minecraft.weathered_copper_door' | 'minecraft.used:minecraft.weathered_copper_door' | 'minecraft.crafted:minecraft.weathered_copper_grate' | 'minecraft.dropped:minecraft.weathered_copper_grate' | 'minecraft.picked_up:minecraft.weathered_copper_grate' | 'minecraft.used:minecraft.weathered_copper_grate' | 'minecraft.crafted:minecraft.weathered_copper_trapdoor' | 'minecraft.dropped:minecraft.weathered_copper_trapdoor' | 'minecraft.picked_up:minecraft.weathered_copper_trapdoor' | 'minecraft.used:minecraft.weathered_copper_trapdoor' | 'minecraft.crafted:minecraft.weathered_cut_copper' | 'minecraft.dropped:minecraft.weathered_cut_copper' | 'minecraft.picked_up:minecraft.weathered_cut_copper' | 'minecraft.used:minecraft.weathered_cut_copper' | 'minecraft.crafted:minecraft.weathered_cut_copper_slab' | 'minecraft.dropped:minecraft.weathered_cut_copper_slab' | 'minecraft.picked_up:minecraft.weathered_cut_copper_slab' | 'minecraft.used:minecraft.weathered_cut_copper_slab' | 'minecraft.crafted:minecraft.weathered_cut_copper_stairs' | 'minecraft.dropped:minecraft.weathered_cut_copper_stairs' | 'minecraft.picked_up:minecraft.weathered_cut_copper_stairs' | 'minecraft.used:minecraft.weathered_cut_copper_stairs' | 'minecraft.crafted:minecraft.weeping_vines' | 'minecraft.dropped:minecraft.weeping_vines' | 'minecraft.picked_up:minecraft.weeping_vines' | 'minecraft.used:minecraft.weeping_vines' | 'minecraft.crafted:minecraft.wet_sponge' | 'minecraft.dropped:minecraft.wet_sponge' | 'minecraft.picked_up:minecraft.wet_sponge' | 'minecraft.used:minecraft.wet_sponge' | 'minecraft.crafted:minecraft.wheat' | 'minecraft.dropped:minecraft.wheat' | 'minecraft.picked_up:minecraft.wheat' | 'minecraft.used:minecraft.wheat' | 'minecraft.crafted:minecraft.wheat_seeds' | 'minecraft.dropped:minecraft.wheat_seeds' | 'minecraft.picked_up:minecraft.wheat_seeds' | 'minecraft.used:minecraft.wheat_seeds' | 'minecraft.crafted:minecraft.white_banner' | 'minecraft.dropped:minecraft.white_banner' | 'minecraft.picked_up:minecraft.white_banner' | 'minecraft.used:minecraft.white_banner' | 'minecraft.crafted:minecraft.white_bed' | 'minecraft.dropped:minecraft.white_bed' | 'minecraft.picked_up:minecraft.white_bed' | 'minecraft.used:minecraft.white_bed' | 'minecraft.crafted:minecraft.white_candle' | 'minecraft.dropped:minecraft.white_candle' | 'minecraft.picked_up:minecraft.white_candle' | 'minecraft.used:minecraft.white_candle' | 'minecraft.crafted:minecraft.white_carpet' | 'minecraft.dropped:minecraft.white_carpet' | 'minecraft.picked_up:minecraft.white_carpet' | 'minecraft.used:minecraft.white_carpet' | 'minecraft.crafted:minecraft.white_concrete' | 'minecraft.dropped:minecraft.white_concrete' | 'minecraft.picked_up:minecraft.white_concrete' | 'minecraft.used:minecraft.white_concrete' | 'minecraft.crafted:minecraft.white_concrete_powder' | 'minecraft.dropped:minecraft.white_concrete_powder' | 'minecraft.picked_up:minecraft.white_concrete_powder' | 'minecraft.used:minecraft.white_concrete_powder' | 'minecraft.crafted:minecraft.white_dye' | 'minecraft.dropped:minecraft.white_dye' | 'minecraft.picked_up:minecraft.white_dye' | 'minecraft.used:minecraft.white_dye' | 'minecraft.crafted:minecraft.white_glazed_terracotta' | 'minecraft.dropped:minecraft.white_glazed_terracotta' | 'minecraft.picked_up:minecraft.white_glazed_terracotta' | 'minecraft.used:minecraft.white_glazed_terracotta' | 'minecraft.crafted:minecraft.white_shulker_box' | 'minecraft.dropped:minecraft.white_shulker_box' | 'minecraft.picked_up:minecraft.white_shulker_box' | 'minecraft.used:minecraft.white_shulker_box' | 'minecraft.crafted:minecraft.white_stained_glass' | 'minecraft.dropped:minecraft.white_stained_glass' | 'minecraft.picked_up:minecraft.white_stained_glass' | 'minecraft.used:minecraft.white_stained_glass' | 'minecraft.crafted:minecraft.white_stained_glass_pane' | 'minecraft.dropped:minecraft.white_stained_glass_pane' | 'minecraft.picked_up:minecraft.white_stained_glass_pane' | 'minecraft.used:minecraft.white_stained_glass_pane' | 'minecraft.crafted:minecraft.white_terracotta' | 'minecraft.dropped:minecraft.white_terracotta' | 'minecraft.picked_up:minecraft.white_terracotta' | 'minecraft.used:minecraft.white_terracotta' | 'minecraft.crafted:minecraft.white_tulip' | 'minecraft.dropped:minecraft.white_tulip' | 'minecraft.picked_up:minecraft.white_tulip' | 'minecraft.used:minecraft.white_tulip' | 'minecraft.crafted:minecraft.white_wool' | 'minecraft.dropped:minecraft.white_wool' | 'minecraft.picked_up:minecraft.white_wool' | 'minecraft.used:minecraft.white_wool' | 'minecraft.crafted:minecraft.wild_armor_trim_smithing_template' | 'minecraft.dropped:minecraft.wild_armor_trim_smithing_template' | 'minecraft.picked_up:minecraft.wild_armor_trim_smithing_template' | 'minecraft.used:minecraft.wild_armor_trim_smithing_template' | 'minecraft.crafted:minecraft.witch_spawn_egg' | 'minecraft.dropped:minecraft.witch_spawn_egg' | 'minecraft.picked_up:minecraft.witch_spawn_egg' | 'minecraft.used:minecraft.witch_spawn_egg' | 'minecraft.crafted:minecraft.wither_rose' | 'minecraft.dropped:minecraft.wither_rose' | 'minecraft.picked_up:minecraft.wither_rose' | 'minecraft.used:minecraft.wither_rose' | 'minecraft.crafted:minecraft.wither_skeleton_skull' | 'minecraft.dropped:minecraft.wither_skeleton_skull' | 'minecraft.picked_up:minecraft.wither_skeleton_skull' | 'minecraft.used:minecraft.wither_skeleton_skull' | 'minecraft.crafted:minecraft.wither_skeleton_spawn_egg' | 'minecraft.dropped:minecraft.wither_skeleton_spawn_egg' | 'minecraft.picked_up:minecraft.wither_skeleton_spawn_egg' | 'minecraft.used:minecraft.wither_skeleton_spawn_egg' | 'minecraft.crafted:minecraft.wither_spawn_egg' | 'minecraft.dropped:minecraft.wither_spawn_egg' | 'minecraft.picked_up:minecraft.wither_spawn_egg' | 'minecraft.used:minecraft.wither_spawn_egg' | 'minecraft.crafted:minecraft.wolf_spawn_egg' | 'minecraft.dropped:minecraft.wolf_spawn_egg' | 'minecraft.picked_up:minecraft.wolf_spawn_egg' | 'minecraft.used:minecraft.wolf_spawn_egg' | 'minecraft.crafted:minecraft.wooden_axe' | 'minecraft.dropped:minecraft.wooden_axe' | 'minecraft.picked_up:minecraft.wooden_axe' | 'minecraft.used:minecraft.wooden_axe' | 'minecraft.crafted:minecraft.wooden_hoe' | 'minecraft.dropped:minecraft.wooden_hoe' | 'minecraft.picked_up:minecraft.wooden_hoe' | 'minecraft.used:minecraft.wooden_hoe' | 'minecraft.crafted:minecraft.wooden_pickaxe' | 'minecraft.dropped:minecraft.wooden_pickaxe' | 'minecraft.picked_up:minecraft.wooden_pickaxe' | 'minecraft.used:minecraft.wooden_pickaxe' | 'minecraft.crafted:minecraft.wooden_shovel' | 'minecraft.dropped:minecraft.wooden_shovel' | 'minecraft.picked_up:minecraft.wooden_shovel' | 'minecraft.used:minecraft.wooden_shovel' | 'minecraft.crafted:minecraft.wooden_sword' | 'minecraft.dropped:minecraft.wooden_sword' | 'minecraft.picked_up:minecraft.wooden_sword' | 'minecraft.used:minecraft.wooden_sword' | 'minecraft.crafted:minecraft.writable_book' | 'minecraft.dropped:minecraft.writable_book' | 'minecraft.picked_up:minecraft.writable_book' | 'minecraft.used:minecraft.writable_book' | 'minecraft.crafted:minecraft.written_book' | 'minecraft.dropped:minecraft.written_book' | 'minecraft.picked_up:minecraft.written_book' | 'minecraft.used:minecraft.written_book' | 'minecraft.crafted:minecraft.yellow_banner' | 'minecraft.dropped:minecraft.yellow_banner' | 'minecraft.picked_up:minecraft.yellow_banner' | 'minecraft.used:minecraft.yellow_banner' | 'minecraft.crafted:minecraft.yellow_bed' | 'minecraft.dropped:minecraft.yellow_bed' | 'minecraft.picked_up:minecraft.yellow_bed' | 'minecraft.used:minecraft.yellow_bed' | 'minecraft.crafted:minecraft.yellow_candle' | 'minecraft.dropped:minecraft.yellow_candle' | 'minecraft.picked_up:minecraft.yellow_candle' | 'minecraft.used:minecraft.yellow_candle' | 'minecraft.crafted:minecraft.yellow_carpet' | 'minecraft.dropped:minecraft.yellow_carpet' | 'minecraft.picked_up:minecraft.yellow_carpet' | 'minecraft.used:minecraft.yellow_carpet' | 'minecraft.crafted:minecraft.yellow_concrete' | 'minecraft.dropped:minecraft.yellow_concrete' | 'minecraft.picked_up:minecraft.yellow_concrete' | 'minecraft.used:minecraft.yellow_concrete' | 'minecraft.crafted:minecraft.yellow_concrete_powder' | 'minecraft.dropped:minecraft.yellow_concrete_powder' | 'minecraft.picked_up:minecraft.yellow_concrete_powder' | 'minecraft.used:minecraft.yellow_concrete_powder' | 'minecraft.crafted:minecraft.yellow_dye' | 'minecraft.dropped:minecraft.yellow_dye' | 'minecraft.picked_up:minecraft.yellow_dye' | 'minecraft.used:minecraft.yellow_dye' | 'minecraft.crafted:minecraft.yellow_glazed_terracotta' | 'minecraft.dropped:minecraft.yellow_glazed_terracotta' | 'minecraft.picked_up:minecraft.yellow_glazed_terracotta' | 'minecraft.used:minecraft.yellow_glazed_terracotta' | 'minecraft.crafted:minecraft.yellow_shulker_box' | 'minecraft.dropped:minecraft.yellow_shulker_box' | 'minecraft.picked_up:minecraft.yellow_shulker_box' | 'minecraft.used:minecraft.yellow_shulker_box' | 'minecraft.crafted:minecraft.yellow_stained_glass' | 'minecraft.dropped:minecraft.yellow_stained_glass' | 'minecraft.picked_up:minecraft.yellow_stained_glass' | 'minecraft.used:minecraft.yellow_stained_glass' | 'minecraft.crafted:minecraft.yellow_stained_glass_pane' | 'minecraft.dropped:minecraft.yellow_stained_glass_pane' | 'minecraft.picked_up:minecraft.yellow_stained_glass_pane' | 'minecraft.used:minecraft.yellow_stained_glass_pane' | 'minecraft.crafted:minecraft.yellow_terracotta' | 'minecraft.dropped:minecraft.yellow_terracotta' | 'minecraft.picked_up:minecraft.yellow_terracotta' | 'minecraft.used:minecraft.yellow_terracotta' | 'minecraft.crafted:minecraft.yellow_wool' | 'minecraft.dropped:minecraft.yellow_wool' | 'minecraft.picked_up:minecraft.yellow_wool' | 'minecraft.used:minecraft.yellow_wool' | 'minecraft.crafted:minecraft.zoglin_spawn_egg' | 'minecraft.dropped:minecraft.zoglin_spawn_egg' | 'minecraft.picked_up:minecraft.zoglin_spawn_egg' | 'minecraft.used:minecraft.zoglin_spawn_egg' | 'minecraft.crafted:minecraft.zombie_head' | 'minecraft.dropped:minecraft.zombie_head' | 'minecraft.picked_up:minecraft.zombie_head' | 'minecraft.used:minecraft.zombie_head' | 'minecraft.crafted:minecraft.zombie_horse_spawn_egg' | 'minecraft.dropped:minecraft.zombie_horse_spawn_egg' | 'minecraft.picked_up:minecraft.zombie_horse_spawn_egg' | 'minecraft.used:minecraft.zombie_horse_spawn_egg' | 'minecraft.crafted:minecraft.zombie_spawn_egg' | 'minecraft.dropped:minecraft.zombie_spawn_egg' | 'minecraft.picked_up:minecraft.zombie_spawn_egg' | 'minecraft.used:minecraft.zombie_spawn_egg' | 'minecraft.crafted:minecraft.zombie_villager_spawn_egg' | 'minecraft.dropped:minecraft.zombie_villager_spawn_egg' | 'minecraft.picked_up:minecraft.zombie_villager_spawn_egg' | 'minecraft.used:minecraft.zombie_villager_spawn_egg' | 'minecraft.crafted:minecraft.zombified_piglin_spawn_egg' | 'minecraft.dropped:minecraft.zombified_piglin_spawn_egg' | 'minecraft.picked_up:minecraft.zombified_piglin_spawn_egg' | 'minecraft.used:minecraft.zombified_piglin_spawn_egg');
